__copyright__
Copyright 2017 Oracle.  All rights reserved.
Author: Muminul Islam <muminul.islam@oracle.com>

Description:
BMCS does not provide a shared storage service for customers. So a short-term solution is to
allow a customer to deploy an nfs and iSCSI server in their tenant.
This would be an image that is pre-configured with nfs and iSCSI server software
as well as a simple management interface to create/destroy luns(logical unit number) and
create/destroy nfs shares. This image could be installed on the highIO or denseIO shapes
of compute which have a number of NVMe devices which could be carved up and served to
other nodes as nfs or iSCSI luns.

To simplify the setup md will be used to configure the devices with raid10 or raid6,
and then an xfs filesystem will be created on top of this device. NFS shares will be created on top of this filesystem.

The management interface and manage nfs via the /etc/exportfs, and it can use targetcli to manage iSCSI luns.

Storage Appliance(SA) is a piece of software made for oracle bare metal cloud to share storage device using nfs and targetcli.
When the bmcs instance boots SA can detect the attached NVMe devices and create raid10/6 and mount the raid device using xfs file systems.
Once the file system is mounted any directory created on share point can be shared using nfs-utils. LUNs can also be shared to clients using
python rtslib. We have a tinny web based UI that can be used to create nfs share and edit the configuration. UI can also show logs,
current system and storage information.

Dependency packages: python-rtslib, python-pyudev, python-psutils, hdparm, lshw, mdadm, lsblk, nfs-utils
sudo yum python-flask-doc.noarch python-flask.noarch python-psutil.x86_64 pexpect python2-pip.noarch
pip install --proxy www-proxy.fr.oracle.com:80 flask-login Collecting flask-login

Framework and language used: bash, python, flask, oracle JET.

Developers: Muminul Islam, Erwann Chenede, Emmanuel Jannetti
Lead: Wim Coekarts, Van Okamura

iscsi functions: iscsi_util.py
raid functions: raid_array.py
nfs functions: nfs_util.py
bash: command_util.py
init_script: init/config_raid.sh (run this script to get curent raid configuration)


nfs_util.py:
-------------------------------
how to use:
list the entries:
from nfs_util import NfsExports

exports = NfsExports()
entries = exports.get_nfs_entries() "This will give you the list of ExportEntry or empty list if nothing is available. for detail see the nfs_util.py"
Add an entry:
exports.add_entry_raw(directory, IP, options) return 0 for success else failure
options="ro,insecure,nohide,no_root_squash"
remove an entry:
exports.remove_entry(direcotry, IP) return 0 for success else failure

command_util.py:
--------------------------
example on how to call this commands:

from command_util import *
from global import SysCommand

run_command_no_output(['ls', '-la'])
line=command_output_lines(['df', '-h'])
run_systemctl_command("target", SysCommand.START/STOP/ENABLE/DISABLE)
shel_out=output_shell_command("lsblk /dev/sda -o TYPE | awk '$1=="part"'|wc -l")

SytemdService:
from system import SytemdService

sys = SytemdService("target") or SytemdService("target,service")
sys.load_details()
# get the properties
print str(sys)
sys.set_service("firewalld")
sys.load_details()

service_utl.py
---------------------
how to get systemctl status.

from system import SytemdService

sys = SytemdService("target")
sys.load_details()
#start service
sys.start_service()
sys.stop_service()
sys.restart_service()
