#!/usr/bin/bash
# Copyright (c) 2018, Oracle and/or its affiliates.
# Licensed under the Universal Permissive License v 1.0 as shown at http://oss.oracle.com/licenses/upl.


#
#  This script is used during post-uninstall of LSA version 1.7.0 package
#  Version 1.7.0 have an issue within RPM spec file : services were not restarted
#  This is fixed for 1.7.1 and higher.
#  The rpm uninstallation of 1.7.0 call the install.sh script  (see %postun phase)
#  The install.sh script was removed  in 1.7.1 and higher version of LSA.
#  This was triggering an error message during update from 1.7.0 to 1.7.x
#  We introduce this script back so when 1.7.0 uninstall tries to call backend/init/install.sh,
#  this new version of the script is called and we can introduce what we need regaring systemd units
#
#  When there will be no more 1.7.0 version of LSA running at customer sites, this script
#  can be removed again.
#

SYSCTL=/usr/bin/systemctl
$SYSCTL try-restart webapp-priv-exec.service storage-pool-import.service config-lsa.service httpd.service
