# Copyright (c) 2018, Oracle and/or its affiliates. All rights reserved.
# Licensed under the Universal Permissive License v 1.0 as shown at http://oss.oracle.com/licenses/upl.
""" module hosting stubbed autodoc blueprint views """

from flask import Blueprint

from flask.ext.login import login_required

from stubbed_autodoc import autodocKlass

webapp_doc = Blueprint('webappdoc', __name__, url_prefix='/doc')
auto = autodocKlass()


@webapp_doc.route('/')
@webapp_doc.route('/private')
@login_required
def private_doc():
    return auto.html(groups=['private'], title='Linux Storage Appliance private REST API (UNSTABLE)')


@webapp_doc.route('/internal')
@login_required
def internal_doc():
    return auto.html(groups=['internal'], title='Internal Linux Storage Appliance REST API')
