/**
 * Copyright (c) 2017, 2018, Oracle and/or its affiliates.
 * Licensed under the Universal Permissive License v 1.0 as shown at http://oss.oracle.com/licenses/upl.
 */
/*
 * module to host common definition.
 * constant, reference to common object etc...
 * for common helper functions see helpers
 */
define(['ojs/ojcore','ojs/ojvalidation-number', 'helpers'],
       function (oj, ojv, helpers)
    {


        function Commons()
        {
        }
        Commons.prototype.definitions = {};
        Commons.prototype.definitions.percentGaugeThresholds = [{max: 60, color: '#47D600'},
            {max: 70, color: '#FFCC33'},
            {max: 80, color: '#FF6633'},
            {max: 85, color: '#FF0000'},
            {color: '#990000'}];

        Commons.prototype.definitions.cpuUtilizationLabel = oj.Translations.getTranslatedString('CPU');
        Commons.prototype.definitions.memoryUtilizationLabel = oj.Translations.getTranslatedString('Memory');
        Commons.prototype.definitions.swapUtilizationLabel = oj.Translations.getTranslatedString('Swap');
        Commons.prototype.definitions.diskUtilizationLabel = oj.Translations.getTranslatedString('Root filesystem');



        /* action labels */
        Commons.prototype.definitions.backupLabel = oj.Translations.getTranslatedString('Backup');
        Commons.prototype.definitions.restoreLabel = oj.Translations.getTranslatedString('Restore');
        Commons.prototype.definitions.snapshotLabel = oj.Translations.getTranslatedString('snapshot...');
        Commons.prototype.definitions.deleteLabel = oj.Translations.getTranslatedString('Delete');
        Commons.prototype.definitions.modifyLabel = oj.Translations.getTranslatedString('View/Modify');
        Commons.prototype.definitions.duplicateLabel = oj.Translations.getTranslatedString('Duplicate');
        Commons.prototype.definitions.cmdLabel = oj.Translations.getTranslatedString('Mount Information');
        Commons.prototype.definitions.addLabel = oj.Translations.getTranslatedString('Add');
        Commons.prototype.definitions.cancelLabel = oj.Translations.getTranslatedString('Cancel');
        Commons.prototype.definitions.closeLabel = oj.Translations.getTranslatedString('Close');
        Commons.prototype.definitions.okLabel = oj.Translations.getTranslatedString('OK');


        Commons.prototype.definitions.statusEnabledIcon = 'oj-fwk-icon-status-confirmation';
        Commons.prototype.definitions.statusDisabledIcon = 'oj-fwk-icon-status-error';
        Commons.prototype.definitions.statusDegradedIcon = 'oj-fwk-icon-status-warning';
        Commons.prototype.definitions.statusUnknownIcon = 'oj-fwk-icon-help';


        Commons.prototype.definitions.SHOW_BACKUPS = false;
        Commons.prototype.definitions.SHOW_ISCSI = false;

        Commons.prototype.definitions.UI_UPDATE_BASE_TIME = 2;

        Commons.prototype.converters = {};
        Commons.prototype.converters.byteConverter = oj.Validation.converterFactory(
            "LSAByteConverter").createConverter(
                {
                    "maximumFractionDigits": 2,
                    "minimumFractionDigits": 1,
                    "minimumIntegerDigits": 1,
                    "style": "unit",
                    "unit": "byte",
                    "lenientParse": "full"
                });
        Commons.prototype.converters.x4mByteConverter = oj.Validation.converterFactory(
            "X4mByteConverter").createConverter(
                {
                    "maximumFractionDigits": 2,
                    "minimumFractionDigits": 1,
                    "minimumIntegerDigits": 1,
                    "style": "unit",
                    "unit": "byte",
                    "lenientParse": "full"
                });
        Commons.prototype.converters.percentConverter = oj.Validation.converterFactory(
            oj.ConverterFactory.CONVERTER_TYPE_NUMBER).createConverter(
                {
                    "useGrouping":"false",
                    "maximumFractionDigits":2,
                    "style": "percent"
                });

        Commons.prototype.helpers = {};
        Commons.prototype.helpers.getElapsedTimeString = helpers.getElapsedTimeString;
        Commons.prototype.helpers.getTimeString = helpers.getTimeString;

        Commons.prototype.paths = {};
        Commons.prototype.paths.images = '/common/static/images/';

        return Commons;
    }
);
