# Copyright (c) 2018, Oracle and/or its affiliates. All rights reserved.
# Licensed under the Universal Permissive License v 1.0 as shown at http://oss.oracle.com/licenses/upl.
"""
module hosting stubbed autodoc
When autodoc is not installed on the host
we have to stub it and to define a class
responsible to handle doc request (see StubAutoDoc)
"""

_autodoc = None
autodocKlass = None

try:
    from flask.ext.autodoc import Autodoc as autodocKlass
except ImportError, e:
    # package not installed on the system
    # we will have to stub autodoc decorator
    class StubAutoDoc:
        def __init__(self):
            pass

        def html(slef, groups='all', template=None, **context):
            return ('AUTODOC not installed', 404)

        def doc(self, groups=None, set_location=True, **properties):
            def stub(func):
                return func
            return stub

        def init_app(self, app):
            pass
    autodocKlass = StubAutoDoc
