/**
 * Copyright (c) 2016, Oracle and/or its affiliates.
 * The Universal Permissive License (UPL), Version 1.0
 */
"use strict";
define(['./DvtToolkit', './DvtTimeComponent', './DvtTimeAxis'], function(dvt) {
  // Internal use only.  All APIs and functionality are subject to change at any time.

!function(t){t.DomUtils=function(){},t.Obj.createSubclass(t.DomUtils,t.Obj),t.DomUtils.addCSSClassName=function(e,i){var n,s,a;return n=!1,null!=i&&null!=e&&(s=t.ToolkitUtils.getAttrNullNS(e,"class"),-1==t.DomUtils._getCSSClassNameIndex(s,i)&&(a=s?i+" "+s:i,t.ToolkitUtils.setAttrNullNS(e,"class",a),n=!0)),n},t.DomUtils.removeCSSClassName=function(e,i){var n,s,a,r,o,l,h;return n=!1,null!=i&&null!=e&&(s=t.ToolkitUtils.getAttrNullNS(e,"class"),-1!=(a=t.DomUtils._getCSSClassNameIndex(s,i))&&(r=a+i.length,o=0==a?null:s.substring(0,a),l=r==s.length?null:s.substring(r+1),h=null==o?null==l?"":l:null==l?o:o+l,t.ToolkitUtils.setAttrNullNS(e,"class",h),n=!0)),n},t.DomUtils.containsCSSClassName=function(e,i){return null!=i&&null!=e&&-1!=t.DomUtils._getCSSClassNameIndex(e.className,i)},t.DomUtils._getCSSClassNameIndex=function(t,e){var i,n,s,a,r,o,l;if(!t||!t.indexOf)return-1;if(e===t)return 0;if(i=e.length,n=t.length,(s=t.indexOf(e))>=0){if(a=0==s||" "==t.charAt(s-1),o=(r=s+i)==n||" "==t.charAt(r),a&&o)return s;if((l=t.lastIndexOf(e))!=s)return a=t.charAt(l-1),o=(r=l+i)==n||" "==t.charAt(r),a&&o?l:t.indexOf(" "+e+" ")}return-1};var e=new Object;t.Obj.createSubclass(e,t.Obj),e._DEFAULT_TIMEAXES_LABEL_STYLE=t.BaseComponentDefaults.FONT_FAMILY_ALTA_12+"color: #333333;",e._DEFAULT_ZOOM_CONTROL_BACKGROUND_COLOR="#ffffff",e._DEFAULT_ZOOM_CONTROL_BORDER_COLOR="#d6d7d8",e._DEFAULT_ZOOM_CONTROL_DIAMETER=31,e._DEFAULT_ZOOM_CONTROL_PADDING=10.5,e._DEFAULT_ZOOM_CONTROL_SPACING=9,e._DEFAULT_STANDALONE_TASK_HEIGHT=22,e._DEFAULT_BASELINE_TASK_HEIGHT=6,e._DEFAULT_MILESTONE_BASELINE_Y_OFFSET=6,e._DEFAULT_SUMMARY_THICKNESS=3,e._DEFAULT_ACTUALTASK_HEIGHT=16,e._DEFAULT_TASK_LABEL_PADDING=5,e._DEFAULT_TASK_PADDING=5,e._DEFAULT_TASK_EFFECT_MARGIN=2,e._DEFAULT_TASK_TINT_FILTER_ID="ojGanttTaskTintFilter",e._DEFAULT_TASK_SHADE_FILTER_ID="ojGanttTaskShadeFilter",e._DEFAULT_TASK_TINT_ALPHA=.3,e._DEFAULT_TASK_SHADE_ALPHA=.35,e._DEFAULT_AXIS_HEIGHT=23,e._ROW_LABELS_AXIS_GAP=10,e._DEFAULT_DEPENDENCY_LINE_INNER_COLOR="#ffffff",e._DEFAULT_DEPENDENCY_LINE_INNER_WIDTH=2,e._DEFAULT_ANIMATION_DURATION=.5,e._DEPENDENCY_LINE_ARC_RADIUS=0,e._DEPENDENCY_LINE_TASK_FLANK_LENGTH=7,e._DEPENDENCY_MARKER_HEIGHT=8,e._DEPENDENCY_MARKER_WIDTH=6,e.getHorizontalScrollbarStyle=function(){return new t.CSSStyle(e._DEFAULT_HORIZONTAL_SCROLLBAR_STYLE)},e.getVerticalScrollbarStyle=function(){return new t.CSSStyle(e._DEFAULT_VERTICAL_SCROLLBAR_STYLE)},e.getStandaloneTaskHeight=function(){return e._DEFAULT_STANDALONE_TASK_HEIGHT},e.getActualTaskHeight=function(){return e._DEFAULT_ACTUALTASK_HEIGHT},e.getBaselineTaskHeight=function(){return e._DEFAULT_BASELINE_TASK_HEIGHT},e.getMilestoneBaselineYOffset=function(){return e._DEFAULT_MILESTONE_BASELINE_Y_OFFSET},e.getSummaryThickness=function(){return e._DEFAULT_SUMMARY_THICKNESS},e.getTaskPadding=function(){return e._DEFAULT_TASK_PADDING},e.getTaskLabelPadding=function(){return e._DEFAULT_TASK_LABEL_PADDING},e.getTaskEffectMargin=function(){return e._DEFAULT_TASK_EFFECT_MARGIN},e.getTaskTintFilterId=function(){return e._DEFAULT_TASK_TINT_FILTER_ID},e.getTaskShadeFilterId=function(){return e._DEFAULT_TASK_SHADE_FILTER_ID},e.getTaskTintAlpha=function(){return e._DEFAULT_TASK_TINT_ALPHA},e.getTaskShadeAlpha=function(){return e._DEFAULT_TASK_SHADE_ALPHA},e.getTimeAxisHeight=function(){return e._DEFAULT_AXIS_HEIGHT},e.getMajorAxisLabelStyle=function(i){var n=i._resources,s=e._DEFAULT_TIMEAXES_LABEL_STYLE;return n&&(s=n.majorAxisLabelFontProp),new t.CSSStyle(s)},e.getMinorAxisLabelStyle=function(i){var n=i._resources,s=e._DEFAULT_TIMEAXES_LABEL_STYLE;return n&&(s=n.minorAxisLabelFontProp),new t.CSSStyle(s)},e.getRowAxisGap=function(){return e._ROW_LABELS_AXIS_GAP},e.getDependencyLineTaskFlankLength=function(){return e._DEPENDENCY_LINE_TASK_FLANK_LENGTH},e.getDependencyLineArcRadius=function(){return e._DEPENDENCY_LINE_ARC_RADIUS},e.getDependencyLineMarkerWidth=function(){return e._DEPENDENCY_MARKER_WIDTH},e.getDependencyLineMarkerHeight=function(){return e._DEPENDENCY_MARKER_HEIGHT},e.getDependencyLineTaskGap=function(){return e.getTaskPadding()-1},e.getTaskLabelStyle=function(e){var i=e._resources,n="";return i&&(n=i.taskLabelFontProp),new t.CSSStyle(n)},e.getRowLabelStyle=function(e){var i=e._resources,n="";return i&&(n=i.rowLabelFontProp),new t.CSSStyle(n)},e.getChartStrokeWidth=function(e){var i=e._resources;if(i){var n=i.chartArea;if(n){var s=n.strokeWidth;if(s)return t.CSSStyle.toNumber(s)}}return 1},e.getHorizontalGridlineWidth=function(e){return e._resources?t.CSSStyle.toNumber(e._resources.horizontalGridlineWidth):1},e.getAnimationDuration=function(i){var n,s=e._DEFAULT_ANIMATION_DURATION;return i._resources&&(n=i._resources.animationDuration)&&(s=t.StyleUtils.getTimeMilliseconds(n)/1e3),s},e.getZoomInButtonBackgroundColor=function(t){return t.zoomIn_bgc?t.zoomIn_bgc:e._DEFAULT_ZOOM_CONTROL_BACKGROUND_COLOR},e.getZoomInButtonActiveBackgroundColor=function(t){return t.zoomIn_a_bgc?t.zoomIn_a_bgc:e._DEFAULT_ZOOM_CONTROL_BACKGROUND_COLOR},e.getZoomInButtonHoverBackgroundColor=function(t){return t.zoomIn_h_bgc?t.zoomIn_h_bgc:e._DEFAULT_ZOOM_CONTROL_BACKGROUND_COLOR},e.getZoomInButtonDisabledBackgroundColor=function(t){return t.zoomIn_d_bgc?t.zoomIn_d_bgc:e._DEFAULT_ZOOM_CONTROL_BACKGROUND_COLOR},e.getZoomInButtonBorderColor=function(t){return t.zoomIn_bc?t.zoomIn_bc:e._DEFAULT_ZOOM_CONTROL_BORDER_COLOR},e.getZoomInButtonActiveBorderColor=function(t){return t.zoomIn_a_bc?t.zoomIn_a_bc:e._DEFAULT_ZOOM_CONTROL_BORDER_COLOR},e.getZoomInButtonHoverBorderColor=function(t){return t.zoomIn_h_bc?t.zoomIn_h_bc:e._DEFAULT_ZOOM_CONTROL_BORDER_COLOR},e.getZoomInButtonDisabledBorderColor=function(t){return t.zoomIn_d_bc?t.zoomIn_d_bc:e._DEFAULT_ZOOM_CONTROL_BORDER_COLOR},e.getZoomOutButtonBackgroundColor=function(t){return t.zoomOut_bgc?t.zoomOut_bgc:e._DEFAULT_ZOOM_CONTROL_BACKGROUND_COLOR},e.getZoomOutButtonActiveBackgroundColor=function(t){return t.zoomOut_a_bgc?t.zoomOut_a_bgc:e._DEFAULT_ZOOM_CONTROL_BACKGROUND_COLOR},e.getZoomOutButtonHoverBackgroundColor=function(t){return t.zoomOut_h_bgc?t.zoomOut_h_bgc:e._DEFAULT_ZOOM_CONTROL_BACKGROUND_COLOR},e.getZoomOutButtonDisabledBackgroundColor=function(t){return t.zoomOut_d_bgc?t.zoomOut_d_bgc:e._DEFAULT_ZOOM_CONTROL_BACKGROUND_COLOR},e.getZoomOutButtonBorderColor=function(t){return t.zoomOut_bc?t.zoomOut_bc:e._DEFAULT_ZOOM_CONTROL_BORDER_COLOR},e.getZoomOutButtonActiveBorderColor=function(t){return t.zoomOut_a_bc?t.zoomOut_a_bc:e._DEFAULT_ZOOM_CONTROL_BORDER_COLOR},e.getZoomOutButtonHoverBorderColor=function(t){return t.zoomOut_h_bc?t.zoomOut_h_bc:e._DEFAULT_ZOOM_CONTROL_BORDER_COLOR},e.getZoomOutButtonDisabledBorderColor=function(t){return t.zoomOut_d_bc?t.zoomOut_d_bc:e._DEFAULT_ZOOM_CONTROL_BORDER_COLOR},e.getFocusedDependencyLineInnerColor=function(t){return e._DEFAULT_DEPENDENCY_LINE_INNER_COLOR},e.getFocusedDependencyLineInnerWidth=function(t){return e._DEFAULT_DEPENDENCY_LINE_INNER_WIDTH},e.getSizeInPixels=function(t,e){if("string"==typeof t){if("%"==t.slice(-1))return e*Number(t.slice(0,-1))/100;if("px"==t.slice(-2))return Number(t.slice(0,-2));t=Number(t)}return"number"==typeof t?t<=1?e*t:t:0};var i=new Object;t.Obj.createSubclass(i,t.Obj),i.getDatatipColor=function(t){var e=t.getTask().getFillColor();return e?e.fill:null},i.getDatatip=function(e,n,s){var a=e.getGantt(),r=e.getRow(),o=a.getOptions().tooltip,l=o?o.renderer:null;if(n&&l){var h=a.getCtx().getTooltipManager(),g={data:e.getProps(),rowData:r.getProps(),color:i.getDatatipColor(e),component:a.getOptions()._widgetConstructor};return h.getCustomTooltip(l,g)}var d=e.getProps().shortDesc;if(null!=d)return d;if(s&&!a.getCtx().isCustomElement()){var p=a.getOptions().valueFormats;if(!p||0==p.length){var u=e.getProps(),_=e.getTask(),c=u.start,f=u.end,m=u.baseline.start,T=u.baseline.end,S=_.getProgressValue(),y=a.getOptions(),b=_.isMilestone("main"),v=_.isMilestone("baseline"),A=!(null==c&&null==f),C=!(null==m&&null==T);if(A)if(b)var E=a.getTimeAxis().formatDate(new Date(null!=c?c:f),null,"general"),R=t.Bundle.getTranslation(y,"accessibleMilestoneInfo",t.Bundle.UTIL_PREFIX,"MILESTONE_INFO",[E]);else{var D=a.getTimeAxis().formatDate(new Date(c),null,"general"),P=a.getTimeAxis().formatDate(new Date(f),null,"general"),O=e.getDuration(c,f);R=t.Bundle.getTranslation(y,"accessibleTaskInfo",t.Bundle.UTIL_PREFIX,"TASK_INFO",[D,P,O])}if(C)if(v)var x=a.getTimeAxis().formatDate(new Date(null!=m?m:T),null,"general"),L=t.Bundle.getTranslation(a.getOptions(),"baselineDate")+": "+x;else{var w=a.getTimeAxis().formatDate(new Date(m),null,"general"),k=a.getTimeAxis().formatDate(new Date(T),null,"general");L=(L=t.Bundle.getTranslation(a.getOptions(),"baselineStart")+": "+w)+"; "+t.Bundle.getTranslation(a.getOptions(),"baselineEnd")+": "+k}if(A){var N=u.label;if(null!=N)var I=t.Bundle.getTranslation(a.getOptions(),"labelLabel")+": "+N;if(null!=S){var M=y._resources;if(M){var B=M.percentConverter;if(B){var F=B.format(S);if(null!=F)var U=t.Bundle.getTranslation(a.getOptions(),"labelProgress")+": "+F}}}}var H=(r=e.getRow()).getLabel();null==H&&(H=r.getIndex()+1);var G=t.Bundle.getTranslation(y,"accessibleRowInfo",t.Bundle.UTIL_PREFIX,"ROW_INFO",[H]);return R&&(G=G+"; "+R),L&&(G=G+"; "+L),I&&(G=G+"; "+I),U&&(G=G+"; "+U),G}}var Y="";return Y=i._addRowDatatip(Y,r,n),Y=i._addTaskDatatip(Y,e,n),i._processDatatip(Y,a,n)},i._processDatatip=function(t,e,i){return""==t?null:i?'<table class="'+e.GetStyleClass("tooltipTable")+'">'+t+"</table>":t},i._addRowDatatip=function(t,e,n){var s=e.getGantt(),a=e.getLabel();return null==a&&(a=e.getIndex()+1),i._addDatatipRow(t,s,"row","Row",a,n)},i._addTaskDatatip=function(t,e,n){var s=e.getGantt(),a=e.getProps(),r=e.getTask(),o=a.start,l=a.end,h=a.baseline.start,g=a.baseline.end,d=a.label,p=r.getProgressValue(),u=!(null==o&&null==l),_=!(null==h&&null==g),c=r.isMilestone("main"),f=r.isMilestone("baseline");return u?(c?(t=i._addDatatipRow(t,s,"date","Date",null!=o?o:l,n),f?t=i._addDatatipRow(t,s,"baselineDate","BaselineDate",null!=h?h:g,n):_&&(t=i._addDatatipRow(t,s,"baselineStart","BaselineStart",h,n),t=i._addDatatipRow(t,s,"baselineEnd","BaselineEnd",g,n))):f?(t=i._addDatatipRow(t,s,"start","Start",o,n),t=i._addDatatipRow(t,s,"end","End",l,n),t=i._addDatatipRow(t,s,"baselineDate","BaselineDate",null!=h?h:g,n)):_?(t=i._addDatatipRow(t,s,"start","Start",o,n),t=i._addDatatipRow(t,s,"baselineStart","BaselineStart",h,n),t=i._addDatatipRow(t,s,"end","End",l,n),t=i._addDatatipRow(t,s,"baselineEnd","BaselineEnd",g,n)):(t=i._addDatatipRow(t,s,"start","Start",o,n),t=i._addDatatipRow(t,s,"end","End",l,n)),t=i._addDatatipRow(t,s,"label","Label",d,n),null!=p&&(t=i._addDatatipRow(t,s,"progress","Progress",p,n))):_&&(t=i._addDatatipRow(t,s,"baselineStart","BaselineStart",h,n),t=i._addDatatipRow(t,s,"baselineEnd","BaselineEnd",g,n)),t},i._addDatatipRow=function(e,n,s,a,r,o,l){if(null==r||""===r)return e;var h,g=i.getValueFormat(n,s);return"off"==g.tooltipDisplay?e:("string"==typeof g.tooltipLabel&&(h=g.tooltipLabel),null==h&&(h=null==a?"":t.Bundle.getTranslation(n.getOptions(),"label"+a)),r=i.formatValue(n,s,g,r),o?e+'<tr><td class="'+n.GetStyleClass("tooltipLabel")+'">'+h+'</td><td class="'+n.GetStyleClass("tooltipValue")+'">'+r+"</td></tr>":(e.length>0&&(e+="<br>"),e+t.Bundle.getTranslatedString(t.Bundle.UTIL_PREFIX,"COLON_SEP_LIST",[h,r])))},i.getValueFormat=function(t,e){var i=t.getOptions().valueFormats;if(!i)return{};if(i instanceof Array){for(var n={},s=0;s<i.length;s++){var a=i[s];n[a.type]=a}t.getOptions().valueFormats=n,i=n}return i[e]?i[e]:{}},i.formatValue=function(t,e,i,n){var s=i.converter;if("start"==e||"end"==e||"date"==e||"baselineStart"==e||"baselineEnd"==e||"baselineDate"==e)return t.getTimeAxis().formatDate(new Date(n),s,"general");if(s&&s.format)return s.format(n);if("progress"==e){var a=t.getOptions()._resources;if(a){var r=a.percentConverter;if(r)return r.format(n)}}return n};var n=function(t){this.Init(t)};t.Obj.createSubclass(n,t.Obj),n.prototype.Init=function(t){this._gantt=t},n.prototype.prepareForAnimations=function(){var i=this._gantt.getCtx();this._gantt.StopAnimation(),this._animationMode="none",this._animationDuration=e.getAnimationDuration(this._gantt.getOptions()),this._gantt.isInitialRender()?this._gantt.isIRAnimationEnabled&&(this._animationMode="onDisplay"):this._gantt.isDCAnimationEnabled&&(this._animationMode="dataChange"),"onDisplay"===this._animationMode?(this.fadeInElemsIR=[],this.fadeInPlayableIR=new t.AnimFadeIn(i,this.fadeInElemsIR,this._animationDuration,0),this.dimensionsPlayableIR=this._createCustomPlayable(t.Easing.linear),this.translationsPlayableIR=this._createCustomPlayable(t.Easing.cubicInOut)):"dataChange"===this._animationMode&&(this.fadeInElemsDC=[],this.fadeInPlayableDC=new t.AnimFadeIn(i,this.fadeInElemsDC,this._animationDuration,0),this.fadeOutElemsDC=[],this.fadeOutPlayableDC=new t.AnimFadeOut(i,this.fadeOutElemsDC,this._animationDuration,0),this.dimensionsPlayableDC=this._createCustomPlayable(t.Easing.linear),this.translationsPlayableDC=this._createCustomPlayable(t.Easing.cubicInOut)),this._onEnds=[]},n.prototype._createCustomPlayable=function(e){var i;return(i=new t.CustomAnimation(this._gantt.getCtx(),this._gantt,this._animationDuration)).setEasing(e),i},n.prototype.triggerAnimations=function(){var e,i;if(this._gantt.StopAnimation(),i=this._gantt.getCtx(),"onDisplay"===this._animationMode?(e=[this.fadeInPlayableIR,this.translationsPlayableIR,this.dimensionsPlayableIR],this._gantt.Animation=new t.ParallelPlayable(i,e,this._animationDuration,0)):"dataChange"===this._animationMode&&(e=[this.fadeInPlayableDC,this.translationsPlayableDC,this.dimensionsPlayableDC,this.fadeOutPlayableDC],this._gantt.Animation=new t.ParallelPlayable(i,e,this._animationDuration,0)),this._gantt.Animation){this._hideDepLines(),t.Playable.appendOnEnd(this._gantt.Animation,this._showDepLines,this),this._gantt.EventManager.removeListeners(this._gantt);for(var n=0;n<this._onEnds.length;n++)t.Playable.appendOnEnd(this._gantt.Animation,this._onEnds[n],this);t.Playable.appendOnEnd(this._gantt.Animation,this._onAnimationEnd,this),this._gantt.Animation.play()}},n.prototype._hideDepLines=function(){var e=this._gantt.getDependencyLines();null!=e&&t.ToolkitUtils.setAttrNullNS(e.getElem(),"display","none")},n.prototype._showDepLines=function(){var e=this._gantt.getDependencyLines();null!=e&&t.ToolkitUtils.removeAttrNullNS(e.getElem(),"display")},n.prototype._onAnimationEnd=function(){this._gantt.AnimationStopped||this._gantt.RenderComplete(),this._gantt.EventManager.addListeners(this._gantt),this._gantt.Animation=null,this._gantt.AnimationStopped=!1,this._animationMode="none"},n.prototype.preAnimateGanttIR=function(t){"onDisplay"===this._animationMode&&this.fadeInElemsIR.push(t._canvas)},n.prototype.preAnimateTaskNode=function(e,i){var n,s=e.getRenderState();"dataChange"===this._animationMode?"add"===s?(e.setTranslate(i.x,i.y),this.fadeInElemsDC.push(e)):"exist"!==s&&"migrate"!==s||((n=this.translationsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,e,e.getTranslateX,e.setTranslateX,i.x),n.addProp(t.Animator.TYPE_NUMBER,e,e.getTranslateY,e.setTranslateY,i.y)):e.setTranslate(i.x,i.y)},n.prototype.preAnimateTaskNodeRemove=function(t,e){"dataChange"===this._animationMode?(this.fadeOutElemsDC.push(t),this._onEnds.push(e)):e()},n.prototype.preAnimateTaskBaseline=function(e,i,n,s){var a,r,o=e.getRenderState("baseline");"onDisplay"===this._animationMode?(i.setDimensions(n.x,n.y,0,n.h,n.r),s(),(a=this.dimensionsPlayableIR.getAnimator()).addProp(t.Animator.TYPE_NUMBER,i,i.getWidth,i.setWidth,n.w)):"dataChange"===this._animationMode?"add"===o?(i.setDimensions(n.x,n.y,0,n.h,n.r),s(),(a=this.dimensionsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,i,i.getWidth,i.setWidth,n.w)):"exist"===o&&((r=this.translationsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,i,i.getX,i.setX,n.x),r.addProp(t.Animator.TYPE_NUMBER,i,i.getY,i.setY,n.y),(a=this.dimensionsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,i,i.getWidth,i.setWidth,n.w),a.addProp(t.Animator.TYPE_NUMBER,i,i.getHeight,i.setHeight,n.h),i.setBorderRadius(n.r),this._onEnds.push(s)):(i.setDimensions(n.x,n.y,n.w,n.h,n.r),s())},n.prototype.preAnimateTaskBaselineRemove=function(t,e){"dataChange"===this._animationMode?(this.fadeOutElemsDC.push(t),this._onEnds.push(e)):e()},n.prototype.preAnimateTaskMain=function(e,i,n){var s,a,r=e.getRenderState("main");"onDisplay"===this._animationMode?(e.setMainDimensions(i.x,i.y,0,i.h,i.r),n(),(s=this.dimensionsPlayableIR.getAnimator()).addProp(t.Animator.TYPE_NUMBER,e,e.getMainWidth,e.setMainWidth,i.w)):"dataChange"===this._animationMode?"add"===r?(e.setMainDimensions(i.x,i.y,0,i.h,i.r),n(),(s=this.dimensionsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,e,e.getMainWidth,e.setMainWidth,i.w)):"exist"===r&&((a=this.translationsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,e,e.getMainX,e.setMainX,i.x),a.addProp(t.Animator.TYPE_NUMBER,e,e.getMainY,e.setMainY,i.y),(s=this.dimensionsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,e,e.getMainWidth,e.setMainWidth,i.w),s.addProp(t.Animator.TYPE_NUMBER,e,e.getMainHeight,e.setMainHeight,i.h),e.setMainBorderRadius(i.r),this._onEnds.push(n)):(e.setMainDimensions(i.x,i.y,i.w,i.h,i.r),n())},n.prototype.preAnimateTaskMainRemove=function(t,e,i,n){"dataChange"===this._animationMode?(this.fadeOutElemsDC.push(t),e&&this.fadeOutElemsDC.push(e),i&&this.fadeOutElemsDC.push(i),this._onEnds.push(n)):n()},n.prototype.preAnimateTaskProgress=function(e,i,n,s){var a,r,o=e.getRenderState("progress");"onDisplay"===this._animationMode?(i.setDimensions(n.x,n.y,0,n.h,n.r),s(),(a=this.dimensionsPlayableIR.getAnimator()).addProp(t.Animator.TYPE_NUMBER,i,i.getWidth,i.setWidth,n.w)):"dataChange"===this._animationMode?"add"===o?(i.setDimensions(n.x,n.y,0,n.h,n.r),s(),(a=this.dimensionsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,i,i.getWidth,i.setWidth,n.w)):"exist"===o&&((r=this.translationsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,i,i.getX,i.setX,n.x),r.addProp(t.Animator.TYPE_NUMBER,i,i.getY,i.setY,n.y),(a=this.dimensionsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,i,i.getWidth,i.setWidth,n.w),a.addProp(t.Animator.TYPE_NUMBER,i,i.getHeight,i.setHeight,n.h),i.setBorderRadius(n.r),this._onEnds.push(s)):(i.setDimensions(n.x,n.y,n.w,n.h,n.r),s())},n.prototype.preAnimateTaskProgressRemove=function(t,e){"dataChange"===this._animationMode?(this.fadeOutElemsDC.push(t),this._onEnds.push(e)):e()},n.prototype.preAnimateTaskLabel=function(e,i,n){var s,a=e.getTask(),r=e.getTaskLabel(),o=r.getLabelOutputText(),l=r.getRenderState(),h=a.getRenderState("main");"onDisplay"===this._animationMode?(n(),o.setY(i.y),o.setX(a.getShape("main").getX()),(s=this.translationsPlayableIR.getAnimator()).addProp(t.Animator.TYPE_NUMBER,o,o.getX,o.setX,i.x),s.addProp(t.Animator.TYPE_NUMBER,o,o.getY,o.setY,i.y)):"dataChange"===this._animationMode?"add"===l?(o.setX(i.x),o.setY(i.y),n(),"add"===h?(o.setX(a.getShape("main").getX()),(s=this.translationsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,o,o.getX,o.setX,i.x),s.addProp(t.Animator.TYPE_NUMBER,o,o.getY,o.setY,i.y)):"exist"===h&&this.fadeInElemsDC.push(o)):"exist"===l&&((s=this.translationsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,o,o.getX,o.setX,i.x),s.addProp(t.Animator.TYPE_NUMBER,o,o.getY,o.setY,i.y),this._onEnds.push(n)):(o.setX(i.x),o.setY(i.y),n())},n.prototype.preAnimateTaskLabelRemove=function(t,e){"dataChange"===this._animationMode?(this.fadeOutElemsDC.push(t),this._onEnds.push(e)):e()},n.prototype.preAnimateHorizontalGridline=function(e,i,n){var s;"dataChange"===this._animationMode?"add"===n?(e.setY1(i.y1),e.setY2(i.y2),e.setX1(i.x1),e.setX2(i.x2),this.fadeInElemsDC.push(e)):"exist"===n&&((s=this.translationsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,e,e.getX1,e.setX1,i.x1),s.addProp(t.Animator.TYPE_NUMBER,e,e.getX2,e.setX2,i.x2),s.addProp(t.Animator.TYPE_NUMBER,e,e.getY1,e.setY1,i.y1),s.addProp(t.Animator.TYPE_NUMBER,e,e.getY2,e.setY2,i.y2)):(e.setY1(i.y1),e.setY2(i.y2),e.setX1(i.x1),e.setX2(i.x2))},n.prototype.preAnimateRowBackground=function(e,i){"dataChange"===this._animationMode?this.dimensionsPlayableDC.getAnimator().addProp(t.Animator.TYPE_NUMBER,e,e.getHeight,e.setHeight,i.h):e.setHeight(i.h)},n.prototype.preAnimateRowNodeRemove=function(t,e){"dataChange"===this._animationMode?(this.fadeOutElemsDC.push(t),this._onEnds.push(e)):e()},n.prototype.preAnimateRowLabel=function(e,i,n){var s,a=e.getRenderState();"dataChange"===this._animationMode?"add"===a?(i.setY(n.y),i.setX(n.x),this.fadeInElemsDC.push(i)):"exist"===a&&((s=this.translationsPlayableDC.getAnimator()).addProp(t.Animator.TYPE_NUMBER,i,i.getX,i.setX,n.x),s.addProp(t.Animator.TYPE_NUMBER,i,i.getY,i.setY,n.y)):(i.setY(n.y),i.setX(n.x))},n.prototype.preAnimateRowLabelRemove=function(t,e){"dataChange"===this._animationMode?(this.fadeOutElemsDC.push(t),this._onEnds.push(e)):e()},t.Gantt=function(t,e,i){this.Init(t,e,i)},t.Obj.createSubclass(t.Gantt,t.TimeComponent),t.Gantt.newInstance=function(e,i,n){return new t.Gantt(e,i,n)},t.Gantt.prototype.Init=function(e,i,n){t.Gantt.superclass.Init.call(this,e,i,n),this.Defaults=new a,this.EventManager=new o(this,e,i,n),this.EventManager.addListeners(this),t.Agent.isTouchDevice()?this._keyboardHandler=null:(this._keyboardHandler=new l(this,this.EventManager),this.EventManager.setKeyboardHandler(this._keyboardHandler))},t.Gantt.prototype.SetOptions=function(e){null==e.taskDefaults&&(e.taskDefaults={baseline:{}}),null==e.taskDefaults.baseline&&(e.taskDefaults.baseline={}),e.taskDefaults.height=null==e.taskDefaults.height?void 0:e.taskDefaults.height,e.taskDefaults.baseline.height=null==e.taskDefaults.baseline.height?void 0:e.taskDefaults.baseline.height,t.Gantt.superclass.SetOptions.call(this,e),this.setSelectionMode(this.Options.selectionMode)},t.Gantt.prototype.getAutomation=function(){return this.Automation||(this.Automation=new s(this)),this.Automation},t.Gantt.prototype.GetStyleClass=function(t){var e=this.getCtx().styleClasses;return null!=e?e[t]:t},t.Gantt.prototype.Parse=function(t){return this._parser=new h,this._parser.parse(t)},t.Gantt.prototype._applyParsedProperties=function(e){this._axisPosition=e.axisPosition,this._selectionMode=e.selectionMode,this._horizontalGridline=e.horizontalGridline,this._verticalGridline=e.verticalGridline,this._viewStartTime=e.viewStart,this._viewEndTime=e.viewEnd,this._rowsData=e.rows,this.isIRAnimationEnabled=e.isIRAnimationEnabled,this.isDCAnimationEnabled=e.isDCAnimationEnabled,this._rowAxisRendered=e.rowAxisRendered,this._rowAxisWidth=e.rowAxisWidth,this._rowAxisMaxWidth=e.rowAxisMaxWidth,this._rowAxisLabelsOverflowBehavior=e.rowAxisLabelsOverflowBehavior,this._referenceObjects=e.referenceObjects,t.Gantt.superclass._applyParsedProperties.call(this,e)},t.Gantt.prototype._bundleTimeAxisOptions=function(t,i){var n=this._resources;n.axisClass=this.GetStyleClass(i),n.axisSeparatorClass=this.GetStyleClass(i+"Ticks"),n.axisLabelClass=this.GetStyleClass(i+"Labels");var s,a={start:t.start,end:t.end,_resources:n,shortDesc:t.shortDesc,orientation:"horizontal"};if(t[i]){var r=t[i];r.scale&&(a.scale=r.scale),r.converter&&(a.converter=r.converter),r.zoomOrder&&(a.zoomOrder=r.zoomOrder)}return"majorAxis"==i?s=e.getMajorAxisLabelStyle(t):"minorAxis"==i&&(s=e.getMinorAxisLabelStyle(t)),a.labelStyle=s,a},t.Gantt.prototype._getPreferredSize=function(e,i){return new t.Dimension(e,i)},t.Gantt.prototype.render=function(e,i,s){if(this.getCache().clearCache(),e){this.SetOptions(e),t.Gantt.superclass.render.call(this,e,i,s),this.isRowAxisEnabled()?g._prepareRowAxis(this):this.getParent().removeChild(this.getRowAxis());var a=this.getAxisPosition();if(e.minorAxis){var r=this._bundleTimeAxisOptions(this.Options,"minorAxis");null==this._minorAxis&&(this._minorAxis=new t.TimeAxis(this.getCtx(),null,null),"top"==a?this._minorAxis.setBorderVisibility(!1,!1,!0,!1):this._minorAxis.setBorderVisibility(!0,!1,!1,!1),this._masterAxis=this._minorAxis),this._minorAxis.setCanvasSize(null);var o=this._minorAxis.getPreferredLength(r,this._canvasLength)}var l=e.majorAxis;if(l)if(l.scale){r=this._bundleTimeAxisOptions(this.Options,"majorAxis"),null==this._majorAxis&&(this._majorAxis=new t.TimeAxis(this.getCtx(),null,null),"top"==a?this._majorAxis.setBorderVisibility(!1,!1,!0,!1):this._majorAxis.setBorderVisibility(!0,!1,!1,!1),this._slaveAxis=this._majorAxis),this._majorAxis.setCanvasSize(null);var h=this._majorAxis.getPreferredLength(r,this._canvasLength);o&&h>o&&(this._masterAxis=this._majorAxis,this._slaveAxis=this._minorAxis,o=h)}else this._majorAxis=null;o&&this.setContentLength(o),this._minorAxis&&this._minorAxis.hasValidOptions()&&this.prepareViewportLength(),this._animationManager=new n(this),this._animationManager.prepareForAnimations(),g.renderGantt(this),this._animationManager.triggerAnimations(),this.UpdateAriaAttributes(),this.Animation||this.RenderComplete()}else this._handleResize(i,s)},t.Gantt.prototype.getAnimationManager=function(){return this._animationManager},t.Gantt.prototype.isInitialRender=function(){return!this._canvas},t.Gantt.prototype.processScrollbarEvent=function(e,i){if(t.Gantt.superclass.processScrollbarEvent.call(this,e,i),i==this.contentDirScrollbar){var n=e.getNewMax();this._databody.setTranslateY(n),this.isRowAxisEnabled()&&this.getRowAxis().setTranslateY(n),null!=this._deplines&&this._deplines.setTranslateY(n)}},t.Gantt.prototype.createViewportChangeEvent=function(){return t.EventFactory.newGanttViewportChangeEvent(this._viewStartTime,this._viewEndTime,this._slaveAxis?this._slaveAxis.getScale():null,this.getTimeAxis().getScale())},t.Gantt.prototype._handleResize=function(t,e){if(this.Width=t,this.Height=e,this.applyStyleValues(),this.isRowAxisEnabled()&&g._updateRowAxisSpace(this),this.prepareViewportLength(),g._renderBackground(this),g._renderRowBackground(this),this.hasValidOptions()){this.renderTimeZoomCanvas(this._canvas),this.isRowAxisEnabled()&&g._prerenderRowAxis(this),this.updateRows(),g._renderDependencies(this);var i=this.getTimeZoomCanvas();g._renderAxes(this,i),g._renderVerticalGridline(this,i),g._renderReferenceObjects(this,i),g._renderZoomControls(this),g._updateRowBackground(this),(this.isTimeDirScrollbarOn()||this.isContentDirScrollbarOn())&&g._renderScrollbars(this,this)}else g._renderEmptyText(this);this.Animation||this.RenderComplete()},t.Gantt.prototype.applyStyleValues=function(){var i=t.Agent.isRightToLeft(this.getCtx()),n=this.getScrollbarPadding();this._borderWidth=e.getChartStrokeWidth(this.Options);var s=2*this._borderWidth;if(this._widthOffset=0,this.timeDirScrollbarStyles=this.getTimeDirScrollbarStyle(),this.contentDirScrollbarStyles=this.getContentDirScrollbarStyle(),this._backgroundWidth=this.Width,this._backgroundHeight=this.Height,this.isTimeDirScrollbarOn()&&(this._backgroundHeight=this._backgroundHeight-t.CSSStyle.toNumber(this.timeDirScrollbarStyles.getHeight())-3*n),this.isContentDirScrollbarOn()){var a=3*n;this._backgroundWidth=this._backgroundWidth-t.CSSStyle.toNumber(this.contentDirScrollbarStyles.getWidth())-a,i&&(this._widthOffset=a-this._borderWidth)}this.setStartXOffset(this._widthOffset+this._borderWidth),this.setStartYOffset(this._borderWidth),this._canvasLength=this._backgroundWidth-s,this._canvasSize=this._backgroundHeight-s},t.Gantt.prototype.updateRows=function(){var t,i=this._rows;if(null!=i&&i.length>0){this.getCache().putToCache("baseTaskLabelCSSStyle",e.getTaskLabelStyle(this.Options)),g._renderDatabody(this),this.isRowAxisEnabled()&&(t=this.getRowAxis());for(var n=0;n<i.length;n++)i[n].render(this.getDatabody(),t)}else g._renderEmptyText(this,!0)},t.Gantt.prototype.HandleMouseWheel=function(e){if(t.Gantt.superclass.HandleMouseWheel.call(this,e),this.hasValidOptions())if(!e||e.ctrlKey||t.Agent.isTouchDevice()){if(e.zoomWheelDelta){var i=this.getCtx().pageToStageCoords(e.pageX,e.pageY);if(this.getGraphicalAreaBounds().containsPoint(i.x,i.y)){var n=this.getContentLength()*e.zoomWheelDelta,s=e.zoomTime,a=e.zoomCompLoc;this.handleZoomWheel(n,s,a,!0)}}}else{var r=e.wheelDelta?e.wheelDelta*t.TimeComponent.SCROLL_LINE_HEIGHT:0,o=e.wheelDeltaX?e.wheelDeltaX*t.TimeComponent.SCROLL_LINE_HEIGHT:0;if(this.panBy(-o,-r),e.wheelDeltaX){var l=this.createViewportChangeEvent();this.dispatchEvent(l)}}},t.Gantt.prototype.handleZoomWheel=function(e,i,n,s){e>this._masterAxis.getMaxContentLength()?(e=this._masterAxis.getMaxContentLength(),this.disableZoomButton(!0)):this.enableZoomButton(!0),this._canvasLength>e?(e=this._canvasLength,this.disableZoomButton(!1)):this.enableZoomButton(!1);var a=this.getContentLength()<=e;t.Gantt.superclass.handleZoomWheel.call(this,e,i,n,s);var r=this._masterAxis.getZoomLevelLengths();if(a)for(;this._masterAxis.getZoomLevelOrder()>0&&(!this._slaveAxis||this._slaveAxis.getZoomLevelOrder()>0);){var o=r[this._masterAxis.getZoomLevelOrder()-1];if(!(this.getContentLength()>=o))break;this._masterAxis.setZoomLevelOrder(this._masterAxis.getZoomLevelOrder()-1),this._masterAxis.decreaseScale(),this._slaveAxis&&(this._slaveAxis.setZoomLevelOrder(this._slaveAxis.getZoomLevelOrder()-1),this._slaveAxis.decreaseScale())}else for(;this._masterAxis.getZoomLevelOrder()<r.length-1&&(!this._slaveAxis||this._slaveAxis.getZoomLevelOrder()<this._slaveAxis.getZoomLevelLengths().length-1)&&(o=r[this._masterAxis.getZoomLevelOrder()],this.getContentLength()<o);)this._masterAxis.setZoomLevelOrder(this._masterAxis.getZoomLevelOrder()+1),this._masterAxis.increaseScale(),this._slaveAxis&&(this._slaveAxis.setZoomLevelOrder(this._slaveAxis.getZoomLevelOrder()+1),this._slaveAxis.increaseScale());this.isTimeDirScrollbarOn()&&this.timeDirScrollbar&&this.timeDirScrollbar.setViewportRange(this._viewStartTime,this._viewEndTime);var l=this.getTimeZoomCanvas();if(g._renderAxes(this,l),this.updateRows(),g._renderDependencies(this),g._renderVerticalGridline(this,l),g._renderReferenceObjects(this,l),s){var h=this.createViewportChangeEvent();this.dispatchEvent(h)}},t.Gantt.prototype.getMajorAxis=function(){return this._majorAxis},t.Gantt.prototype.getMinorAxis=function(){return this._minorAxis},t.Gantt.prototype.getTimeAxis=function(){return this._minorAxis?this._minorAxis:this._majorAxis},t.Gantt.prototype.getDatabody=function(){return this._databody},t.Gantt.prototype.setDatabody=function(t){this._databody=t},t.Gantt.prototype.getDatabodyStart=function(){return this._databodyStart},t.Gantt.prototype.setDatabodyStart=function(t){this._databodyStart=t},t.Gantt.prototype.getDatabodyHeight=function(){return this.getCanvasSize()-this.getAxesHeight()},t.Gantt.prototype.getVerticalGridlines=function(){return this._gridlines},t.Gantt.prototype.setVerticalGridlines=function(t){this._gridlines=t},t.Gantt.prototype.getReferenceObjects=function(){return this._referenceObjects},t.Gantt.prototype.getReferenceObjectsContainer=function(){return this._refObjectsContainer},t.Gantt.prototype.setReferenceObjectsContainer=function(t){this._refObjectsContainer=t},t.Gantt.prototype.getRenderedReferenceObjects=function(){return this._renderedReferenceObjects},t.Gantt.prototype.setRenderedReferenceObjects=function(t){this._renderedReferenceObjects=t},t.Gantt.prototype.setEmptyText=function(t){this._emptyText=t},t.Gantt.prototype.removeEmptyText=function(){this._emptyText&&this._emptyText.getParent()&&(this._emptyText.getParent().removeChild(this._emptyText),delete this._emptyText,this._emptyText=null)},t.Gantt.prototype.getRowsData=function(){return this._rowsData},t.Gantt.prototype.getRows=function(){return this._rows},t.Gantt.prototype.setRows=function(t){this._rows=t},t.Gantt.prototype.getCurrentRow=function(){return this._currentRow},t.Gantt.prototype.setCurrentRow=function(t){this._currentRow=t},t.Gantt.prototype.getAxisPosition=function(){return this._axisPosition},t.Gantt.prototype.getAxisHeight=function(){return e.getTimeAxisHeight()},t.Gantt.prototype.getStartTime=function(){return this._start},t.Gantt.prototype.getEndTime=function(){return this._end},t.Gantt.prototype.getHoverBehavior=function(){return"none"},t.Gantt.prototype.isHorizontalGridlinesVisible=function(){return"visible"==this._horizontalGridline},t.Gantt.prototype.isVerticalGridlinesVisible=function(){return"visible"==this._verticalGridline},t.Gantt.prototype.getContentHeight=function(){return this._contentHeight},t.Gantt.prototype.setContentHeight=function(t){this._contentHeight=t},t.Gantt.prototype.getAxesHeight=function(){if(null==this._axesHeight){var t=0;this._majorAxis&&(t+=this._majorAxis.getSize()),this._minorAxis&&(t+=this._minorAxis.getSize()),this._axesHeight=t}return this._axesHeight},t.Gantt.prototype.isRowAxisEnabled=function(){return"on"==this._rowAxisRendered},t.Gantt.prototype.getRowAxisWidth=function(){return this._rowAxisWidth},t.Gantt.prototype.getRowAxisMaxWidth=function(){return this._rowAxisMaxWidth},t.Gantt.prototype.isRowAxisLabelsWrap=function(){return"normal"==this._rowAxisLabelsOverflowBehavior},t.Gantt.prototype.getRowAxis=function(){return this._rowAxis},t.Gantt.prototype.setRowAxis=function(t){this._rowAxis=t},t.Gantt.prototype.scrollTaskIntoView=function(i){var n,s=t.Agent.isRightToLeft(this.getCtx()),a=this.getAxesHeight(),r=this.getTimeZoomCanvas(),o=(n=(n=i.getTask().getShape("main"))||i.getTask().getShape("baseline")).getFinalX()+i.getFinalX()+(s?n.getPhysicalEndOffset():-n.getPhysicalStartOffset()),l=n.getFinalY()+i.getFinalY(),h=n.getFinalWidth(),g=n.getFinalHeight(),d=this.getStartXOffset()-r.getTranslateX(),p=this._databodyStart-this._databody.getTranslateY(),u=this._canvasLength,_=this._canvasSize-a,c=0,f=0;s?o>d+u?c=o-(d+u)+e.getTaskPadding():o-h<d&&(c=o-h-d-e.getTaskPadding()):o<d?c=o-d-e.getTaskPadding():o+h>d+u&&(c=o+h-(d+u)+e.getTaskPadding()),l<p?f=l-p-e.getTaskPadding():l+g>p+_&&(f=l+g-(p+_)+e.getTaskPadding()),this.panBy(c,f,!0)},t.Gantt.prototype.panBy=function(e,i,n){if(n=void 0!==n&&n,0!=e&&(n||Math.abs(e)>Math.abs(i))&&t.Gantt.superclass.panBy.call(this,e,0),this._databody&&0!=i&&(n||Math.abs(i)>Math.abs(e))){var s=this.getBoundedContentTranslateY(this._databody.getTranslateY()-i);this._databody.setTranslateY(s),this.isRowAxisEnabled()&&this.getRowAxis().setTranslateY(s),this.isContentDirScrollbarOn()&&this.contentDirScrollbar.setViewportRange(s-this.getDatabodyHeight(),s),null!=this._deplines&&this._deplines.setTranslateY(s)}this.isTimeDirScrollbarOn()&&this.timeDirScrollbar&&this.timeDirScrollbar.setViewportRange(this._viewStartTime,this._viewEndTime)},t.Gantt.prototype.getBoundedContentTranslateY=function(t){var e=this.getContentHeight();if(null==e)return t;var i=this.getDatabodyHeight(),n=this.getDatabodyStart(),s=n+Math.min(0,i-e);return Math.min(n,Math.max(t,s))},t.Gantt.prototype.beginDragPan=function(e,i){t.Gantt.superclass.beginDragPan.call(this,e,i),this._currentViewStartTime=this._viewStartTime,this._currentViewEndTime=this._viewEndTime},t.Gantt.prototype.endDragPan=function(e,i){this._currentViewStartTime==this._viewStartTime&&this._currentViewEndTime==this._viewEndTime&&(this._triggerViewportChange=!1),t.Gantt.superclass.endDragPan.call(this,e,i)},t.Gantt.prototype.setTaskBrightness=function(t,e){null!=(t=this.findTaskNodeById(t.getId()))&&(e?t.darken():t.brighten())},t.Gantt.prototype.findTaskNodeById=function(t){var e=this._rows;if(e)for(var i=0;i<e.length;i++)for(var n=e[i].getTasks(),s=0;s<n.length;s++)if(t===n[s].getId())return n[s];return null},t.Gantt.prototype.hasValidOptions=function(){var t=!this._majorAxis||this._majorAxis.hasValidOptions(),e=this._minorAxis&&this._minorAxis.hasValidOptions(),i=this._start&&this._end&&this._end>this._start,n=!this._viewStartTime||!this._viewEndTime||this._viewEndTime>this._viewStartTime,s=!this._viewStartTime||this._viewStartTime>=this._start&&this._viewStartTime<this._end,a=!this._viewEndTime||this._viewEndTime>this._start&&this._viewEndTime<=this._end;return t&&e&&i&&n&&s&&a},t.Gantt.prototype.GetComponentDescription=function(){return t.Bundle.getTranslation(this.getOptions(),"componentName",t.Bundle.UTIL_PREFIX,"GANTT")},t.Gantt.prototype.getSelectionHandler=function(){return this._selectionHandler},t.Gantt.prototype.isSelectionSupported=function(){return!!this._selectionHandler},t.Gantt.prototype.setSelectionMode=function(e){this._selectionHandler="single"==e?new t.SelectionHandler(t.SelectionHandler.TYPE_SINGLE):"multiple"==e?new t.SelectionHandler(t.SelectionHandler.TYPE_MULTIPLE):null,this.getEventManager().setSelectionHandler(this._selectionHandler)},t.Gantt.prototype._processInitialSelections=function(){if(null!=this._rows&&0!=this._rows.length){var t=this.Options.selection;if(t&&this.isSelectionSupported()){for(var e=[],i=0;i<this._rows.length;i++){var n=this._rows[i].getTasks();if(null!=n&&n.length>0)for(var s=0;s<n.length;s++)e.push(n[s])}this.getSelectionHandler().processInitialSelections(t,e)}}},t.Gantt.prototype.getDependencyLines=function(){return this._deplines},t.Gantt.prototype.setDependencyLines=function(t){this._deplines=t},t.Gantt.prototype.setDefaultMarkerId=function(t){this._markerId=t},t.Gantt.prototype.getDefaultMarkerId=function(){return this._markerId},t.Gantt.prototype.getNavigableDependencyLinesForTask=function(t,e){return"successor"==e?t.getSuccessorDependencies():t.getPredecessorDependencies()},t.Gantt.prototype.HandleTouchStart=function(t){};var s=function(t){this._gantt=t};t.Obj.createSubclass(s,t.Automation),s.prototype.GetSubIdForDomElement=function(t){var e=this._gantt.getEventManager().GetLogicalObject(t);if(e&&e instanceof c){var i=e.getRow();return"taskbar["+this._gantt.getRows().indexOf(i)+"]["+i.getTasks().indexOf(e)+"]"}return e&&(e instanceof p||e instanceof u)?"rowLabel["+e.getRowIndex()+"]":null},s.prototype.getDomElementForSubId=function(e){if(e==t.Automation.TOOLTIP_SUBID)return this.GetTooltipElement(this._gantt);var i=e.indexOf("["),n=e.indexOf("]"),s=e.substring(0,i);if(i>-1&&n>-1)if("taskbar"==s){var a=e.indexOf("[",i+1),r=e.indexOf("]",a+1);if(a>-1&&r>-1){var o=parseInt(e.substring(i+1,n)),l=parseInt(e.substring(a+1,r));if(isNaN(o)||isNaN(l))return null;if(null!=(d=this._gantt.getRows())&&d.length>o){var h=d[o].getTasks();if(null!=h&&h.length>l){var g=h[l].getTask().getShape("main");if(null!=g)return g.getElem()}}}}else if("rowLabel"==s){var d;if(o=parseInt(e.substring(i+1,n)),null!=(d=this._gantt.getRows())&&d.length>o){var p=d[o].getRowLabelText();if(null!=p)return p.getElem()}}return null};var a=function(){this.Init({alta:a.VERSION_1})};t.Obj.createSubclass(a,t.BaseComponentDefaults),a.VERSION_1={axisPosition:"top",animationOnDataChange:"none",animationOnDisplay:"none",scrollbar:{horizontal:"off",vertical:"off"},gridlines:{horizontal:"hidden",vertical:"visible"},selectionMode:"none",taskDefaults:{labelPosition:["end","innerCenter","start","max"],borderRadius:"0",height:e.getStandaloneTaskHeight(),progress:{height:"100%",borderRadius:"0"},baseline:{height:e.getBaselineTaskHeight(),borderRadius:"0"},type:"auto"},rowAxis:{rendered:"off",width:"auto",maxWidth:"none",whiteSpace:"nowrap"}},a.prototype.getNoCloneObject=function(){return{start:!0,end:!0,viewportStart:!0,viewportEnd:!0,rows:{tasks:{start:!0,end:!0}},referenceObjects:{value:!0}}},a.prototype.getAnimationDuration=function(t){return t._resources?t._resources.animationDuration:null};var r=function(t,e){this.Init(t,e)};t.Obj.createSubclass(r,t.Container),r.START_START="startStart",r.START_FINISH="startFinish",r.FINISH_START="finishStart",r.FINISH_FINISH="finishFinish",r.CONFLICT_NONE=0,r.CONFLICT_PREDECESSOR=1,r.CONFLICT_SUCCESSOR=2,r.CONFLICT_BOTH=3,r.prototype.Init=function(t,e){r.superclass.Init.call(this,t.getCtx(),null),this._gantt=t,this._props=e},r.prototype.setProps=function(t){this._props=t},r.prototype.getGantt=function(){return this._gantt},r.prototype.getId=function(){return this._props.id},r.prototype.getActiveElementId=function(){return null},r.prototype.getPredecessor=function(){return this._props.predecessorTaskId},r.prototype.getSuccessor=function(){return this._props.successorTaskId},r.prototype.getType=function(){return null==this._props.type?r.FINISH_START:this._props.type},r.prototype.getSvgStyle=function(){return this._props.svgStyle},r.prototype.getSvgClassName=function(){return this._props.svgClassName},r.prototype.getShortDesc=function(){return this._props.shortDesc},r.prototype.getPredecessorNode=function(){return this._predecessorNode},r.prototype.getSuccessorNode=function(){return this._successorNode},r._getTaskStart=function(i){var n=t.Agent.isRightToLeft(i.getGantt().getCtx()),s=i.getTask().getShape("main"),a=i.getTaskLabel(),r=a.getLabelOutputText(),o=a.getEffectiveLabelPosition();return n?null!=r&&null!=r.getParent()&&"end"==o?i.getFinalX()+s.getFinalX()-s.getFinalWidth()-s.getPhysicalEndOffset()-r.getDimensions().w-2*e.getTaskLabelPadding():i.getFinalX()+s.getFinalX()-s.getFinalWidth()-s.getPhysicalEndOffset():null!=r&&null!=r.getParent()&&"start"==o?i.getFinalX()+s.getFinalX()-s.getPhysicalStartOffset()-r.getDimensions().w-2*e.getTaskLabelPadding():i.getFinalX()+s.getFinalX()-s.getPhysicalStartOffset()},r._getTaskMiddle=function(t){var e=t.getTask(),i=e.getShape("main"),n=e.isSummary("main")?t.getProps().height:i.getFinalHeight();return r._getTaskTop(t)+i.getFinalY()+Math.round(n/2)},r._getTaskEnd=function(i){var n=t.Agent.isRightToLeft(i.getGantt().getCtx()),s=i.getTask().getShape("main"),a=i.getTaskLabel(),r=a.getLabelOutputText(),o=a.getEffectiveLabelPosition();return n?null!=r&&null!=r.getParent()&&"start"==o?i.getFinalX()+s.getFinalX()+s.getPhysicalStartOffset()+r.getDimensions().w+2*e.getTaskLabelPadding():i.getFinalX()+s.getFinalX()+s.getPhysicalStartOffset():null!=r&&null!=r.getParent()&&"end"==o?i.getFinalX()+s.getFinalX()+s.getFinalWidth()+s.getPhysicalEndOffset()+r.getDimensions().w+2*e.getTaskLabelPadding():i.getFinalX()+s.getFinalX()+s.getFinalWidth()+s.getPhysicalEndOffset()},r._getTaskTop=function(t){return t.getFinalY()},r._getTaskBottom=function(t){return r._getTaskTop(t)+t.getFinalHeight()},r._isValidType=function(t){return t===r.START_START||t===r.START_FINISH||t===r.FINISH_START||t===r.FINISH_FINISH},r.prototype.render=function(i){this.getParent()!=i&&i.addChild(this),this.setAriaRole("img");var n=this.getPredecessor(),s=this.getSuccessor(),a=this.getType();if(null!=n&&null!=s&&n!=s&&r._isValidType(a)){var o=this.getGantt(),l=o.findTaskNodeById(n),h=o.findTaskNodeById(s);if(null!=l&&null!=h){if(this._predecessorNode=l,this._successorNode=h,this._predecessorNode.addSuccessorDependency(this),this._successorNode.addPredecessorDependency(this),t.TimeAxis.supportsTouch()&&(this.setAriaProperty("label",this.getAriaLabel()),this._predecessorNode.refreshAriaLabel(),this._successorNode.refreshAriaLabel()),t.Agent.isPlatformIE()&&this._cleanup(),null!=this._line){this._line.setCmds(r._calcDepLine(o.getCtx(),this._predecessorNode,this._successorNode,a));var g=this._line.getElem()}else{var d=new t.Path(o.getCtx(),r._calcDepLine(o.getCtx(),l,h,a));0===e.getDependencyLineArcRadius()&&d.setPixelHinting(!0),g=d.getElem(),t.ToolkitUtils.setAttrNullNS(g,"marker-end",t.ToolkitUtils.getUrlById(o.getDefaultMarkerId())),this.addChild(d),this._eventManagerAssociated||(this._gantt.getEventManager().associate(this,this),this._eventManagerAssociated=!0);var p=new t.SolidStroke(e.getFocusedDependencyLineInnerColor(),1,e.getFocusedDependencyLineInnerWidth()),u=new t.SolidStroke("#000",1,1);d.setHoverStroke(p,u),this._line=d}var _=this.getSvgStyle();_&&("string"==typeof _||_ instanceof String?t.ToolkitUtils.setAttrNullNS(g,"style",_):this._line.setStyle(_));var c=o.GetStyleClass("dependencyLine"),f=this.getSvgClassName();f?t.ToolkitUtils.setAttrNullNS(g,"class",c+" "+f):t.ToolkitUtils.setAttrNullNS(g,"class",c)}else this._cleanup()}else this._cleanup()},r.prototype._cleanup=function(){null!=this._line&&(this.removeChild(this._line),this._line=null)},r.prototype._calcConflict=function(){var t=!1,e=!1,i=this.getType(),n=this.getGantt().getNavigableDependencyLinesForTask(this._predecessorNode,"predecessor");if(null!=n)for(var s=0;s<n.length;s++){var a=n[s].getType();(i!=r.START_START&&i!=r.START_FINISH||a!=r.START_START&&a!=r.FINISH_START)&&(i!=r.FINISH_FINISH&&i!=r.FINISH_START||a!=r.FINISH_FINISH&&a!=r.START_FINISH)||(t=!0)}if(null!=(n=this.getGantt().getNavigableDependencyLinesForTask(this._successorNode,"successor")))for(s=0;s<n.length;s++)a=n[s].getType(),(i!=r.START_START&&i!=r.FINISH_START||a!=r.START_START&&a!=r.START_FINISH)&&(i!=r.FINISH_FINISH&&i!=r.START_FINISH||a!=r.FINISH_FINISH&&a!=r.FINISH_START)||(e=!0);return t&&e?r.CONFLICT_BOTH:t?r.CONFLICT_PREDECESSOR:e?r.CONFLICT_SUCCESSOR:r.CONFLICT_NONE},r._calcDepLine=function(e,i,n,s){var a=t.Agent.isRightToLeft(e);switch(s){case r.START_START:return a?r._calcDepLineHelper(i,n,!0,!0):r._calcDepLineHelper(i,n,!1,!1);case r.START_FINISH:return a?r._calcDepLineHelper(i,n,!0,!1):r._calcDepLineHelper(i,n,!1,!0);case r.FINISH_START:return a?r._calcDepLineHelper(i,n,!1,!0):r._calcDepLineHelper(i,n,!0,!1);case r.FINISH_FINISH:return a?r._calcDepLineHelper(i,n,!1,!1):r._calcDepLineHelper(i,n,!0,!0)}return null},r._calcDepLineHelper=function(i,n,s,a){var o=e.getDependencyLineArcRadius(),l=e.getDependencyLineTaskFlankLength(),h=e.getDependencyLineMarkerWidth(),g=s?r._getTaskEnd(i):r._getTaskStart(i),d=a?r._getTaskEnd(n):r._getTaskStart(n),p=r._getTaskMiddle(i),u=r._getTaskMiddle(n),_=u>=p?r._getTaskBottom(i)+e.getDependencyLineTaskGap():r._getTaskTop(i)-e.getDependencyLineTaskGap();g=Math.round(g)+.5,d=Math.round(d)+.5,p=Math.round(p)+.5,u=Math.round(u)+.5,_=Math.round(_)+.5;var c=g+(s?1:-1)*l,f=a?d+l+h:d-l-h,m=t.PathUtils.moveTo(g,p);return s&&f<c||!s&&f>c?(m+=t.PathUtils.horizontalLineTo(c+(s?-1:1)*o),u>p?(m+=t.PathUtils.arcTo(o,o,Math.PI/2,s?1:0,c,p+o),s&&a||!s&&!a?(m+=t.PathUtils.verticalLineTo(u-o),m+=t.PathUtils.arcTo(o,o,Math.PI/2,s?1:0,c+(s?-1:1)*o,u)):(m+=t.PathUtils.verticalLineTo(_-o),m+=t.PathUtils.arcTo(o,o,Math.PI/2,s?1:0,c+(s?-1:1)*o,_),m+=t.PathUtils.horizontalLineTo(f+(s?1:-1)*o),m+=t.PathUtils.arcTo(o,o,Math.PI/2,s?0:1,f,_+o),m+=t.PathUtils.verticalLineTo(u-o),m+=t.PathUtils.arcTo(o,o,Math.PI/2,s?0:1,f+(s?1:-1)*o,u))):u<p?(m+=t.PathUtils.arcTo(o,o,Math.PI/2,s?0:1,c,p-o),s&&a||!s&&!a?(m+=t.PathUtils.verticalLineTo(u+o),m+=t.PathUtils.arcTo(o,o,Math.PI/2,s?0:1,c+(s?-1:1)*o,u)):(m+=t.PathUtils.verticalLineTo(_+o),m+=t.PathUtils.arcTo(o,o,Math.PI/2,s?0:1,c+(s?-1:1)*o,_),m+=t.PathUtils.horizontalLineTo(f+(s?1:-1)*o),m+=t.PathUtils.arcTo(o,o,Math.PI/2,s?1:0,f,_-o),m+=t.PathUtils.verticalLineTo(u+o),m+=t.PathUtils.arcTo(o,o,Math.PI/2,s?1:0,f+(s?1:-1)*o,u))):(m+=t.PathUtils.arcTo(o,o,Math.PI/2,s?1:0,c,p+o),m+=t.PathUtils.verticalLineTo(_-o),m+=t.PathUtils.arcTo(o,o,Math.PI/2,s?1:0,c+(s?-1:1)*o,_),m+=t.PathUtils.horizontalLineTo(f+(s?1:-1)*o),m+=t.PathUtils.arcTo(o,o,Math.PI/2,s?1:0,f,_-o),m+=t.PathUtils.verticalLineTo(u+o),m+=a?t.PathUtils.arcTo(o,o,Math.PI/2,0,f-o,u):t.PathUtils.arcTo(o,o,Math.PI/2,1,f+o,u))):u>p?(m+=t.PathUtils.horizontalLineTo(f+(s?-1:1)*o),m+=t.PathUtils.arcTo(o,o,Math.PI/2,s?1:0,f,p+o),m+=t.PathUtils.verticalLineTo(u-o),m+=a?t.PathUtils.arcTo(o,o,Math.PI/2,1,f-o,u):t.PathUtils.arcTo(o,o,Math.PI/2,0,f+o,u)):u<p?(m+=t.PathUtils.horizontalLineTo(f+(s?-1:1)*o),m+=t.PathUtils.arcTo(o,o,Math.PI/2,s?0:1,f,p-o),m+=t.PathUtils.verticalLineTo(u+o),m+=a?t.PathUtils.arcTo(o,o,Math.PI/2,0,f-o,u):t.PathUtils.arcTo(o,o,Math.PI/2,1,f+o,u)):(s&&a||!s&&!a)&&(m+=t.PathUtils.horizontalLineTo(c+(s?-1:1)*o),m+=t.PathUtils.arcTo(o,o,Math.PI/2,s?1:0,c,p+o),m+=t.PathUtils.verticalLineTo(_-o),m+=t.PathUtils.arcTo(o,o,Math.PI/2,s?0:1,c+(s?1:-1)*o,_),m+=t.PathUtils.horizontalLineTo(f-o),m+=t.PathUtils.arcTo(o,o,Math.PI/2,s?0:1,f,_-o),m+=t.PathUtils.verticalLineTo(u+o),m+=t.PathUtils.arcTo(o,o,Math.PI/2,s?0:1,f+(s?-1:1)*o,u)),m+=t.PathUtils.lineTo(d,u)},r.prototype.getNextNavigable=function(e){if(e.keyCode==t.KeyboardEvent.UP_ARROW||e.keyCode==t.KeyboardEvent.DOWN_ARROW){var i=this.getKeyboardFocusTask();i||(i=this.getPredecessorNode());var n=this,s=this.getGantt().getEventManager().getKeyboardHandler();if(s&&s.getNextNavigableDependencyLine){var a=i==this.getPredecessorNode()?"successor":"predecessor",r=this.getGantt().getNavigableDependencyLinesForTask(i,a);n=s.getNextNavigableDependencyLine(i,this,e,r)}return n.setKeyboardFocusTask(i),n}return e.keyCode==t.KeyboardEvent.RIGHT_ARROW||e.keyCode==t.KeyboardEvent.LEFT_ARROW?t.Agent.isRightToLeft(this.getGantt().getCtx())?e.keyCode==t.KeyboardEvent.LEFT_ARROW?this.getSuccessorNode():this.getPredecessorNode():e.keyCode==t.KeyboardEvent.RIGHT_ARROW?this.getSuccessorNode():this.getPredecessorNode():e.type==t.MouseEvent.CLICK?this:null},r.prototype.setKeyboardFocusTask=function(t){this._keyboardNavNode=t},r.prototype.getKeyboardFocusTask=function(){return this._keyboardNavNode},r.prototype.getKeyboardBoundingBox=function(t){return this.getDimensions(t)},r.prototype.getTargetElem=function(){return this._line.getElem()},r.prototype.showKeyboardFocusEffect=function(){if(this._line){var e=t.ToolkitUtils.getAttrNullNS(this._line.getElem(),"marker-end");t.DomUtils.addCSSClassName(this._line.getElem(),this._gantt.GetStyleClass("focus")),this._line.showHoverEffect(),null!=e&&t.ToolkitUtils.setAttrNullNS(this._line.getElem(),"marker-end",e),this._isShowingKeyboardFocusEffect=!0}},r.prototype.hideKeyboardFocusEffect=function(){this.isShowingKeyboardFocusEffect()&&(this._line.hideHoverEffect(),t.DomUtils.removeCSSClassName(this._line.getElem(),this._gantt.GetStyleClass("focus")),this._isShowingKeyboardFocusEffect=!1)},r.prototype.isShowingKeyboardFocusEffect=function(){return this._isShowingKeyboardFocusEffect},r.prototype.getDatatip=function(t,e,i){return this.getAriaLabel()},r.prototype.getAriaLabel=function(){var e=this.getShortDesc();if(null!=e)return e;var i=this._gantt.getOptions(),n=this.getPredecessor(),s=this.getSuccessor(),a=this.getType();if(null==n||null==s||!r._isValidType(a))return"";var o=t.Bundle.getTranslation(i,a+"DependencyAriaDesc");return e=t.Bundle.getTranslation(i,"accessibleDependencyInfo","","",[o,n,s])};var o=function(t){o.superclass.constructor.call(this,t)};t.Obj.createSubclass(o,t.TimeComponentEventManager),o.prototype.setFocus=function(t){o.superclass.setFocus.call(this,t),t instanceof c&&this._comp.scrollTaskIntoView(t)};var l=function(t,e){this.Init(t,e)};t.Obj.createSubclass(l,t.TimeComponentKeyboardHandler),l.prototype.Init=function(t,e){l.superclass.Init.call(this,e),this._gantt=t},l._findPreviousTask=function(t,e,i){var n=e.getTasks();return null==n||0==n.length?0==i?null:l._findPreviousTask(t,t[i-1],i-1):n[n.length-1]},l._findNextTask=function(t,e,i){var n=e.getTasks();return null==n||0==n.length?i==t.length-1?null:l._findNextTask(t,t[i+1],i+1):n[0]},l.getNextNavigable=function(e,i,n,s){if(i instanceof c){var a=i.getRow(),r=e.getRows(),o=a.getTasks();if(null==o||0==o.length)return;var h=t.Agent.isRightToLeft(e.getCtx()),g=r.indexOf(a);switch(n.keyCode){case h?t.KeyboardEvent.RIGHT_ARROW:t.KeyboardEvent.LEFT_ARROW:var d=o.indexOf(i);if(0!=d)return o[d-1];if(g>0)return l._findPreviousTask(r,r[g-1],g-1);break;case h?t.KeyboardEvent.LEFT_ARROW:t.KeyboardEvent.RIGHT_ARROW:if((d=o.indexOf(i))!=o.length-1)return o[d+1];if(g<r.length-1)return l._findNextTask(r,r[g+1],g+1);break;case t.KeyboardEvent.UP_ARROW:if(g>0&&null!=(i=l._findPreviousTask(r,r[g-1],g-1)))return i.getRow().getTasks()[0];break;case t.KeyboardEvent.DOWN_ARROW:if(g<r.length-1&&null!=(i=l._findNextTask(r,r[g+1],g+1)))return i.getRow().getTasks()[0]}return i}return null},l.prototype.isNavigationEvent=function(e){var i=!1;switch(e.keyCode){case t.KeyboardEvent.OPEN_ANGLED_BRACKET:case t.KeyboardEvent.CLOSE_ANGLED_BRACKET:i=!!e.altKey;break;default:i=l.superclass.isNavigationEvent.call(this,e)}return i},l.prototype._getDistance=function(t){var e=t.getType(),i=t.getPredecessorNode(),n=t.getSuccessorNode(),s=e==r.START_START||e==r.START_FINISH?i.getProps().start:i.getProps().end;if(e==r.START_START||e==r.FINISH_START)var a=n.getProps().start;else a=n.getProps().end;return Math.abs(a-s)},l.prototype._getDependencyComparator=function(){var t=this;return function(e,i){var n=t._getDistance(e),s=t._getDistance(i);return n<s?-1:n>s?1:0}},l.prototype.getFirstNavigableDependencyLine=function(e,i,n){var s=i.keyCode;if(!n||n.length<1||!e)return null;for(var a=t.Agent.isRightToLeft(this._gantt.getCtx()),r=null,o=0,l=0;l<n.length;l++){var h=n[l];if(s==t.KeyboardEvent.CLOSE_ANGLED_BRACKET)var g=a?h.getPredecessor():h.getSuccessor();else g=a?h.getSuccessor():h.getPredecessor();if(e.getId()!=g){var d=this._getDistance(h);(null==r||d<o)&&(o=d,r=h)}}return r},l.prototype.getNextNavigableDependencyLine=function(e,i,n,s){if(!s)return null;if(!i)return s[0];if(!e)return i;s.sort(this._getDependencyComparator());for(var a=n.keyCode==t.KeyboardEvent.DOWN_ARROW,r=0,o=0;o<s.length;o++){if(s[o]===i){r=a?o==s.length-1?0:o+1:0==o?s.length-1:o-1;break}}return s[r]},l.prototype.processKeyDown=function(e){if(e.keyCode==t.KeyboardEvent.TAB){var i=this._eventManager.getFocus();if(i)return t.EventManager.consumeEvent(e),i;var n=this._gantt.getRows();if(null!=n&&n.length>0){var s=n[0].getTasks();if(null!=s&&s.length>0)return t.EventManager.consumeEvent(e),s[0]}}return l.superclass.processKeyDown.call(this,e)};var h=function(){};t.Obj.createSubclass(h,t.Obj),h.prototype.parse=function(t){var e=new Object,i=function(e){var i=typeof t[e];if("number"===i||"string"===i){var n=new Date(t[e]).getTime();if(!isNaN(n))return n}return null};return e.start=i("start"),e.end=i("end"),t.viewportStart&&(e.viewStart=i("viewportStart")),t.viewportEnd&&(e.viewEnd=i("viewportEnd")),e.rows=t.rows,e.dependencies=t.dependencies,e.axisPosition="top",null!=t.axisPosition&&(e.axisPosition=t.axisPosition),e.selectionMode="none",null!=t.selectionMode&&(e.selectionMode=t.selectionMode),e.horizontalGridline="hidden",e.verticalGridline="hidden",null!=t.gridlines&&(null!=t.gridlines.horizontal&&(e.horizontalGridline=t.gridlines.horizontal),null!=t.gridlines.vertical&&(e.verticalGridline=t.gridlines.vertical)),e.xScrollbar="off",e.yScrollbar="off",t.scrollbars&&(t.scrollbars.horizontal&&(e.xScrollbar=t.scrollbars.horizontal),t.scrollbars.vertical&&(e.yScrollbar=t.scrollbars.vertical)),e.isIRAnimationEnabled="auto"==t.animationOnDisplay,e.isDCAnimationEnabled="auto"==t.animationOnDataChange,null!=t.rowAxis&&(e.rowAxisRendered=t.rowAxis.rendered,e.rowAxisWidth=t.rowAxis.width,e.rowAxisMaxWidth=t.rowAxis.maxWidth,e.rowAxisLabelsOverflowBehavior=t.rowAxis.whiteSpace),e.referenceObjects=t.referenceObjects,e.styleClass=t.className,e.inlineStyle=t.style,e};var g={};t.Obj.createSubclass(g,t.Obj),g.renderGantt=function(t){if(g._renderBackground(t),g._renderRowBackground(t),g._renderScrollableCanvas(t),t.getAnimationManager().preAnimateGanttIR(t),t.removeEmptyText(),t.hasValidOptions()){g._prepareTaskFillFilters(t),t.renderTimeZoomCanvas(t._canvas);var e=t.getTimeZoomCanvas();g._renderAxes(t,e),g._renderVerticalGridline(t,e),t.isRowAxisEnabled()&&g._prerenderRowAxis(t),g._renderRows(t,e,t.getRowAxis()),g._renderDependencies(t,e),g._renderReferenceObjects(t,e),g._renderZoomControls(t),g._updateRowBackground(t),t._processInitialSelections(),(t.isTimeDirScrollbarOn()||t.isContentDirScrollbarOn())&&g._renderScrollbars(t,t)}else g._renderEmptyText(t)},g._prepareTaskFillFilters=function(i){if(!document.getElementById(e.getTaskTintFilterId())){var n=e.getTaskTintAlpha(),s=t.SvgShapeUtils.createElement("filter",e.getTaskTintFilterId()),a=t.SvgShapeUtils.createElement("feColorMatrix");a.setAttribute("color-interpolation-filters","sRGB"),a.setAttribute("type","matrix"),a.setAttribute("values",1-n+" 0 0 0 "+n+" 0 "+(1-n)+" 0 0 "+n+" 0 0 "+(1-n)+" 0 "+n+" 0 0 0 1 0"),s.appendChild(a);var r=e.getTaskShadeAlpha(),o=t.SvgShapeUtils.createElement("filter",e.getTaskShadeFilterId()),l=t.SvgShapeUtils.createElement("feColorMatrix");l.setAttribute("color-interpolation-filters","sRGB"),l.setAttribute("type","matrix"),l.setAttribute("values",1-r+" 0 0 0 0 0 "+(1-r)+" 0 0 0 0 0 "+(1-r)+" 0 0 0 0 0 1 0"),o.appendChild(l),i.appendSharedDefs(s),i.appendSharedDefs(o)}},g._prerenderTimeDirScrollbar=function(e,i,n){var s=n.w,a=t.CSSStyle.toNumber(e.timeDirScrollbarStyles.getHeight());return e.setTimeDirScrollbar(new t.SimpleScrollbar(e.getCtx(),e.HandleEvent,e)),i.addChild(e.timeDirScrollbar),t.LayoutUtils.position(n,"bottom",e.timeDirScrollbar,s,a,0),new t.Dimension(s,a)},g._prerenderContentDirScrollbar=function(e,i,n){var s=t.CSSStyle.toNumber(e.contentDirScrollbarStyles.getWidth()),a=n.h;return e.setContentDirScrollbar(new t.SimpleScrollbar(e.getCtx(),e.HandleEvent,e)),i.addChild(e.contentDirScrollbar),t.LayoutUtils.position(n,t.Agent.isRightToLeft(e.getCtx())?"left":"right",e.contentDirScrollbar,s,a,0),new t.Dimension(s,a)},g._renderScrollbars=function(e,i){var n=e.getDatabody();if(null!=n){var s=e.getDatabodyStart(),a=e.getCtx(),r=e.getScrollbarPadding();if(null==e._scrollbarsCanvas?(e._scrollbarsCanvas=new t.Container(a,"sbCanvas"),i.addChild(e._scrollbarsCanvas)):e._scrollbarsCanvas.removeChildren(),e.isTimeDirScrollbarOn())var o=e.getCanvasLength(),l=e.Height-r,h=g._prerenderTimeDirScrollbar(e,e._scrollbarsCanvas,new t.Rectangle(0,0,o,l));if(e.isContentDirScrollbarOn()){o=e.Width-r,l=e.getCanvasSize()-e.getAxesHeight();var d=g._prerenderContentDirScrollbar(e,e._scrollbarsCanvas,new t.Rectangle(0,0,o,l))}if(e.timeDirScrollbar){var p={};p.color=e.timeDirScrollbarStyles.getStyle(t.CSSStyle.COLOR),p.backgroundColor=e.timeDirScrollbarStyles.getStyle(t.CSSStyle.BACKGROUND_COLOR),p.min=e._start,p.max=e._end,p.isHorizontal=!0,p.isReversed=t.Agent.isRightToLeft(e.getCtx()),e.timeDirScrollbar.setTranslateX(e.getStartXOffset()),e.timeDirScrollbar.render(p,h.w,h.h),e.timeDirScrollbar.setViewportRange(e._viewStartTime,e._viewEndTime)}if(e.contentDirScrollbar){(p={}).color=e.contentDirScrollbarStyles.getStyle(t.CSSStyle.COLOR),p.backgroundColor=e.contentDirScrollbarStyles.getStyle(t.CSSStyle.BACKGROUND_COLOR),p.min=-(Math.max(e.getContentHeight(),d.h)-s),p.max=s,p.isHorizontal=!1,p.isReversed=!0,e.contentDirScrollbar.setTranslateY(s+e.getStartYOffset()),e.contentDirScrollbar.render(p,d.w,d.h);var u=0;"bottom"==e.getAxisPosition()&&(u=e.getAxesHeight()),e.contentDirScrollbar.setViewportRange(n.getTranslateY()-(e.getCanvasSize()-s-u),n.getTranslateY())}}else null!=e._scrollbarsCanvas&&e._scrollbarsCanvas.removeChildren()},g._prepareRowAxis=function(t){var e=t.getRowAxis();e||(e=new d(t),t.setRowAxis(e)),g._updateRowAxisSpace(t)},g._updateRowAxisSpace=function(i){var n=t.Agent.isRightToLeft(i.getCtx()),s=i.getRowAxis();i._rowAxisPreferredWidth=Math.ceil(s.getPreferredWidth(i.Width-e.getRowAxisGap()));var a=i._rowAxisPreferredWidth+e.getRowAxisGap();i._backgroundWidth=i._backgroundWidth-a,n||(i._widthOffset=i._widthOffset+a,i.setStartXOffset(i.getStartXOffset()+a)),i._canvasLength=i._canvasLength-a},g._prerenderRowAxis=function(i){var n=t.Agent.isRightToLeft(i.getCtx()),s=i.getRowAxis();if(null!=s){s.setPixelHinting(!0);var a=i._rowAxisPreferredWidth,r=i.getCanvasSize()-i.getAxesHeight();n?s.setTranslateX(i.getStartXOffset()+i.getCanvasLength()+i._borderWidth+e.getRowAxisGap()):s.setTranslateX(0);var o=i.getDatabodyStart(),l=new t.ClipPath;l.addRect(s.getTranslateX(),o+i.getStartYOffset(),a,r),s.setClipPath(l),s.getParent()!=i.getParent()&&i.getParent().addChild(s)}},g._renderBackground=function(e){var i=e._backgroundWidth,n=e._backgroundHeight;e._background?(e._background.setClipPath(null),e._background.setWidth(i),e._background.setHeight(n),e._background.setX(e._widthOffset)):e._background=new t.Rect(e.getCtx(),e._widthOffset,0,i,n,"bg"),e._background.SetSvgProperty("style","stroke-width:"+2*e._borderWidth+"px"),e._background.setClassName(e.GetStyleClass("databody")),e._background.setPixelHinting(!0),e._background.setCursor("move");var s=new t.ClipPath;s.addRect(e._widthOffset,0,i,n),e._background.setClipPath(s),e._background.getParent()!=e&&e.addChild(e._background)},g._renderRowBackground=function(e){var i=e._canvasLength;e._rowBackground?(e._rowBackground.setWidth(i),e._rowBackground.setX(e.getStartXOffset()),e._rowBackground.setY(e.getStartYOffset())):e._rowBackground=new t.Rect(e.getCtx(),e.getStartXOffset(),e.getStartYOffset(),i,0),e._rowBackground.setClassName(e.GetStyleClass("row")),e._rowBackground.setPixelHinting(!0),e._rowBackground.setCursor("move");var n=new t.ClipPath;n.addRect(e.getStartXOffset(),e.getStartYOffset(),i,e._canvasSize),e._rowBackground.setClipPath(n),e._rowBackground.getParent()!=e&&e.addChild(e._rowBackground)},g._updateRowBackground=function(t){var i,n,s,a=t.getRows();null!=a&&a.length>0&&(i=0,t.isHorizontalGridlinesVisible()&&(i=e.getHorizontalGridlineWidth(t.getOptions())),(n=t._rowBackground).setY(t.getDatabodyStart()),s={h:a[a.length-1].getTop()+a[a.length-1].getRowHeight()+i},t.getAnimationManager().preAnimateRowBackground(n,s))},g._renderScrollableCanvas=function(e){e._canvas||(e._canvas=new t.Container(e.getCtx(),"canvas"),e.addChild(e._canvas))},g._renderAxes=function(t,e){var i=t.getMajorAxis(),n=t.getMinorAxis();if("top"==t.getAxisPosition()){var s=0;i&&(g._renderAxis(t,e,i,s,t.getAxisHeight()),s+=i.getSize()),n&&(g._renderAxis(t,e,n,s,t.getAxisHeight()),s+=n.getSize()),t.setDatabodyStart(s)}else s=t._canvasSize,i&&(g._renderAxis(t,e,i,null,t.getAxisHeight()),s-=i.getSize(),g._positionAxis(i,s)),n&&(g._renderAxis(t,e,n,s,t.getAxisHeight()),s-=n.getSize(),g._positionAxis(n,s)),t.setDatabodyStart(0)},g._renderAxis=function(t,e,i,n,s){i.getParent()!==e&&e.addChild(i),i.render(null,t.getContentLength(),s),null!=n&&g._positionAxis(i,n)},g._positionAxis=function(e,i){var n=new t.Matrix(1,0,0,1,0,i);e.setMatrix(n)},g._renderZoomControls=function(i){var n=i.getCtx(),s=i._resources,a=t.Agent.isRightToLeft(n),r={zoomInProps:{imageSize:16,cssUrl:s.zoomIn,cssUrlHover:s.zoomIn_h,cssUrlActive:s.zoomIn_a,cssUrlDisabled:s.zoomIn_d,enabledBackgroundColor:e.getZoomInButtonBackgroundColor(s),enabledBorderColor:e.getZoomInButtonBorderColor(s),hoverBackgroundColor:e.getZoomInButtonHoverBackgroundColor(s),hoverBorderColor:e.getZoomInButtonHoverBorderColor(s),activeBackgroundColor:e.getZoomInButtonActiveBackgroundColor(s),activeBorderColor:e.getZoomInButtonActiveBorderColor(s),disabledBackgroundColor:e.getZoomInButtonDisabledBackgroundColor(s),disabledBorderColor:e.getZoomInButtonDisabledBorderColor(s)},zoomOutProps:{imageSize:16,cssUrl:s.zoomOut,cssUrlHover:s.zoomOut_h,cssUrlActive:s.zoomOut_a,cssUrlDisabled:s.zoomOut_d,enabledBackgroundColor:e.getZoomOutButtonBackgroundColor(s),enabledBorderColor:e.getZoomOutButtonBorderColor(s),hoverBackgroundColor:e.getZoomOutButtonHoverBackgroundColor(s),hoverBorderColor:e.getZoomOutButtonHoverBorderColor(s),activeBackgroundColor:e.getZoomOutButtonActiveBackgroundColor(s),activeBorderColor:e.getZoomOutButtonActiveBorderColor(s),disabledBackgroundColor:e.getZoomOutButtonDisabledBackgroundColor(s),disabledBorderColor:e.getZoomOutButtonDisabledBorderColor(s)}};if(a)var o=i.getStartXOffset()+e._DEFAULT_ZOOM_CONTROL_PADDING;else o=i.getCanvasLength()+i.getStartXOffset()-(e._DEFAULT_ZOOM_CONTROL_PADDING+e._DEFAULT_ZOOM_CONTROL_DIAMETER);r.zoomInProps.posX=o,r.zoomOutProps.posX=o;var l=i._startY+e._DEFAULT_ZOOM_CONTROL_PADDING;if("top"==i.getAxisPosition())var h=l;else h=i._backgroundHeight-l;if("top"==i.getAxisPosition())var g=h,d=h+e._DEFAULT_ZOOM_CONTROL_DIAMETER+e._DEFAULT_ZOOM_CONTROL_SPACING;else g=h-2*e._DEFAULT_ZOOM_CONTROL_DIAMETER-e._DEFAULT_ZOOM_CONTROL_SPACING,d=h-e._DEFAULT_ZOOM_CONTROL_DIAMETER;r.zoomInProps.posY=g,r.zoomOutProps.posY=d,i.renderZoomControls(r)},g._renderEmptyText=function(e,i){if(i){var n=e.getDatabody();n&&n.getParent()&&(n.getParent().removeChild(n),e.setDatabody(null)),e._rowBackground&&e._rowBackground.setHeight(0),e.setRows(null);var s=t.Bundle.getTranslatedString(t.Bundle.UTIL_PREFIX,"NO_DATA",null);e.removeEmptyText()}else s=t.Bundle.getTranslatedString(t.Bundle.UTIL_PREFIX,"INVALID_DATA",null),e.clearComponent();var a=t.TextUtils.renderEmptyText(e._canvas,s,new t.Rectangle(0,0,e._backgroundWidth,e._backgroundHeight),e.EventManager,null);a.setClassName(e.GetStyleClass("nodata")),e.setEmptyText(a)},g._renderDatabody=function(e,i){var n=e.getDatabody();null==n&&(n=new t.Container(e.getCtx(),"db"),i.addChild(n),e.setDatabody(n),n.setTranslateY(e.getDatabodyStart()),e.isRowAxisEnabled()&&e.getRowAxis().setTranslateY(e.getDatabodyStart()+e.getStartYOffset()));var s=new t.ClipPath;s.addRect(0,e.getDatabodyStart(),e.getContentLength(),e.getDatabodyHeight()),n.setClipPath(s),n.setTranslateY(e.getBoundedContentTranslateY(n.getTranslateY()))},g._renderVerticalGridline=function(e,i){var n=e.getVerticalGridlines();if(null!=n&&n.removeChildren(),e.isVerticalGridlinesVisible()){null==n&&(n=new t.Container(e.getCtx()),i.addChild(n),e.setVerticalGridlines(n));var s=e.GetStyleClass("vgridline"),a=e.getMajorAxis();(null==a||e.getOptions().minorGridline)&&(a=e.getMinorAxis());for(var r=a.getElem().getElementsByTagName("line"),o=0;o<r.length;o++){var l=t.ToolkitUtils.getAttrNullNS(r[o],"x1"),h=new t.Line(e.getCtx(),l,e.getDatabodyStart(),l,e.getDatabodyStart()+e._canvasSize-e.getAxesHeight());h.setPixelHinting(!0),h.setClassName(s,!0),n.addChild(h)}}},g._renderReferenceObjects=function(e,i){var n=e.getCtx(),s=t.Agent.isRightToLeft(n),a=e.getStartTime(),r=e.getEndTime(),o=e.getContentLength(),l=e.getReferenceObjects(),h=e.getReferenceObjectsContainer(),g=e.getRenderedReferenceObjects();if(l){var d=[],p=Math.min(1,l.length);null==h&&(h=new t.Container(n),e.setReferenceObjectsContainer(h),g=[]),i.addChild(h);for(var u=0;u<p;u++){var _=l[u];if(_){var c=_.value,f=new Date(c).getTime();if(null!=c&&!isNaN(f)&&("number"==typeof c||"string"==typeof c)){var m=t.TimeAxis.getDatePosition(a,r,f,o);s&&(m=o-m);var T=g.pop();null!=T?(T.setX1(m),T.setY1(e.getDatabodyStart()),T.setX2(m),T.setY2(e.getDatabodyStart()+e._canvasSize-e.getAxesHeight())):(T=new t.Line(e.getCtx(),m,e.getDatabodyStart(),m,e.getDatabodyStart()+e._canvasSize-e.getAxesHeight())).setPixelHinting(!0),T.getParent()!=h&&h.addChild(T),d.push(T);var S=_.svgStyle;S&&("string"==typeof S||S instanceof String?t.ToolkitUtils.setAttrNullNS(T.getElem(),"style",S):T.setStyle(S));var y=e.GetStyleClass("referenceObject"),b=_.svgClassName;b=b?y+" "+b:y,T.setClassName(b,!0)}}}for(var v=0;v<g.length;v++){var A=g[v];A.getParent().removeChild(A)}e.setRenderedReferenceObjects(d)}else h&&h.removeChildren(),e.setRenderedReferenceObjects([])},g._renderRows=function(t,i,n){var s=t.getOptions(),a=s.rows,r=null!=a&&g._prerenderRows(a);if(t.isRowAxisEnabled())var o=t.getRowAxis().getRowLabelTexts();if(r&&0!=a.length){g._renderDatabody(t,i);var l=0,h=t.getDatabody(),d=0;if(t.isHorizontalGridlinesVisible()&&(d=e.getHorizontalGridlineWidth(s)),t.getCache().putToCache("baseTaskLabelCSSStyle",e.getTaskLabelStyle(s)),t.getRows()){for(p=g._generateRowNodes(t,i),u=0;u<p.length;u++){if((c=p[u]).setTop(l),o){f=o[u];n&&null!=c.getRowLabelText()&&n.removeChild(c.getRowLabelText()),c.setRowLabelText(f)}t.isDCAnimationEnabled?c.render(h,n,u):c.render(h,n),l=l+c.getRowHeight()+d}l-=d}else{for(var p=[],u=0;u<a.length;u++){var c=new _(t,a[u],u,l);if(o){var f=o[u];n&&null!=c.getRowLabelText()&&n.removeChild(c.getRowLabelText()),c.setRowLabelText(f)}c.render(h,n),p.push(c),l=l+c.getRowHeight()+d}l-=d}t.setRows(p),t.setContentHeight(l),h.setTranslateY(t.getBoundedContentTranslateY(h.getTranslateY()))}else g._renderEmptyText(t,!0)},g._prerenderRows=function(t){for(var e=0;e<t.length;e++){var i=t[e];if(null==i.id){var n=i.tasks;if(1!=n.length)return!1;i.id=n[0].id}}return!0},g._generateRowNodes=function(t){for(var e=t.getRows(),i=t.getRowsData(),n=[],s={},a={},r=0;r<e.length;r++){(A=e[r]).setRenderState("delete"),s[A.getId()]=A;for(var o=A.getTasks(),l=0;l<o.length;l++){(E=o[l]).setRenderState("delete"),E.isSelected()&&E.setSelected(!1),a[E.getProps().id]=[A.getId(),E]}}var h=t.getOptions().taskDefaults,g={};for(r=0;r<i.length;r++){var d=i[r],p=d.id,u=d.tasks,f=s[p];if(f){f.setRenderState("exist");for(l=0;l<u.length;l++){var m=(b=u[l]).id;if(f.isTaskVisible(b)){var T=f.mergeTaskDefaults(b,h);if(v=a[m]){var S=v[0],y=v[1];S===p?y.setRenderState("exist"):(y.setRenderState("migrate"),s[S].removeTask(y),f.addTask(y)),y.setProps(T),y.setRow(f)}else{(C=g[p])?C.push(T):g[p]=[T]}}}}else{(f=new _(t,d,r)).setRenderState("add");for(l=0;l<u.length;l++){var b;m=(b=u[l]).id;if(f.isTaskVisible(b)){var v;T=f.mergeTaskDefaults(b,h);if(v=a[m]){S=v[0];(y=v[1])&&(y.setRenderState("migrate"),s[S].removeTask(y))}else(y=new c(t,f,T)).setRenderState("add");f.addTask(y),y.setProps(T),y.setRow(f)}}}f.setIndex(r),f.setProps(d),n.push(f)}for(r=e.length-1;r>=0;r--){var A;if("delete"===(A=e[r]).getRenderState())A.remove();else{var C=g[A.getId()];for(l=(o=A.getTasks()).length-1;l>=0;l--){var E;if("delete"===(E=o[l]).getRenderState()){if(C&&C.length>0){var R=C.pop();E.setRenderState("refurbish"),E.setProps(R)}else A.removeTask(E);E.remove()}}if(C&&C.length>0)for(var D=0;D<C.length;D++)R=C[D],(y=new c(t,A,R)).setRenderState("add"),A.addTask(y)}}return n},g._renderDependencies=function(e,i){var n=e.getDependencyLines();null!=n&&null!=i&&n.removeChildren();var s=e.getOptions().dependencies;if(null!=s&&0!=s.length){null==n&&((n=new t.Container(e.getCtx())).setTranslateY(e.getDatabodyStart()),e.setDependencyLines(n),e.setDefaultMarkerId(g._createDefaultMarker(e))),i&&i.addChild(n);var a=new t.ClipPath;a.addRect(0,e.getDatabodyStart(),e.getContentLength(),e.getDatabodyHeight()),n.setClipPath(a),n.setTranslateY(e.getBoundedContentTranslateY(n.getTranslateY()));var o=n.getNumChildren();if(o>0)for(var l=0;l<o;l++){var h=n.getChildAt(l);h.render(n)}else for(l=0;l<s.length;l++)(h=new r(e,s[l])).render(n)}},g._createDefaultMarker=function(i){var n=i.getCtx(),s=t.SvgShapeUtils.getUniqueId("mrk"),a=t.SvgShapeUtils.createElement("marker",s);t.ToolkitUtils.setAttrNullNS(a,"class",i.GetStyleClass("dependencyLineConnector")),t.ToolkitUtils.setAttrNullNS(a,"markerUnits","userSpaceOnUse");var r=t.SvgShapeUtils.createElement("path"),o=e.getDependencyLineMarkerWidth(),l=e.getDependencyLineMarkerHeight();return t.ToolkitUtils.setAttrNullNS(a,"viewBox","0 0 "+o+" "+l),t.ToolkitUtils.setAttrNullNS(a,"refX",o),t.ToolkitUtils.setAttrNullNS(a,"refY",l/2),t.ToolkitUtils.setAttrNullNS(a,"markerWidth",o),t.ToolkitUtils.setAttrNullNS(a,"markerHeight",l),t.ToolkitUtils.setAttrNullNS(a,"orient","auto"),t.ToolkitUtils.setAttrNullNS(r,"d","M0,0L"+o+","+l/2+",0,"+l+"V0Z"),a.appendChild(r),n.appendDefs(a),s};var d=function(t){this.Init(t)};t.Obj.createSubclass(d,t.Container),d.prototype.Init=function(t){d.superclass.Init.call(this,t.getCtx()),this._gantt=t},d.prototype.getPreferredWidth=function(i){this._generateRowLabels();var n,s,a=this._gantt.getRowAxisMaxWidth(),r=this._gantt.getRowAxisWidth();return null!=a&&"none"!==a&&(n=Math.min(e.getSizeInPixels(a,i),i)),n=null==n||isNaN(n)?i:n,null!=r&&"auto"!==r&&(s=e.getSizeInPixels(this._gantt.getRowAxisWidth(),i)),s=null==s||isNaN(s)?t.TextUtils.getMaxTextDimensions(this._rowLabelTexts).w:s,Math.min(s,n)},d.prototype._generateRowLabels=function(){var i=this._gantt.getRowsData();this._rowLabelTexts=[];for(var n=this._gantt.getOptions(),s=e.getRowLabelStyle(n),a=0;a<i.length;a++){var r=i[a],o=null!=r.label?r.label:"";if(this._gantt.isRowAxisLabelsWrap())var l=new u(this._gantt.getCtx(),o,0,0);else l=new p(this._gantt.getCtx(),o,0,0);l.setRowIndex(a),l.setClassName(this._gantt.GetStyleClass("rowLabel"));var h=r.labelStyle;if(null!=h){var g=e.getRowLabelStyle(n);g.parseInlineStyle(h),"string"==typeof h||h instanceof String?t.ToolkitUtils.setAttrNullNS(l.getElem(),"style",h):l.setStyle(h),l.setCSSStyle(g)}else l.setCSSStyle(s);this._rowLabelTexts.push(l)}},d.prototype.getRowLabelTexts=function(){return this._rowLabelTexts};var p=function(t,e,i,n,s){this.Init(t,e,i,n,s)};t.Obj.createSubclass(p,t.OutputText),p.prototype.Init=function(t,e,i,n,s){p.superclass.Init.call(this,t,e,i,n,s)},p.prototype.getRow=function(){return this._rowNode},p.prototype.setRow=function(t){this._rowNode=t},p.prototype.getRowIndex=function(){return this._rowIndex},p.prototype.setRowIndex=function(t){this._rowIndex=t};var u=function(t,e,i,n,s){this.Init(t,e,i,n,s)};t.Obj.createSubclass(u,t.MultilineText),u.prototype.Init=function(t,e,i,n,s){u.superclass.Init.call(this,t,e,i,n,s)},u.prototype.getRow=function(){return this._rowNode},u.prototype.setRow=function(t){this._rowNode=t},u.prototype.getRowIndex=function(){return this._rowIndex},u.prototype.setRowIndex=function(t){this._rowIndex=t};var _=function(t,e,i,n){this.Init(t,e,i,n)};t.Obj.createSubclass(_,t.Container),_.prototype.Init=function(t,e,i,n){_.superclass.Init.call(this,t.getCtx(),null),this._gantt=t,this._props=e,this._index=i,this._top=n,this._rowHeight=0,this._renderState="add"},_.prototype.getGantt=function(){return this._gantt},_.prototype.getProps=function(){return this._props},_.prototype.setProps=function(t){this._props=t},_.prototype.getIndex=function(){return this._index},_.prototype.setIndex=function(t){this._index=t},_.prototype.getTop=function(){return this._top},_.prototype.setTop=function(t){this._top=t},_.prototype.getId=function(){return this._props.id},_.prototype.getRenderState=function(){return this._renderState},_.prototype.setRenderState=function(t){this._renderState=t},_.prototype.getLabel=function(){return this._props.label},_.prototype.setRowLabelText=function(t){this._rowLabelText=t},_.prototype.getRowLabelText=function(){return this._rowLabelText},_.prototype.isTaskVisible=function(t){var e=this._isElementVisible(t),i=this._isElementVisible(t.baseline);return e||i},_.prototype._isElementVisible=function(t){if(t){var e=typeof t.start,i=typeof t.end;if(!(null!=t.start&&"string"!==e&&"number"!==e||null!=t.end&&"string"!==i&&"number"!==i)&&(t.start=this._getDate(t.start),t.end=this._getDate(t.end),null!=t.start||null!=t.end)){var n=this._gantt.getStartTime(),s=this._gantt.getEndTime(),a=t.end?t.end:t.start,r=t.start;return!(a<n||r>s||s<n)}}return!1},_.prototype.mergeTaskDefaults=function(i,n){var s=i.baseline,a=i.progress;if(null==s&&(i.baseline=void 0),null==a&&(i.progress=void 0),s&&(null!=s.start||null!=s.end)){null==i.height&&n.height===e.getStandaloneTaskHeight()&&(i.height=e.getActualTaskHeight());var r=i.type?i.type:n.type;("milestone"===r||"auto"===r&&(s.start==s.end||null==s.start||null==s.end))&&null==s.height&&n.baseline.height===e.getBaselineTaskHeight()&&(s.height=e.getActualTaskHeight())}return t.JsonUtils.merge(i,n)},_.prototype.getTasks=function(){var t=this._props.tasks;if(null==t&&(this._tasks=[]),t&&null==this._tasks){this._tasks=[];for(var e=0;e<t.length;e++){var i=t[e];this.isTaskVisible(i)&&(i=this.mergeTaskDefaults(i,this._gantt.getOptions().taskDefaults),this._tasks.push(new c(this._gantt,this,i)))}this.sortTasks()}return this._tasks},_.prototype.addTask=function(t){null==this._tasks?this._tasks=[t]:this._tasks.push(t)},_.prototype.removeTask=function(t){if(null!=this._tasks){var e=this._tasks.indexOf(t);e>-1&&this._tasks.splice(e,1)}},_.prototype.sortTasks=function(){null!=this._tasks&&this._tasks.sort(function(t,e){var i=t.getProps(),n=e.getProps();return(i.start?i.start:i.end)-(n.start?n.start:n.end)})},_.prototype.assignRowLevel=function(t){var i,n,s,a,r,o,l,h,g,d=[],p=[],u=[];if(0==t.length)return[e.getStandaloneTaskHeight()+2*e.getTaskPadding()];for(s=0;s<t.length;s++){if(n=(i=t[s]).getFinalHeight()+2*e.getTaskPadding(),r=0,l=null,0===p.length)p.push(i),u.push(n);else{for(o=!0,a=0;a<p.length;a++){if(!i.overlaps(p[a])){l=p[a],p[a]=i,n>u[a]&&(u[a]=n),o=!1;break}r+=1}o&&(p.push(i),u.push(n))}i.setRowLevel(r),h=i.getPreviousAdjacentTaskNode(),g=i.getNextAdjacentTaskNode(),h&&h.setNextAdjacentTaskNode(null),g&&g.setPreviousAdjacentTaskNode(null),i.setPreviousAdjacentTaskNode(null),i.setNextAdjacentTaskNode(null),l&&(i.setPreviousAdjacentTaskNode(l),l.setNextAdjacentTaskNode(i))}for(i.setPrevAdjMilestoneBaselineTaskNode(null),i.setNextAdjMilestoneBaselineTaskNode(null),a=0;a<p.length;a++)d.push([]);for(s=0;s<t.length;s++)(i=t[s]).getTask().isMilestone("baseline")&&d[i.getRowLevel()].push(i);for(a=0;a<p.length;a++)d[a].sort(function(t,e){var i=t.getProps().baseline,n=e.getProps().baseline,s=i.start?i.start:i.end;return(n.start?n.start:n.end)-s});for(s=0;s<t.length;s++){var _=d[(i=t[s]).getRowLevel()],c=_.length;if(c>0){var f=_[c-1],m=f.getProps().baseline,T=m.start?m.start:m.end,S=i.getProps(),y=S.start?S.start:S.end,b=S.end?S.end:S.start;T<y?(i.setPrevAdjMilestoneBaselineTaskNode(f),_.pop()):T>b&&null==i.getNextAdjMilestoneBaselineTaskNode()?i.setNextAdjMilestoneBaselineTaskNode(f):T!=y&&T!=b||_.pop()}}return u.reduce(function(t,e,i){return t.push((t[i-1]||0)+e),t},[])},_.prototype.render=function(t,i,n){this.sortTasks();for(var s=this.getTasks(),a=this.assignRowLevel(s),r=0;r<s.length;r++){var o=s[r],l=o.getProps(),h=(_=o.getTask()).getTimeSpanDimensions(l.start,l.end);h||(h=_.getTimeSpanDimensions(l.baseline.start,l.baseline.end));var g=h.startPos,d=0;o.getRowLevel()>0&&(d=a[o.getRowLevel()-1]),o.setFinalY(d+this.getTop()+e.getTaskPadding()),o.setFinalX(g),o.render(this)}for(var p=0;p<s.length;p++){var u=(o=s[p]).getTaskLabel(),_=o.getTask();u.setAssociatedShape(_.getShape("main")),u.render()}this.setRowHeight(a[a.length-1]),this._renderRowLabel(this._gantt,this.getRowLabelText(),i),this.getParent()!=t&&(null!=n?t.addChildAt(this,n):t.addChild(this)),this._renderHorizontalGridline(this._gantt,this,this)},_.prototype._renderRowLabel=function(e,i,n){var s,a,r,o,l,h=t.Agent.isRightToLeft(e.getCtx());e.isRowAxisEnabled()&&n&&(h||i.alignRight(),i.isTruncated()&&i.setTextString(i.getUntruncatedTextString()),a=t.TextUtils.fitText(i,e._rowAxisPreferredWidth,this.getRowHeight(),n,1),o=(this.getTop()+(this.getTop()+this.getRowHeight())-i.getDimensions().h)/2,r=h?0:e._rowAxisPreferredWidth,s={textString:i.getTextString(),x:r,y:o},i.getTextString().length>0&&a&&(e.getEventManager().associate(i,i),i.setRow(this),(l=this.getLabelState())&&(i.setY(l.y),i.setX(l.x)),this.recordLabelState(s),this._gantt.getAnimationManager().preAnimateRowLabel(this,i,s),n.addChild(i)))},_.prototype._renderHorizontalGridline=function(i,n,s){var a,r,o,l,h="exist",g=i.GetStyleClass("hgridline"),d=e.getHorizontalGridlineWidth(i.getOptions())%2*.5;i.isHorizontalGridlinesVisible()?(o=r=s.getTop()+s.getRowHeight()+d,0,a=i.getContentLength(),this._horizontalLine||(this._horizontalLine=new t.Line(i.getCtx(),0,r,a,o),this._horizontalLine.setPixelHinting(!0),this._horizontalLine.setClassName(g,!0),n.addChild(this._horizontalLine),h="add"),l={x1:0,x2:a,y1:r,y2:o},this._gantt.getAnimationManager().preAnimateHorizontalGridline(this._horizontalLine,l,h)):(this._horizontalLine&&n.removeChild(this._horizontalLine),this._horizontalLine=null)},_.prototype.recordLabelState=function(t){this._rowLabelState=t},_.prototype.getLabelState=function(){return this._rowLabelState},_.prototype.remove=function(){var t,e=this;t=function(){var t=e.getParent();t&&t.removeChild(e)},this._gantt.getAnimationManager().preAnimateRowNodeRemove(this,t),this._removeRowLabel()},_.prototype._removeRowLabel=function(){var t,e=this.getRowLabelText();e&&(t=function(){e.getParent()&&e.getParent().removeChild(e)},this._gantt.getAnimationManager().preAnimateRowLabelRemove(e,t))},_.prototype.getRowHeight=function(){return this._rowHeight},_.prototype.setRowHeight=function(t){this._rowHeight=t},_.prototype._getDate=function(t){return null==t?null:t.getTime?t.getTime():isNaN(t)?new Date(t).getTime():t};var c=function(t,e,i){this.Init(t,e,i)};t.Obj.createSubclass(c,t.Container),c.prototype.Init=function(t,e,i){c.superclass.Init.call(this,t.getCtx(),null),this._gantt=t,this._row=e,this._props=i,this._renderState="add",this._task=new f(t,this),this._taskLabel=new m(t,this),this._gantt.getEventManager().associate(this,this)},c.prototype.getProps=function(){return this._props},c.prototype.setProps=function(t){this._props=t},c.prototype.getId=function(){return this._props.id},c.prototype.getActiveElementId=function(){return null},c.prototype.getRow=function(){return this._row},c.prototype.setRow=function(t){this._row=t},c.prototype.getGantt=function(){return this._gantt},c.prototype.getRenderState=function(){return this._renderState},c.prototype.setRenderState=function(t){this._renderState=t},c.prototype.getRowLevel=function(){return this._rowLevel},c.prototype.setRowLevel=function(t){this._rowLevel=t},c.prototype.getPreviousAdjacentTaskNode=function(){return this._previousAdjacentTaskNode},c.prototype.setPreviousAdjacentTaskNode=function(t){this._previousAdjacentTaskNode=t},c.prototype.getNextAdjacentTaskNode=function(){return this._nextAdjacentTaskNode},c.prototype.setNextAdjacentTaskNode=function(t){this._nextAdjacentTaskNode=t},c.prototype.getPrevAdjMilestoneBaselineTaskNode=function(){return this._previousAdjacentMilestoneBaselineTaskNode},c.prototype.setPrevAdjMilestoneBaselineTaskNode=function(t){this._previousAdjacentMilestoneBaselineTaskNode=t},c.prototype.getNextAdjMilestoneBaselineTaskNode=function(){return this._nextAdjacentMilestoneBaselineTaskNode},c.prototype.setNextAdjMilestoneBaselineTaskNode=function(t){this._nextAdjacentMilestoneBaselineTaskNode=t},c.prototype.overlaps=function(t){var e=this.getOverallStartTime(),i=this.getOverallEndTime(),n=t.getOverallStartTime();return e<t.getOverallEndTime()&&n<i},c.prototype.getOverallStartTime=function(){var t=this._props.start?this._props.start:this._props.end,e=null;return this._props.baseline&&(e=this._props.baseline.start?this._props.baseline.start:this._props.baseline.end),null==t?e:null==e?t:Math.min(t,e)},c.prototype.getOverallEndTime=function(){var t=this._props.end?this._props.end:this._props.start,e=null;return this._props.baseline&&(e=this._props.baseline.end?this._props.baseline.end:this._props.baseline.start),null==t?e:null==e?t:Math.max(t,e)},c.prototype.getTaskShapePhysicalBounds=function(i,n){var s=t.Agent.isRightToLeft(this._gantt.getCtx())?-1:1,a=this._task.getShape(i),r=a.getFinalX()+this.getFinalX(),o=a.getFinalWidth()+a.getPhysicalEndOffset(),l=r-s*a.getPhysicalStartOffset(),h=r+s*o;if(n){var g=this._taskLabel.getLabelOutputText();if(g&&null!=g.getParent()){var d=this._taskLabel.getEffectiveLabelPosition();"end"===d?h+=s*(e.getTaskLabelPadding()+g.getDimensions().w):"start"===d&&(l-=s*(e.getTaskLabelPadding()+g.getDimensions().w))}}return{startPos:l,endPos:h}},c.prototype.getTask=function(){return this._task},c.prototype.getTaskLabel=function(){return this._taskLabel},c.prototype.render=function(e){var i;this.getParent()!=e&&e.addChild(this),this.setAriaRole("img"),t.TimeAxis.supportsTouch()&&this.refreshAriaLabel(),this._task.render(),i={x:this._finalX,y:this._finalY},this._gantt.getAnimationManager().preAnimateTaskNode(this,i)},c.prototype.remove=function(){var t,e=this;t=function(){"delete"===e.getRenderState()&&e._row.removeChild(e)},this._gantt.getAnimationManager().preAnimateTaskNodeRemove(this,t)},c.prototype.addPredecessorDependency=function(t){null==this._predecessors&&(this._predecessors=[]),this._predecessors.push(t)},c.prototype.getPredecessorDependencies=function(){return this._predecessors},c.prototype.addSuccessorDependency=function(t){null==this._successors&&(this._successors=[]),this._successors.push(t)},c.prototype.getSuccessorDependencies=function(){return this._successors},c.prototype.getFinalX=function(){return this._finalX},c.prototype.setFinalX=function(t){this._finalX=t},c.prototype.getFinalY=function(){return this._finalY},c.prototype.setFinalY=function(t){this._finalY=t},c.prototype.getFinalHeight=function(t){return this._task.getFinalHeight(t)},c.prototype.getDuration=function(e,i){var n=this._gantt.getOptions(),s=i-e,a=this._gantt.getMinorAxis().getScale();return"hours"==a||"minutes"==a||"seconds"==a?(s=Math.round(s/36e5*100)/100,t.Bundle.getTranslation(n,"accessibleDurationHours",t.Bundle.UTIL_PREFIX,"DURATION_HOURS",[s])):(s=Math.round(s/864e5*100)/100,t.Bundle.getTranslation(n,"accessibleDurationDays",t.Bundle.UTIL_PREFIX,"DURATION_DAYS",[s]))},c.prototype.getAriaLabel=function(){var e=[],n=this._gantt.getOptions();this.isSelectable()&&e.push(t.Bundle.getTranslation(n,this.isSelected()?"stateSelected":"stateUnselected",t.Bundle.UTIL_PREFIX,this.isSelected()?"STATE_SELECTED":"STATE_UNSELECTED"));var s=i.getDatatip(this,!1,!0);if(this._task.isMilestone("main")?s=t.Bundle.getTranslation(n,"accessibleTaskTypeMilestone")+", "+s:this._task.isSummary("main")&&(s=t.Bundle.getTranslation(n,"accessibleTaskTypeSummary")+", "+s),null!=this._predecessors||null!=this._successors){var a="";if(null!=this._predecessors&&this._predecessors.length>0&&(a=t.Bundle.getTranslation(n,"accessiblePredecessorInfo",t.Bundle.UTIL_PREFIX,"PREDECESSOR_INFO",[this._predecessors.length]),t.TimeAxis.supportsTouch()))for(var r=0;r<this._predecessors.length;r++)a=a+", "+this._predecessors[r].getAriaLabel();if(null!=this._successors&&this._successors.length>0&&(a.length>0&&(a+=", "),a+=t.Bundle.getTranslation(n,"accessibleSuccessorInfo",t.Bundle.UTIL_PREFIX,"SUCCESSOR_INFO",[this._successors.length]),t.TimeAxis.supportsTouch()))for(r=0;r<this._successors.length;r++)a=a+", "+this._successors[r].getAriaLabel();a.length>0&&(s=s+", "+a)}var o=t.Displayable.generateAriaLabel(s,e),l=this.getAriaProperty("label");return null!=l&&l.indexOf(o)>-1?null:o},c.prototype.refreshAriaLabel=function(){this._updateAriaLabel()},c.prototype._updateAriaLabel=function(){this.setAriaProperty("label",this.getAriaLabel()),this.applyAriaProperties()},c.prototype.getDatatip=function(){return i.getDatatip(this,!0)},c.prototype.getDatatipColor=function(){return i.getDatatipColor(this)},c.prototype.isSelectable=function(){return"none"!=this._gantt.getOptions().selectionMode},c.prototype.isSelected=function(){return this._selected},c.prototype.setSelected=function(t){this._selected=t,this._selected?this._task.showEffect("selected"):this._task.removeEffect("selected"),this._updateAriaLabel(),this._gantt.setCurrentRow(this.getRow().getId())},c.prototype.showHoverEffect=function(){this._task.showEffect("hover")},c.prototype.hideHoverEffect=function(){this._task.removeEffect("hover")},c.prototype.getNextNavigable=function(e){var i=null,n=this._gantt.getEventManager().getKeyboardHandler();if(e.type==t.MouseEvent.CLICK||n.isMultiSelectEvent(e))i=this;else if((e.keyCode==t.KeyboardEvent.OPEN_ANGLED_BRACKET||t.KeyboardEvent.CLOSE_ANGLED_BRACKET)&&e.altKey){if((n=this._gantt.getEventManager().getKeyboardHandler())&&n.getFirstNavigableDependencyLine){if(t.Agent.isRightToLeft(this.getGantt().getCtx()))var s=e.keyCode==t.KeyboardEvent.CLOSE_ANGLED_BRACKET?"predecessor":"successor";else s=e.keyCode==t.KeyboardEvent.OPEN_ANGLED_BRACKET?"predecessor":"successor";var a=this._gantt.getNavigableDependencyLinesForTask(this,s);i=n.getFirstNavigableDependencyLine(this,e,a)}i?i.setKeyboardFocusTask(this):i=this}else n.isNavigationEvent(e)&&(i=l.getNextNavigable(this._gantt,this,e));return i},c.prototype.getTargetElem=function(){return this._task.getShape("main").getElem()},c.prototype.getKeyboardBoundingBox=function(t){return this.getDimensions(t)},c.prototype.showKeyboardFocusEffect=function(){this._isShowingKeyboardFocusEffect=!0,this._task.showEffect("focus")},c.prototype.hideKeyboardFocusEffect=function(){this.isShowingKeyboardFocusEffect()&&(this._isShowingKeyboardFocusEffect=!1,this.hideHoverEffect())},c.prototype.isShowingKeyboardFocusEffect=function(){return this._isShowingKeyboardFocusEffect};var f=function(t,e){this.Init(t,e)};t.Obj.createSubclass(f,t.Obj),f.prototype.Init=function(t,e){this._gantt=t,this._container=e},f.prototype.getGantt=function(){return this._gantt},f.prototype.getShape=function(t){return"main"===t?this._mainShape:"progress"===t?this._progressShape:"baseline"===t?this._baselineShape:void 0},f.prototype.getSvgStyle=function(t){return t.svgStyle?t.svgStyle:t.style},f.prototype.getSvgClassName=function(t){return t.svgClassName?t.svgClassName:t.className},f.prototype._applyStyles=function(e,i){var n=this.getSvgClassName(i),s=this.getSvgStyle(i);n&&e.setClassName(e.getClassName()+" "+n),"string"==typeof s?t.ToolkitUtils.setAttrNullNS(e.getElem(),"style",s):e.setStyle(s)},f.prototype.isMilestone=function(t){var e,i,n=this._container.getProps(),s=n.baseline;return"milestone"===n.type||"auto"===n.type&&(T.MAIN_TYPES.indexOf(t)>-1?(e=n.start,i=n.end):T.BASELINE_TYPES.indexOf(t)>-1&&(e=s.start,i=s.end),null!=e&&e==i||null!=e&&null==i||null==e&&null!=i)},f.prototype.isSummary=function(t){var e=this._container.getProps();return"main"===t&&"summary"===e.type},f.prototype.getTimeSpanDimensions=function(e,i){var n,s,a=this._gantt.getStartTime(),r=this._gantt.getEndTime(),o=this._gantt.getContentLength(),l=t.Agent.isRightToLeft(this._gantt.getCtx());return null!=e||null!=i?(null==e?e=i:null==i&&(i=e),n=t.TimeAxis.getDatePosition(a,r,e,o),s=t.TimeAxis.getDatePosition(a,r,i,o),l&&(n=o-n,s=o-s),{startPos:n,endPos:s,distance:s-n}):null},f.prototype.getFillColor=function(){if(null==this._fillColor){if(null==this._mainShape)return null;this._fillColor=this._mainShape.getFillColor()}return this._fillColor},f.prototype.getFinalHeight=function(t){var i=this._container.getProps(),n=i.baseline,s=i.height,a=0;!n||null==n.start&&null==n.end||(a=n.height);var r=this.isMilestone("baseline")?e.getMilestoneBaselineYOffset()+Math.max(a,s):s+a;if(!t){var o=null!==this.getProgressValue()?this.getProgressHeight():0;if(s<o)return Math.max(o,(o-s)/2+r)}return r},f.prototype.showEffect=function(t){this.showMainEffect(t)},f.prototype.removeEffect=function(t){this.removeMainEffect(t)},f.prototype.render=function(){var t=null!==this.getProgressValue()?this.getProgressHeight():0;this.renderBaseline(t),this.renderMain(t),this.renderProgress(t),"summary"===this._container.getProps().type&&this._mainShape&&this._container.addChild(this._mainShape)},f.prototype.getRenderState=function(t){return"main"===t?this._mainShape.getRenderState():"progress"===t?this._progressShape.getRenderState():"baseline"===t?this._baselineShape.getRenderState():void 0},f.prototype.renderBaseline=function(t){var i,n,s,a,r,o,l,h,g,d,p,u=this._container.getProps(),_=u.baseline,c=this;_&&(o=this.getTimeSpanDimensions(_.start,"milestone"===u.type&&null!=_.start&&_.start!=_.end?_.start:_.end))?(a=this.getTimeSpanDimensions(u.start?u.start:u.end,_.start),i=this.isMilestone("baseline"),l=a?a.distance:0,g=Math.abs(o.distance),d=_.height,n=i?Math.max(u.height,d)+e.getMilestoneBaselineYOffset()-d:u.height,h=Math.max(0,(t-u.height)/2)+n,p=_.borderRadius,null==this._baselineShape?(this._baselineShape=new T(this._gantt.getCtx(),l,h,g,d,p,this,"baseline"),i?this._container.addChildAt(this._baselineShape,0):this._container.addChild(this._baselineShape),this._baselineShape.setRenderState("add")):(this._baselineShape.setRenderState("refurbish"===this._container.getRenderState()?"add":"exist"),i&&this._container.addChildAt(this._baselineShape,0)),this._baselineShape.setFinalWidth(g),this._baselineShape.setFinalHeight(d),this._baselineShape.setFinalX(l),this._baselineShape.setFinalY(h),r=function(){c._applyStyles(c._baselineShape,_)},s={x:l,y:h,w:g,h:d,r:p},this._gantt.getAnimationManager().preAnimateTaskBaseline(this,this._baselineShape,s,r)):this.removeBaseline()},f.prototype.removeBaseline=function(){var t,e=this;this._baselineShape&&(t=function(){e._container.removeChild(e._baselineShape),e._baselineShape=null},this._gantt.getAnimationManager().preAnimateTaskBaselineRemove(this._baselineShape,t))},f.prototype.renderMain=function(t){var e,i,n,s,a,r,o,l=this._container.getProps(),h=l.height,g=this;l&&(n=this.getTimeSpanDimensions(l.start,"milestone"===l.type&&null!=l.start&&l.start!=l.end?l.start:l.end))?(0,s=Math.max(0,(t-h)/2),a=Math.abs(n.distance),r=this.isSummary("main")?this._container.getFinalHeight(!0):h,o=l.borderRadius,null==this._mainShape?(this._mainShape=new T(this._gantt.getCtx(),0,s,a,r,o,this,"main"),this._container.addChild(this._mainShape),this._mainShape.setRenderState("add")):this._mainShape.setRenderState("refurbish"===this._container.getRenderState()?"add":"exist"),this._mainShape.setFinalWidth(a),this._mainShape.setFinalHeight(r),this._mainShape.setFinalX(0),this._mainShape.setFinalY(s),i=function(){g._fillColor=null,g._applyStyles(g._mainShape,l)},e={x:0,y:s,w:a,h:r,r:o},this._gantt.getAnimationManager().preAnimateTaskMain(this,e,i)):this.removeMain()},f.prototype.showMainEffect=function(t){var e=this._mainShape.getX(),i=this._mainShape.getY(),n=this._mainShape.getWidth(),s=this._mainShape.getHeight(),a=this._mainShape.getBorderRadius();"selected"===t?null==this._mainSelectShape&&(this._mainSelectShape=new T(this._gantt.getCtx(),e,i,n,s,a,this,"mainSelect"),this._container.addChildAt(this._mainSelectShape,0),this._container.getParent().addChild(this._container)):"hover"!==t&&"focus"!==t||null==this._mainHoverShape&&(this._mainHoverShape=new T(this._gantt.getCtx(),e,i,n,s,a,this,"mainHover"),this._container.addChildAt(this._mainHoverShape,this._container.getChildIndex(this._mainShape)),this._container.getParent().addChild(this._container))},f.prototype.removeMainEffect=function(t){"selected"===t?(null!=this._mainSelectShape&&this._container.removeChild(this._mainSelectShape),this._mainSelectShape=null):"hover"!==t&&"focus"!==t||(null!=this._mainHoverShape&&(this._container.removeChild(this._mainHoverShape),this._container.isSelected()||this._container.getParent().addChildAt(this._container,0)),this._mainHoverShape=null)},f.prototype.getMainWidth=function(){return this._mainShape.getWidth()},f.prototype.setMainWidth=function(t){this._mainShape.setWidth(t),this._mainSelectShape&&this._mainSelectShape.setWidth(t),this._mainHoverShape&&this._mainHoverShape.setWidth(t)},f.prototype.getMainHeight=function(){return this._mainShape.getHeight()},f.prototype.setMainHeight=function(t){this._mainShape.setHeight(t),this._mainSelectShape&&this._mainSelectShape.setHeight(t),this._mainHoverShape&&this._mainHoverShape.setHeight(t)},f.prototype.getMainX=function(){return this._mainShape.getX()},f.prototype.setMainX=function(t){this._mainShape.setX(t),this._mainSelectShape&&this._mainSelectShape.setX(t),this._mainHoverShape&&this._mainHoverShape.setX(t)},f.prototype.getMainY=function(){return this._mainShape.getY()},f.prototype.setMainY=function(t){this._mainShape.setY(t),this._mainSelectShape&&this._mainSelectShape.setY(t),this._mainHoverShape&&this._mainHoverShape.setY(t)},f.prototype.getMainBorderRadius=function(){return this._mainShape.getY()},f.prototype.setMainBorderRadius=function(t){this._mainShape.setBorderRadius(t),this._mainSelectShape&&this._mainSelectShape.setBorderRadius(t),this._mainHoverShape&&this._mainHoverShape.setBorderRadius(t)},f.prototype.setMainDimensions=function(t,e,i,n,s){this._mainShape.setDimensions(t,e,i,n,s),this._mainSelectShape&&this._mainSelectShape.setDimensions(t,e,i,n,s),this._mainHoverShape&&this._mainHoverShape.setDimensions(t,e,i,n,s)},f.prototype.removeMain=function(){var t,e=this;this._mainShape&&(t=function(){e.removeMainEffect("selected"),e._container.removeChild(e._mainShape),e._mainShape=null,e.removeProgress()},this._gantt.getAnimationManager().preAnimateTaskMainRemove(this._mainShape,this._mainSelectShape,this._mainHoverShape,t))},f.prototype.getProgressValue=function(){var t=this._container.getProps().progress;return!this.isMilestone("main")&&t&&"number"==typeof t.value?t.value:null},f.prototype.getProgressHeight=function(){var t,i,n=this._container.getProps(),s=n.progress;return s&&!this.isMilestone("main")?(t=s.height,i=n.height,"100%"===t?i:e.getSizeInPixels(t,i)):0},f.prototype.renderProgress=function(t){var e,i,n,s,a,r=this._container.getProps(),o=r.progress,l=r.height,h=this.getProgressValue(),g=this;null!==h&&this._mainShape&&!this.isMilestone("main")?(0,n=Math.max(0,(l-t)/2),s=h*this._mainShape.getFinalWidth(),a=o.borderRadius,null==this._progressShape?(this._progressShape=new T(this._gantt.getCtx(),0,n,s,t,a,this,"progress"),this._container.addChild(this._progressShape),this._progressShape.setRenderState("add")):this._progressShape.setRenderState("refurbish"===this._container.getRenderState()?"add":"exist"),this._progressShape.setFinalWidth(s),this._progressShape.setFinalHeight(t),this._progressShape.setFinalX(0),this._progressShape.setFinalY(n),e=function(){g._applyStyles(g._progressShape,o)},i={x:0,y:n,w:s,h:t,r:a},this._gantt.getAnimationManager().preAnimateTaskProgress(this,this._progressShape,i,e)):this.removeProgress()},f.prototype.removeProgress=function(){var t,e=this;this._progressShape&&(t=function(){e._container.removeChild(e._progressShape),e._progressShape=null},this._gantt.getAnimationManager().preAnimateTaskProgressRemove(this._progressShape,t))};var m=function(t,e,i){this.Init(t,e,i)};t.Obj.createSubclass(m,t.Obj),m.prototype.Init=function(t,e,i){this._gantt=t,this._container=e,this._associatedShape=i,this._renderState="add"},m.prototype.getGantt=function(){return this._gantt},m.prototype.getAssociatedShape=function(){return this._associatedShape},m.prototype.setAssociatedShape=function(t){this._associatedShape=t},m.prototype.getLabelOutputText=function(){return this._labelOutputText},m.prototype.getEffectiveLabelPosition=function(){return this._effectiveLabelPosition},m.prototype.getRenderState=function(){return this._renderState},m.prototype._applyStyles=function(i){var n;null!=i?((n=e.getTaskLabelStyle(this._gantt.getOptions())).parseInlineStyle(i),"string"==typeof i?t.ToolkitUtils.setAttrNullNS(this._labelOutputText.getElem(),"style",i):this._labelOutputText.setStyle(i)):n=this._gantt.getCache().getFromCache("baseTaskLabelCSSStyle"),this._labelOutputText.setCSSStyle(n)},m.prototype._placeLabel=function(i){var n,s,a,r,o,l,h=this._labelOutputText.getDimensions(),g=t.Agent.isRightToLeft(this._gantt.getCtx()),d=e.getTaskLabelPadding();switch("progress"!==i&&"progressStart"!==i||this.setAssociatedShape(this._container.getTask().getShape("progress")),l="main"===this._associatedShape.getType()&&this._container.getTask().isSummary("main")?this._container.getProps().height:this._associatedShape.getFinalHeight(),o=this._associatedShape.getFinalY()+(l-h.h)/2,this.setFinalY(o),a=this._associatedShape.getFinalWidth(),n=g?this._associatedShape.getPhysicalEndOffset():this._associatedShape.getPhysicalStartOffset(),s=g?this._associatedShape.getPhysicalStartOffset():this._associatedShape.getPhysicalEndOffset(),i){case"end":g?this._labelOutputText.alignRight():this._labelOutputText.alignLeft(),r=a+s+d;break;case"progress":g?this._labelOutputText.alignLeft():this._labelOutputText.alignRight(),r=a-d;break;case"oProgress":g?this._labelOutputText.alignRight():this._labelOutputText.alignLeft(),r=this._container.getTask().getShape("progress").getFinalWidth()+d;break;case"innerStart":case"progressStart":g?this._labelOutputText.alignRight():this._labelOutputText.alignLeft(),r=-n+d;break;case"innerEnd":g?this._labelOutputText.alignLeft():this._labelOutputText.alignRight(),r=a+s-d;break;case"innerCenter":this._labelOutputText.alignCenter(),r=a/2;break;case"start":g?this._labelOutputText.alignLeft():this._labelOutputText.alignRight(),r=-(n+d)}g&&(r=-r),this.setFinalX(r),this._effectiveLabelPosition=i},m.prototype._getAvailableWidth=function(i){var n,s,a,r,o,l,h,g,d,p,u,_,c,f,m,T,S,y,b,v,A=e.getTaskLabelPadding(),C=t.Agent.isRightToLeft(this._gantt.getCtx()),E=this._gantt.getContentLength();switch(v=E-(b=C?E:0),i){case"end":s=v,r=this._container.getNextAdjacentTaskNode(),l=this._container.getNextAdjMilestoneBaselineTaskNode(),r&&(s=r.getTaskShapePhysicalBounds("main").startPos),l&&(s=C?Math.max(s,l.getTaskShapePhysicalBounds("baseline").startPos):Math.min(s,l.getTaskShapePhysicalBounds("baseline").startPos)),f=Math.abs(this._container.getTaskShapePhysicalBounds("main").endPos-s)-2*A,m="end";break;case"innerCenter":case"innerStart":case"innerEnd":if(y="number"==typeof((S=this._container.getProps()).progress?S.progress.value:null),!(o=this._container.getTask()).isMilestone("main")){if(g=this._container.getTaskShapePhysicalBounds("main"),_=Math.abs(g.endPos-g.startPos),y){if(T=this._labelOutputText.getDimensions(),(d=o.getShape("progress"))?(p=d.getFinalWidth(),u=d.getFinalHeight()):(p=0,u=0),c=_-p,"innerStart"===i){if(f=p-2*A,T.w<=f&&T.h<=u){m="progressStart";break}}else if("innerEnd"===i&&(f=c-2*A,T.w<f)){m="innerEnd";break}T.h<=u&&p>c?(f=p-2*A,m="progress"):(f=c-2*A,m="oProgress");break}f=_-2*A,m=i;break}f=0,m=i;break;case"start":n=b,a=this._container.getPreviousAdjacentTaskNode(),h=this._container.getPrevAdjMilestoneBaselineTaskNode(),a&&(n=a.getTaskShapePhysicalBounds("main",!0).endPos),h&&(n=C?Math.min(n,h.getTaskShapePhysicalBounds("baseline").endPos):Math.max(n,h.getTaskShapePhysicalBounds("baseline").endPos)),f=Math.abs(n-this._container.getTaskShapePhysicalBounds("main").startPos)-2*A,m="start";break;default:return null}return[m,f]},m.prototype._preprocessLabelPosition=function(t){var e=this._container.getTask().isMilestone("main");if("string"==typeof t){if(e)switch(t){case"innerCenter":case"innerEnd":t="end";break;case"innerStart":t="start"}return[t]}return Array.isArray(t)?e?t.map(function(t){switch(t){case"innerCenter":case"innerEnd":return"end";case"innerStart":return"start";default:return t}}):t:[]},m.prototype._evaluatePosition=function(e){for(var i,n,s,a={},r=this._labelOutputText.getDimensions(),o=r.w,l=(r.h,e=this._preprocessLabelPosition(e),0),h=0;h<e.length;h++){var g=e[h];if("max"!==g){if(a[g]?d=a[g]:(d=this._getAvailableWidth(g),a[g]=d),d){if(i=d[0],o<=(n=d[1]))break;n>l&&(l=n,s=g)}}else if(null!=s){var d=a[s];i=d[0],n=d[1];break}}return null!=i&&(o>n&&t.TextUtils.fitText(this._labelOutputText,n,1/0,this._container,1),this._placeLabel(i),!0)},m.prototype.render=function(){var e,i,n,s,a,r=this._container.getProps(),o=this;this._renderState="refurbish"===this._container.getRenderState()?"add":"exist",r&&(e=r.label,i=r.labelPosition,n=r.labelStyle),null!=e&&e.length>0&&"none"!==i&&this._associatedShape?(null==this._labelOutputText&&(this._labelOutputText=new t.OutputText(this._gantt.getCtx(),e,0,0),this._labelOutputText.setClassName(this._gantt.GetStyleClass("taskLabel")),this._renderState="add"),null==this._labelOutputText.getParent()&&this._container.addChild(this._labelOutputText),this._labelOutputText.setTextString(e),this._applyStyles(n),this._evaluatePosition(i)?(a=function(){var e,i;switch(o._effectiveLabelPosition){case"innerCenter":case"innerEnd":case"innerStart":case"progressStart":case"progress":case"oProgress":i=o._associatedShape.getFillColor(),null!=(e=t.ColorUtils.getContrastingTextColor(i?i.computedFill:null))&&o._labelOutputText.setFill(new t.SolidFill(e))}},s={x:this.getFinalX(),y:this.getFinalY()},this._gantt.getAnimationManager().preAnimateTaskLabel(this._container,s,a)):this.remove()):this.remove()},m.prototype.remove=function(){var t,e=this;this._labelOutputText&&(t=function(){e._container.removeChild(e._labelOutputText),e._labelOutputText=null,e._effectiveLabelPosition=null},this._gantt.getAnimationManager().preAnimateTaskLabelRemove(this._labelOutputText,t))},m.prototype.getFinalX=function(){return this._finalX},m.prototype.setFinalX=function(t){this._finalX=t},m.prototype.getFinalY=function(){return this._finalY},m.prototype.setFinalY=function(t){this._finalY=t};var T=function(t,e,i,n,s,a,r,o,l){this.Init(t,e,i,n,s,a,r,o,l)};t.Obj.createSubclass(T,t.Path),T.MAIN_TYPES=["main","mainSelect","mainHover"],T.MAIN_EFFECT_TYPES=["mainSelect","mainHover"],T.BASELINE_TYPES=["baseline","baselineSelect","baselineHover"],T.BASELINE_EFFECT_TYPES=["baselineSelect","baselineHover"],T.prototype.Init=function(e,i,n,s,a,r,o,l,h){var g;switch(this._x=i,this._y=n,this._w=s,this._h=a,this._r=null!=r?r:"0",this._task=o,this._type=l,this._renderState="add",this._typeCmdGeneratorMap={main:this._generateRepShapeCmd,mainSelect:this._generateRepShapeCmd,mainHover:this._generateRepShapeCmd,progress:this._generateRectCmd,baseline:this._generateRepShapeCmd,baselineSelect:this._generateRepShapeCmd,baselineHover:this._generateRepShapeCmd},this._isRTL=t.Agent.isRightToLeft(e),g=this._typeCmdGeneratorMap[this._type].call(this,this._x,this._y,this._w,this._h,this._r),T.superclass.Init.call(this,e,g,h),this._applyDefaultStyleClasses(),this._type){case"main":case"progress":case"baseline":this.setPixelHinting(!0)}},T.prototype._generateRepShapeCmd=function(t,i,n,s,a){var r,o=(T.MAIN_EFFECT_TYPES.indexOf(this._type)>-1||T.BASELINE_EFFECT_TYPES.indexOf(this._type)>-1)*e.getTaskEffectMargin();return this._task.isMilestone(this._type)&&0==n?(r=o*Math.sqrt(2),this._generateDiamondCmd(t,i-r,s+2*r,a)):this._task.isSummary(this._type)&&"main"===this._type?this._generateSummaryCmd(t,i,n,s,a):this._generateRectCmd(this._isRTL?t+o:t-o,i-o,n+2*o,s+2*o,a)},T.prototype._generateRectCmd=function(e,i,n,s,a){return"0"===a||"0px"===a?t.PathUtils.moveTo(e,i)+t.PathUtils.horizontalLineTo(this._isRTL?e-n:e+n)+t.PathUtils.verticalLineTo(i+s)+t.PathUtils.horizontalLineTo(e)+t.PathUtils.closePath():t.PathUtils.rectangleWithBorderRadius(e-this._isRTL*n,i,n,s,a,Math.min(n,s),"0")},T.prototype._generateSummaryCmd=function(i,n,s,a,r){var o=e.getSummaryThickness();if("0"===r||"0px"===r)return s>2*o?t.PathUtils.moveTo(i,n+a)+t.PathUtils.verticalLineTo(n)+t.PathUtils.horizontalLineTo(this._isRTL?i-s:i+s)+t.PathUtils.verticalLineTo(n+a)+t.PathUtils.horizontalLineTo(this._isRTL?i-s+o:i+s-o)+t.PathUtils.verticalLineTo(n+o)+t.PathUtils.horizontalLineTo(this._isRTL?i-o:i+o)+t.PathUtils.verticalLineTo(n+a)+t.PathUtils.closePath():this._generateRectCmd(i,n,s,a,r);var l=Math.min(new t.CSSStyle({"border-radius":r}).getBorderRadius(),Math.min(s,a)),h=Math.max(l-o,0);return s>2*o?t.PathUtils.moveTo(i,n+a)+t.PathUtils.verticalLineTo(n+l)+t.PathUtils.arcTo(l,l,Math.PI/2,this._isRTL?0:1,this._isRTL?i-l:i+l,n)+t.PathUtils.horizontalLineTo(this._isRTL?i-s+l:i+s-l)+t.PathUtils.arcTo(l,l,Math.PI/2,this._isRTL?0:1,this._isRTL?i-s:i+s,n+l)+t.PathUtils.verticalLineTo(n+a)+t.PathUtils.horizontalLineTo(this._isRTL?i-s+o:i+s-o)+t.PathUtils.verticalLineTo(n+o+h)+t.PathUtils.arcTo(h,h,Math.PI/2,this._isRTL?1:0,this._isRTL?i-s+o+h:i+s-o-h,n+o)+t.PathUtils.horizontalLineTo(this._isRTL?i-o-h:i+o+h)+t.PathUtils.arcTo(h,h,Math.PI/2,this._isRTL?1:0,this._isRTL?i-o:i+o,n+o+h)+t.PathUtils.verticalLineTo(n+a)+t.PathUtils.closePath():t.PathUtils.rectangleWithBorderRadius(i-this._isRTL*s,n,s,a,l+"px "+l+"px 0px 0px",Math.min(s,a),"0")},T.prototype._generateDiamondCmd=function(e,i,n,s){var a=n/2;if("0"===s||"0px"===s)return t.PathUtils.moveTo(e,i)+t.PathUtils.lineTo(e+a,i+a)+t.PathUtils.lineTo(e,i+n)+t.PathUtils.lineTo(e-a,i+a)+t.PathUtils.closePath();var r=Math.min(new t.CSSStyle({"border-radius":s}).getBorderRadius(),n/(2*Math.sqrt(2))),o=r/Math.sqrt(2),l=r,h=r;return t.PathUtils.moveTo(e-o,i+o)+t.PathUtils.arcTo(l,h,0,1,e+o,i+o)+t.PathUtils.lineTo(e+a-o,i+a-o)+t.PathUtils.arcTo(l,h,0,1,e+a-o,i+a+o)+t.PathUtils.lineTo(e+o,i+n-o)+t.PathUtils.arcTo(l,h,0,1,e-o,i+n-o)+t.PathUtils.lineTo(e-a+o,i+a+o)+t.PathUtils.arcTo(l,h,0,1,e-a+o,i+a-o)+t.PathUtils.closePath()},T.prototype._applyDefaultStyleClasses=function(){var e,i,n,s,a,r;"progress"===this._type?(e=this._task.getGantt().GetStyleClass("taskProgress"),this.setClassName(e)):T.MAIN_TYPES.indexOf(this._type)>-1?(e=this._task.getGantt().GetStyleClass("task"),i=this._task.getGantt().GetStyleClass("taskMilestone"),n=this._task.getGantt().GetStyleClass("taskBar"),s=this._task.getGantt().GetStyleClass("taskSummary"),this._task.isMilestone(this._type)&&0==this._w?e+=" "+i:this._task.isSummary(this._type)?e+=" "+s:e+=" "+n,"mainSelect"===this._type?(this.setStyle({fill:"none",filter:"none"}),e+=" "+this._task.getGantt().GetStyleClass("selected")):"mainHover"===this._type&&(e+=" "+this._task.getGantt().GetStyleClass("hover"),r={fill:"none"},null!=(a=this._task.getFillColor())&&(this.setStroke(t.SelectionEffectUtils.createSelectingStroke(a.fill)),"none"===a.filter&&(r.filter="none")),this.setStyle(r)),this.setClassName(e)):T.BASELINE_TYPES.indexOf(this._type)>-1&&(e=this._task.getGantt().GetStyleClass("baseline"),i=this._task.getGantt().GetStyleClass("baselineMilestone"),n=this._task.getGantt().GetStyleClass("baselineBar"),this._task.isMilestone(this._type)&&0==this._w?e+=" "+i:e+=" "+n,this.setClassName(e))},T.prototype.getFillColor=function(){var i,n,s,a,r,o,l;i=this.getElem().cloneNode(!1),(n=this._task.getGantt().getCtx().getSvgDocument()).appendChild(i);try{if(a=(s=window.getComputedStyle(i)).fill,o=s.filter,!(String.prototype.startsWith?a.startsWith("url("):0==a.indexOf("url("))){switch(o){case"url("+JSON.stringify("#"+e.getTaskTintFilterId())+")":case"url(#"+e.getTaskTintFilterId()+")":r=t.ColorUtils.getBrighter(a,e.getTaskTintAlpha());break;case"url("+JSON.stringify("#"+e.getTaskShadeFilterId())+")":case"url(#"+e.getTaskShadeFilterId()+")":r=t.ColorUtils.getDarker(a,e.getTaskShadeAlpha());break;default:r=a}l={fill:a,computedFill:r,filter:o}}}finally{n.removeChild(i)}return l},T.prototype.getPhysicalStartOffset=function(){return(T.MAIN_TYPES.indexOf(this._type)>-1||T.BASELINE_TYPES.indexOf(this._type)>-1)&&this._task.isMilestone(this._type)?this._finalHeight/2:0},T.prototype.getPhysicalEndOffset=function(){return(T.MAIN_TYPES.indexOf(this._type)>-1||T.BASELINE_TYPES.indexOf(this._type)>-1)&&this._task.isMilestone(this._type)?this._finalHeight/2:0},T.prototype.getType=function(){return this._type},T.prototype.getRenderState=function(){return this._renderState},T.prototype.setRenderState=function(t){this._renderState=t},T.prototype.getWidth=function(){return this._w},T.prototype.getFinalWidth=function(){return this._finalWidth},T.prototype.setWidth=function(t){var e;!(T.MAIN_TYPES.indexOf(this._type)>-1||T.BASELINE_TYPES.indexOf(this._type)>-1)||0!==this._w&&0!==t||(this._w=t,this._applyDefaultStyleClasses()),this._w=t,e=this._typeCmdGeneratorMap[this._type].call(this,this._x,this._y,this._w,this._h,this._r),this.setCmds(e)},T.prototype.setFinalWidth=function(t){this._finalWidth=t},T.prototype.getHeight=function(){return this._h},T.prototype.getFinalHeight=function(){return this._finalHeight},T.prototype.setHeight=function(t){var e;this._h=t,e=this._typeCmdGeneratorMap[this._type].call(this,this._x,this._y,this._w,this._h,this._r),this.setCmds(e)},T.prototype.setFinalHeight=function(t){this._finalHeight=t},T.prototype.getX=function(){return this._x},T.prototype.getFinalX=function(){return this._finalX},T.prototype.setX=function(t){var e;this._x=t,e=this._typeCmdGeneratorMap[this._type].call(this,this._x,this._y,this._w,this._h,this._r),this.setCmds(e)},T.prototype.setFinalX=function(t){this._finalX=t},T.prototype.getY=function(){return this._y},T.prototype.getFinalY=function(){return this._finalY},T.prototype.setY=function(t){var e;this._y=t,e=this._typeCmdGeneratorMap[this._type].call(this,this._x,this._y,this._w,this._h,this._r),this.setCmds(e)},T.prototype.setFinalY=function(t){this._finalY=t},T.prototype.getBorderRadius=function(){return this._r},T.prototype.setBorderRadius=function(t){var e;this._r=null!=t?t:0,e=this._typeCmdGeneratorMap[this._type].call(this,this._x,this._y,this._w,this._h,this._r),this.setCmds(e)},T.prototype.setDimensions=function(t,e,i,n,s){var a;!(T.MAIN_TYPES.indexOf(this._type)>-1||T.BASELINE_TYPES.indexOf(this._type)>-1)||0!==this._w&&0!==i||(this._w=i,this._applyDefaultStyleClasses()),this._x=t,this._y=e,this._w=i,this._h=n,this._r=null!=s?s:"0",a=this._typeCmdGeneratorMap[this._type].call(this,this._x,this._y,this._w,this._h,this._r),this.setCmds(a)},t.exportProperty(t,"Gantt",t.Gantt),t.exportProperty(t.Gantt,"newInstance",t.Gantt.newInstance),t.exportProperty(t.Gantt.prototype,"destroy",t.Gantt.prototype.destroy),t.exportProperty(t.Gantt.prototype,"getAutomation",t.Gantt.prototype.getAutomation),t.exportProperty(t.Gantt.prototype,"render",t.Gantt.prototype.render),t.exportProperty(s.prototype,"getDomElementForSubId",s.prototype.getDomElementForSubId),t.exportProperty(s.prototype,"GetSubIdForDomElement",s.prototype.GetSubIdForDomElement)}(dvt);
  return dvt;
});
