/**
 * Copyright (c) 2014, 2016, Oracle and/or its affiliates.
 * The Universal Permissive License (UPL), Version 1.0
 */
"use strict";
define(['./DvtToolkit'], function(dvt) {
  // Internal use only.  All APIs and functionality are subject to change at any time.

!function(t){t.OverviewUtils=new Object,t.OverviewUtils.supportsTouch=function(){return t.Agent.isTouchDevice()},t.Obj.createSubclass(t.OverviewUtils,t.Obj),t.OverviewUtils.getDatePosition=function(t,e,i,n){var s=(i-t)*n,r=e-t;return 0==s||0==r?0:s/r},t.OverviewUtils.getPositionDate=function(t,e,i,n){var s=i*(e-t);return 0==s||0==n?t:s/n+t},t.Overview=function(t,e,i){this.Init(t,e,i)},t.Obj.createSubclass(t.Overview,t.Container),t.Overview.MIN_WINDOW_SIZE=10,t.Overview.DEFAULT_VERTICAL_TIMEAXIS_SIZE=40,t.Overview.DEFAULT_HORIZONTAL_TIMEAXIS_SIZE=20,t.Overview.HANDLE_PADDING_SIZE=20,t.Overview._DEFAULT_AXIS_LABEL_PADDING=5,t.Overview._DEFAULT_WINDOW_BORDER_WIDTH=1,t.Overview.prototype.Init=function(e,n,s){t.Overview.superclass.Init.call(this,e),this.initDefaults(),this._callback=n,this._callbackObj=s,this.isFlashEnvironment()?this._lastChildIndex=7:this._lastChildIndex=6,(null!=this._callback||null!=this._callbackObj)&&(this.EventManager=new i(this,e,n,s),this.EventManager.addListeners(this),t.OverviewUtils.supportsTouch()?(this.addEvtListener(t.TouchEvent.TOUCHSTART,this.HandleTouchStart,!1,this),this.addEvtListener(t.TouchEvent.TOUCHMOVE,this.HandleTouchMove,!1,this),this.addEvtListener(t.TouchEvent.TOUCHEND,this.HandleTouchEnd,!1,this),this.addEvtListener(t.MouseEvent.CLICK,this.HandleShapeClick,!1,this)):(this.addEvtListener(t.MouseEvent.MOUSEOVER,this.HandleShapeMouseOver,!1,this),this.addEvtListener(t.MouseEvent.MOUSEOUT,this.HandleShapeMouseOut,!1,this),this.addEvtListener(t.MouseEvent.CLICK,this.HandleShapeClick,!1,this),this.addEvtListener(t.KeyboardEvent.KEYDOWN,this.HandleKeyDown,!1,this),this.addEvtListener(t.KeyboardEvent.KEYUP,this.HandleKeyUp,!1,this))),this._initPos=0},t.Overview.prototype.initDefaults=function(){this.Defaults=new e},t.Overview.prototype.setViewportRange=function(t,e,i){null==i&&(i=this.Width);var n=this.getDatePosition(t),s=this.getDatePosition(e);if(!(n<this.getMinimumPosition()||s>this.getMaximumPosition())){var r=Math.max(s-n,this.getMinimumWindowSize());if(r>0&&n>=0&&s<=i){var o=this.getSlidingWindow();this.isHorizontalRTL()?this.setSlidingWindowPos(o,i-(n+r)):this.setSlidingWindowPos(o,n),this.setSlidingWindowSize(o,r),this.ScrollTimeAxis()}}},t.Overview.prototype.setInitialPosition=function(t){t>=this.getMinimumPosition()&&t<=this.getMaximumPosition()&&(this._initPos=t)},t.Overview.prototype.isFeatureOff=function(e){return null!=this._featuresOff&&-1!=t.ArrayUtils.getIndex(this._featuresOff,e)},t.Overview.prototype.isAnimationOnClick=function(){return!("off"===this._animationOnClick)},t.Overview.prototype.render=function(e,i,n){if(null!=i&&null!=n&&(this.Width=i,this.Height=n),null==e){var s=this._start,r=this._end,o=this.getSlidingWindow(),h=this.getSlidingWindowPos(o);null!=o&&0!=h&&(this._renderStart=t.OverviewUtils.getPositionDate(s,r,h,this.Width)),this.removeChildren()}else{this.SetOptions(e);var a=this.Parse(this.Options);this._applyParsedProperties(a)}var l=null!=this._callback||null!=this._callbackObj;this.createBackground(i,n),l&&this.createSlidingWindow(i,n),this.updateTimeAxis(i,n),this.parseFilledTimeRanges(i,n),this.updateCurrentTime(i,n),this.parseDataXML(i,n),l&&(this.createBorderAroundSlidingWindow(i,n),this.isFlashEnvironment()&&(this._resizeArrow=this.createResizeArrow()),this.updateSlidingWindow(i,n)),null!=this._initialFocusTime&&(this._initPos=Math.max(0,t.OverviewUtils.getDatePosition(this._start,this._end,this._initialFocusTime,this._width))),this._initPos>0&&this.longScrollToPos(this._initPos)},t.Overview.prototype.SetOptions=function(t){this.Options=this.Defaults.calcOptions(t)},t.Overview.prototype.getParser=function(e){return new t.OverviewParser(this)},t.Overview.prototype.Parse=function(t){return this.getParser(t).parse(t)},t.Overview.prototype._applyParsedProperties=function(t){this._start=t.start,this._end=t.end,this._width=t.width,this._renderStart=t.renderStart,this._currentTime=t.currentTime,this._initialFocusTime=t.initialFocusTime,this._animationOnClick=t.animationOnClick,this._leftMargin=Math.max(0,t.leftMargin),this._rightMargin=Math.max(0,t.rightMargin),isNaN(this._leftMargin)&&(this._leftMargin=0),isNaN(this._rightMargin)&&(this._rightMargin=0),this._orientation=t.orientation,this._isRtl=t.isRtl,null!=t.featuresOff&&(this._featuresOff=t.featuresOff.split(" ")),null!=t.minimumWindowSize&&t.minimumWindowSize>0&&(this._minimumWindowSize=t.minimumWindowSize),this._timeAxisInfo=t.timeAxisInfo,null!=t.timeAxisInfo&&(this._ticks=this._timeAxisInfo.ticks),this._formattedTimeRanges=t.formattedTimeRanges,this._borderTopStyle=n.getBorderTopStyle(this.Options),this._borderTopColor=n.getBorderTopColor(this.Options),this._windowBackgroundColor=n.getWindowBackgroundColor(this.Options),this._windowBackgroundAlpha=n.getWindowBackgroundAlpha(this.Options),this._windowBorderTopStyle=n.getWindowBorderTopStyle(this.Options),this._windowBorderRightStyle=n.getWindowBorderRightStyle(this.Options),this._windowBorderBottomStyle=n.getWindowBorderBottomStyle(this.Options),this._windowBorderLeftStyle=n.getWindowBorderLeftStyle(this.Options),this._windowBorderTopColor=n.getWindowBorderTopColor(this.Options),this._windowBorderRightColor=n.getWindowBorderRightColor(this.Options),this._windowBorderBottomColor=n.getWindowBorderBottomColor(this.Options),this._windowBorderLeftColor=n.getWindowBorderLeftColor(this.Options),this._handleTextureColor=n.getHandleTextureColor(this.Options),this._handleFillColor=n.getHandleFillColor(this.Options),this._handleBackgroundImage=n.getHandleBackgroundImage(this.Options),this._handleWidth=n.getHandleWidth(this.Options),this._handleHeight=n.getHandleHeight(this.Options),this._overviewBackgroundColor=n.getOverviewBackgroundColor(this.Options),this._currentTimeIndicatorColor=n.getCurrentTimeIndicatorColor(this.Options),this._timeIndicatorColor=n.getTimeIndicatorColor(this.Options),this._timeAxisBarColor=n.getTimeAxisBarColor(this.Options),this._timeAxisBarOpacity=n.getTimeAxisBarAlpha(this.Options),this._leftFilterPanelColor=n.getLeftFilterPanelColor(this.Options),this._leftFilterPanelAlpha=n.getLeftFilterPanelAlpha(this.Options),this._rightFilterPanelColor=n.getRightFilterPanelColor(this.Options),this._rightFilterPanelAlpha=n.getRightFilterPanelAlpha(this.Options)},t.Overview.prototype.getDatePosition=function(e){return Math.max(0,t.OverviewUtils.getDatePosition(this._start,this._end,e,this.getOverviewSize()))+this._leftMargin},t.Overview.prototype.getPositionDate=function(e){return t.OverviewUtils.getPositionDate(this._start,this._end,Math.max(0,e-this._leftMargin),this.getOverviewSize())},t.Overview.prototype.isRTL=function(){return"true"==this._isRtl},t.Overview.prototype.isHorizontalRTL=function(){return this.isRTL()&&!this.isVertical()},t.Overview.prototype.isVertical=function(){return"vertical"==this._orientation},t.Overview.prototype.isOverviewAbove=function(){return"above"==this.Options.overviewPosition},t.Overview.prototype.setMargins=function(t,e){!isNaN(t)&&null!=t&&t>0&&(this._leftMargin=t),!isNaN(e)&&null!=e&&e>0&&(this._rightMargin=e)},t.Overview.prototype.getOverviewSize=function(){return this.isVertical()?this.Height-this._leftMargin-this._rightMargin:this.Width-this._leftMargin-this._rightMargin},t.Overview.prototype.getMinimumPosition=function(){return this._leftMargin},t.Overview.prototype.getMaximumPosition=function(){return this.isVertical()?this.Height-this._rightMargin:this.Width-this._rightMargin},t.Overview.prototype.getMinimumWindowSize=function(){return null!=this._minWinSize?this._minWinSize:null!=this._minimumWindowSize?(this._minWinSize=t.OverviewUtils.getDatePosition(this._start,this._end,this._start+this._minimumWindowSize,this.getOverviewSize()),this._minWinSize):t.Overview.MIN_WINDOW_SIZE},t.Overview.prototype.getGrippySize=function(){return 10},t.Overview.prototype.getHandleStart=function(){return t.OverviewUtils.supportsTouch()?this.getHandleSize()/2:0},t.Overview.prototype.getHandleSize=function(){return t.OverviewUtils.supportsTouch()?30:10},t.Overview.prototype.isHandle=function(t){var e=t.getId();return"lh"==e||"rh"==e||"lhb"==e||"rhb"==e||"grpy"==e||"lbgrh"==e||"rbgrh"==e||null!=t.getParent()&&"grpy"==t.getParent().getId()},t.Overview.prototype.getTimeAxisWidth=function(){if(null==this._timeAxisInfo)return 0;if(null==this._timeAxisWidth){var e=parseInt(this._timeAxisInfo.width,10);!isNaN(e)&&e<this.Width?this._timeAxisWidth=e:this._timeAxisWidth=t.Overview.DEFAULT_VERTICAL_TIMEAXIS_SIZE}return this._timeAxisWidth},t.Overview.prototype.getTimeAxisHeight=function(){if(null==this._timeAxisInfo)return 0;if(null==this._timeAxisHeight){var e=parseInt(this._timeAxisInfo.height,10);!isNaN(e)&&e<this.Height?this._timeAxisHeight=e:this._timeAxisHeight=t.Overview.DEFAULT_HORIZONTAL_TIMEAXIS_SIZE}return this._timeAxisHeight},t.Overview.prototype.getPageX=function(e){return t.OverviewUtils.supportsTouch()&&null!=e.targetTouches?e.targetTouches.length>0?e.targetTouches[0].pageX:null:e.pageX},t.Overview.prototype.getPageY=function(e){return t.OverviewUtils.supportsTouch()&&null!=e.targetTouches?e.targetTouches.length>0?e.targetTouches[0].pageY:null:e.pageY},t.Overview.prototype.isLeftAndRightFilterRendered=function(){return!1},t.Overview.prototype.getSlidingWindow=function(){return this.getChildAt(1)},t.Overview.prototype.getLeftBackground=function(){return this.isLeftAndRightFilterRendered()?this.getChildAt(3):null},t.Overview.prototype.getRightBackground=function(){return this.isLeftAndRightFilterRendered()?this.getChildAt(4):null},t.Overview.prototype.getLeftBackgroundHandle=function(){return this.isLeftAndRightFilterRendered()&&!this.isFeatureOff("zoom")?this.getChildAt(5):null},t.Overview.prototype.getRightBackgroundHandle=function(){return this.isLeftAndRightFilterRendered()&&!this.isFeatureOff("zoom")?this.getChildAt(6):null},t.Overview.prototype.getLeftHandle=function(){var t=this._lastChildIndex;return this.getChildAt(this.getNumChildren()-t)},t.Overview.prototype.getRightHandle=function(){var t=this._lastChildIndex-1;return this.getChildAt(this.getNumChildren()-t)},t.Overview.prototype.getLeftTopBar=function(){var t=this._lastChildIndex-2;return this.getChildAt(this.getNumChildren()-t)},t.Overview.prototype.getRightTopBar=function(){var t=this._lastChildIndex-3;return this.getChildAt(this.getNumChildren()-t)},t.Overview.prototype.getBottomBar=function(){var t=this._lastChildIndex-4;return this.getChildAt(this.getNumChildren()-t)},t.Overview.prototype.getTopBar=function(){var t=this._lastChildIndex-5;return this.getChildAt(this.getNumChildren()-t)},t.Overview.prototype.setLinePos=function(t,e,i){this.isVertical()?(-1!=e&&t.setY1(e),-1!=i&&t.setY2(i)):(-1!=e&&t.setX1(e),-1!=i&&t.setX2(i))},t.Overview.prototype.getLinePos1=function(t){return this.isVertical()?t.getY1():t.getX1()},t.Overview.prototype._findDrawable=function(t){var e=t.target;if(null!=e){var i=e.getId();if(null==i)return null;if("_border"==i.substr(i.length-7))return this.getChildAfter(e);if("tick"!=i.substr(0,4)&&"ltb"!=i&&"rtb"!=i&&"bb"!=i&&"tab"!=i)return e}return null},t.Overview.prototype.isMovable=function(t){return!("window"!=t.getId()&&"ftr"!=t.getId()&&"sta"!=t.getId()&&!this.isHandle(t))},t.Overview.prototype.isFlashEnvironment=function(){return window&&window.isFlashEnvironment},t.Overview.prototype.createBackground=function(e,i){var n=new t.Rect(this.getCtx(),0,0,e,i,"bg");return n.setSolidFill(this._overviewBackgroundColor),n.setPixelHinting(!0),this.addChild(n),n},t.Overview.prototype.createSlidingWindow=function(e,i){var n=this.isVertical();if(n)var s=new t.Rect(this.getCtx(),0,0,e,0,"window");else s=new t.Rect(this.getCtx(),0,0,0,i,"window");if(s.setSolidFill(this._windowBackgroundColor,this._windowBackgroundAlpha),s.setPixelHinting(!0),!this.isFeatureOff("zoom")){var r=this.getHandleSize(),o=this.getHandleStart(),h=this.getGrippySize();if(n){var a=(e-36)/2,l=t.PathUtils.moveTo(a,0)+t.PathUtils.quadTo(a+3,6,a+8,8)+t.PathUtils.lineTo(a+28,8)+t.PathUtils.quadTo(a+33,6,a+36,0);t.PathUtils.closePath();var d=t.PathUtils.moveTo(a,0)+t.PathUtils.quadTo(a+3,-6,a+8,-8)+t.PathUtils.lineTo(a+28,-8)+t.PathUtils.quadTo(a+33,-6,a+36,0);t.PathUtils.closePath();var g=new t.Rect(this.getCtx(),0,0,e,r,"lhb"),v=new t.Rect(this.getCtx(),0,0,e,r,"rhb"),u="row-resize";if(this._handleBackgroundImage)var w=this.createGrippyImage(e,h),c=this.createGrippyImage(e,h);else w=this.createGrippy(a),c=this.createGrippy(a)}else{var p=(i-36)/2;l=t.PathUtils.moveTo(0,p)+t.PathUtils.quadTo(6,p+3,8,p+8)+t.PathUtils.lineTo(8,p+28)+t.PathUtils.quadTo(6,p+33,0,p+36),t.PathUtils.closePath(),d=t.PathUtils.moveTo(0,p)+t.PathUtils.quadTo(-6,p+3,-8,p+8)+t.PathUtils.lineTo(-8,p+28)+t.PathUtils.quadTo(-6,p+33,0,p+36),t.PathUtils.closePath(),g=new t.Rect(this.getCtx(),0-o,0,r,i,"lhb"),v=new t.Rect(this.getCtx(),o,0,r,i,"rhb"),u="col-resize",this._handleBackgroundImage?(w=this.createGrippyImage(h,i),c=this.createGrippyImage(h,i)):(w=this.createGrippy(p),c=this.createGrippy(p))}g.setSolidFill(this._windowBackgroundColor,0),v.setSolidFill(this._windowBackgroundColor,0),g.setPixelHinting(!0),v.setPixelHinting(!0);var _=new t.Path(this.getCtx(),l,"lh"),f=new t.Path(this.getCtx(),d,"rh");_.setSolidFill(this._handleFillColor),_.setSolidStroke(this._handleFillColor),f.setSolidFill(this._handleFillColor),f.setSolidStroke(this._handleFillColor),this._windowBackgroundColor==this._handleFillColor&&(_.setPixelHinting(!0),f.setPixelHinting(!0)),g.setCursor(u),v.setCursor(u),_.setCursor(u),f.setCursor(u),w.setCursor(u),c.setCursor(u),s.addChild(g),s.addChild(_),s.addChild(w),s.addChild(v),s.addChild(f),s.addChild(c)}if(s.setCursor("move"),this.addChild(s),n)if(this.isRTL())var S=new t.Line(this.getCtx(),this.getTimeAxisWidth(),0,this.getTimeAxisWidth(),i,"tab");else S=new t.Line(this.getCtx(),e-this.getTimeAxisWidth(),0,e-this.getTimeAxisWidth(),i,"tab");else S=this.isOverviewAbove()?new t.Line(this.getCtx(),0,this.getTimeAxisHeight(),e,this.getTimeAxisHeight(),"tab"):new t.Line(this.getCtx(),0,i-this.getTimeAxisHeight(),e,i-this.getTimeAxisHeight(),"tab");if(S.setSolidStroke(this._timeAxisBarColor,this._timeAxisBarOpacity),S.setPixelHinting(!0),this._timeAxisTopBar=S,this.addChild(S),this.isLeftAndRightFilterRendered()){if(n)var O=new t.Rect(this.getCtx(),0,0,e,0,"lbg"),T=new t.Rect(this.getCtx(),0,0,e,0,"rbg");else O=new t.Rect(this.getCtx(),0,0,0,i,"lbg"),T=new t.Rect(this.getCtx(),0,0,0,i,"rbg");if(O.setSolidFill(this._leftFilterPanelColor,this._leftFilterPanelAlpha),this.addChild(O),T.setSolidFill(this._rightFilterPanelColor,this._rightFilterPanelAlpha),this.addChild(T),t.OverviewUtils.supportsTouch()&&null!=o){r=this.getHandleStart();if(n)var P=new t.Rect(this.getCtx(),0,0,e,o,"lbgrh"),m=new t.Rect(this.getCtx(),0,0,e,o,"rbgrh");else P=new t.Rect(this.getCtx(),0,0,o,i,"lbgrh"),m=new t.Rect(this.getCtx(),0,0,o,i,"rbgrh");P.setSolidFill(this._leftFilterPanelColor,0),this.addChild(P),m.setSolidFill(this._rightFilterPanelColor,0),this.addChild(m)}}},t.Overview.prototype.createGrippyImage=function(e,i){var n=(e-this._handleWidth)/2,s=(i-this._handleHeight)/2,r=new t.Image(this.getCtx(),this._handleBackgroundImage,n,s,this._handleWidth,this._handleHeight,"grpy");return r.setMouseEnabled(!1),r},t.Overview.prototype.createGrippy=function(e){var i=new t.Container(this.getCtx(),"grpy"),n=this._handleTextureColor;if(this.isVertical()){for(var s=8+e,r=3,o=0;o<9;o++){var h=new t.Line(this.getCtx(),s+2*o,r,s+2*o+1,r,"dot1"+o);h.setSolidStroke(n),i.addChild(h),r+=2,(h=new t.Line(this.getCtx(),s+1+2*o,r,s+1+2*o+1,r,"dot2"+o)).setSolidStroke(n),i.addChild(h),r+=2,(h=new t.Line(this.getCtx(),s+2*o,r,s+2*o+1,r,"dot3"+o)).setSolidStroke(n),i.addChild(h),r=3}(h=new t.Line(this.getCtx(),s+18,r,s+18+1,r,"dot4")).setSolidStroke(n),i.addChild(h),r+=4,(h=new t.Line(this.getCtx(),s+18,r,s+18+1,r,"dot5")).setSolidStroke(n),i.addChild(h)}else{for(s=3,r=8+e,o=0;o<9;o++)(h=new t.Line(this.getCtx(),s,r+2*o,s,r+2*o+1,"dot1"+o)).setSolidStroke(n),i.addChild(h),s+=2,(h=new t.Line(this.getCtx(),s,r+1+2*o,s,r+1+2*o+1,"dot2"+o)).setSolidStroke(n),i.addChild(h),s+=2,(h=new t.Line(this.getCtx(),s,r+2*o,s,r+2*o+1,"dot3"+o)).setSolidStroke(n),i.addChild(h),s=3;(h=new t.Line(this.getCtx(),s,r+18,s,r+18+1,"dot4")).setSolidStroke(n),i.addChild(h),s+=4,(h=new t.Line(this.getCtx(),s,r+18,s,r+18+1,"dot5")).setSolidStroke(n),i.addChild(h)}return i.setPixelHinting(!0),i},t.Overview.prototype.updateSlidingWindow=function(e,i){var n=this.isVertical(),s=this.getSlidingWindow(),r=this.getOverviewSize(),o=n?this.Height:this.Width,h=this._width,a=this._start,l=this._end,d=this._renderStart,g=t.OverviewUtils.getPositionDate(a,l,0,h),v=t.OverviewUtils.getPositionDate(a,l,o,h),u=this.getDatePosition(g),w=Math.min(o,this.getDatePosition(v)),c=this.getDatePosition(d),p=c,_=w-u;this.isHorizontalRTL()?this.setSlidingWindowPos(s,r-c-_):this.setSlidingWindowPos(s,p),this.setSlidingWindowSize(s,_),this.ScrollTimeAxis(),this._increment=this.calculateIncrement(r)},t.Overview.prototype.createBorderAroundSlidingWindow=function(e,i){var n=this.getSlidingWindow(),s=t.Overview._DEFAULT_WINDOW_BORDER_WIDTH/2;if(this.isVertical())var r=n.getY(),o=r+s,h=r+n.getHeight(),a=h-s,l=0,d=s,g=e,v=g-s,u=new t.Line(this.getCtx(),l,o,e,o,"lh"),w=new t.Line(this.getCtx(),l,a,e,a,"rh"),c=new t.Line(this.getCtx(),d,0,d,r,"ltb"),p=new t.Line(this.getCtx(),d,h,d,i,"rtb"),_=new t.Line(this.getCtx(),v,r,v,h,"bb"),f=new t.Line(this.getCtx(),d,r,d,h,"tb");else o=(r=0)+s,a=(h=i)-s,d=(l=n.getX())+s,v=(g=l+n.getWidth())-s,u=new t.Line(this.getCtx(),d,r,d,h,"lh"),w=new t.Line(this.getCtx(),v,r,v,h,"rh"),c=new t.Line(this.getCtx(),0,o,l+1,o,"ltb"),p=new t.Line(this.getCtx(),g-1,o,e,o,"rtb"),_=new t.Line(this.getCtx(),l,a,g,a,"bb"),f=new t.Line(this.getCtx(),l,o,g,o,"tb");u.setPixelHinting(!0),w.setPixelHinting(!0),c.setPixelHinting(!0),p.setPixelHinting(!0),_.setPixelHinting(!0),f.setPixelHinting(!0),"none"!=this._windowBorderLeftStyle&&u.setSolidStroke(this._windowBorderLeftColor),this.addChild(u),"none"!=this._windowBorderRightStyle&&w.setSolidStroke(this._windowBorderRightColor),this.addChild(w),"none"!=this._borderTopStyle&&this._borderTopColor&&(c.setSolidStroke(this._borderTopColor),p.setSolidStroke(this._borderTopColor)),this.addChild(c),this.addChild(p),"none"!=this._windowBorderBottomStyle&&_.setSolidStroke(this._windowBorderBottomColor),this.addChild(_),"none"!=this._windowBorderTopStyle&&f.setSolidStroke(this._windowBorderTopColor),this.addChild(f)},t.Overview.prototype.createResizeArrow=function(){if(this.isVertical())var e=t.PathUtils.moveTo(6,0)+t.PathUtils.lineTo(0,5)+t.PathUtils.lineTo(5,5)+t.PathUtils.lineTo(5,17)+t.PathUtils.lineTo(0,17)+t.PathUtils.lineTo(6,22)+t.PathUtils.lineTo(12,17)+t.PathUtils.lineTo(7,17)+t.PathUtils.lineTo(7,5)+t.PathUtils.lineTo(12,5)+t.PathUtils.closePath();else e=t.PathUtils.moveTo(5,0)+t.PathUtils.lineTo(0,6)+t.PathUtils.lineTo(5,12)+t.PathUtils.lineTo(5,7)+t.PathUtils.lineTo(17,7)+t.PathUtils.lineTo(17,12)+t.PathUtils.lineTo(22,6)+t.PathUtils.lineTo(17,0)+t.PathUtils.lineTo(17,4)+t.PathUtils.lineTo(5,4)+t.PathUtils.lineTo(5,0)+t.PathUtils.closePath();var i=new t.Path(this.getCtx(),e,"arr");return i.setSolidFill("#ffffff"),i.setSolidStroke("#000000"),i.setVisible(!1),this.addChild(i),i},t.Overview.prototype.setRectPos=function(t,e){this.isVertical()?t.setY(e):t.setX(e)},t.Overview.prototype.getRectPos=function(t){return this.isVertical()?t.getY():t.getX()},t.Overview.prototype.getRectSize=function(t){return this.isVertical()?t.getHeight():t.getWidth()},t.Overview.prototype.setRectSize=function(t,e){this.isVertical()?t.setHeight(e):t.setWidth(e)},t.Overview.prototype.getSlidingWindowPos=function(t){return this.isVertical()?t.getTranslateY():t.getTranslateX()},t.Overview.prototype.setSlidingWindowPos=function(e,i){if(i=Math.max(0,i),this.isVertical()?e.setTranslateY(i):e.setTranslateX(i),this.isLeftAndRightFilterRendered()){this.getLeftBackground().setWidth(i);var n=i+this.getSlidingWindowSize(e),s=this.getRightBackground();if(s.setX(n),s.setWidth(Math.max(0,this.Width-n)),t.OverviewUtils.supportsTouch()&&!this.isFeatureOff("zoom")){var r=this.getHandleStart();this.getLeftBackgroundHandle().setX(i-r),this.getRightBackgroundHandle().setX(n)}}},t.Overview.prototype.getSlidingWindowSize=function(t){return this.getRectSize(t)},t.Overview.prototype.setSlidingWindowSize=function(e,i){if(i=Math.max(this.getMinimumWindowSize(),i),i=Math.min(this.isVertical()?this.Height:this.Width,i),this.setRectSize(e,i),this.isLeftAndRightFilterRendered()){var n=this.getSlidingWindowPos(e)+i,s=this.getRightBackground();if(s.setX(n),s.setWidth(Math.max(0,this.Width-n)),t.OverviewUtils.supportsTouch()&&!this.isFeatureOff("zoom"))this.getRightBackgroundHandle().setX(n)}if(!this.isFeatureOff("zoom")){var r=e.getChildAt(3),o=e.getChildAt(4),h=e.getChildAt(5);this.isVertical()?(o.setTranslateY(i),r.setTranslateY(i-this.getHandleSize()),h.setTranslateY(i-this.getGrippySize())):(o.setTranslateX(i),r.setTranslateX(i-this.getHandleSize()),h.setTranslateX(i-this.getGrippySize()))}},t.Overview.prototype.calculateIncrement=function(e){var i=this._width,n=this._start,s=this._end,r=t.OverviewUtils.getPositionDate(n,s,1,e),o=t.OverviewUtils.getPositionDate(n,s,2,e),h=t.OverviewUtils.getDatePosition(n,s,r,i);return t.OverviewUtils.getDatePosition(n,s,o,i)-h},t.Overview.prototype.updateTimeAxis=function(e,i){if(null!=this._ticks)for(var n=this.isVertical(),s=this.getOverviewSize(),r=(this._start,this._end,0);r<this._ticks.length;r++){var o=this._ticks[r],h=parseInt(o.time,10),a=this.getDatePosition(h),l=o.label,d=0;if(r+1<this._ticks.length){var g=parseInt(this._ticks[r+1].time,10);d=this.getDatePosition(g)-a}else d=s-a;this.isHorizontalRTL()&&(a=s-a),n&&(d=this.Width),d-=2*t.Overview._DEFAULT_AXIS_LABEL_PADDING,this.addTick(a,e,i,"tick"+r),this.addLabel(a,l,e,i,d,"label"+r)}},t.Overview.prototype.addTick=function(e,i,n,s){if(this.isVertical())var r=new t.Line(this.getCtx(),0,e,i,e,s);else r=new t.Line(this.getCtx(),e,0,e,n,s);var o=new t.SolidStroke(this._timeIndicatorColor);o.setStyle(t.Stroke.DASHED,3),r.setStroke(o),r.setPixelHinting(!0),this.addChild(r)},t.Overview.prototype.addLabel=function(e,i,n,s,r,o,h){if(h=h||new t.CSSStyle("font-weight:bold"),this.isVertical()){var a=new t.OutputText(this.getCtx(),i,4,e,o);if(a.setCSSStyle(h),this.isRTL()){var l=a.getDimensions();a.setX(Math.max(4,this.Width-l.w-4))}}else{if(this.isOverviewAbove())var d=2;else d=s-this.getTimeAxisHeight()+2;var g=t.Overview._DEFAULT_AXIS_LABEL_PADDING;(a=new t.OutputText(this.getCtx(),i,e+g,d,o)).setCSSStyle(h),this.isHorizontalRTL()&&(l=a.getDimensions(),a.setX(e-Math.min(l.w,r)-g))}t.TextUtils.fitText(a,r,1/0,this),a._rawText=a.getUntruncatedTextString()},t.Overview.prototype.updateCurrentTime=function(e,i){if(!(null==this._currentTime||isNaN(this._currentTime)||this._currentTime<this._start||this._currentTime>this._end)){var n=this.getDatePosition(this._currentTime);if(this.isVertical())var s=new t.Line(this.getCtx(),0,n,e,n,"ocd");else this.isRTL()&&(n=e-n),s=new t.Line(this.getCtx(),n,0,n,i,"ocd");s.setSolidStroke(this._currentTimeIndicatorColor),s.setPixelHinting(!0),this.addChild(s)}},t.Overview.prototype.parseFilledTimeRanges=function(t,e){if(null!=this._formattedTimeRanges)for(var i=this._start,n=this._end,s=0;s<this._formattedTimeRanges.length;s++){var r=this._formattedTimeRanges[s];this.addFilledTimeRange(r,i,n,t,e)}},t.Overview.prototype.addFilledTimeRange=function(e,i,n,s,r){var o=parseInt(e.rs,10),h=parseInt(e.re,10),a=e.c;if(null!=o&&null!=h){var l=this.getOverviewSize(),d=this.getDatePosition(o),g=this.getDatePosition(h),v=g-d;if(this.isHorizontalRTL()&&(d=l-d-v,g=l-g-v),this.isVertical())var u=new t.Rect(this.getCtx(),0,d,s-this.getTimeAxisWidth(),v,"ftr");else u=new t.Rect(this.getCtx(),d,this.isOverviewAbove()?this.getTimeAxisHeight():0,v,r-this.getTimeAxisHeight(),"ftr");null!=a&&u.setSolidFill(a,.4),u.setCursor("move"),u.setPixelHinting(!0),this.addChild(u)}},t.Overview.prototype.parseDataXML=function(t,e){},t.Overview.prototype.animateSlidingWindow=function(e,i){var n=this.getSlidingWindow(),s=n.getChildAt(3),r=n.getChildAt(4),o=n.getChildAt(5);if(null!=i||e!=this.getSlidingWindowPos(n)){var h=this.getLeftHandle(),a=this.getRightHandle(),l=this.getLeftTopBar(),d=this.getRightTopBar(),g=this.getBottomBar(),v=this.getTopBar();if(this.isVertical()){var u=n.getTranslateY,w=n.setTranslateY,c=n.getHeight,p=n.setHeight,_=h.getY1,f=h.setY1,S=h.getY2,O=h.setY2,T=a.getY1,P=a.setY1,m=a.getY2,E=a.setY2,C=l.getY2,y=l.setY2,D=d.getY1,A=d.setY1,W=g.getY1,R=g.setY1,L=g.getY2,x=g.setY2,b=v.getY1,H=v.setY1,B=v.getY2,I=v.setY2;if(null!=r&&null!=o)var M=r.getTranslateY,Y=r.setTranslateY,U=o.getTranslateY,z=o.setTranslateY}else u=n.getTranslateX,w=n.setTranslateX,c=n.getWidth,p=n.setWidth,_=h.getX1,f=h.setX1,S=h.getX2,O=h.setX2,T=a.getX1,P=a.setX1,m=a.getX2,E=a.setX2,C=l.getX2,y=l.setX2,D=d.getX1,A=d.setX1,W=g.getX1,R=g.setX1,L=g.getX2,x=g.setX2,b=v.getX1,H=v.setX1,B=v.getX2,I=v.setX2,null!=r&&null!=o&&(M=r.getTranslateX,Y=r.setTranslateX,U=o.getTranslateX,z=o.setTranslateX);var N=this.getMinimumPosition(),k=this.getMaximumPosition(),X=this.getSlidingWindowSize(n);e=null!=i?Math.max(N,Math.min(k-i,e)):Math.max(N,Math.min(k-X,e));var F=this.isAnimationOnClick()?new t.Animator(this.getCtx(),.5,0,t.Easing.linear):null;if(this.animateProperty(F,n,u,w,e),null!=i&&(this.animateProperty(F,n,c,p,i),null!=r&&this.animateProperty(F,r,M,Y,i),null!=s&&this.animateProperty(F,s,M,Y,i-this.getHandleSize()),null!=o&&this.animateProperty(F,o,U,z,i-this.getGrippySize())),this.animateProperty(F,h,_,f,e),this.animateProperty(F,h,S,O,e),null!=i?(this.animateProperty(F,a,T,P,e+i),this.animateProperty(F,a,m,E,e+i)):(this.animateProperty(F,a,T,P,e+X),this.animateProperty(F,a,m,E,e+X)),this.animateProperty(F,l,C,y,e+1),null!=i?this.animateProperty(F,d,D,A,e+i-1):this.animateProperty(F,d,D,A,e+X-1),this.animateProperty(F,g,W,R,e),this.animateProperty(F,v,b,H,e),null!=i?(this.animateProperty(F,g,L,x,e+i),this.animateProperty(F,v,B,I,e+i)):(this.animateProperty(F,g,L,x,e+X),this.animateProperty(F,v,B,I,e+X)),this.isLeftAndRightFilterRendered()){var V=this.getLeftBackground(),K=V.getWidth,G=V.setWidth;this.animateProperty(F,V,K,G,e);var Z=e+X,j=this.getRightBackground(),q=j.getWidth,J=j.setWidth,Q=j.getX,$=j.setX;if(this.isVertical())var tt=this.Height;else tt=this.Width;if(this.animateProperty(F,j,q,J,tt-Z),this.animateProperty(F,j,Q,$,Z),t.OverviewUtils.supportsTouch()&&!this.isFeatureOff("zoom")){var et=this.getHandleStart(),it=this.getLeftBackgroundHandle(),nt=it.getX,st=it.setX,rt=this.getRightBackgroundHandle(),ot=rt.getX,ht=rt.setX;this.animateProperty(F,it,nt,st,e-et),this.animateProperty(F,rt,ot,ht,Z)}}null!=F&&F.play()}},t.Overview.prototype.animateProperty=function(e,i,n,s,r){null!=e?e.addProp(t.Animator.TYPE_NUMBER,i,n,s,r):s.call(i,r)},t.Overview.prototype.HandleShapeMouseOver=function(e){var i=this._findDrawable(e);if(i&&"bg"!=i.getId()&&"ocd"!=i.getId())if("label"==i.getId().substr(0,5)&&(i instanceof t.OutputText||i instanceof t.BackgroundOutputText))i.isTruncated()&&this.getCtx().getTooltipManager().showDatatip(e.pageX,e.pageY,i._rawText,"#000000");else{if(null!=this._resizeArrow&&this.isHandle(i)){var n=this.getCtx().pageToStageCoords(e.pageX,e.pageY);n=this.stageToLocal(n),this.isVertical()?this._resizeArrow.setTranslate(n.x+6,n.y-10):this._resizeArrow.setTranslate(n.x-6,n.y-20),this._resizeArrow.setVisible(!0)}if("window"!=i.getId()&&"ftr"!=i.getId()&&"arr"!=i.getId()&&!this.isHandle(i))return i;this.isFlashEnvironment()&&this.setCursor("move")}},t.Overview.prototype.HandleShapeMouseOut=function(t){null==this._moveDrawable&&this.setCursor("default");var e=this._findDrawable(t);if(null!=e)return this.isHandle(e)&&null!=this._resizeArrow&&this._resizeArrow.setVisible(!1),e},t.Overview.prototype.HandleShapeClick=function(e,i,n){e.stopPropagation();var s=this._findDrawable(e);if(s&&"window"!=s.getId()&&!this.isHandle(s)){if("bg"==s.getId()||"label"==s.getId().substr(0,5)||"ocd"==s.getId()||"lbg"==s.getId()||"rbg"==s.getId()){null==i&&(i=e.pageX),null==n&&(n=e.pageY);var r=this.getCtx().pageToStageCoords(i,n);if(r=this.stageToLocal(r),this.isVertical())var o=r.y,h=this.Height;else o=r.x,h=this.Width;var a=this.getSlidingWindow(),l=o-this.getRectSize(a)/2;this.animateSlidingWindow(l),this.isHorizontalRTL()&&(o=this.Width-o);var d=this.getPositionDate(o),g=new t.OverviewEvent(t.OverviewEvent.SUBTYPE_SCROLL_TIME);if(g.setTime(d),l=Math.max(0,Math.min(l,h-this.getRectSize(a))),this.isHorizontalRTL())var v=this.getPositionDate(this.Width-(l+this.getRectSize(a))),u=this.getPositionDate(this.Width-l);else v=this.getPositionDate(l),u=this.getPositionDate(l+this.getRectSize(a));return g.setNewStartTime(v),g.setNewEndTime(u),void this.dispatchEvent(g)}return s}},t.Overview.prototype.beginDragPan=function(e,i,n){var s=this._findDrawable(e);if(null!=s&&this.isMovable(s)){if("ftr"!=s.getId()&&"sta"!=s.getId()||(s=this.getSlidingWindow()),this._initX=i,this._initY=n,this.isHandle(s)){var r=this.getSlidingWindow();this.isHorizontalRTL()?(this._oldEndPos=this.Width-r.getX(),this._oldStartPos=this._oldEndPos-r.getWidth()):(this._oldStartPos=r.getX(),this._oldEndPos=this._oldStartPos+r.getWidth()),"grpy"==s.getParent().getId()&&(s=s.getParent());var o=s.getId();"grpy"==o&&(o=(s=r.getChildBefore(s)).getId()),"lh"!=o&&"rh"!=o||(o=(s=r.getChildBefore(s)).getId()),"lbgrh"==o&&(s=r.getChildAt(0)),"rbgrh"==o&&(s=r.getChildAt(r.getNumChildren()-3)),t.OverviewUtils.supportsTouch()||(this.isVertical()?(s.setY(0-t.Overview.HANDLE_PADDING_SIZE),s.setHeight(2*(s.getHeight()+t.Overview.HANDLE_PADDING_SIZE))):(s.setX(0-t.Overview.HANDLE_PADDING_SIZE),s.setWidth(2*(s.getWidth()+t.Overview.HANDLE_PADDING_SIZE)))),this.overrideCursors(s.getCursor())}this._moveDrawable=s;var h=new t.OverviewEvent(t.OverviewEvent.SUBTYPE_PRE_RANGECHANGE);return this.dispatchEvent(h),!0}return!1},t.Overview.prototype.overrideCursors=function(t){var e=this.getSlidingWindow();if(null!=e&&e.setCursor(t),this.isLeftAndRightFilterRendered()){var i=this.getLeftBackground(),n=this.getRightBackground();null!=i&&null!=n&&(i.setCursor(t),n.setCursor(t))}},t.Overview.prototype.resetCursors=function(){var t=this.getSlidingWindow();if(null!=t&&t.setCursor("move"),this.isLeftAndRightFilterRendered()){var e=this.getLeftBackground(),i=this.getRightBackground();null!=e&&null!=i&&(e.setCursor("default"),i.setCursor("default"))}},t.Overview.prototype.endDragPan=function(){null!=this._moveDrawable&&1==this._isDragPanning&&("window"==this._moveDrawable.getId()?this.finishWindowDrag(0,0):this.isHandle(this._moveDrawable)&&(this.finishHandleDrag(0,0),t.OverviewUtils.supportsTouch()||(this.isVertical()?(this._moveDrawable.setY(0),this._moveDrawable.setHeight(this.getHandleSize())):(this._moveDrawable.setX(0),this._moveDrawable.setWidth(this.getHandleSize()))),this.resetCursors()),this._isDragPanning=!1,this._moveDrawable=null,this._initX=-1)},t.Overview.prototype.contDragPan=function(t,e,i){if(null!=this._moveDrawable&&-1!=this._initX){this._isDragPanning=!0;var n=e-this._initX,s=i-this._initY;this._initX=e,this._initY=i,"window"==this._moveDrawable.getId()?this.handleWindowDragPositioning(t,n,s):"lh"==this._moveDrawable.getId()||"lhb"==this._moveDrawable.getId()?this.handleLeftHandleDragPositioning(t,n,s):"rh"!=this._moveDrawable.getId()&&"rhb"!=this._moveDrawable.getId()||this.handleRightHandleDragPositioning(t,n,s)}},t.Overview.prototype.HandleTouchStart=function(t){var e=t.touches;this._touchStartX=e[0].pageX,this._touchStartY=e[0].pageY,2==e.length&&(t.preventDefault(),this._touchStartX2=e[1].pageX,this._touchStartY2=e[1].pageY,Math.abs(this._touchStartY-this._touchStartY2)<20?this._counter=0:(this._touchStartX=null,this._touchStartY=null,this._touchStartX2=null,this._touchStartY2=null))},t.Overview.prototype.HandleTouchMove=function(t){t.preventDefault();var e=t.touches;if(null!=this._touchStartX2&&null!=this._touchStartY2){if(this._counter<50)return void this._counter++;var i=e[1].pageX-this._touchStartX2;this.handleRightHandleDragPositioning(null,i,0),this._touchStartX2=e[1].pageX,this._counter=0}else{var n=Math.abs(this._touchStartX-e[0].pageX),s=Math.abs(this._touchStartY-e[0].pageY);(n>3||s>3)&&(this._touchStartX=null,this._touchStartY=null)}},t.Overview.prototype.HandleTouchEnd=function(t){null!=this._touchStartX2&&null!=this._touchStartY2?this.finishHandleDrag(0,0):null!=this._touchStartX&&null!=this._touchStartY&&this.HandleShapeClick(t,this._touchStartX,this._touchStartY),this._touchStartX=null,this._touchStartY=null,this._touchStartX2=null,this._touchStartY2=null},t.Overview.prototype.stopDragAction=function(){this.endDragPan()},t.Overview.prototype.HandleKeyDown=function(e){var i=e.keyCode;if(i===t.KeyboardEvent.LEFT_ARROW||i===t.KeyboardEvent.RIGHT_ARROW){var n=e.shiftKey?this.handleRightHandleDragPositioning:this.handleWindowDragPositioning,s=i===t.KeyboardEvent.LEFT_ARROW?-1:1;n.call(this,e,s,s)}},t.Overview.prototype.HandleKeyUp=function(e){var i=e.keyCode;if(i===t.KeyboardEvent.LEFT_ARROW||i===t.KeyboardEvent.RIGHT_ARROW){var n=e.shiftKey?this.finishHandleDrag:this.finishWindowDrag,s=i===t.KeyboardEvent.LEFT_ARROW?-1:1;n.call(this,s,s)}},t.Overview.prototype.ScrollToStart=function(){var t=this.getSlidingWindow(),e=this.Width;this.isHorizontalRTL()?this.setSlidingWindowPos(t,e-this.getSlidingWindowSize(t)):this.setSlidingWindowPos(t,0),this.ScrollTimeAxis()},t.Overview.prototype.ScrollToEnd=function(){var t=this.getSlidingWindow(),e=this.Width;this.isHorizontalRTL()?this.setSlidingWindowPos(t,0):this.setSlidingWindowPos(t,e-this.getSlidingWindowSize(t)),this.ScrollTimeAxis()},t.Overview.prototype.ScrollByAmount=function(t){var e=this.getSlidingWindow(),i=t/this._increment;if(this.isVertical())var n=this.Height-e.getHeight();else n=this.Width-e.getWidth(),this.isRTL()&&(i=0-i);this.setSlidingWindowPos(e,Math.min(n,this.getSlidingWindowPos(e)+i)),this.ScrollTimeAxis()},t.Overview.prototype.longScrollToPos=function(t){var e=t/this._increment;this.isHorizontalRTL()&&(e=0-e),this.animateSlidingWindow(e)},t.Overview.prototype.ScrollToPos=function(t){var e=this.getSlidingWindow(),i=t/this._increment;this.isHorizontalRTL()&&(i=0-i),this.setSlidingWindowPos(e,i),this.ScrollTimeAxis()},t.Overview.prototype.scrollToTime=function(e){var i=Math.max(0,t.OverviewUtils.getDatePosition(this._start,this._end,e,this._width));this.longScrollToPos(i)},t.Overview.prototype.handleWindowDragPositioning=function(e,i,n){this.fireScrollEvent(t.OverviewEvent.SUBTYPE_SCROLL_POS,i,n)},t.Overview.prototype.finishWindowDrag=function(e,i){this.fireScrollEvent(t.OverviewEvent.SUBTYPE_SCROLL_END,e,i)},t.Overview.prototype.fireScrollEvent=function(e,i,n){var s=this.getSlidingWindow(),r=this.getSlidingWindowPos(s),o=this.getRectSize(s),h=this.getMinimumPosition(),a=this.getMaximumPosition();if(this.isVertical())var l=n;else l=i;if(r+l<=h)if(this.setSlidingWindowPos(s,h),this.isHorizontalRTL())var d=t.OverviewEvent.END_POS;else d=t.OverviewEvent.START_POS;else r+o+l>=a?(this.setSlidingWindowPos(s,a-o),d=this.isHorizontalRTL()?t.OverviewEvent.START_POS:t.OverviewEvent.END_POS):(this.setSlidingWindowPos(s,r+l),d=this.isHorizontalRTL()?(a-o-r-this._leftMargin)*this._increment:(r-this._leftMargin)*this._increment);this.ScrollTimeAxis();var g=new t.OverviewEvent(e);if(g.setPosition(d),this.isHorizontalRTL())var v=this.getPositionDate(this.Width-(r+this.getRectSize(s))),u=this.getPositionDate(this.Width-r);else v=this.getPositionDate(r),u=this.getPositionDate(r+this.getRectSize(s));g.setNewStartTime(v),g.setNewEndTime(u),this.dispatchEvent(g)},t.Overview.prototype.handleLeftHandleDragPositioning=function(t,e,i){this.handleLeftOrRightHandleDragPositioning(t,e,i,!0)},t.Overview.prototype.handleRightHandleDragPositioning=function(t,e,i){this.handleLeftOrRightHandleDragPositioning(t,e,i,!1)},t.Overview.prototype.handleLeftOrRightHandleDragPositioning=function(e,i,n,s){var r=this.getOverviewSize();if(this.isVertical())var o=n;else o=i;if(0!=o){var h=this.getSlidingWindow(),a=this.getSlidingWindowPos(h),l=this.getSlidingWindowSize(h);if(s){if(l-o<=this.getMinimumWindowSize())return;if(a+o<=this.getMinimumPosition())return;if(this.isVertical())var d=this.getCtx().pageToStageCoords(this.getPageX(e),this.getPageY(e)).y;else d=this.getCtx().pageToStageCoords(this.getPageX(e),this.getPageY(e)).x;if(d=this.stageToLocal(d),o>0&&d<=a)return;if(o<0&&d>=a)return;this.setSlidingWindowPos(h,a+o),this.setSlidingWindowSize(h,l-o)}else{if(l+o<=this.getMinimumWindowSize())return;if(a+l+o>=this.getMaximumPosition())return;if(d=this.isVertical()?this.getCtx().pageToStageCoords(this.getPageX(e),this.getPageY(e)).y:this.getCtx().pageToStageCoords(this.getPageX(e),this.getPageY(e)).x,d=this.stageToLocal(d),o>0&&d<=a+l)return;if(o<0&&d>=a+l)return;this.setSlidingWindowSize(h,l+o)}this.ScrollTimeAxis();var g=this.getPositionDate(this.getSlidingWindowSize(h)),v=r*(this._end-this._start)/(g-this._start);if(this.isRangeChangingSupported()){var u=new t.OverviewEvent(t.OverviewEvent.SUBTYPE_RANGECHANGING);if(u.setNewSize(v),u.setEndHandle(this.isHorizontalRTL()?s:!s),s?u.setExpand(o<0):u.setExpand(o>0),this.isHorizontalRTL())var w=this.getPositionDate(this.Width-(this.getSlidingWindowPos(h)+this.getRectSize(h))),c=this.getPositionDate(this.Width-this.getSlidingWindowPos(h));else w=this.getPositionDate(this.getSlidingWindowPos(h)),c=this.getPositionDate(this.getSlidingWindowPos(h)+this.getRectSize(h));u.setNewStartTime(w),u.setNewEndTime(c),this.dispatchEvent(u)}}},t.Overview.prototype.isRangeChangingSupported=function(){return!0},t.Overview.prototype.finishHandleDrag=function(e,i){var n=this._start,s=this._end,r=this._width,o=this.getOverviewSize(),h=this.getSlidingWindow(),a=o*(s-n)/(this.getPositionDate(this.getRectSize(h))-n),l=this.getPositionDate(this._oldStartPos),d=this.getPositionDate(this._oldEndPos);if(this.isHorizontalRTL())var g=this.getPositionDate(this.Width-(this.getSlidingWindowPos(h)+this.getRectSize(h))),v=this.getPositionDate(this.Width-this.getSlidingWindowPos(h));else g=this.getPositionDate(this.getSlidingWindowPos(h)),v=this.getPositionDate(this.getSlidingWindowPos(h)+this.getRectSize(h));var u=new t.OverviewEvent(t.OverviewEvent.SUBTYPE_RANGECHANGE);u.setOldSize(r),u.setNewSize(a),u.setOldStartTime(l),u.setOldEndTime(d),u.setNewStartTime(g),u.setNewEndTime(v),this.dispatchEvent(u)},t.Overview.prototype.ScrollTimeAxis=function(){var e=this.getSlidingWindow(),i=t.Overview._DEFAULT_WINDOW_BORDER_WIDTH/2,n=this.getSlidingWindowPos(e),s=n+i,r=n+this.getSlidingWindowSize(e)-i,o=this.getLeftHandle(),h=this.getRightHandle(),a=this.getLeftTopBar(),l=this.getRightTopBar(),d=this.getBottomBar(),g=this.getTopBar();this.setLinePos(o,s,s),this.setLinePos(h,r,r),this.setLinePos(a,-1,n),this.setLinePos(l,this.getLinePos1(h),-1),this.setLinePos(d,this.getLinePos1(o),this.getLinePos1(h)),this.setLinePos(g,this.getLinePos1(o),this.getLinePos1(h))},t.Overview.prototype.dispatchEvent=function(e){t.EventDispatcher.dispatchEvent(this._callback,this._callbackObj,this,e)},t.Overview.prototype.destroy=function(){this.EventManager&&(this.EventManager.removeListeners(this),this.EventManager.destroy(),this.EventManager=null),t.OverviewUtils.supportsTouch()?(this.removeEvtListener(t.TouchEvent.TOUCHSTART,this.HandleTouchStart,!1,this),this.removeEvtListener(t.TouchEvent.TOUCHMOVE,this.HandleTouchMove,!1,this),this.removeEvtListener(t.TouchEvent.TOUCHEND,this.HandleTouchEnd,!1,this),this.removeEvtListener(t.MouseEvent.CLICK,this.HandleShapeClick,!1,this)):(this.removeEvtListener(t.MouseEvent.MOUSEOVER,this.HandleShapeMouseOver,!1,this),this.removeEvtListener(t.MouseEvent.MOUSEOUT,this.HandleShapeMouseOut,!1,this),this.removeEvtListener(t.MouseEvent.CLICK,this.HandleShapeClick,!1,this),this.removeEvtListener(t.KeyboardEvent.KEYDOWN,this.HandleKeyDown,!1,this),this.removeEvtListener(t.KeyboardEvent.KEYUP,this.HandleKeyUp,!1,this)),t.Overview.superclass.destroy.call(this)};var e=function(){this.Init({alta:e.VERSION_1})};t.Obj.createSubclass(e,t.BaseComponentDefaults),e.VERSION_1={overviewPosition:"below",style:{currentTimeIndicatorColor:"#c000d1",handleFillColor:"#ffffff",handleTextureColor:"#b3c6db",leftFilterPanelAlpha:.7,leftFilterPanelColor:"#ffffff",overviewBackgroundColor:"#e6ecf3",rightFilterPanelAlpha:.7,rightFilterPanelColor:"#ffffff",timeAxisBarColor:"#e5e5e5",timeAxisBarAlpha:1,timeIndicatorColor:"#bcc7d2",windowBackgroundAlpha:1,windowBackgroundColor:"#ffffff",windowBorderBottomColor:"#4f4f4f",windowBorderBottomStyle:"solid",windowBorderLeftColor:"#4f4f4f",windowBorderLeftStyle:"solid",windowBorderRightColor:"#4f4f4f",windowBorderRightStyle:"solid",windowBorderTopColor:"#4f4f4f",windowBorderTopStyle:"solid"}},t.OverviewParser=function(t){this.Init(t)},t.Obj.createSubclass(t.OverviewParser,t.Obj),t.OverviewParser.prototype.Init=function(t){this._view=t},t.OverviewParser.prototype.parse=function(t){var e=t;return this.ParseRootAttributes(e)},t.OverviewParser.prototype.ParseRootAttributes=function(e){var i=new Object;if(i.animationOnClick=e.animationOnClick,null!=e.startTime&&(i.start=e.startTime),null!=e.endTime&&(i.end=e.endTime),null==i.start&&(i.start=(new Date).getTime()),(null==i.end||i.end<=i.start)&&(i.end=i.start+864e5),null!=e.currentTime&&(i.currentTime=e.currentTime),null!=e.initialFocusTime&&(i.initialFocusTime=e.initialFocusTime),i.orientation="horizontal",null!=e.orientation&&(i.orientation=e.orientation),i.featuresOff=e.featuresOff,i.minimumWindowSize=e.minimumWindowSize,i.leftMargin=e.leftMargin,i.rightMargin=e.rightMargin,null!=e.viewportEndTime){var n=e.viewportEndTime,s=i.start;null!=e.viewportStartTime&&e.viewportStartTime<n&&(s=e.viewportStartTime),null!=e.viewportEndPos?i.width=this.calculateWidth(i.start,i.end,s,n,e.viewportEndPos):i.width=this.calculateWidth(i.start,i.end,s,n,this._view.Width),i.renderStart=s}else i.renderStart=i.start;return 0==i.width&&(i.width=1e3),i.overviewPosition="below",i.selectionMode="none",i.isRtl=t.Agent.isRightToLeft(this._view.getCtx()).toString(),null!=e.rtl&&(i.isRtl=e.rtl.toString()),i},t.OverviewParser.prototype.calculateWidth=function(t,e,i,n,s){var r=s*(e-t),o=n-i;return 0==r||0==o?0:r/o},t.OverviewEvent=function(e){this.Init(t.OverviewEvent.TYPE),this._subtype=e},t.Obj.createSubclass(t.OverviewEvent,t.BaseComponentEvent),t.OverviewEvent.TYPE="overview",t.OverviewEvent.SUBTYPE_PRE_RANGECHANGE="dropCallback",t.OverviewEvent.SUBTYPE_SCROLL_TIME="scrollTime",t.OverviewEvent.SUBTYPE_SCROLL_POS="scrollPos",t.OverviewEvent.SUBTYPE_SCROLL_END="scrollEnd",t.OverviewEvent.SUBTYPE_RANGECHANGE="rangeChange",t.OverviewEvent.SUBTYPE_RANGECHANGING="rangeChanging",t.OverviewEvent.TIME_KEY="time",t.OverviewEvent.POS_KEY="pos",t.OverviewEvent.OLD_SIZE_KEY="oldSize",t.OverviewEvent.NEW_SIZE_KEY="newSize",t.OverviewEvent.OLD_START_TIME_KEY="oldStartTime",t.OverviewEvent.NEW_START_TIME_KEY="newStartTime",t.OverviewEvent.OLD_END_TIME_KEY="oldEndTime",t.OverviewEvent.NEW_END_TIME_KEY="newEndTime",t.OverviewEvent.EXPAND_KEY="expand",t.OverviewEvent.END_HANDLE_KEY="endHandle",t.OverviewEvent.START_POS=-1,t.OverviewEvent.END_POS=-2,t.OverviewEvent.prototype.getSubType=function(){return this._subtype},t.OverviewEvent.prototype.setTime=function(e){this.addParam(t.OverviewEvent.TIME_KEY,e)},t.OverviewEvent.prototype.getTime=function(){return this.getParamValue(t.OverviewEvent.TIME_KEY)},t.OverviewEvent.prototype.setOldSize=function(e){this.addParam(t.OverviewEvent.OLD_SIZE_KEY,e)},t.OverviewEvent.prototype.getOldSize=function(){return this.getParamValue(t.OverviewEvent.OLD_SIZE_KEY)},t.OverviewEvent.prototype.setNewSize=function(e){this.addParam(t.OverviewEvent.NEW_SIZE_KEY,e)},t.OverviewEvent.prototype.getNewSize=function(){return this.getParamValue(t.OverviewEvent.NEW_SIZE_KEY)},t.OverviewEvent.prototype.setOldStartTime=function(e){this.addParam(t.OverviewEvent.OLD_START_TIME_KEY,e)},t.OverviewEvent.prototype.getOldStartTime=function(){return this.getParamValue(t.OverviewEvent.OLD_START_TIME_KEY)},t.OverviewEvent.prototype.setNewStartTime=function(e){this.addParam(t.OverviewEvent.NEW_START_TIME_KEY,e)},t.OverviewEvent.prototype.getNewStartTime=function(){return this.getParamValue(t.OverviewEvent.NEW_START_TIME_KEY)},t.OverviewEvent.prototype.setOldEndTime=function(e){this.addParam(t.OverviewEvent.OLD_END_TIME_KEY,e)},t.OverviewEvent.prototype.getOldEndTime=function(){return this.getParamValue(t.OverviewEvent.OLD_END_TIME_KEY)},t.OverviewEvent.prototype.setNewEndTime=function(e){this.addParam(t.OverviewEvent.NEW_END_TIME_KEY,e)},t.OverviewEvent.prototype.getNewEndTime=function(){return this.getParamValue(t.OverviewEvent.NEW_END_TIME_KEY)},t.OverviewEvent.prototype.setExpand=function(e){this.addParam(t.OverviewEvent.EXPAND_KEY,e)},t.OverviewEvent.prototype.isExpand=function(){return this.getParamValue(t.OverviewEvent.EXPAND_KEY)},t.OverviewEvent.prototype.setEndHandle=function(e){this.addParam(t.OverviewEvent.END_HANDLE_KEY,e)},t.OverviewEvent.prototype.isEndHandle=function(){return this.getParamValue(t.OverviewEvent.END_HANDLE_KEY)},t.OverviewEvent.prototype.setPosition=function(e){this.addParam(t.OverviewEvent.POS_KEY,e)},t.OverviewEvent.prototype.getPosition=function(){return this.getParamValue(t.OverviewEvent.POS_KEY)};var i=function(t){this.Init(t.getCtx(),t.processEvent,t),this._overview=t};t.Obj.createSubclass(i,t.EventManager),i.prototype.addListeners=function(e){t.SvgDocumentUtils.addDragListeners(this._overview,this._onDragStart,this._onDragMove,this._onDragEnd,this)},i.prototype._onDragStart=function(e){return t.Agent.isTouchDevice()?this._onTouchDragStart(e):this._onMouseDragStart(e)},i.prototype._onDragMove=function(e){return t.Agent.isTouchDevice()?this._onTouchDragMove(e):this._onMouseDragMove(e)},i.prototype._onDragEnd=function(e){return t.Agent.isTouchDevice()?this._onTouchDragEnd(e):this._onMouseDragEnd(e)},i.prototype._getRelativePosition=function(e,i){return this._stageAbsolutePosition||(this._stageAbsolutePosition=this._context.getStageAbsolutePosition()),new t.Point(e-this._stageAbsolutePosition.x,i-this._stageAbsolutePosition.y)},i.prototype._onMouseDragStart=function(e){if(e.button!=t.MouseEvent.RIGHT_CLICK_BUTTON){var i=this._getRelativePosition(e.pageX,e.pageY);return t.EventManager.consumeEvent(e),this.getCtx().getStage().getSVGRoot().parentNode.focus(),this._overview.beginDragPan(e,i.x,i.y)}return!1},i.prototype._onMouseDragMove=function(t){var e=this._getRelativePosition(t.pageX,t.pageY);return t.stopPropagation(),this._overview.contDragPan(t,e.x,e.y),!0},i.prototype._onMouseDragEnd=function(t){t.stopPropagation(),this._overview.endDragPan(),this._stageAbsolutePosition=null},i.prototype._onTouchDragStart=function(t){var e=t.touches;if(t.stopPropagation(),1==e.length){var i=this._getRelativePosition(e[0].pageX,e[0].pageY);return t.preventDefault(),this._overview.beginDragPan(t,i.x,i.y)}return!1},i.prototype._onTouchDragMove=function(t){var e=t.touches;if(1==e.length){var i=this._getRelativePosition(e[0].pageX,e[0].pageY);this._overview.contDragPan(t,i.x,i.y),t.preventDefault()}t.stopPropagation()},i.prototype._onTouchDragEnd=function(e){this._overview.endDragPan(),t.EventManager.consumeEvent(e),this._stageAbsolutePosition=null},t.exportProperty(t,"Overview",t.Overview),t.exportProperty(t.Overview.prototype,"render",t.Overview.prototype.render);var n=new Object;t.Obj.createSubclass(n,t.Obj),n.getHandleFillColor=function(t){return null!=t._hfc?t._hfc:t.style.handleFillColor},n.getHandleTextureColor=function(t){return null!=t._htc?t._htc:t.style.handleTextureColor},n.getHandleBackgroundImage=function(t){return null!=t._hbi?t._hbi:t.style.handleBackgroundImage},n.getHandleWidth=function(t){return null!=t._hw?t._hw:t.style.handleWidth},n.getHandleHeight=function(t){return null!=t._hh?t._hh:t.style.handleHeight},n.getBorderTopColor=function(t){return null!=t._btc?t._btc:t.style.borderTopColor},n.getBorderTopStyle=function(t){return null!=t._bts?t._bts:t.style.borderTopStyle},n.getWindowBackgroundColor=function(t){return null!=t._wbc?t._wbc:t.style.windowBackgroundColor},n.getWindowBackgroundAlpha=function(t){return t.style.windowBackgroundAlpha},n.getWindowBorderTopStyle=function(t){return null!=t._wbts?t._wbts:t.style.windowBorderTopStyle},n.getWindowBorderRightStyle=function(t){return null!=t._wbrs?t._wbrs:t.style.windowBorderRightStyle},n.getWindowBorderBottomStyle=function(t){return null!=t._wbbs?t._wbbs:t.style.windowBorderBottomStyle},n.getWindowBorderLeftStyle=function(t){return null!=t._wbls?t._wbls:t.style.windowBorderLeftStyle},n.getWindowBorderTopColor=function(t){return null!=t._wbtc?t._wbtc:t.style.windowBorderTopColor},n.getWindowBorderRightColor=function(t){return null!=t._wbrc?t._wbrc:t.style.windowBorderRightColor},n.getWindowBorderBottomColor=function(t){return null!=t._wbbc?t._wbbc:t.style.windowBorderBottomColor},n.getWindowBorderLeftColor=function(t){return null!=t._wblc?t._wblc:t.style.windowBorderLeftColor},n.getOverviewBackgroundColor=function(t){return null!=t._obc?t._obc:t.style.overviewBackgroundColor},n.getCurrentTimeIndicatorColor=function(t){return null!=t._ctic?t._ctic:t.style.currentTimeIndicatorColor},n.getTimeAxisBarColor=function(t){return null!=t._tabc?t._tabc:t.style.timeAxisBarColor},n.getTimeAxisBarAlpha=function(t){return null!=t._tabo?t._tabo:t.style.timeAxisBarAlpha},n.getTimeIndicatorColor=function(t){return null!=t._tic?t._tic:t.style.timeIndicatorColor},n.getLeftFilterPanelColor=function(t){return t.style.leftFilterPanelColor},n.getLeftFilterPanelAlpha=function(t){return t.style.leftFilterPanelAlpha},n.getRightFilterPanelColor=function(t){return t.style.rightFilterPanelColor},n.getRightFilterPanelAlpha=function(t){return t.style.rightFilterPanelAlpha}}(dvt);
  return dvt;
});
