/**
 * Copyright (c) 2014, 2016, Oracle and/or its affiliates.
 * The Universal Permissive License (UPL), Version 1.0
 */
"use strict";
define(['./DvtToolkit', './DvtSubcomponent'], function(dvt) {
  // Internal use only.  All APIs and functionality are subject to change at any time.

!function(t){var e=function(){};t.Obj.createSubclass(e,t.BaseComponent),e.prototype.Init=function(i,o,n){e.superclass.Init.call(this,i,o,n),this.EventManager=this.CreateEventManager(this,i,this.dispatchEvent,this),this.EventManager.addListeners(this),this._dragSource=new t.DragSource(i),this._dropTarget=new s(this),this.EventManager.setDragSource(this._dragSource),this._legend=null,this._hasFocus=!1,this._navigableIdToFocus=null},e.prototype.SetOptions=function(e){if(e){if(this.Options=this.Defaults.calcOptions(e),t.Agent.isEnvironmentBrowser()||(this.Options.animationOnDisplay="none",this.Options.animationOnDataChange="none"),this.Options._nodes=this.Options.nodes,this.Options.rootNode){this.Options._ancestors=null;var i=d.findRootAndAncestors(this.Options.nodes,this.Options.rootNode,[]);i&&i.root&&(this.Options.nodes=[i.root]),i&&i.ancestors&&(this.Options._ancestors=i.ancestors)}}else this.Options||(this.Options=this.GetDefaults())},e.prototype.render=function(e,s,o){var n=e||!this.Options;this.SetOptions(e);var r=this._processNodes();this.ApplyParsedProperties({root:r}),isNaN(s)||isNaN(o)||(this.Width=s,this.Height=o),this.EventManager&&this.EventManager.hideTooltip();var a=new t.Rectangle(0,0,this.Width,this.Height);this.Layout(a);var l=new t.Container(this.getCtx());this.addChild(l),this._templates&&(this._afContext=new t.AfContext(this.getCtx(),this.EventManager),this._afContext.setRmIfNotFit(!0)),this.Render(l,a),this.StopAnimation();var h=this.getOptions().animationOnDataChange,_=new t.Rectangle(0,0,this.Width,this.Height),d=!1;if(this._container){if(h&&n)if(t.BlackBoxAnimationHandler.isSupported(h))this.Animation=t.BlackBoxAnimationHandler.getCombinedAnimation(this.getCtx(),h,this._container,l,_,this.AnimationDuration),d=!0;else if(this._oldRoot&&"auto"==h){this._deleteContainer=this.GetDeleteContainer(),this.addChild(this._deleteContainer);var u=new i(this.getCtx(),this._deleteContainer);u.animate(this._oldRoot,this._root,this._oldAncestors,this._ancestors),this.Animation=u.getAnimation(!0)}}else this.Animation=this.GetDisplayAnimation(l,_);this._oldRoot=null,this._oldAncestors=null,this.Animation&&(this.EventManager.removeListeners(this),this.Animation.setOnEnd(this.OnAnimationEnd,this),this.Animation.play()),d?this._oldContainer=this._container:this._container&&this.removeChild(this._container),this._container=l,n?this._processInitialSelections():this.ReselectNodes(),this._processInitialFocus(!this.Animation),this.Animation||this._processInitialHighlighting(),this.UpdateAriaAttributes(),this.Animation||this.RenderComplete()},e.prototype.Parse=function(t){return null},e.prototype.Layout=function(t){},e.prototype.Render=function(t,e){},e.prototype.RenderBackground=function(e,i){var s=new t.Rect(this.getCtx(),0,0,this.Width,this.Height);s.setInvisibleFill(),e.addChild(s)},e.prototype.LayoutBreadcrumbs=function(t){if(this._ancestors.length>0){var e=this._root?this._root.getLabel():null;this._breadcrumbs&&this.EventManager.removeComponentKeyboardHandler(this._breadcrumbs.getEventManager()),this._breadcrumbs=a.render(this,t,this._ancestors,e),this.EventManager.addComponentKeyboardHandlerAt(this._breadcrumbs.getEventManager(),0)}else this._breadcrumbs&&this.EventManager.removeComponentKeyboardHandler(this._breadcrumbs.getEventManager()),this._breadcrumbs=null},e.prototype.RenderBreadcrumbs=function(t){this._breadcrumbs&&t.addChild(this._breadcrumbs)},e.prototype.LayoutLegend=function(t){this._legend=l.render(this,t,this._legendSource)},e.prototype.RenderLegend=function(t){this._legend&&(t.addChild(this._legend),this._legend=null)},e.prototype.RenderEmptyText=function(e){var i=this.getOptions(),s=i.emptyText;s||(s=t.Bundle.getTranslation(i,"labelNoData",t.Bundle.UTIL_PREFIX,"NO_DATA")),t.TextUtils.renderEmptyText(e,s,new t.Rectangle(0,0,this.Width,this.Height),this.getEventManager(),i._statusMessageStyle)},e.prototype.HasValidData=function(){return this._root&&this._root.getSize()>0},e.prototype.GetDisplayAnimation=function(e,i){var s=this.getOptions().animationOnDisplay;return t.BlackBoxAnimationHandler.isSupported(s)?t.BlackBoxAnimationHandler.getInAnimation(this.getCtx(),s,e,i,this.AnimationDuration):null},e.prototype.OnAnimationEnd=function(){this._deleteContainer&&(this.removeChild(this._deleteContainer),this._deleteContainer=null),this._oldContainer&&(this.removeChild(this._oldContainer),this._oldContainer=null),this.EventManager.addListeners(this),this._processInitialFocus(!0),this._processInitialHighlighting(),this.AnimationStopped||this.RenderComplete(),this.Animation=null,this.AnimationStopped=!1},e.prototype.GetDeleteContainer=function(){return new t.Container(this.getCtx())},e.prototype.CreateKeyboardHandler=function(t){return new h(t)},e.prototype.CreateEventManager=function(t,e,i,s){return new o(t,e,i,s)},e.prototype.GetInitialFocusedItem=function(t){if(t&&t.isArtificialRoot()){var e=t.getChildNodes();if(e&&e.length>0)return e[0]}return t},e.prototype.highlight=function(e){this.getOptions().highlightedCategories=t.JsonUtils.clone(e),t.CategoryRolloverHandler.highlight(e,d.getAllNodes(this._root),"any"==this.getOptions().highlightMatch)},e.prototype.select=function(e){var i=this.getOptions();if(i.selection=t.JsonUtils.clone(e),this._selectionHandler){var s=d.getAllNodes(this._root);this._selectionHandler.processInitialSelections(i.selection,s)}},e.prototype.__getMaxDepth=function(){return this._maxDepth},e.prototype.__getNodeCount=function(){return this._nodeCount},e.prototype.ApplyParsedProperties=function(e){var i=this.getOptions();if(this._oldRoot=this._root,this._oldAncestors=this._ancestors,this._root=e.root,this._ancestors=i._ancestors?i._ancestors:[],this._nodeCount=this._root?d.calcNodeCount(this._root):0,this._maxDepth=this._root?d.calcMaxDepth(this._root,0):0,this.AnimationDuration=t.StyleUtils.getTimeMilliseconds(i.animationDuration)/1e3,this._styles=e.styles?e.styles:{},"none"==i.selectionMode?this._nodeSelection=null:"single"==i.selectionMode?this._nodeSelection=t.SelectionHandler.TYPE_SINGLE:this._nodeSelection=t.SelectionHandler.TYPE_MULTIPLE,this._nodeSelection?(this._selectionHandler=new t.SelectionHandler(this._nodeSelection),this._initialSelection=i.selection):this._selectionHandler=null,this.EventManager.setSelectionHandler(this._selectionHandler),this.EventManager.setKeyboardHandler(this.CreateKeyboardHandler(this.EventManager)),this._legendSource=null,this._attrGroups=[],i.attributeGroups){for(var s=d.getAllNodes(this._root),o=0;o<i.attributeGroups.length;o++){var n=i.attributeGroups[o],r=null;if("continuous"==n.attributeType)d.calcContinuousAttrGroupsExtents(n,s),r=new t.ContinuousAttrGroups(n.min,n.max,n.minLabel,n.maxLabel,n.colors);else{r=new t.DiscreteAttrGroups;for(var a=0;a<n.groups.length;a++){var l=n.groups[a];r.add(l.id,l.label,{color:l.color,pattern:l.pattern})}}this._attrGroups.push({attrGroups:r,stampId:n.S,id:n.id}),i._adf||i._legendSource||0!=o?i._legendSource&&i._legendSource==n.id&&(this._legendSource=r):this._legendSource=r}d.processContinuousAttrGroups(this._attrGroups,s)}var h=i._contextMenus;if(h&&h.length>0){var _=new t.ContextMenuHandler(this.getCtx(),h);this.EventManager.setContextMenuHandler(_)}var u=i._templates;if(u)for(var p in this._templates={},u){var c=t.AfComponentFactory.parseJsonElement(u[p]);this._templates[p]=c}},e.prototype.ReselectNodes=function(){for(var t=this._selectionHandler?this._selectionHandler.getSelection():new Array,e=0;e<t.length;e++)t[e].setSelected(!0)},e.prototype._processInitialSelections=function(){if(this._selectionHandler&&this._initialSelection){var t=d.getAllNodes(this._root);this._selectionHandler.processInitialSelections(this._initialSelection,t),this._initialSelection=null}},e.prototype._processInitialHighlighting=function(){var t=this.getOptions().highlightedCategories;t&&t.length>0&&this.highlight(t)},e.prototype._processInitialFocus=function(t){var e=null,i=this.__getNavigableIdToFocus();i&&(e=n.getNodeById(this._root,i),this.EventManager.setFocus(e)),t&&this.__setNavigableIdToFocus(null),e||(e=this.GetInitialFocusedItem(this._root),this.EventManager.setFocus(e)),t&&this.setFocused(this.isFocused())},e.prototype.setFocused=function(t){this._hasFocus=t,this.EventManager.setFocused(t)},e.prototype.isFocused=function(){return this._hasFocus},e.prototype.__getAnimationDuration=function(){return this.AnimationDuration},e.prototype.__getTemplate=function(t){return this._templates?this._templates[t]:null},e.prototype.__getAfContext=function(){return this._afContext},e.prototype.__getNodeUnderPoint=function(t,e){return this._root.getNodeUnderPoint(t,e)},e.prototype.__isDragAvailable=function(t){return this._selectionHandler?t[0]:null},e.prototype.__getDragTransferable=function(t){t.isSelected()||(this._selectionHandler.processClick(t,!1),this.EventManager.fireSelectionEvent());for(var e=[],i=this._selectionHandler.getSelection(),s=0;s<i.length;s++)e.push(i[s].getId());return e},e.prototype.__getDragFeedback=function(){for(var t=[],e=this._selectionHandler.getSelection(),i=0;i<e.length;i++)t.push(e[i].getDisplayable());return t},e.prototype.__showDropSiteFeedback=function(t){if(this._dropSiteFeedback&&(this.removeChild(this._dropSiteFeedback),this._dropSiteFeedback=null),t&&(this._dropSiteFeedback=t.getDropSiteFeedback(),this._dropSiteFeedback)){var e=this.getOptions().styleDefaults;this._dropSiteFeedback.setSolidFill(e._dropSiteFillColor,e._dropSiteOpacity),this._dropSiteFeedback.setSolidStroke(e._dropSiteBorderColor),this.addChild(this._dropSiteFeedback)}return this._dropSiteFeedback},e.prototype.__processBreadcrumbsEvent=function(e){e instanceof t.BreadcrumbsDrillEvent&&this.__drill(e.getId(),!1)},e.prototype.__drill=function(e,i){var s=this.getOptions()._widgetConstructor;i&&this._root&&e==this._root.getId()&&this._ancestors.length>0?(this.__setNavigableIdToFocus(e),this.dispatchEvent(t.EventFactory.newTreeDrillEvent(this._ancestors[0].id,d.findRootAndAncestors(this.getOptions()._nodes,this._ancestors[0].id,[]).root,s))):i||this.dispatchEvent(t.EventFactory.newTreeDrillEvent(e,d.findRootAndAncestors(this.getOptions()._nodes,e,[]).root,s)),this.getCtx().getTooltipManager().hideTooltip()},e.prototype.getLogicalObject=function(t){return this.EventManager.GetLogicalObject(t)},e.prototype.getRootNode=function(){return this._root},e.prototype.__getNavigableIdToFocus=function(){return this._navigableIdToFocus},e.prototype.__setNavigableIdToFocus=function(t){this._navigableIdToFocus=t},e.prototype.__getNodeSelection=function(){return this._nodeSelection},e.prototype.CreateNode=function(t){return null},e.prototype.getBundlePrefix=function(){return null},e.prototype.getAutomation=function(){return new u(this)},e.prototype.getBreadcrumbs=function(){return this._breadcrumbs},e.prototype._processNodes=function(){var e=this.getOptions();if(null==e.nodes||0==e.displayLevels)return null;var i=[],s=t.ArrayUtils.createBooleanMap(e.hiddenCategories);for(a=0;a<e.nodes.length;a++){var o=e.nodes[a];o._index=a;var n=this._processNode(s,o,e.displayLevels);n&&i.push(n)}if(1==i.length)return i[0];for(var r=0,a=0;a<i.length;a++)r+=i[a].getSize();var l={value:r,bArtificialRoot:!0},h=this.CreateNode(l);return h.setChildNodes(i),h},e.prototype._processNode=function(t,e,i){if(d.isHiddenNode(t,e))return null;var s=this.CreateNode(e);if(s.isDisclosed()&&i>1){for(var o=[],n=e.nodes?e.nodes:[],r=0;r<n.length;r++){var a=n[r];a._index=r;var l=this._processNode(t,a,null!=i?i-1:i);l&&o.push(l)}s.setChildNodes(o)}return s},e.prototype.UpdateAriaNavigation=function(e){if(t.Agent.isTouchDevice()||t.Agent.isEnvironmentTest())for(var i=d.getAllVisibleNodes(e),s=0;s<i.length-1;s++){var o=this.getId()+(i[s+1].getId()?i[s+1].getId():i[s+1].getLabel());o=o.replace(/\s+/g,""),i[s+1].getDisplayable().setId(o,!0),i[s].getDisplayable().setAriaProperty("flowto",o)}},e.prototype.isDragAvailable=function(t,e,i){return this._dragSource.isDragAvailable(i)},e.prototype.getDragTransferable=function(t,e){return this._dragSource.getDragTransferable(t,e)},e.prototype.getDragOverFeedback=function(t,e){return this._dragSource.getDragOverFeedback(t,e)},e.prototype.getDragContext=function(t,e){return this._dragSource.getDragContext(t,e)},e.prototype.getDragOffset=function(t,e){return this._dragSource.getDragOffset(t,e)},e.prototype.getPointerOffset=function(t,e){return this._dragSource.getPointerOffset(t,e)},e.prototype.initiateDrag=function(){this._dragSource.initiateDrag()},e.prototype.dragDropEnd=function(){this._dragSource.dragDropEnd()},e.prototype.acceptDrag=function(t,e,i){return this._dropTarget.acceptDrag(t,e,i)},e.prototype.dragEnter=function(){this._dropTarget.dragEnter()},e.prototype.dragExit=function(){this._dropTarget.dragExit()},e.prototype.getDropSite=function(t,e){return this._dropTarget.getDropSite(t,e)};var i=function(t,e){this.Init(t,e)};t.Obj.createSubclass(i,t.DataAnimationHandler),i.prototype.animate=function(t,e,s,o){if(this._bDrill=!1,this._oldRoot=t,this._oldAncestors=s,i._isAncestor(o,t)||i._isAncestor(s,e)){this._bDrill=!0;var n=t.getDescendantNodes(),r=e.getDescendantNodes();n.push(t),r.push(e),this.constructAnimation(n,r)}else this.constructAnimation([t],[e])},i.prototype.isDrillAnimation=function(){return this._bDrill},i.prototype.isAncestorInsert=function(t){return!!this._bDrill&&(this._oldRoot.getId()==t.getId()||i._isAncestor(this._oldAncestors,t))},i._isAncestor=function(t,e){if(!e||!t)return!1;for(var i=0;i<t.length;i++)if(t[i].id==e.getId())return!0;return!1};var s=function(t){this._view=t};t.Obj.createSubclass(s,t.DropTarget),s.prototype.acceptDrag=function(t,e,i){var s=this._view.__getNodeUnderPoint(t,e);return s?(s!=this._dropSite&&(this._view.__showDropSiteFeedback(s),this._dropSite=s),i[0]):(this._view.__showDropSiteFeedback(null),null)},s.prototype.dragExit=function(){this._view.__showDropSiteFeedback(null),this._dropSite=null},s.prototype.getDropSite=function(t,e){var i=this._view.__getNodeUnderPoint(t,e);return i?{clientRowKey:i.getId()}:null};var o=function(t,e,i,s){this.Init(e,i,s),this._view=t};t.Obj.createSubclass(o,t.EventManager),o.prototype.GetView=function(){return this._view},o.prototype.OnDblClickInternal=function(t){var e=this.GetLogicalObject(t.target);e&&e.isSelectable&&e.isSelectable()&&this._processDrill(e,t.shiftKey)},o.prototype.OnClick=function(t){o.superclass.OnClick.call(this,t);var e=this.GetLogicalObject(t.target);this._processNodeLabel(e),!e||e.isSelectable&&e.isSelectable()||this._processDrill(e,t.shiftKey)},o.prototype.OnMouseOver=function(t){o.superclass.OnMouseOver.call(this,t);var e=this.GetLogicalObject(t.target);e&&e.handleMouseOver&&e.handleMouseOver()},o.prototype.OnMouseOut=function(t){o.superclass.OnMouseOut.call(this,t);var e=this.GetLogicalObject(t.target);if(e&&e.handleMouseOut){var i=this.GetLogicalObject(t.relatedTarget),s=i&&i.getId?i.getId():null;null!=e.getId()&&s==e.getId()||e.handleMouseOut()}},o.prototype.ProcessKeyboardEvent=function(e){var i=!1,s=e.keyCode,n=this.getFocus();return s!=t.KeyboardEvent.ENTER||e.ctrlKey?i=o.superclass.ProcessKeyboardEvent.call(this,e):((n=this.getFocus()).isDrillReplaceEnabled&&n.isDrillReplaceEnabled()&&(e.shiftKey&&(n=this._view.getRootNode()),this._view.__drill(n.getId(),e.shiftKey)),t.EventManager.consumeEvent(e),i=!0),i},o.prototype.HandleTouchClickInternal=function(t){var e=t.target,i=this.GetLogicalObject(e);this._processNodeLabel(i),this._currentHoverItem&&this._currentHoverItem!=i&&(this._currentHoverItem.handleMouseOut(),this._currentHoverItem=null),i&&(i instanceof n&&this._currentHoverItem!=i&&(this._currentHoverItem=i,i.handleMouseOver()),i.isSelectable&&i.isSelectable()||this._processDrill(i,t.shiftKey))},o.prototype.HandleTouchDblClickInternal=function(t){var e=t.target,i=this.GetLogicalObject(e);i&&i.isSelectable&&i.isSelectable()&&this._processDrill(i,!1)},o.prototype._processNodeLabel=function(t){t&&t instanceof r&&t.isDrillable()&&this._view.__drill(t.getId(),!1)},o.prototype._processDrill=function(t,e){t.isDrillReplaceEnabled&&t.isDrillReplaceEnabled()&&this._view.__drill(t.getId(),e)},o.prototype.ProcessRolloverEvent=function(e,i,s){var o=this._view.getOptions();if("dim"==o.hoverBehavior){var n=i.getCategories?i.getCategories():[];o.highlightedCategories=s?n.slice():null;var r=t.EventFactory.newCategoryHighlightEvent(o.highlightedCategories,s),a=d.getAllNodes(this.GetView().getRootNode()),l=t.StyleUtils.getTimeMilliseconds(o.hoverBehaviorDelay);this.RolloverHandler.processEvent(r,a,l,"any"==o.highlightMatch)}},o.prototype.GetTouchResponse=function(){return this._view.getOptions().touchResponse};var n=function(){};t.Obj.createSubclass(n,t.Obj),n._ANIMATION_DELETE_PRIORITY=0,n._ANIMATION_UPDATE_PRIORITY=1,n._ANIMATION_INSERT_PRIORITY=2,n._DEFAULT_FILL_COLOR="#000000",n._DEFAULT_TEXT_SIZE=11,n.__NODE_SELECTED_SHADOW=new t.Shadow("#000000",2,5,5,45,.5),n.prototype.Init=function(e,i){this._view=e,this._options=i;var s=this._view.getOptions();this._id=i.id||i.label,this._color=i.color?i.color:n._DEFAULT_FILL_COLOR,this._textStr=i.label,this._labelStyle=i.labelStyle?new t.CSSStyle(i.labelStyle):null,this._pattern=i.pattern,this._selectable=i.selectable,this._shortDesc=i.shortDesc?i.shortDesc:i.tooltip,this._size=i.value;var o=i.drilling;this._drilling="on"==o||"off"==o?o:s.drilling,this._stampId=i.S,this._bArtificialRoot=i.bArtificialRoot,this._alpha=1,this._lastVisitedChild=null,this._isShowingKeyboardFocusEffect=!1,this.IsHover=!1},n.prototype.setChildNodes=function(t){if(null!=t)for(var e=0;e<t.length;e++)t[e]._parent=this;this._children=t},n.prototype.getChildNodes=function(){return this._children?this._children:[]},n.prototype.getDescendantNodes=function(){var t,e,i=[];if(!this.hasChildren())return i;for(var s=0;s<this._children.length;s++)t=(e=this._children[s]).getDescendantNodes(),i.push(e),i=i.concat(t);return i},n.prototype.SetLastVisitedChild=function(t){this._lastVisitedChild=t},n.prototype.GetLastVisitedChild=function(){return this._lastVisitedChild},n.prototype.MarkAsLastVisitedChild=function(){var t=this.GetParent();t&&t.SetLastVisitedChild(this)},n.prototype.isDescendantOf=function(t){return!(!t||!this.GetParent())&&(this.GetParent()==t||this.GetParent().isDescendantOf(t))},n.prototype.GetNodesAtDepth=function(t,e){var i=[];if(e<0)return i;if(0==e)return[this];if(t.hasChildren())for(var s,o=t.getChildNodes(),n=0;n<o.length;n++)s=o[n],i=i.concat(s.GetNodesAtDepth(s,e-1));return i},n.getNodeById=function(t,e){if(t.getId()==e)return t;for(var i=null,s=t.getChildNodes(),o=s.length,r=null,a=0;a<o;a++)if(r=s[a],i=n.getNodeById(r,e))return i;return null},n.prototype.getView=function(){return this._view},n.prototype.getStampId=function(){return this._stampId},n.prototype.getOptions=function(){return this._options},n.prototype.getCategories=function(){if(this.isArtificialRoot())return[];var t=this.getOptions().categories;if(!t){var e=this.GetParent(),i=e?e.getCategories():null;(t=i?i.slice():[]).push(this.getId())}return t},n.prototype.getId=function(){return this._id},n.prototype.getSize=function(){return this._size},n.prototype.getColor=function(){return this._color},n.prototype.getDatatip=function(){var t=this._view.getOptions().tooltip,e=t?t.renderer:null;return e?this.getView().getCtx().getTooltipManager().getCustomTooltip(e,this.getDataContext()):this._shortDesc},n.prototype.getDatatipColor=function(){return this._color},n.prototype.getShortDesc=function(){return this._shortDesc},n.prototype.getDataContext=function(){return{id:this.getId(),label:this.getLabel(),value:this.getSize(),color:this.getColor(),data:this.getOptions(),component:this.getView().getOptions()._widgetConstructor}},n.prototype.getIndex=function(){return this.getOptions()._index},n.prototype.getAlpha=function(){return this._alpha},n.prototype.setAlpha=function(t){this._alpha=t,this._shape&&this._shape.setAlpha(this._alpha)},n.prototype.setDisclosed=function(t){this.getOptions()._expanded=t},n.prototype.isDisclosed=function(){return!1!==this.getOptions()._expanded},n.prototype.isArtificialRoot=function(){return this._bArtificialRoot},n.prototype.isDrillReplaceEnabled=function(){return"on"==this._drilling},n.prototype.getShowPopupBehaviors=function(){var e=this.getView().getOptions()._spb;return e&&e[this.getStampId()]?t.ShowPopupBehavior.createBehaviors(e[this.getStampId()]):null},n.prototype.render=function(t){},n.prototype.renderChildren=function(t){var e=this.getChildNodes();if(null!=e)for(var i=0;i<e.length;i++)e[i].render(t)},n.prototype.processAttrGroups=function(t){var e=t.get(this.getOptions()._cv);e&&(this._color=e)},n.prototype.getNextNavigable=function(t){return this.MarkAsLastVisitedChild(),this},n.prototype.getKeyboardBoundingBox=function(e){return new t.Rectangle(0,0,0,0)},n.prototype.getTargetElem=function(){return null},n.prototype.showKeyboardFocusEffect=function(){this._isShowingKeyboardFocusEffect=!0,this.showHoverEffect(),this.handleMouseOver&&this.handleMouseOver()},n.prototype.hideKeyboardFocusEffect=function(){this._isShowingKeyboardFocusEffect&&(this._isShowingKeyboardFocusEffect=!1,this.hideHoverEffect()),this.handleMouseOut&&this.handleMouseOut()},n.prototype.isShowingKeyboardFocusEffect=function(){return this._isShowingKeyboardFocusEffect},n.prototype.handleMouseOver=function(){this.IsHover=!0},n.prototype.handleMouseOut=function(){this.IsHover=!1},n.prototype.isSelectable=function(){return"off"!=this._selectable&&null!=this.getView().__getNodeSelection()},n.prototype.isSelected=function(){return this._selected},n.prototype.setSelected=function(t){this._selected=t,this.UpdateAriaLabel()},n.prototype.showHoverEffect=function(){},n.prototype.hideHoverEffect=function(){},n.prototype.highlight=function(t,e){this.setAlpha(e)},n.prototype.isDragAvailable=function(t){return this.getView().__isDragAvailable(t)},n.prototype.getDragTransferable=function(t,e){return this.getView().__getDragTransferable(this)},n.prototype.getDragFeedback=function(t,e){return this.getView().__getDragFeedback()},n.prototype.getDropSiteFeedback=function(){return null},n.prototype.getPopupBounds=function(t){return null},n.prototype.contains=function(t,e){return!1},n.prototype.getNodeUnderPoint=function(t,e){return null},n.prototype.GetAnimationParams=function(){return[]},n.prototype.SetAnimationParams=function(t){},n.prototype.animateUpdate=function(e,i){e.isDrillAnimation()||e.constructAnimation(i.getChildNodes(),this.getChildNodes());var s,o=this.GetAnimationParams(),r=i.GetAnimationParams(o);if(!t.ArrayUtils.equals(r,o)){(s=new t.CustomAnimation(this.getView().getCtx(),this,this.getView().__getAnimationDuration())).getAnimator().addProp(t.Animator.TYPE_NUMBER_ARRAY,this,this.GetAnimationParams,this.SetAnimationParams,o),e.add(s,n._ANIMATION_UPDATE_PRIORITY);var a=this._size!=i._size,l=t.ColorUtils.getRGBA(this._color)!=t.ColorUtils.getRGBA(i._color);this.SetAnimationParams(r);var h=this._view.getOptions().animationUpdateColor;h&&(a||l)&&(this._color=h)}},n.prototype.animateInsert=function(e){if(!e.isDrillAnimation()||!e.isAncestorInsert(this)){this.setAlpha(0);var i=new t.AnimFadeIn(this.getView().getCtx(),this,this.getView().__getAnimationDuration());if(e.add(i,n._ANIMATION_INSERT_PRIORITY),this.hasChildren())for(var s=0;s<this._children.length;s++)this._children[s].animateInsert(e)}},n.prototype.animateDelete=function(e,i){i.addChild(this._shape);var s=new t.AnimFadeOut(this.getView().getCtx(),this,this.getView().__getAnimationDuration());if(e.add(s,n._ANIMATION_DELETE_PRIORITY),!e.isDrillAnimation()&&this.hasChildren())for(var o=0;o<this._children.length;o++)this._children[o].animateDelete(e,i)},n.prototype.hasChildren=function(){return null!=this._children&&this._children.length>0},n.prototype.GetParent=function(){return this._parent},n.prototype.GetDepth=function(){for(var t=0,e=this.GetParent();e;)t++,e=e.GetParent();return t},n.prototype.GetFill=function(){return this._pattern?new t.PatternFill(this._pattern,this._color):new t.SolidFill(this._color)},n.GetNodeTextColor=function(e){return e._pattern?"#000000":t.ColorUtils.getContrastingTextColor(e._color)},n.prototype.ApplyLabelTextStyle=function(e){var i=n.GetNodeTextColor(this);e.setSolidFill(i),e.setCSSStyle(this.getMergedLabelTextStyle()),t.Agent.isHighContrast()&&e.setSolidFill(i)},n.prototype.getMergedLabelTextStyle=function(){var e=new Array;return e.push(this._view.getOptions().nodeDefaults.labelStyle),this._labelStyle&&e.push(this._labelStyle),t.CSSStyle.mergeStyles(e)},n.prototype.GetTextSize=function(){var t=n._DEFAULT_TEXT_SIZE,e=this._view.getOptions().nodeDefaults.labelStyle.getFontSize();return e&&(t=parseFloat(e)),t},n.prototype.getLabelBackgroundColor=function(){var t=this._labelStyle,e=t?t.getStyle("background-color"):null;return e||this._view.getOptions().nodeDefaults.labelStyle.getStyle("background-color")},n.prototype.getDisplayable=function(){return this._shape},n.prototype.getLabel=function(){return this._textStr},n.prototype.GetAfContext=function(){return this.getView().__getAfContext()},n.prototype.GetElAttributes=function(){return this.getOptions()._cf},n.prototype.GetTemplate=function(){return this.getView().__getTemplate(this.getStampId())},n.prototype.isDoubleClickable=function(){return this.isDrillReplaceEnabled()},n.prototype.UpdateAriaLabel=function(){},n.prototype.isRootNode=function(){return this.getId()==this.getView().getRootNode().getId()||this.isArtificialRoot()};var r=function(t,e,i,s,o){this.Init(i,s,o),this._node=t,this._id=e,this._bDrillable=!1};t.Obj.createSubclass(r,t.SimpleObjPeer),r.prototype.getId=function(){return this._id},r.prototype.isDrillable=function(){return this._bDrillable},r.prototype.setDrillable=function(t){this._bDrillable=t},r.prototype.handleMouseOver=function(){this._node&&this._node.handleMouseOver&&this._node.handleMouseOver()},r.prototype.handleMouseOut=function(){this._node&&this._node.handleMouseOut&&this._node.handleMouseOut()};var a=function(){};t.Obj.createSubclass(a,t.Obj),a._COMPONENT_GAP=6,a._ENABLED_INLINE_STYLE="color: #003286;",a.render=function(e,i,s,o){var n=e.getCtx(),r=e.getOptions().styleDefaults,l=new Array;l.push(new t.CSSStyle(a._ENABLED_INLINE_STYLE)),l.push(r._drillTextStyle);var h=t.CSSStyle.mergeStyles(l).toString(),_=h+"text-decoration: underline;",d=new Array;d.push(r._currentTextStyle);var u={labelStyle:h,labelStyleOver:_,labelStyleDown:_,disabledLabelStyle:t.CSSStyle.mergeStyles(d).toString()},p=new t.Breadcrumbs(n,e.__processBreadcrumbsEvent,e,u);e.addChild(p);var c=s.slice(0).reverse();c.push({label:o});var g={items:c};p.render(g,i.w);var E=p.getDimensions();p.setTranslate(i.x,i.y);var f=E.h+a._COMPONENT_GAP;return i.y+=f,i.h-=f,e.removeChild(p),p};var l=function(){};t.Obj.createSubclass(l,t.Obj),l._LEGEND_GAP=4,l._LEGEND_LABEL_GAP=7,l._LEGEND_SECTION_GAP=24,l._LABEL_SIZE=11,l._LABEL_COLOR="#636363",l._LABEL_INLINE_STYLE="color:"+l._LABEL_COLOR+";",l.render=function(e,i,s){var o=e.getOptions(),n=o.sizeLabel,r=o.colorLabel;if(null!=n||null!=r||null!=s){var a=e.getCtx(),h=e.getEventManager(),_=new t.Container(a);e.addChild(_);var d=l._renderLabels(a,e,_,i.w,n,r,s),u=t.CSSStyle.afterSkinAlta(e.getOptions().skin)?null:"#000000",p=new Array;p.push(o.styleDefaults._labelStyle);var c={borderColor:u,labelStyle:t.CSSStyle.mergeStyles(p)},g=t.LegendAttrGroupsRenderer.renderAttrGroups(a,h,_,i.w,i.h,s,c),E=d?d.getDimensions():null,f=g?g.getDimensions():null;if(d&&!g)d.setTranslateX(i.y+(i.w-E.w)/2);else if(g&&!d)g.setTranslateX(i.y+(i.w-f.w)/2);else if(g&&d){var y=i.w-l._LEGEND_SECTION_GAP;if(E.w+f.w>y){if(E.w>y/2&&f.w>y/2)_.removeChild(d),_.removeChild(g),d=l._renderLabels(a,e,_,y/2,n,r,s),g=t.LegendAttrGroupsRenderer.renderAttrGroups(a,h,_,y/2,i.h,s,c);else if(E.w>f.w){var S=y-f.w;_.removeChild(d),d=l._renderLabels(a,e,_,S,n,r,s)}else{var v=y-E.w;_.removeChild(g),g=t.LegendAttrGroupsRenderer.renderAttrGroups(a,h,_,v,i.h,s,c)}E=d.getDimensions(),f=g.getDimensions()}t.Agent.isRightToLeft(a)?(g.setTranslateX(i.x),d.setTranslateX(i.x+i.w-E.w)):(d.setTranslateX(i.x),g.setTranslateX(i.x+i.w-f.w))}var T=_.getDimensions();return _.setTranslateY(i.y+i.h-T.h),i.h-=T.h+l._LEGEND_GAP,e.removeChild(_),_}},l._renderLabels=function(e,i,s,o,n,r,a){var h=t.Agent.isRightToLeft(e),_=i.getEventManager(),d=i.getOptions().styleDefaults,u=null;if(n||r){u=new t.Container(e),s.addChild(u);var p=new Array;p.push(d._attributeTypeTextStyle);var c=t.CSSStyle.mergeStyles(p);(p=new Array).push(d._attributeValueTextStyle);var g,E,f,y,S,v,T,A,C=t.CSSStyle.mergeStyles(p),O=0;if(n){var I=t.Bundle.getTranslation(i.getOptions(),"labelSize",i.getBundlePrefix(),"SIZE");(g=new t.OutputText(e,I,0,0)).setCSSStyle(c),u.addChild(g),f=g.getDimensions().w,(E=new t.OutputText(e,n,0,0)).setCSSStyle(C),u.addChild(E),O=f+(y=E.getDimensions().w)+l._LEGEND_LABEL_GAP}var R=0;if(r){var b=t.Bundle.getTranslation(i.getOptions(),"labelColor",i.getBundlePrefix(),"COLOR");(S=new t.OutputText(e,b,0,0)).setCSSStyle(c),u.addChild(S),T=S.getDimensions().w,(v=new t.OutputText(e,r,0,0)).setCSSStyle(C),u.addChild(v),R=T+(A=v.getDimensions().w)+l._LEGEND_LABEL_GAP}if(O+R>(o-=l._LEGEND_SECTION_GAP)){var x=o/2;if(O>x&&R>x){var N=x-f-l._LEGEND_LABEL_GAP;t.TextUtils.fitText(E,N,1/0,u)?(y=E.getDimensions().w,_.associate(E,new t.SimpleObjPeer(n))):(u.removeChild(g),u.removeChild(E),E=null,y=0);var D=x-T-l._LEGEND_LABEL_GAP;t.TextUtils.fitText(v,D,1/0,u)?(A=v.getDimensions().w,_.associate(v,new t.SimpleObjPeer(r))):(u.removeChild(S),u.removeChild(v),v=null,A=0)}else O>R?t.TextUtils.fitText(E,o-R-f-l._LEGEND_LABEL_GAP,1/0,u)?(y=E.getDimensions().w,_.associate(E,new t.SimpleObjPeer(n))):(u.removeChild(g),u.removeChild(E),E=null,y=0):t.TextUtils.fitText(v,o-O-T-l._LEGEND_LABEL_GAP,1/0,u)?(A=v.getDimensions().w,_.associate(v,new t.SimpleObjPeer(r))):(u.removeChild(S),u.removeChild(v),v=null,A=0)}var m=0;h?(v&&(v.setX(m),m+=A+l._LEGEND_LABEL_GAP,S.setX(m),m+=T+l._LEGEND_SECTION_GAP),E&&(E.setX(m),m+=y+l._LEGEND_LABEL_GAP,g.setX(m))):(E&&(g.setX(m),m+=f+l._LEGEND_LABEL_GAP,E.setX(m),m+=y+l._LEGEND_SECTION_GAP),v&&(S.setX(m),m+=T+l._LEGEND_LABEL_GAP,v.setX(m)))}return u};var h=function(t){this.Init(t)};t.Obj.createSubclass(h,t.KeyboardHandler),h.prototype.isSelectionEvent=function(t){return this.isNavigationEvent(t)&&!t.ctrlKey},h.prototype.isMultiSelectEvent=function(e){return e.keyCode==t.KeyboardEvent.SPACE&&e.ctrlKey};var _=function(){};t.Obj.createSubclass(_,t.BaseComponentDefaults),_.VERSION_1={skin:t.CSSStyle.SKIN_ALTA,animationDuration:500,animationOnDataChange:"none",animationOnDisplay:"none",drilling:"off",displayLevels:Number.MAX_VALUE,highlightMatch:"all",hoverBehavior:"none",hoverBehaviorDelay:200,nodeDefaults:{labelStyle:new t.CSSStyle(t.BaseComponentDefaults.FONT_FAMILY_ALTA_11),labelMinLength:1},selectionMode:"multiple",sorting:"off",_statusMessageStyle:new t.CSSStyle(t.BaseComponentDefaults.FONT_FAMILY_ALTA),styleDefaults:{_attributeTypeTextStyle:new t.CSSStyle(t.BaseComponentDefaults.FONT_FAMILY_ALTA_BOLD_12+"color:#4F4F4F"),_attributeValueTextStyle:new t.CSSStyle(t.BaseComponentDefaults.FONT_FAMILY_ALTA_12),_currentTextStyle:new t.CSSStyle(t.BaseComponentDefaults.FONT_FAMILY_ALTA_12),_drillTextStyle:new t.CSSStyle(t.BaseComponentDefaults.FONT_FAMILY_ALTA_12),_labelStyle:new t.CSSStyle(t.BaseComponentDefaults.FONT_FAMILY_ALTA)},touchResponse:"auto",_resources:{}},_.prototype.Init=function(e){var i={skyros:t.JsonUtils.merge(e.skyros,_.VERSION_1),alta:t.JsonUtils.merge(e.alta,{}),next:t.JsonUtils.merge(e.next,{})};_.superclass.Init.call(this,i)},_.prototype.getAnimationDuration=function(t){return t.animationDuration};var d={};t.Obj.createSubclass(d,t.Obj),d.calcMaxDepth=function(t,e){var i=e,s=t.getChildNodes();if(s)for(var o=0;o<s.length;o++){var n=d.calcMaxDepth(s[o],e+1);i=Math.max(i,n)}return i},d.calcNodeCount=function(t){var e=1,i=t.getChildNodes();if(i)for(var s=0;s<i.length;s++)e+=d.calcNodeCount(i[s]);return e},d.getAllNodes=function(t){var e=[];return d._addNodesToArray(t,e),e},d.getAllVisibleNodes=function(t){var e=[];return d._addNodesToArray(t,e,!1,!0),e},d.getLeafNodes=function(t){var e=[];return d._addNodesToArray(t,e,!0),e},d.isHiddenNode=function(e,i){return t.ArrayUtils.hasAnyMapItem(e,i.categories)},d.calcContinuousAttrGroupsExtents=function(t,e){var i=t.S;if(null!=i&&(null==t.min||null==t.max)){for(var s=1/0,o=-1/0,n=0;n<e.length;n++){var r=e[n];if(i==r.getStampId()){var a=r.getOptions()._cv;null!=a&&(o=Math.max(o,a),s=Math.min(s,a))}}null==t.min&&(t.min=s),null==t.max&&(t.max=o)}},d.processContinuousAttrGroups=function(e,i){for(var s=0;s<e.length;s++){var o=e[s],n=o.attrGroups,r=o.stampId;if(n instanceof t.ContinuousAttrGroups&&null!=r)for(var a=0;a<i.length;a++){var l=i[a];r==l.getStampId()&&l.processAttrGroups(n)}}},d._addNodesToArray=function(t,e,i,s){if(t){var o=t.getChildNodes(),n=o?o.length:0;i&&0!=n||s&&!t.getDisplayable()||e.push(t);for(var r=0;r<n;r++)d._addNodesToArray(o[r],e,i,s)}},d.findRootAndAncestors=function(t,e,i){for(var s=0;s<t.length;s++){if(t[s].id==e)return{root:t[s],ancestors:i};if(t[s].nodes){i.unshift(t[s]);var o=d.findRootAndAncestors(t[s].nodes,e,i);if(null!=o)return o;i.shift()}}return null};var u=function(t){this._treeView=t};t.Obj.createSubclass(u,t.Automation),u.NODE_ID_PREFIX="node",u.BREADCRUMBS_PREFIX="breadcrumbs",u.DISCLOSURE_SUFFIX="disclosure",u.ISOLATE_SUFFIX="isolate",u.RESTORE="restore",u.prototype.GetSubIdForDomElement=function(e){var i=this._treeView.getLogicalObject(e),s=this._treeView.getRootNode(),o=e instanceof t.Button;if(e.getParent()instanceof t.Button&&(e=e.getParent(),o=!0),!i){var a=e.getParent();return a instanceof t.Breadcrumbs?u.BREADCRUMBS_PREFIX+"["+a.getCrumbIndex(e)+"]":null}var l=null;if(i instanceof r&&o){var h=i._node;return l=this.GetSubIdForDomElement(h.getDisplayable()),this._getSubIdForButton(l,h,e)}if(i instanceof n){var _=i,d="";if(!s.isArtificialRoot()){if(_==s)return u.NODE_ID_PREFIX+"[0]";d+="[0]"}var p=this._getIndicesFromNode(_,s.getChildNodes());return(d=p?d+p:d).length>0&&(l=u.NODE_ID_PREFIX+d),o?this._getSubIdForButton(l,i,e):l}return null},u.prototype._getSubIdForButton=function(e,i,s){if(e){if(i instanceof p){var o=s.getAriaProperty("label"),n=t.Bundle.getTranslation(options,"stateIsolated",t.Bundle.UTIL_PREFIX,"STATE_ISOLATED");return o.indexOf(n)>=0?u.RESTORE:e+":"+u.ISOLATE_SUFFIX}if(i instanceof v)return e+":"+u.DISCLOSURE_SUFFIX}return null},u.prototype._getIndicesFromNode=function(t,e){if(e&&e.length>0)for(var i=0;i<e.length;i++){if(e[i]==t)return"["+i+"]";var s=this._getIndicesFromNode(t,e[i].getChildNodes());if(s)return"["+i+"]"+s}return null},u.prototype.getDomElementForSubId=function(e){if(!e)return null;var i=this._treeView.getRootNode();if(e==t.Automation.TOOLTIP_SUBID)return this.GetTooltipElement(this._treeView);if(0==e.indexOf(u.BREADCRUMBS_PREFIX)){var s=e.substring(e.indexOf("[")+1,e.indexOf("]")),o=i.getView().getBreadcrumbs().getCrumb(s);return o?o.getElem():null}if(e==u.RESTORE){var n=this._treeView._restoreNode||this._treeView.__getLastIsolatedNode();if(n)return n.getIsolateRestoreButton().getElem()}i.isArtificialRoot()||(e=e.substring(0,e.indexOf("["))+e.substring(e.indexOf("]")+1));var r=-1==e.indexOf("[")?i:this._getNodeFromSubId(i,e);if(r){var a=e.indexOf(":");if(!(a>=0))return r.getDisplayable().getElem();if(e=e.substring(a+1),r instanceof v&&e==u.DISCLOSURE_SUFFIX){var l=r.getExpandCollapseButton();if(l)return l.getElem()}if(r instanceof p&&e==u.ISOLATE_SUFFIX){var h=r.getIsolateRestoreButton();if(h)return h.getElem()}}return null},u.prototype._getNodeFromSubId=function(t,e){var i=e.indexOf("["),s=e.indexOf("]");if(i>=0&&s>=0){var o=e.substring(i+1,s),n=(e=e.substring(s+1)).indexOf("["),r=e.indexOf("]"),a=u._getNodeByIndex(t.getChildNodes(),o);return a&&n>=0&&r>=0?this._getNodeFromSubId(a,e):a}},u.prototype._getNodeFromPath=function(t,e){var i=e.shift(),s=u._getNodeByIndex(t.getChildNodes(),i);return 0==e.length?s:e.length>0?this._getNodeFromPath(s,e):null},u.prototype.getNode=function(t){var e=this._treeView.getRootNode();e.isArtificialRoot()||0!=t[0]||t.shift();var i=0==t.length?e:this._getNodeFromPath(e,t);return{color:i.getColor(),label:i.getLabel(),selected:null!=i.isSelected()&&i.isSelected(),size:i.getSize(),tooltip:i.getShortDesc()}},u._getNodeByIndex=function(t,e){for(var i=0;i<t.length;i++)if(e==t[i].getIndex())return t[i];return null},t.Treemap=function(t,e,i){this.Init(t,e,i)},t.Obj.createSubclass(t.Treemap,e),t.Treemap._BUFFER_SPACE=7,t.Treemap._MIN_BUFFER_SPACE=1,t.Treemap._BACKGROUND_FILL_COLOR="#EBEFF5",t.Treemap._BACKGROUND_BORDER_COLOR="#DBE0EA",t.Treemap._BACKGROUND_INLINE_DEFAULT="background-color:"+t.Treemap._BACKGROUND_FILL_COLOR+";border-color:"+t.Treemap._BACKGROUND_BORDER_COLOR+";border-width:2px",t.Treemap.newInstance=function(e,i,s){return new t.Treemap(e,i,s)},t.Treemap.prototype.Init=function(e,i,s){t.Treemap.superclass.Init.call(this,e,i,s),this.Defaults=new S,this._nodeContent={},this.setId("treemap1000"+Math.floor(1e9*Math.random()))},t.Treemap.prototype.ApplyParsedProperties=function(e){t.Treemap.superclass.ApplyParsedProperties.call(this,e);var i=this.getOptions();"sliceAndDiceHorizontal"==i.layout?this._layout=new E(!0):"sliceAndDiceVertical"==i.layout?this._layout=new E(!1):this._layout=new g,this._isolatedNodes=[],this._processInitialIsolate(i.isolatedNode),"auto"==i.animationOnDisplay&&(i.animationOnDisplay="alphaFade")},t.Treemap.prototype.Layout=function(e){var i="jet"!=this.getOptions()._environment?t.Treemap._BUFFER_SPACE:t.Treemap._MIN_BUFFER_SPACE;i=Math.max(Math.ceil(i*Math.min(e.w,e.h)/400),t.Treemap._MIN_BUFFER_SPACE),e.x+=i,e.y+=i,e.w-=2*i,e.h-=2*i;var s=this._layout.getGapSize(this,1);e.x+=s,e.w-=2*s,this.LayoutBreadcrumbs(e),this.LayoutLegend(e),e.x-=s,e.w+=2*s;var o=this._isolatedNodes.length;if(o>0&&this._isolateRestoreLayout){var n=this._isolatedNodes[o-1];this._layout.layout(this,n,e.x,e.y,e.w,e.h,!0)}else{this._root&&this._layout.layout(this,this._root,e.x,e.y,e.w,e.h,!1);for(var r=0;r<o;r++){var a=this._isolatedNodes[r];this._layout.layout(this,a,e.x,e.y,e.w,e.h,!0)}}},t.Treemap.prototype.Render=function(e,i){if(this.RenderBackground(e,t.Treemap._BACKGROUND_INLINE_DEFAULT),this.RenderBreadcrumbs(e),this.RenderLegend(e),this.HasValidData()){this._groupTextLayer=new t.Container(this.getCtx()),e.addChild(this._groupTextLayer),this._isolatedNode?this._isolatedNode.render(e):this._root.hasChildren()?(this._root.renderChildren(e),this.UpdateAriaNavigation(this._root)):this._root.render(e),this._isolatedLayer=new t.Container(this.getCtx()),e.addChild(this._isolatedLayer),this._selectedLayer=new t.Container(this.getCtx()),e.addChild(this._selectedLayer),e.addChild(this._groupTextLayer),this._hoverEffect=new t.Rect(this.getCtx(),0,0,0,0),this._hoverEffect.setVisible(!1),this._hoverEffect.setMouseEnabled(!1),this._hoverEffect.setPixelHinting(!0),this._hoverEffect.setInvisibleFill(),e.addChild(this._hoverEffect);for(var s=0;s<this._isolatedNodes.length;s++){var o=this._isolatedNodes[s].getDisplayable();this._isolatedLayer.addChild(o)}}else this.RenderEmptyText(e)},t.Treemap.prototype.OnAnimationEnd=function(){if(!this.AnimationStopped){this._container.removeChildren();var e=new t.Rectangle(0,0,this.Width,this.Height);this.Layout(e),this.Render(this._container),this.ReselectNodes()}t.Treemap.superclass.OnAnimationEnd.call(this)},t.Treemap.prototype.ReselectNodes=function(){for(var t=this._selectionHandler?this._selectionHandler.getSelection():new Array,e=0;e<t.length;e++)if(this._isolatedNodes.length>0){var i=this._isolatedNodes[this._isolatedNodes.length-1];(t[e]==i||t[e].isDescendantOf(i))&&t[e].setSelected(!0)}else t[e].setSelected(!0)},t.Treemap.prototype.CreateKeyboardHandler=function(t){return new f(t)},t.Treemap.prototype.CreateEventManager=function(t,e,i,s){return new y(t,e,i,s)},t.Treemap.prototype.GetInitialFocusedItem=function(t){var e=this.__getLastIsolatedNode();return e?this.__getDefaultNavigable(d.getLeafNodes(e)):t?this.__getDefaultNavigable(d.getLeafNodes(t)):null},t.Treemap.prototype.__showHoverEffect=function(t,e,i,s,o){this._hoverEffect.setX(t).setY(e).setWidth(i).setHeight(s),this._hoverEffect.setStroke(o),this._hoverEffect.setVisible(!0)},t.Treemap.prototype.__hideHoverEffect=function(){this._hoverEffect.setVisible(!1)},t.Treemap.prototype.__getGroupTextLayer=function(){return this._groupTextLayer},t.Treemap.prototype.__moveToSelectedLayer=function(t){for(var e=0,i=this._selectedLayer.getNumChildren(),s=0;s<i;s++){var o=this._selectedLayer.getChildAt(s);t.zIndex>o.zIndex&&(e=s+1)}e<i?this._selectedLayer.addChildAt(t,e):this._selectedLayer.addChild(t)},t.Treemap.prototype.__getNodeUnderPoint=function(t,e){return this._isolatedNodes.length>0?this._isolatedNodes[this._isolatedNodes.length-1].getNodeUnderPoint(t,e):this._root.getNodeUnderPoint(t,e)},t.Treemap.prototype.__isolate=function(e){var i=this.getEventManager().getFocus();i&&i.hideKeyboardFocusEffect(),this._isolatedNodes.push(e),this.getOptions().isolatedNode=e.getId(),this.dispatchEvent(t.EventFactory.newTreemapIsolateEvent(e.getId())),this._isolateRestoreLayout=!0,this.Layout(new t.Rectangle(0,0,this.Width,this.Height)),this._isolateRestoreLayout=!1;var s=e.getDisplayable();this._isolatedLayer.addChild(s),this._renderIsolateRestore(e)},t.Treemap.prototype.__restore=function(){this._restoreNode=this._isolatedNodes.pop(),this.getOptions().isolatedNode=this._isolatedNodes.length>0?this._isolatedNodes[this._isolatedNodes.length-1].getId():null;var e=this.getEventManager().getFocus();e&&e.hideKeyboardFocusEffect(),this.__setNavigableIdToFocus(this._restoreNode.getId()),this.dispatchEvent(t.EventFactory.newTreemapIsolateEvent()),this._isolateRestoreLayout=!0,this.Layout(new t.Rectangle(0,0,this.Width,this.Height)),this._isolateRestoreLayout=!1,this._renderIsolateRestore(this._restoreNode),this._restoreNode=null},t.Treemap.prototype.__getLastIsolatedNode=function(){return this._isolatedNodes&&this._isolatedNodes.length>0?this._isolatedNodes[this._isolatedNodes.length-1]:null},t.Treemap.prototype._renderIsolateRestore=function(e){if("none"!=this.getOptions().animationOnDataChange){for(var i=this._selectionHandler?this._selectionHandler.getSelection():new Array,s=0;s<i.length;s++)i[s].setSelected(!1);var o=e.getIsolateAnimation();this.Animation=new t.ParallelPlayable(this.getCtx(),o),this.Animation.setOnEnd(this.OnAnimationEnd,this),this.getEventManager().removeListeners(this),this.Animation.play()}else this.render(null,this.Width,this.Height,!0)},t.Treemap.prototype._processInitialIsolate=function(t){if(t&&this._root){var e=this._root.getDescendantNodes();e.push(this._root);for(var i=0;i<e.length;i++)if(e[i].getId()==t)return void this._isolatedNodes.push(e[i])}},t.Treemap.prototype.__getDefaultNavigable=function(t){var e=this.getEventManager().getKeyboardHandler();return e?e.getDefaultNavigable(t):t&&t.length>0?t[0]:null},t.Treemap.prototype.getShapesForViewSwitcher=function(t){var e={};if(this._root)for(var i=[this._root];i.length>0;){var s=i.splice(0,1)[0],o=s.getId(),n=s.getDisplayable();if(o&&n&&(e[o]=n,e[o+"_text"]=s._text,s._topLeftShape&&n.removeChild(s._topLeftShape),s._fillShape&&n.removeChild(s._fillShape),n.setFill(s.GetFill()),t)){var r=s.GetParent();if(r){var a=r.getDisplayable(),l=null;if(l=a?a.getParent():this._container){var h=l.getChildIndex(a);s._border&&l.addChildAt(s._border,h+1),s._borderBR&&l.addChildAt(s._borderBR,h+1),s._borderTL&&l.addChildAt(s._borderTL,h+1),s._text&&l.addChildAt(s._text,h+1),l.addChildAt(n,h+1)}}}var _=s.getChildNodes();_&&(i=i.concat(_))}return e},t.Treemap.prototype.GetComponentDescription=function(){return t.Bundle.getTranslation(this.getOptions(),"componentName",t.Bundle.UTIL_PREFIX,"TREEMAP")},t.Treemap.prototype.getBundlePrefix=function(){return t.Bundle.TREEMAP_PREFIX},t.Treemap.prototype.CreateNode=function(t){return new p(this,t)},t.Treemap.prototype.getIsolatedNodes=function(){return this._isolatedNodes},t.Treemap.prototype.getNodeContent=function(){return this._nodeContent};var p=function(e,i){this.Init(e,i);var s=this._view.getOptions(),o=s.nodeDefaults,n=o.header,r=i.header?i.header:{};this._groupLabelDisplay=i.groupLabelDisplay?i.groupLabelDisplay:o.groupLabelDisplay,this._labelDisplay=i.labelDisplay?i.labelDisplay:o.labelDisplay,this._labelHalign=i.labelHalign?i.labelHalign:o.labelHalign,this._labelValign=i.labelValign?i.labelValign:o.labelValign,this._headerHalign=r.labelHalign?r.labelHalign:n.labelHalign,this._headerLabelStyle=r.labelStyle?new t.CSSStyle(r.labelStyle):null,this._bHeaderUseNodeColor="on"==(r.useNodeColor?r.useNodeColor:n.useNodeColor),this._className=i.className||i.svgClassName,this._style=i.style||i.svgStyle,this._isolate=r.isolate?r.isolate:n.isolate,"auto"==this._isolate&&(this._isolate=t.Agent.isTouchDevice()?"off":"on"),this._bIsolated=null!=s.isolatedNode&&s.isolatedNode==this.getId()};t.Obj.createSubclass(p,n),p.TEXT_STYLE_HEADER="header",p.TEXT_STYLE_NODE="node",p.TEXT_STYLE_OFF="off",p.TEXT_BUFFER_HORIZ=5,p.TEXT_BUFFER_VERT=2,p.MIN_TEXT_BUFFER=2,p._LINE_FUDGE_FACTOR=1,p._ANIMATION_ISOLATE_DURATION=.3,p._MIN_TITLE_BAR_HEIGHT=22,p._MIN_TITLE_BAR_HEIGHT_ISOLATE=22,p.DEFAULT_HEADER_BORDER_WIDTH=1,p.DEFAULT_HEADER_WITH_NODE_COLOR_ALPHA=.5,p._ISOLATE_ICON_SIZE=12,p._ISOLATE_GAP_SIZE=4,p._ISOLATE_TOUCH_BUFFER=3,p.DEFAULT_NODE_TOP_BORDER_COLOR="#FFFFFF",p.DEFAULT_NODE_BOTTOM_BORDER_COLOR="#000000",p.DEFAULT_NODE_BORDER_WIDTH=1,p.DEFAULT_NODE_BORDER_OPACITY=.3,p.DEFAULT_NODE_PATTERN_BORDER_OPACITY=.15,p.MIN_SIZE_FOR_BORDER=2*p.DEFAULT_NODE_BORDER_WIDTH,p.GROUP_HOVER_INNER_OPACITY=.8,p.GROUP_HOVER_INNER_WIDTH=3,p.NODE_HOVER_OPACITY=1,p.NODE_SELECTION_WIDTH=2,p.prototype.render=function(e){if(this._hasLayout){var i;if(this._shape=this._createShapeNode(),e.addChild(this._shape),this.hasChildren()?(this._childNodeGroup=new t.Container(this.getView().getCtx()),this._shape.addChild(this._childNodeGroup),this.renderChildren(this._childNodeGroup)):i=this.GetTemplate(),i){var s=this.GetElAttributes(),o=this.GetAfContext();o.setELContext(s);var n=p.DEFAULT_NODE_BORDER_WIDTH+p._LINE_FUDGE_FACTOR,r=p.TEXT_BUFFER_HORIZ,a=p.TEXT_BUFFER_VERT,l=this._width-2*r-n,h=this._height-2*a-n;if(l>0&&h>0){o.setAvailableWidth(l),o.setAvailableHeight(h),o.setFontSize(this.GetTextSize());var _,d=t.AfComponentFactory.parseAndLayout(o,i,this._shape);if(this._contentRoot=d,t.Agent.isRightToLeft(e.getCtx())){var u=d.getDimensions();_=this._x+this._width-r-.5*n-u.w}else _=this._x+r+.5*n;d.setTranslate(_,this._y+a+.5*n)}}else if(!this._createCustomNodeContent()&&(this._text=this._createTextNode(this._shape),null!=this._text)){var c=this.getLabelBackgroundColor();if(this._textStyle!=p.TEXT_STYLE_HEADER&&(this._pattern||c)){var g=this._text.getDimensions();this._textBackground=new t.Rect(this.getView().getCtx(),g.x,g.y,g.w,g.h),c?this._textBackground.setSolidFill(c):this._textBackground.setSolidFill("#FFFFFF"),this._textBackground.setMouseEnabled(!1),this._shape.addChild(this._textBackground),this._addChildText(this._text)}}this.hasChildren()?this._shape.setAriaRole("group"):this._shape.setAriaRole("img"),this.UpdateAriaLabel()}},p.prototype.setSelected=function(e){if(p.superclass.setSelected.call(this,e),this._shape){var i=this.getView().getOptions().nodeDefaults,s=i.header;if(this.isSelected()){var o=this._x,r=this._y+p._LINE_FUDGE_FACTOR,a=Math.max(this._width-p._LINE_FUDGE_FACTOR,0),l=Math.max(this._height-p._LINE_FUDGE_FACTOR,0);t.Agent.isPlatformWebkit()&&(r-=p._LINE_FUDGE_FACTOR),this._removeChildShape(this._selectionOuter),this._removeChildShape(this._selectionInner),this._selectionOuter=null,this._selectionInner=null,this._selectionOuter=new t.Rect(this.getView().getCtx(),o,r,a,l),this._selectionOuter.setMouseEnabled(!1),this._selectionOuter.setFill(null),this._selectionOuter.setPixelHinting(!0),this._shape.addChild(this._selectionOuter);var h=Math.max(a-2,0),_=Math.max(l-2,0);this._selectionInner=new t.Rect(this.getView().getCtx(),o+1,r+1,h,_),this._selectionInner.setMouseEnabled(!1),this._selectionInner.setFill(null),this._selectionInner.setPixelHinting(!0),this._shape.addChild(this._selectionInner),this._textStyle==p.TEXT_STYLE_HEADER?(this.IsHover||this.isShowingKeyboardFocusEffect()?this._innerShape.setSolidFill(s.hoverBackgroundColor):(this._innerShape.setSolidFill(s.selectedBackgroundColor),this._text&&this.ApplyHeaderTextStyle(this._text,"_selectedLabelStyle")),this._selectionOuter.setSolidStroke(s.selectedOuterColor),this._selectionInner.setSolidStroke(s.selectedInnerColor),t.Agent.isTouchDevice()&&(this._isolateButton=this._createIsolateRestoreButton(this._shape))):(this._selectionOuter.setSolidStroke(i.selectedOuterColor),this._selectionInner.setSolidStroke(i.selectedInnerColor),t.Agent.isBrowserSafari()||t.Agent.isPlatformGecko()||this._shape.addDrawEffect(n.__NODE_SELECTED_SHADOW),this.getView().__moveToSelectedLayer(this._shape))}else if(this._removeChildShape(this._selectionInner),this._selectionInner=null,t.Agent.isTouchDevice()&&this._removeIsolateRestoreButton(),this._textStyle==p.TEXT_STYLE_HEADER)this.IsHover||this.isShowingKeyboardFocusEffect()?this._innerShape.setSolidFill(s.hoverBackgroundColor):(this.ApplyHeaderStyle(this._shape,this._innerShape),this._text&&(this.isDrillReplaceEnabled()?this.ApplyHeaderTextStyle(this._text,"_drillableLabelStyle"):this.ApplyHeaderTextStyle(this._text,"labelStyle"))),this._selectionOuter&&(this.IsHover||this.isShowingKeyboardFocusEffect()?this._selectionOuter.setSolidStroke(s.hoverOuterColor):(this._removeChildShape(this._selectionOuter),this._selectionOuter=null));else{this._shape.removeAllDrawEffects(),this._selectionOuter&&(this._removeChildShape(this._selectionOuter),this._selectionOuter=null);var d=this.GetParent();d&&d._childNodeGroup&&d._childNodeGroup.addChild(this._shape)}}},p.prototype.showHoverEffect=function(){if(this._shape&&this._hasLayout){var e,i,s,o,n,r=this.getView().getOptions().nodeDefaults,a=r.header,l=this._view.__getLastIsolatedNode();if(null==l||l==this||this.isDescendantOf(l))this._textStyle==p.TEXT_STYLE_HEADER?(this._innerShape.setSolidFill(a.hoverBackgroundColor),this._selectionOuter||(i=this._x,s=this._y,o=this._width-p._LINE_FUDGE_FACTOR,n=this._height-p._LINE_FUDGE_FACTOR,this._selectionOuter=new t.Rect(this.getView().getCtx(),i,s,o,n),this._selectionOuter.setMouseEnabled(!1),this._selectionOuter.setFill(null),this._selectionOuter.setPixelHinting(!0),this._shape.addChild(this._selectionOuter)),this._selectionOuter.setSolidStroke(this.isSelected()?a.selectedOuterColor:a.hoverOuterColor),i=this._x+p.GROUP_HOVER_INNER_WIDTH/2,s=this._y+this._titleBarHeight+p.GROUP_HOVER_INNER_WIDTH/2,o=this._width-p.GROUP_HOVER_INNER_WIDTH-p._LINE_FUDGE_FACTOR,n=this._height-this._titleBarHeight-p.GROUP_HOVER_INNER_WIDTH-p._LINE_FUDGE_FACTOR,e=new t.SolidStroke(a.hoverInnerColor,p.GROUP_HOVER_INNER_OPACITY,p.GROUP_HOVER_INNER_WIDTH),this._text&&(this.isDrillReplaceEnabled()?this.ApplyHeaderTextStyle(this._text,"_drillableHoverLabelStyle"):this.ApplyHeaderTextStyle(this._text,"_hoverLabelStyle"))):(i=this._x+p.NODE_SELECTION_WIDTH/2,s=this._y+p.NODE_SELECTION_WIDTH/2,o=this._width-p.NODE_SELECTION_WIDTH-p._LINE_FUDGE_FACTOR,n=this._height-p.NODE_SELECTION_WIDTH-p._LINE_FUDGE_FACTOR,e=new t.SolidStroke(r.hoverColor,p.NODE_HOVER_OPACITY,p.NODE_SELECTION_WIDTH)),n=Math.max(n,0),o=Math.max(o,0),this.getView().__showHoverEffect(i,s,o,n,e)}},p.prototype.hideHoverEffect=function(){if(this._shape&&this._hasLayout){var t=this.getView().getOptions().nodeDefaults.header;this._textStyle==p.TEXT_STYLE_HEADER&&(this.isSelected()?(this._innerShape.setSolidFill(t.selectedBackgroundColor),this._selectionOuter.setSolidStroke(t.selectedOuterColor),this._text&&(this.isDrillReplaceEnabled()?this.ApplyHeaderTextStyle(this._text,"_drillableSelectedLabelStyle"):this.ApplyHeaderTextStyle(this._text,"_selectedLabelStyle"))):(this.ApplyHeaderStyle(this._shape,this._innerShape),this._selectionOuter&&(this._shape.removeChild(this._selectionOuter),this._selectionOuter=null),this._text&&(this.isDrillReplaceEnabled()?this.ApplyHeaderTextStyle(this._text,"_drillableLabelStyle"):this.ApplyHeaderTextStyle(this._text,"labelStyle")))),this.getView().__hideHoverEffect()}},p.prototype.highlight=function(t,e){this.hasChildren()?(this._text&&this._text.setAlpha(e),this._textStyle==p.TEXT_STYLE_HEADER&&this._bHeaderUseNodeColor&&this._innerShape&&this._innerShape.setAlpha(e)):p.superclass.highlight.call(this,t,e)},p.prototype.isIsolateEnabled=function(){return"off"!=this._isolate&&this._textStyle==p.TEXT_STYLE_HEADER},p.prototype.getPopupBounds=function(e){return e&&e.getAlign()?new t.Rectangle(this._x,this._y,this._width,this._height):p.superclass.getPopupBounds.call(this,e)},p.prototype.getNextNavigable=function(e){var i,s;if(e.type==t.MouseEvent.CLICK)return p.superclass.getNextNavigable.call(this,e);if((i=e.keyCode)==t.KeyboardEvent.SPACE&&e.ctrlKey)return this;if(i==t.KeyboardEvent.UP_ARROW&&e.altKey||i==t.KeyboardEvent.CLOSE_BRACKET)(r=this.GetParent())&&r.getId()!=this.getView().getRootNode().getId()?(s=r,r.MarkAsLastVisitedChild()):s=this;else if(i==t.KeyboardEvent.DOWN_ARROW&&e.altKey||i==t.KeyboardEvent.OPEN_BRACKET)s=this.GetLastVisitedChild()||(this.hasChildren()?this.getView().__getDefaultNavigable(this.getChildNodes()):this);else{var o=this.getView().__getLastIsolatedNode(),n=0;if(o)if(this==o)n=0;else{var r=this.GetParent();for(n=1;o!=r;)n++,r=r.GetParent()}else{for(o=this;o.GetParent();)o=o.GetParent();n=this.GetDepth()}var a=this.GetNodesAtDepth(o,n);s=t.KeyboardHandler.getNextNavigable(this,e,a)}return s.MarkAsLastVisitedChild(),s},p.prototype.getKeyboardBoundingBox=function(e){return new t.Rectangle(this._x,this._y,this._width,this._height)},p.prototype.getTargetElem=function(){return this._shape?this._shape.getElem():null},p.prototype.setZIndex=function(t){this._zIndex=t},p.prototype.setLayoutParams=function(e,i,s,o){if(!(s<=0||o<=0)){if(this._hasLayout=!0,this._oldState=this.GetAnimationParams(),this._x=e,this._y=i,this._width=s||0,this._height=o||0,this.hasChildren()?this._textStyle=this._groupLabelDisplay:this._textStyle=this._labelDisplay,this._textStr||(this._textStyle=p.TEXT_STYLE_OFF),this._textStyle==p.TEXT_STYLE_HEADER){this._titleBarHeight=p._MIN_TITLE_BAR_HEIGHT;var n=new t.OutputText(this.getView().getCtx(),this._textStr);n.setFontSize(this.GetTextSize()),this.ApplyHeaderTextStyle(n,"labelStyle");var r=n.getDimensions().h;n=null,this._titleBarHeight=Math.max(this._titleBarHeight,r),this.isIsolateEnabled()&&(this._titleBarHeight=Math.max(this._titleBarHeight,p._MIN_TITLE_BAR_HEIGHT_ISOLATE));var a=this._x,l=this._y+this._titleBarHeight,h=this._width,_=this._height-this._titleBarHeight;if(h>=0&&_>=0)return new t.Rectangle(a,l,h,_);this._textStyle=null}return new t.Rectangle(this._x,this._y,this._width,this._height)}},p.prototype.getNodeUnderPoint=function(t,e){if(this.contains(t,e)||!this._hasLayout){for(var i=this.getChildNodes(),s=0;s<i.length;s++)if(i[s].contains(t,e))return i[s].getNodeUnderPoint(t,e);if(this._hasLayout)return this}return null},p.prototype.contains=function(t,e){return t>=this._x&&t<=this._x+this._width&&e>=this._y&&e<=this._y+this._height},p.prototype.GetAnimationParams=function(){var e=t.ColorUtils.getRed(this._color),i=t.ColorUtils.getGreen(this._color),s=t.ColorUtils.getBlue(this._color);return[this._x,this._y,this._width,this._height,e,i,s,this.hasChildren()?0:Math.random()]},p.prototype.SetAnimationParams=function(e){this.setLayoutParams(e[0],e[1],e[2],e[3]);var i=Math.round(e[4]),s=Math.round(e[5]),o=Math.round(e[6]);this._color=t.ColorUtils.makeRGB(i,s,o),this._updateShapes()},p.prototype.getIsolateAnimation=function(){for(var t=[this._getIsolateAnimation()],e=this.getDescendantNodes(),i=0;i<e.length;i++)t.push(e[i]._getIsolateAnimation());return t},p.prototype._getIsolateAnimation=function(){if(this._oldState){var e=new t.CustomAnimation(this.getView().getCtx(),this,p._ANIMATION_ISOLATE_DURATION);return e.getAnimator().addProp(t.Animator.TYPE_NUMBER_ARRAY,this,this.GetAnimationParams,this.SetAnimationParams,this.GetAnimationParams()),this.SetAnimationParams(this._oldState),e}return null},p.prototype.animateUpdate=function(t,e){return this._removeAllNodeContent(),0==this.GetDepth()||e._hasLayout&&e._width>0&&e._height>0?p.superclass.animateUpdate.call(this,t,e):this.animateInsert(t)},p.prototype.animateInsert=function(t,e){this._removeAllNodeContent(),p.superclass.animateInsert.call(this,t,e)},p.prototype.animateDelete=function(t,e){this._removeAllNodeContent(),p.superclass.animateDelete.call(this,t,e)},p.prototype._createShapeNode=function(){var e,i=this.getView().getCtx(),s="gaps"==this.getView().getOptions().nodeSeparators;if(this._textStyle==p.TEXT_STYLE_HEADER){if(s){var o=this._getGeometriesWithGaps();e=new t.Rect(i,o._shape.x,o._shape.y,o._shape.w,o._shape.h),this._innerShape=new t.Rect(i,o._innerShape.x,o._innerShape.y,o._innerShape.w,o._innerShape.h),this._backgroundShape=new t.Rect(i,o._backgroundShape.x,o._backgroundShape.y,o._backgroundShape.w,o._backgroundShape.h),this._backgroundShape.setSolidFill("#FFFFFF"),e.addChild(this._backgroundShape)}else e=new t.Rect(i,this._x,this._y,this._width,this._height),this._innerShape=new t.Rect(i,this._x+1,this._y+1,this._width-2,this._height-2);this.ApplyHeaderStyle(e,this._innerShape),this._innerShape.setMouseEnabled(!1),e.addChild(this._innerShape),this.__isIsolated()&&(this._isolateButton=this._createIsolateRestoreButton(e))}else{var n=this.GetFill();if(s){o=this._getGeometriesWithGaps();(e=new t.Rect(i,o._shape.x,o._shape.y,o._shape.w,o._shape.h)).setFill(this.hasChildren()?t.SolidFill.invisibleFill():n)}else{if(e=new t.Rect(i,this._x,this._y,this._width,this._height),(this.getView().__getNodeCount()<1e3||!t.Agent.isTouchDevice())&&this._width>=p.MIN_SIZE_FOR_BORDER&&this._height>=p.MIN_SIZE_FOR_BORDER){new t.SolidStroke(p.DEFAULT_NODE_TOP_BORDER_COLOR),new t.SolidStroke(p.DEFAULT_NODE_BOTTOM_BORDER_COLOR,p.DEFAULT_NODE_BORDER_OPACITY);this._pattern&&new t.SolidStroke(this._color,p.DEFAULT_NODE_PATTERN_BORDER_OPACITY);var r=this.getColor(),a=t.ColorUtils.interpolateColor(p.DEFAULT_NODE_TOP_BORDER_COLOR,r,1-p.DEFAULT_NODE_BORDER_OPACITY),l=t.ColorUtils.interpolateColor(p.DEFAULT_NODE_BOTTOM_BORDER_COLOR,r,1-p.DEFAULT_NODE_BORDER_OPACITY),h=Math.min(this._width,this._height);h>=4?(e.setSolidFill(l),this._topLeftShape=new t.Rect(i,this._x,this._y,this._width-1,this._height-1),this._topLeftShape.setSolidFill(a),this._topLeftShape.setMouseEnabled(!1),e.addChild(this._topLeftShape),this._fillShape=new t.Rect(i,this._x+1,this._y+1,this._width-2,this._height-2),this._fillShape.setFill(n),this._fillShape.setMouseEnabled(!1),e.addChild(this._fillShape)):h>=2?(e.setSolidFill(l),this._fillShape=new t.Rect(i,this._x,this._y,this._width-1,this._height-1),this._fillShape.setFill(n),this._fillShape.setMouseEnabled(!1),e.addChild(this._fillShape)):e.setFill(n)}else e.setFill(n)}e.setStyle(this._style),e.setClassName(this._className)}return this.getView().getEventManager().associate(e,this),this.isSelectable()?e.setSelectable(!0):this.isDrillReplaceEnabled()?e.setCursor("pointer"):e.setCursor("default"),e.zIndex=this._zIndex,e},p.prototype._createIsolateRestoreButton=function(e){if(this._textStyle!=p.TEXT_STYLE_HEADER||!this.isIsolateEnabled())return null;var i=null,s=this._x,o=this._x+this._width-p._LINE_FUDGE_FACTOR,n=this._y+p._LINE_FUDGE_FACTOR,a=this._y+this._titleBarHeight;if(o-s-2*p._ISOLATE_GAP_SIZE>p._ISOLATE_ICON_SIZE){var l;if(i=this.__isIsolated()?this._getRestoreButton():this._getIsolateButton(),l=t.Agent.isRightToLeft(e.getCtx())?s+p._ISOLATE_GAP_SIZE:o-p._ISOLATE_ICON_SIZE-p._ISOLATE_GAP_SIZE,i.setTranslate(l,(a+n-p._ISOLATE_ICON_SIZE)/2),e.addChild(i),t.Agent.isTouchDevice()){var h=new t.Rect(e.getCtx(),-p._ISOLATE_TOUCH_BUFFER,-p._ISOLATE_TOUCH_BUFFER,p._ISOLATE_ICON_SIZE+2*p._ISOLATE_TOUCH_BUFFER,p._ISOLATE_ICON_SIZE+2*p._ISOLATE_TOUCH_BUFFER);h.setInvisibleFill(),i.addChild(h)}if(t.CSSStyle.afterSkinAlta(this.getView().getOptions().skin))this.getView().getEventManager().associate(i,this);else{var _=t.Bundle.getTranslation(this.getView().getOptions(),this.__isIsolated()?"tooltipRestore":"tooltipIsolate",t.Bundle.TREEMAP_PREFIX,this.__isIsolated()?"RESTORE":"ISOLATE");this.getView().getEventManager().associate(i,new r(this,this.getId(),_))}}return i},p.prototype._removeIsolateRestoreButton=function(){this._isolateButton&&(this._removeChildShape(this._isolateButton),this._isolateButton=null)},p.prototype._createTextNode=function(e){var i=t.Agent.isRightToLeft(e.getCtx());if(!this._textStr||!e||!this._textStyle||this._textStyle==p.TEXT_STYLE_OFF)return null;var s=this._height;if((g=this.GetTextSize())>s)return null;var o=this._textStyle==p.TEXT_STYLE_NODE?this._labelHalign:this._headerHalign;i&&("start"==o?o="end":"end"==o&&(o="start"));var n,a=this._width-(p.TEXT_BUFFER_HORIZ+p.MIN_TEXT_BUFFER),l=0;if(this.isIsolateEnabled()&&(l=p._ISOLATE_ICON_SIZE+p._ISOLATE_GAP_SIZE,a-="center"==o?2*l:l),a<=0)return null;var h=this.getMergedLabelTextStyle();if(n=this._textStyle==p.TEXT_STYLE_NODE&&s>2*g&&"nowrap"!=h.getStyle(t.CSSStyle.WHITE_SPACE)&&t.TextUtils.getTextStringWidth(this.getView().getCtx(),this._textStr,h)>a?new t.MultilineText(this.getView().getCtx(),this._textStr):new t.OutputText(this.getView().getCtx(),this._textStr),"start"==o?(i?n.setX(this._x+p.TEXT_BUFFER_HORIZ+l):n.setX(this._x+p.TEXT_BUFFER_HORIZ),n.alignLeft()):"center"==o?(n.setX(this._x+this._width/2),n.alignCenter()):"end"==o&&(i?n.setX(this._x+this._width-p.TEXT_BUFFER_HORIZ):n.setX(this._x+this._width-p.TEXT_BUFFER_HORIZ-l),n.alignRight()),this._textStyle==p.TEXT_STYLE_NODE)this.ApplyLabelTextStyle(n),s=this._height-2*p.TEXT_BUFFER_VERT;else if(this._textStyle==p.TEXT_STYLE_HEADER){var _=t.Agent.isPlatformWebkit()?p._LINE_FUDGE_FACTOR:0;n.setY(this._y+p.DEFAULT_HEADER_BORDER_WIDTH+this._titleBarHeight/2+_),n.alignMiddle(),this.ApplyHeaderTextStyle(n,"labelStyle")}if(null!=n){if(this._textStyle==p.TEXT_STYLE_HEADER&&this.isDrillReplaceEnabled()){this.ApplyHeaderTextStyle(n,"_drillableLabelStyle"),n.setCursor("pointer");var d=new r(this,this.getId(),null,this.getDatatip(),this.getDatatipColor());d.setDrillable(!0),this.getView().getEventManager().associate(n,d)}else n.setMouseEnabled(!1);var u=this.getView().getOptions().nodeDefaults.labelMinLength,c=t.TextUtils.fitText(n,a,s,e,u);if(this._textStyle==p.TEXT_STYLE_NODE){var g=n.getDimensions().h;"top"==this._labelValign?n.setY(this._y+p.TEXT_BUFFER_VERT):"center"==this._labelValign?n.setY(this._y+this._height/2-g/2):"bottom"==this._labelValign&&n.setY(this._y+this._height-p.TEXT_BUFFER_VERT-g)}return c?n:null}},p.prototype.ApplyHeaderStyle=function(e,i){var s=this.getView().getOptions().nodeDefaults.header;if(this._bHeaderUseNodeColor){var o=this.getColor();i.setSolidFill(o);var n=t.ColorUtils.interpolateColor(s.borderColor,o,1-p.DEFAULT_HEADER_WITH_NODE_COLOR_ALPHA);e.setSolidFill(n)}else e.setSolidFill(s.borderColor),i.setSolidFill(s.backgroundColor);this._backgroundShape&&this._backgroundShape.setFill(i.getFill())},p.prototype.ApplyHeaderTextStyle=function(e,i){var s=[];this.GetDepth()<=1&&this.getView().__getMaxDepth()>=3&&s.push(new t.CSSStyle("font-weight:bold;")),s.push(this.getView().getOptions().nodeDefaults.header[i]),!this._bHeaderUseNodeColor||"labelStyle"!=i&&"_drillableLabelStyle"!=i||s.push(new t.CSSStyle("color: "+n.GetNodeTextColor(this))),this._headerLabelStyle&&s.push(this._headerLabelStyle),e.setCSSStyle(t.CSSStyle.mergeStyles(s))},p.prototype.handleMouseOver=function(){this._isolateButton||t.Agent.isTouchDevice()||(this._isolateButton=this._createIsolateRestoreButton(this._shape)),p.superclass.handleMouseOver.call(this)},p.prototype.handleMouseOut=function(){!0===this.__isIsolated()||t.Agent.isTouchDevice()||this._removeIsolateRestoreButton(),p.superclass.handleMouseOut.call(this)},p.prototype._getGeometriesWithGaps=function(){var e={};if(this._textStyle==p.TEXT_STYLE_HEADER){e._shape=new t.Rectangle(this._x,this._y,this._width-1,this._titleBarHeight),e._innerShape=new t.Rectangle(this._x+1,this._y+1,this._width-3,this._titleBarHeight-1);var i=Math.max(this._width-1,0),s=Math.max(this._height-this._titleBarHeight-1,0);e._backgroundShape=new t.Rectangle(this._x,this._y+this._titleBarHeight,i,s)}else if(this.hasChildren())e._shape=new t.Rectangle(this._x,this._y,0,0);else{var o=Math.max(this._width-1,0),n=Math.max(this._height-1,0);e._shape=new t.Rectangle(this._x,this._y,o,n)}return e},p.prototype._updateShapes=function(){if(this._shape){var t=this.getView().getOptions();if("gaps"==t.nodeSeparators){var e=this._getGeometriesWithGaps();this._shape.setRect(e._shape),this._innerShape&&this._innerShape.setRect(e._innerShape),this._backgroundShape&&this._backgroundShape.setRect(e._backgroundShape)}else this._shape.setRect(this._x,this._y,this._width,this._height),this._innerShape&&this._innerShape.setRect(this._x+1,this._y+1,this._width-2,this._height-2);(this._textStyle!=p.TEXT_STYLE_HEADER||this._bHeaderUseNodeColor)&&this._shape.setFill(this.GetFill()),this.isSelected()&&this.setSelected(!1),this._removeChildShape(this._fillShape),this._removeChildShape(this._topLeftShape),this._fillShape=null,this._topLeftShape=null,this._removeIsolateRestoreButton(),this.GetTemplate()?(this._removeChildShape(this._contentRoot),this._contentRoot=null):t.nodeContent&&t.nodeContent.renderer&&this._textStyle!=p.TEXT_STYLE_HEADER?this._removeAllNodeContent():(this._removeChildShape(this._textBackground),this._textBackground=null,this._text&&this._text.getParent().removeChild(this._text),this._text=this._createTextNode(this._shape))}},p.prototype.getDropSiteFeedback=function(){return this._shape?new t.Rect(this.getView().getCtx(),this._shape.getX(),this._shape.getY(),this._shape.getWidth(),this._shape.getHeight()):null},p.prototype._addChildText=function(t){this._textStyle==p.TEXT_STYLE_NODE&&this.hasChildren()?this.getView().__getGroupTextLayer().addChild(t):this._shape.addChild(t)},p.prototype._removeChildShape=function(t){t&&this._shape.removeChild(t)},p.prototype._getIsolateButton=function(){var e=this.getView().getCtx(),i=t.Agent.isRightToLeft(this._context),s=this.getView().getOptions()._resources,o=i&&s.isolateRtl?s.isolateRtl:s.isolate,n=i&&s.isolateOverRtl?s.isolateOverRtl:s.isolateOver,r=i&&s.isolateDownRtl?s.isolateDownRtl:s.isolateDown,a=new t.Image(e,o,0,0,p._ISOLATE_ICON_SIZE,p._ISOLATE_ICON_SIZE),l=new t.Image(e,n,0,0,p._ISOLATE_ICON_SIZE,p._ISOLATE_ICON_SIZE),h=new t.Image(e,r,0,0,p._ISOLATE_ICON_SIZE,p._ISOLATE_ICON_SIZE);a.setInvisibleFill(),l.setInvisibleFill(),h.setInvisibleFill();var _=new t.Button(e,a,l,h);return _.addEvtListener(t.MouseEvent.CLICK,this.__isolateNode,!1,this),_},p.prototype._getRestoreButton=function(){var e=this.getView().getCtx(),i=t.Agent.isRightToLeft(this._context),s=this.getView().getOptions()._resources,o=i&&s.restoreRtl?s.restoreRtl:s.restore,n=i&&s.restoreOverRtl?s.restoreOverRtl:s.restoreOver,r=i&&s.restoreDownRtl?s.restoreDownRtl:s.restoreDown,a=new t.Image(e,o,0,0,p._ISOLATE_ICON_SIZE,p._ISOLATE_ICON_SIZE),l=new t.Image(e,n,0,0,p._ISOLATE_ICON_SIZE,p._ISOLATE_ICON_SIZE),h=new t.Image(e,r,0,0,p._ISOLATE_ICON_SIZE,p._ISOLATE_ICON_SIZE);a.setInvisibleFill(),l.setInvisibleFill(),h.setInvisibleFill();var _=new t.Button(e,a,l,h);return _.addEvtListener(t.MouseEvent.CLICK,this.__restoreNode,!1,this),_},p.prototype.__isIsolated=function(){return this._bIsolated},p.prototype.__isolateNode=function(t){this._bIsolated=!0,this._removeAllNodeContent(),this.hideHoverEffect(),this.getView().__isolate(this),this._removeIsolateRestoreButton(),this.UpdateAriaLabel(),t&&t.stopPropagation()},p.prototype.__restoreNode=function(t){this._bIsolated=!1,this.hideHoverEffect(),this.getView().__restore(),this._removeIsolateRestoreButton(),this.UpdateAriaLabel(),t&&t.stopPropagation()},p.prototype.getIsolateRestoreButton=function(){return this._isolateButton},p.prototype.getDatatip=function(e,i,s){return e&&e instanceof t.Button?null:p.superclass.getDatatip.call(this,e,i,s)},p.prototype.getDatatipColor=function(e){return e&&e instanceof t.Button?null:p.superclass.getDatatipColor.call(this,e)},p.prototype.getTooltip=function(e){return e&&e instanceof t.Button?t.Bundle.getTranslation(this.getView().getOptions(),this.__isIsolated()?"tooltipRestore":"tooltipIsolate",t.Bundle.TREEMAP_PREFIX,this.__isIsolated()?"RESTORE":"ISOLATE"):null},p.prototype.getAriaLabel=function(){var e=this.getView().getOptions(),i=[];return this.isSelectable()&&i.push(t.Bundle.getTranslation(e,this.isSelected()?"stateSelected":"stateUnselected",t.Bundle.UTIL_PREFIX,this.isSelected()?"STATE_SELECTED":"STATE_UNSELECTED")),this.__isIsolated()&&i.push(t.Bundle.getTranslation(e,"stateIsolated",t.Bundle.UTIL_PREFIX,"STATE_ISOLATED")),this.isDrillReplaceEnabled()&&i.push(t.Bundle.getTranslation(e,"stateDrillable",t.Bundle.UTIL_PREFIX,"STATE_DRILLABLE")),t.Displayable.generateAriaLabel(this.getShortDesc(),i)},p.prototype.UpdateAriaLabel=function(){!t.Agent.deferAriaCreation()&&this._shape&&this._shape.setAriaProperty("label",this.getAriaLabel())},p.prototype._createCustomNodeContent=function(){var t=this.getView(),e=t.getOptions(),i=this.getId();this._removeNodeContent(i);var s=e.nodeContent.renderer;if(!s||this.hasChildren())return!1;var o=t.getIsolatedNodes();if(o.length<=0||this.isDescendantOf(o[t._isolatedNodes.length-1])){var n=t.getCtx(),r={bounds:{x:this._x,y:this._y,width:this._width-p.DEFAULT_NODE_BORDER_WIDTH,height:this._height-p.DEFAULT_NODE_BORDER_WIDTH},id:i,data:this.getOptions(),component:e._widgetConstructor};r=n.fixRendererContext(r);var a=n.getContainer(),l=s(r);if(!l)return;var h=n.createOverlayDiv();h.appendChild(l),t.getNodeContent()[i]=h,a.appendChild(h);var _=n.getOverlayAttachedCallback();_&&_(h)}return!0},p.prototype._removeNodeContent=function(t){var e=this.getView(),i=e.getNodeContent(),s=i[t];s&&(e.getCtx().getContainer().removeChild(s),delete i[t])},p.prototype._removeAllNodeContent=function(){for(var t in this.getView().getNodeContent())this._removeNodeContent(t)};var c=function(){this.Init()};t.Obj.createSubclass(c,t.Obj),c._GROUP_GAP=2,c.prototype.Init=function(){this._zIndex=0},c.prototype.layout=function(t,e,i,s,o,n,r){},c.prototype.setNodeBounds=function(e,i,s,o,n,r){if(e.setZIndex(this._zIndex),this._zIndex++,!r||!e.hasChildren()){var a=this.getGapSize(e.getView(),e.GetDepth()),l=Math.round(i+a),h=Math.round(s+a),_=Math.round(i+o-a)-l,d=Math.round(s+n-a)-h,u=e.setLayoutParams(l,h,_,d);if(u)return u}return new t.Rectangle(i,s,o,n)},c.prototype.getGapSize=function(t,e){var i=t.getOptions().groupGaps;return"outer"==i?1==e&&t.__getMaxDepth()>=2?c._GROUP_GAP:0:"all"==i&&e<t.__getMaxDepth()?c._GROUP_GAP:0};var g=function(){this.Init()};t.Obj.createSubclass(g,c),g.prototype.layout=function(t,e,i,s,o,n,r){var a=!r;this._layout(e,i,s,o,n,a)},g.prototype._layout=function(e,i,s,o,n,r){var a=this.setNodeBounds(e,i,s,o,n,r),l=e.getChildNodes();if(null!=l&&l.length>0){this._calcPixelSize(l,a.w*a.h),l=l.slice(0).sort(function(t,e){return t.getSize()-e.getSize()});var h=Math.min(a.w,a.h),_=new t.Rectangle(a.x,a.y,a.w,a.h);this._squarify(l,new Array,h,_,1/0)}},g.prototype._calcPixelSize=function(t,e){var i=0,s=0;for(s=0;s<t.length;s++)i+=t[s].getSize()>0?t[s].getSize():0;var o=0==e?0:e/i;for(s=0;s<t.length;s++){var n=t[s];n.__pxSize=n.getSize()*o}},g.prototype._squarify=function(t,e,i,s,o){if(null!=t&&0!=t.length)for(;t.length>0;){var n=t.pop();if(n.__pxSize<0)return void this._layoutRow(e,i,s);e.push(n);var r=this._getWorst(e,i);if(r>o)return t.push(n),e.pop(),s=this._layoutRow(e,i,s),void this._squarify(t,new Array,Math.min(s.w,s.h),s,1/0);if(0==t.length)return void this._layoutRow(e,i,s);o=r}else this._layoutRow(e,i,s)},g.prototype._getWorst=function(t,e){for(var i=0,s=1/0,o=-1/0,n=0;n<t.length;n++)i+=t[n].__pxSize,s=Math.min(s,t[n].__pxSize),o=Math.max(o,t[n].__pxSize);var r=i*i,a=e*e;return Math.max(a*o/r,r/(a*s))},g.prototype._layoutRow=function(e,i,s){var o,n=0;for(o=0;o<e.length;o++)n+=e[o].__pxSize;var r,a,l=s.x,h=s.y;if(i==s.w){for(a=0==i?0:n/i,o=0;o<e.length;o++)r=e[o].__pxSize/a,this._layout(e[o],l,h,r,a,!1),l+=r;return new t.Rectangle(s.x,s.y+a,s.w,s.h-a)}for(r=0==i?0:n/i,o=0;o<e.length;o++)a=e[o].__pxSize/r,this._layout(e[o],l,h,r,a,!1),h+=a;return new t.Rectangle(s.x+r,s.y,s.w-r,s.h)};var E=function(t){this.Init(),this._isHoriz=t};t.Obj.createSubclass(E,c),E.prototype.layout=function(t,e,i,s,o,n,r){var a=!r;this._layout(this._isHoriz,t,e,i,s,o,n,a)},E.prototype._layout=function(e,i,s,o,n,r,a,l){var h=i.getOptions(),_=this.setNodeBounds(s,o,n,r,a,l),d=s.getChildNodes();if(null!=d){var u,p=_.x,c=_.y,g=_.w,E=_.h,f=0;for(u=0;u<d.length;u++)f+=d[u].getSize()>0?d[u].getSize():0;for("on"==h.sorting&&(d=d.slice(0)).sort(function(t,e){return e.getSize()-t.getSize()}),e&&t.Agent.isRightToLeft(i.getCtx())&&(d=d.slice(0).reverse()),u=0;u<d.length;u++){var y=d[u];if(!(y.getSize()<=0)){var S=y.getSize()/f;e?g=_.w*S:E=_.h*S,this._layout(!e,i,y,p,c,g,E,!1),e?p+=g:c+=E}}}};var f=function(t){this.Init(t)};t.Obj.createSubclass(f,h),f.prototype.isNavigationEvent=function(e){var i=f.superclass.isNavigationEvent.call(this,e);if(!i){var s=e.keyCode;s!=t.KeyboardEvent.OPEN_BRACKET&&s!=t.KeyboardEvent.CLOSE_BRACKET||(i=!0)}return i};var y=function(t,e,i,s){o.call(this,t,e,i,s)};t.Obj.createSubclass(y,o),y.prototype.ProcessKeyboardEvent=function(e){var i=!0;if(e.keyCode==t.KeyboardEvent.ENTER&&e.ctrlKey){var s=this.getFocus();s.isIsolateEnabled()&&(s.__isIsolated()?s.__restoreNode():s.__isolateNode()),t.EventManager.consumeEvent(e)}else i=y.superclass.ProcessKeyboardEvent.call(this,e);return i},y.prototype.isClearMenuAllowed=function(){return!1},t.Bundle.addDefaultStrings(t.Bundle.TREEMAP_PREFIX,{COLOR:"Color",ISOLATE:"Isolate",OTHER:"Other",RESTORE:"Restore",SIZE:"Size"});var S=function(){this.Init({skyros:S.VERSION_1,alta:{},next:S.SKIN_NEXT})};t.Obj.createSubclass(S,_),S.SKIN_NEXT={skin:t.CSSStyle.SKIN_NEXT,nodeSeparators:"gaps"},S.VERSION_1={groupGaps:"outer",nodeDefaults:{header:{backgroundColor:"#FFFFFF",borderColor:"#d6dfe6",hoverBackgroundColor:"#ebeced",hoverOuterColor:"#ebeced",hoverInnerColor:"#d6d7d8",isolate:"auto",labelHalign:"start",labelStyle:new t.CSSStyle(t.BaseComponentDefaults.FONT_FAMILY_ALTA_12+"color:#252525;"),selectedBackgroundColor:"#dae9f5",selectedInnerColor:"#FFFFFF",selectedOuterColor:"#000000",useNodeColor:"off",_hoverLabelStyle:new t.CSSStyle(t.BaseComponentDefaults.FONT_FAMILY_ALTA_12+"color:#252525;"),_selectedLabelStyle:new t.CSSStyle(t.BaseComponentDefaults.FONT_FAMILY_ALTA_12+"color:#252525;"),_drillableLabelStyle:new t.CSSStyle(t.BaseComponentDefaults.FONT_FAMILY_ALTA_12+"color:#145c9e;"),_drillableHoverLabelStyle:new t.CSSStyle(t.BaseComponentDefaults.FONT_FAMILY_ALTA_12+"color:#145c9e;"),_drillableSelectedLabelStyle:new t.CSSStyle(t.BaseComponentDefaults.FONT_FAMILY_ALTA_12+"color:#145c9e;")},hoverColor:"#ebeced",groupLabelDisplay:"header",labelDisplay:"node",labelHalign:"center",labelValign:"center",selectedInnerColor:"#FFFFFF",selectedOuterColor:"#000000"},nodeSeparators:"bevels",nodeContent:{}},t.Sunburst=function(t,e,i){this.Init(t,e,i)},t.Obj.createSubclass(t.Sunburst,e),t.Sunburst._ROTATION_SHAPE_RADIUS=15,t.Sunburst._ROTATION_SHAPE_RADIUS_TOUCH=60,t.Sunburst._ANIMATION_TYPE_FAN="fan",t.Sunburst._BACKGROUND_INLINE_DEFAULT="",t.Sunburst._BUFFER_SPACE=3,t.Sunburst._MIN_BUFFER_SPACE=2,t.Sunburst.LARGE_DATASET_THRESHOLD=1e3,t.Sunburst.newInstance=function(e,i,s){return new t.Sunburst(e,i,s)},t.Sunburst.prototype.Init=function(e,i,s){t.Sunburst.superclass.Init.call(this,e,i,s),this.Defaults=new C,this._angleExtent=2*Math.PI},t.Sunburst.prototype.ApplyParsedProperties=function(e){t.Sunburst.superclass.ApplyParsedProperties.call(this,e);var i=this.getOptions();t.Agent.isPlatformIE()?this._rotateCursor="url("+i._resources.rotateCursor+"), auto":this._rotateCursor="url("+i._resources.rotateCursor+") 8 8, auto",this._startAngle=(360-i.startAngle)*v.TWO_PI/360,this._startAngle>Math.PI&&(this._startAngle-=v.TWO_PI),"auto"==i.animationOnDisplay&&(i.animationOnDisplay="fan")},t.Sunburst.prototype.Layout=function(e){var i=Math.max(Math.ceil(t.Sunburst._BUFFER_SPACE*Math.min(e.w,e.h)/400),t.Sunburst._MIN_BUFFER_SPACE);e.x+=i,e.y+=i,e.w-=2*i,e.h-=2*i,this.LayoutBreadcrumbs(e),this.LayoutLegend(e),this._totalRadius=Math.floor(Math.min(e.w,e.h)/2),this._root&&T.layout(this._totalRadius,this._root,this._startAngle,this._angleExtent,this.getOptions().sorting)},t.Sunburst.prototype.Render=function(e,i){if(this.RenderBackground(e,t.Sunburst._BACKGROUND_INLINE_DEFAULT),this.RenderBreadcrumbs(e),this.RenderLegend(e),this._translatePt=new t.Point(i.x+i.w/2,i.y+i.h/2),this.__isRotationEnabled()&&this.HasValidData()){var s=t.Agent.isTouchDevice()?t.Sunburst._ROTATION_SHAPE_RADIUS_TOUCH:t.Sunburst._ROTATION_SHAPE_RADIUS,o=new t.Circle(this.getCtx(),i.x+i.w/2,i.y+i.h/2,this._totalRadius+s);o.setInvisibleFill(),o.setCursor(this._rotateCursor),e.addChild(o),this.getEventManager().associate(o,new r(null,A.ROTATION_ID))}var n=new t.Container(this.getCtx());if(n.setTranslate(this._translatePt.x,this._translatePt.y),e.addChild(n),this.HasValidData()){var a=new t.Container(this.getCtx());n.addChild(a),this._root.render(a),this.UpdateAriaNavigation(this._root),this._selectedLayer=new t.Container(this.getCtx()),n.addChild(this._selectedLayer),this._hoverLayer=new t.Container(this.getCtx()),n.addChild(this._hoverLayer)}else this.RenderEmptyText(e)},t.Sunburst.prototype.CreateEventManager=function(t,e,i,s){return new A(t,e,i,s)},t.Sunburst.prototype.GetDisplayAnimation=function(e,i){if(this.getOptions().animationOnDisplay===t.Sunburst._ANIMATION_TYPE_FAN&&this.HasValidData()){this._animateAngleExtent(0);var s=new t.CustomAnimation(this.getCtx(),this,this.AnimationDuration);return s.getAnimator().addProp(t.Animator.TYPE_NUMBER,this,this.__getAngleExtent,this._animateAngleExtent,2*Math.PI),s}return t.Sunburst.superclass.GetDisplayAnimation.call(this,e,i)},t.Sunburst.prototype.GetDeleteContainer=function(){var e=t.Sunburst.superclass.GetDeleteContainer.call(this);return e&&e.setTranslate(this._translatePt.x,this._translatePt.y),e},t.Sunburst.prototype.OnAnimationEnd=function(){if(!this.AnimationStopped){this._container.removeChildren();var e=new t.Rectangle(0,0,this.Width,this.Height);this.Layout(e),this.Render(this._container,e);for(var i=this._selectionHandler?this._selectionHandler.getSelection():new Array,s=0;s<i.length;s++)i[s].setSelected(!0)}this._angleExtent<2*Math.PI&&this._animateAngleExtent(2*Math.PI),t.Sunburst.superclass.OnAnimationEnd.call(this)},t.Sunburst.prototype.__moveToHoverLayer=function(t){this._hoverLayer.addChild(t)},t.Sunburst.prototype.__moveToSelectedLayer=function(e){this._selectedLayer.addChild(e),t.Agent.isBrowserSafari()||t.Agent.isPlatformGecko()||(this._selectedLayer.removeAllDrawEffects(),this._selectedLayer.addDrawEffect(n.__NODE_SELECTED_SHADOW))},t.Sunburst.prototype.__getAngleExtent=function(){return this._angleExtent},t.Sunburst.prototype._animateAngleExtent=function(e){this._angleExtent=e;var i=new t.Rectangle(0,0,this.Width,this.Height);this.Layout(i),this._root&&this._root.updateShapes(!0)},t.Sunburst.prototype.__startRotation=function(t,e){this.__setRotationAnchor(this._calcAngle(t,e))},t.Sunburst.prototype.__setRotationAnchor=function(e){this._currentAngle=e,this._rotationMask=new t.Rect(this.getCtx(),0,0,this.Width,this.Height),this._rotationMask.setInvisibleFill(),this._rotationMask.setCursor(this._rotateCursor),this.addChild(this._rotationMask),this.getEventManager().associate(this._rotationMask,new r(null,A.ROTATION_ID))},t.Sunburst.prototype.__continueRotation=function(t,e){this.__rotate(this._calcAngle(t,e))},t.Sunburst.prototype.__rotate=function(e){var i=e-this._currentAngle;this._currentAngle=e,this._updateStartAngle(i);var s=360-Math.round(180*this._startAngle/Math.PI);this.dispatchEvent(t.EventFactory.newSunburstRotationEvent(s,!1))},t.Sunburst.prototype.__endRotation=function(){this._currentAngle=null,this.removeChild(this._rotationMask),this._rotationMask=null;var e=360-Math.round(180*this._startAngle/Math.PI);this.dispatchEvent(t.EventFactory.newSunburstRotationEvent(e,!1)),this.dispatchEvent(t.EventFactory.newSunburstRotationEvent(e,!0))},t.Sunburst.prototype.SetOptions=function(e){t.Sunburst.superclass.SetOptions.call(this,e),this.Options.expanded instanceof Array&&(this.Options._expandedNodes=t.ArrayUtils.createBooleanMap(this.Options.expanded))},t.Sunburst.prototype.expandCollapseNode=function(e){var i=this.getRootNode(),s=!n.getNodeById(i,e).isDisclosed(),o=this.getOptions().expanded;if("all"==o){for(var r=d.getAllNodes(this._root),a=0;a<r.length;a++)r[a]=r[a].getId();o=r}if(o instanceof Array)if(s)o.push(e);else{var l=o.indexOf(e);l>-1&&o.splice(l,1)}else o.has&&(o=s?o.add([e]):o.delete([e]));this.dispatchEvent(new t.EventFactory.newSunburstExpandCollapseEvent(s?"expand":"collapse",e,d.findRootAndAncestors(this.getOptions()._nodes,e,[]).root,this.getOptions()._widgetConstructor,o)),this.__setNavigableIdToFocus(e)},t.Sunburst.prototype._calcAngle=function(t,e){return Math.atan2(e-this._translatePt.y,t-this._translatePt.x)},t.Sunburst.prototype._updateStartAngle=function(e){this._startAngle+=e,this._startAngle<-Math.PI?this._startAngle+=2*Math.PI:this._startAngle>Math.PI&&(this._startAngle-=2*Math.PI);var i=new t.Rectangle(0,0,this.Width,this.Height);this.Layout(i),this._root&&this._root.updateShapes(!0)},t.Sunburst.prototype.__getNodeUnderPoint=function(t,e){return this._root.getNodeUnderPoint(t-this._translatePt.x,e-this._translatePt.y)},t.Sunburst.prototype.__showDropSiteFeedback=function(e){var i=t.Sunburst.superclass.__showDropSiteFeedback.call(this,e);return i&&i.setTranslate(this._translatePt.x,this._translatePt.y),i},t.Sunburst.prototype.__isRotationEnabled=function(){return"off"!=this.getOptions().rotation},t.Sunburst.prototype.getShapesForViewSwitcher=function(t){var e={};if(this._root)for(var i=[this._root];i.length>0;){var s=i.splice(0,1)[0],o=s.getId(),n=s.getDisplayable();if(o&&n&&(e[o]=n,e[o+"_text"]=s._text,t)){var r=n.getParent();if(r){var a=r.getChildIndex(n);r.addChildAt(s._text,a+1)}}var l=s.getChildNodes();l&&(i=i.concat(l))}return e},t.Sunburst.prototype.GetComponentDescription=function(){return t.Bundle.getTranslation(this.getOptions(),"componentName",t.Bundle.UTIL_PREFIX,"SUNBURST")},t.Sunburst.prototype.getBundlePrefix=function(){return t.Bundle.SUNBURST_PREFIX},t.Sunburst.prototype.CreateNode=function(t){return new v(this,t)},t.Sunburst.prototype.getCenterPoint=function(){return this._translatePt};var v=function(t,e){this.Init(t,e);var i=this._view.getOptions().nodeDefaults;this._labelDisplay=e.labelDisplay?e.labelDisplay:i.labelDisplay,this._evaluateExpanded(t,e),this._labelHalign=e.labelHalign?e.labelHalign:i.labelHalign,this._radius=e.radius,this._className=e.className||e.svgClassName,this._style=e.style||e.svgStyle,this._showDisclosure="on"==e.showDisclosure||"off"!=e.showDisclosure&&"on"==i.showDisclosure};t.Obj.createSubclass(v,n),v.TEXT_BUFFER_HORIZ=6,v._EXPAND_ICON_SIZE=16,v._ROOT_NODE_MARGIN=2,v._MIN_ARC_LENGTH=1.5,v._MIN_ANGLE_EXTENT=6e-4,v.TWO_PI=2*Math.PI,v._CENTER_ARTIFICIAL_ROOT_RADIUS=.25,v._CENTER_NODE_RADIUS=.5,v._CENTER_WITH_CONTENT_RADIUS=1,v.prototype.render=function(e){if(this._hasLayout){this._nodeContainer=e,this._shape=this._createShapeNode(),e.addChild(this._shape);var i=this.GetTemplate();if(this._showRootContent()&&i){var s=Math.sqrt(2),o=this._outerRadius*s-2*v._ROOT_NODE_MARGIN,n=o;this._x=-this._outerRadius/s+v._ROOT_NODE_MARGIN,this._y=-this._outerRadius/s+v._ROOT_NODE_MARGIN;var r=this.GetElAttributes(),a=this.GetAfContext();if(a.setELContext(r),o>0&&n>0){a.setAvailableWidth(o),a.setAvailableHeight(n),a.setFontSize(this.GetTextSize());var l=t.AfComponentFactory.parseAndLayout(a,i,this._shape);this._contentRoot=l;var h=l.getDimensions();l.setTranslate(this._x+(o-h.w)/2,this._y+(n-h.h)/2)}}else if(!(this.isRootNode()&&this._createRootNodeContent()||(this._text=this._createTextNode(this._shape),null==this._text))){this._shape.addChild(this._text);var _=this.getLabelBackgroundColor();if(this._pattern||_){h=this._text.getDimensions();this._textBackground=new t.Rect(this.getView().getCtx(),h.x,h.y,h.w,h.h),_?this._textBackground.setSolidFill(_):this._textBackground.setSolidFill("#FFFFFF"),this._textBackground.setMouseEnabled(!1),this._shape.addChild(this._textBackground);var d=this._text.getMatrix();d.isIdentity()||this._textBackground.setMatrix(d),this._shape.addChild(this._text)}}this._shape.setAriaRole("img"),this._shape.setStyle(this._style),this._shape.setClassName(this._className),this.UpdateAriaLabel(),this.renderChildren(e)}},v.prototype.renderChildren=function(e){var i=this.getChildNodes(),s=this.getView().__getNodeCount()>=t.Sunburst.LARGE_DATASET_THRESHOLD;if(null!=i)for(var o=0,n=0;n<i.length;n++){var r=i[n]._angleExtent;if(!(r<v._MIN_ANGLE_EXTENT)){if(s){var a=i[n]._getOuterRadius(),l=r*a,h=(i[n]._startAngle+r)*a;if(l<v._MIN_ARC_LENGTH&&Math.abs(o-h)<v._MIN_ARC_LENGTH)continue;o=h}i[n].render(e)}}},v.prototype.setSelected=function(e){v.superclass.setSelected.call(this,e),null!=this._shape&&(this.isSelected()?(this._shape.setSelected(!0),this.getView().__moveToSelectedLayer(this._shape)):(this._shape.setSelected(!1),t.Agent.isTouchDevice()&&this._expandButton?this.getView().__moveToSelectedLayer(this._shape):this._nodeContainer&&this._nodeContainer.addChild(this._shape)))},v.prototype.showHoverEffect=function(){this._shape&&this._hasLayout&&(this._shape.showHoverEffect(),this.isSelected()?this.getView().__moveToSelectedLayer(this._shape):this.getView().__moveToHoverLayer(this._shape))},v.prototype.hideHoverEffect=function(){this._shape&&this._hasLayout&&!this.isShowingKeyboardFocusEffect()&&(this._shape.hideHoverEffect(),!this.isSelected()&&this._nodeContainer&&this._nodeContainer.addChild(this._shape))},v.prototype.isExpandCollapseEnabled=function(){return this._showDisclosure},v.prototype.getNextNavigable=function(e){var i,s,o,n,r;if(e.type==t.MouseEvent.CLICK)return v.superclass.getNextNavigable.call(this,e);if((i=e.keyCode)==t.KeyboardEvent.SPACE&&e.ctrlKey)return this;for(r=this;r.GetParent();)r=r.GetParent();o=this.GetNodesAtDepth(r,this.GetDepth()),n=v._findNodeIndex(this,o);var a,l,h=this._startAngle+this._angleExtent/2;switch(h=v._normalizedRadToDeg(h),i){case t.KeyboardEvent.UP_ARROW:if(this===r||h>180){if((a=this.GetLastVisitedChild())&&(l=a._startAngle+a._angleExtent/2,(l=v._normalizedRadToDeg(l))>180))return a;s=t.KeyboardHandler.getNextAdjacentNavigable(this,e,this.getDescendantNodes())}else s=this._navigateToParent();break;case t.KeyboardEvent.DOWN_ARROW:if(this===r||h>=0&&h<=180){if((a=this.GetLastVisitedChild())&&(l=a._startAngle+a._angleExtent/2,(l=v._normalizedRadToDeg(l))>=0&&l<=180))return a;s=t.KeyboardHandler.getNextAdjacentNavigable(this,e,this.getDescendantNodes())}else s=this._navigateToParent();break;case t.KeyboardEvent.LEFT_ARROW:s=1==o.length?this:0==n?o[o.length-1]:o[n-1];break;case t.KeyboardEvent.RIGHT_ARROW:s=1==o.length?this:n==o.length-1?o[0]:o[n+1];break;default:s=this}return s.MarkAsLastVisitedChild(),s},v.prototype._navigateToParent=function(){var t,e=this.GetParent();return e?(t=e,e.MarkAsLastVisitedChild()):t=this,t.MarkAsLastVisitedChild(),t},v._normalizedRadToDeg=function(e){var i=t.Math.radsToDegrees(e);return i<0?i+=360:i>360&&(i-=360),i},v.prototype.getKeyboardBoundingBox=function(e){if(this._shape){var i=this._shape.getDimensions(),s=new t.Point(i.x,i.y);return s=this._shape.localToStage(s),i.x=s.x,i.y=s.y,i}return new t.Rectangle(0,0,0,0)},v.prototype.getTargetElem=function(){return this._shape?this._shape.getElem():null},v.prototype.getContextMenuLocation=function(){var t=v._calcPointOnArc(.5*(this._outerRadius+this._innerRadius),this._startAngle+this._angleExtent/2);return this._shape.localToStage(t)},v.prototype.setLayoutParams=function(t,e,i,s){this._innerRadius=t,this._outerRadius=e,this._startAngle=i,this._angleExtent=s,this._hasLayout=!0},v.prototype.GetFill=function(){return this.isArtificialRoot()?t.SolidFill.invisibleFill():v.superclass.GetFill.call(this)},v.prototype.GetAnimationParams=function(e){var i=t.ColorUtils.getRed(this._color),s=t.ColorUtils.getGreen(this._color),o=t.ColorUtils.getBlue(this._color),n=this._startAngle;if(e&&!isNaN(e[2])){var r=e[2];r-this._startAngle>Math.PI?n+=v.TWO_PI:this._startAngle-r>Math.PI&&(n-=v.TWO_PI)}return[this._innerRadius,this._outerRadius,n,this._angleExtent,i,s,o]},v.prototype.SetAnimationParams=function(e){this.setLayoutParams(e[0],e[1],e[2],e[3]);var i=Math.round(e[4]),s=Math.round(e[5]),o=Math.round(e[6]);this._color=t.ColorUtils.makeRGB(i,s,o),this.updateShapes(!1)},v.prototype.animateUpdate=function(t,e){!this.isRootNode()||e._getOuterRadius()==this._getOuterRadius()&&e.getId()==this.getId()||this._removeRootNodeContentOverlay(),e._hasLayout&&e._angleExtent>0?v.superclass.animateUpdate.call(this,t,e):this.animateInsert(t)},v.prototype.animateInsert=function(t,e){this.isRootNode()&&this._removeRootNodeContentOverlay(),v.superclass.animateInsert.call(this,t,e)},v.prototype.animateDelete=function(t,e){this.isRootNode()&&this._removeRootNodeContentOverlay(),v.superclass.animateDelete.call(this,t,e)},v.prototype.getNodeUnderPoint=function(t,e){if(this.contains(t,e))return this;for(var i=this.getChildNodes(),s=0;s<i.length;s++){var o=i[s].getNodeUnderPoint(t,e);if(o)return o}return null},v.prototype.contains=function(t,e){var i=v._calcRadius(t,e),s=v._calcAngle(t,e);return this.ContainsRadius(i)&&this.ContainsAngle(s)},v.prototype.ContainsAngle=function(t){for(;t<this._startAngle;)t+=v.TWO_PI;for(;t-this._startAngle>v.TWO_PI;)t-=v.TWO_PI;return t>=this._startAngle&&t<=this._startAngle+this._angleExtent},v.prototype.ContainsRadius=function(t){return t>=this._innerRadius&&t<=this._outerRadius},v._calcPointOnArc=function(t,e){return{x:Math.cos(e)*t,y:Math.sin(e)*t}},v._containsRect=function(t,e){return e.contains(t.x,t.y)&&e.contains(t.x+t.w,t.y)&&e.contains(t.x+t.w,t.y+t.h)&&e.contains(t.x,t.y+t.h)},v._calcAngle=function(t,e){var i=Math.atan2(e,t);return i<0?i+=v.TWO_PI:i>v.TWO_PI&&(i-=v.TWO_PI),i},v._calcRadius=function(t,e){return Math.sqrt(t*t+e*e)},v.prototype._createShapeNode=function(){if(!this._angleExtent||this._angleExtent<=0)return null;var e=this._createPathCmd(),i=new t.Path(this.getView().getCtx(),e);this.getView().getEventManager().associate(i,this),i.setAlpha(this.getAlpha()),i.setFill(this.GetFill());var s=this._view.getOptions().nodeDefaults,o=this.getOptions(),n=o.borderColor||s.borderColor,r=o.borderWidth||s.borderWidth;return i.setStroke(new t.SolidStroke(n,1,r)),i.setHoverStroke(new t.SolidStroke(s.hoverColor,1,3)),i.setSelectedStroke(new t.SolidStroke(s.selectedInnerColor,1,1.5),new t.SolidStroke(s.selectedOuterColor,1,3.5)),i.setSelectedHoverStroke(new t.SolidStroke(s.hoverColor,1,3)),i.setSelectable(this.isSelectable()),this.isDrillReplaceEnabled()&&i.setCursor("pointer"),this.isArtificialRoot()&&(i.setAlpha(.001),i.setMouseEnabled(!1)),i},v.prototype._createPathCmd=function(){var e,i,s,o,n;return this._angleExtent<v.TWO_PI?(i=v._calcPointOnArc(this._outerRadius,this._startAngle),s=v._calcPointOnArc(this._outerRadius,this._startAngle+this._angleExtent),o=v._calcPointOnArc(this._innerRadius,this._startAngle+this._angleExtent),n=v._calcPointOnArc(this._innerRadius,this._startAngle),e=t.PathUtils.moveTo(i.x,i.y)+t.PathUtils.arcTo(this._outerRadius,this._outerRadius,this._angleExtent,1,s.x,s.y)+t.PathUtils.lineTo(o.x,o.y)+t.PathUtils.arcTo(this._innerRadius,this._innerRadius,this._angleExtent,0,n.x,n.y)+t.PathUtils.closePath()):(i=v._calcPointOnArc(this._outerRadius,this._startAngle),s=v._calcPointOnArc(this._outerRadius,this._startAngle+this._angleExtent/2),o=v._calcPointOnArc(this._innerRadius,this._startAngle),n=v._calcPointOnArc(this._innerRadius,this._startAngle+this._angleExtent/2),e=t.PathUtils.moveTo(i.x,i.y)+t.PathUtils.arcTo(this._outerRadius,this._outerRadius,this._angleExtent/2,1,s.x,s.y)+t.PathUtils.arcTo(this._outerRadius,this._outerRadius,this._angleExtent/2,1,i.x,i.y),this._innerRadius>0&&(e+=t.PathUtils.moveTo(n.x,n.y)+t.PathUtils.arcTo(this._innerRadius,this._innerRadius,this._angleExtent/2,0,o.x,o.y)+t.PathUtils.arcTo(this._innerRadius,this._innerRadius,this._angleExtent/2,0,n.x,n.y)),e+=t.PathUtils.closePath()),e},v.prototype._createExpandCollapseButton=function(e){var i=this.isDisclosed();if(!e||!this.isExpandCollapseEnabled()||!this.hasChildren()&&i)return null;var s=i?this._getCollapseButton():this._getExpandButton();this._positionButton(s),e.addChild(s);var o=t.Bundle.getTranslation(this.getView().getOptions(),this.isDisclosed()?"tooltipCollapse":"tooltipExpand",t.Bundle.SUNBURST_PREFIX,this.isDisclosed()?"COLLAPSE":"EXPAND");return this.getView().getEventManager().associate(s,new r(this,this.getId(),o)),s},v.prototype._positionButton=function(t){var e=v._calcPointOnArc(this._outerRadius,this._startAngle+this._angleExtent/2);t.setTranslate(e.x-v._EXPAND_ICON_SIZE/2,e.y-v._EXPAND_ICON_SIZE/2)},v.prototype._createTextNode=function(e){if(!this._textStr||!e||!this._labelDisplay||"off"==this._labelDisplay)return null;if(this==this.getView().getRootNode()&&this._angleExtent<v.TWO_PI)return null;var i=!1;return"auto"==this._labelDisplay?i=!(!t.Agent.isPlatformIE()&&t.Agent.getOS()==t.Agent.WINDOWS_OS):"rotated"==this._labelDisplay&&(i=!0),i&&this._angleExtent<this.getView().__getAngleExtent()?this._createTextRotated(e):this._createTextHoriz(e)},v.prototype._createTextHoriz=function(e){var i;if(0==this._innerRadius)i={x:0,y:0};else{i=v._calcPointOnArc((this._innerRadius+this._outerRadius)/2,this._startAngle+this._angleExtent/2);var s=3*this.GetTextSize()/2,o=v._calcAngle(i.x-s/2,i.y),n=v._calcAngle(i.x+s/2,i.y);this.ContainsAngle(o)&&this.ContainsAngle(n)||(i=null)}if(i){var r=new t.OutputText(this.getView().getCtx(),this._textStr,i.x,i.y,null);r.setFontSize(this.GetTextSize()),this.ApplyLabelTextStyle(r),r.alignCenter(),r.alignMiddle(),r.setMouseEnabled(!1);for(var a=r.getDimensions(),l=i.x,h=i.x,_=i.y-a.h/2,d=i.y+a.h/2,u=!0;this.contains(l,_)&&this.contains(l,d)&&u;)l--,this._angleExtent>Math.PI&&i.x-l>=a.w&&(u=!1);for(var p=!0;this.contains(h,_)&&this.contains(h,d)&&p;)h++,this._angleExtent>Math.PI&&h-i.x>=a.w&&(p=!1);l+=3,h-=3;var c=2*Math.min(i.x-l,h-i.x);c<a.w&&(r.setX((l+h)/2),c=h-l);var g=this.getView().getOptions().nodeDefaults.labelMinLength;return t.TextUtils.fitText(r,c,a.h,e,g)?r:null}},v.prototype._createTextRotated=function(e){var i=Math.max(this._innerRadius,10),s=this._outerRadius-i-v.TEXT_BUFFER_HORIZ,o=this._angleExtent*(i+v.TEXT_BUFFER_HORIZ)*1.1;if(o<=6)return null;var n=new t.OutputText(this.getView().getCtx(),this._textStr,0,0);if(n.setFontSize(this.GetTextSize()),this.ApplyLabelTextStyle(n),!t.TextUtils.fitText(n,s,o,e))return null;var r=(i+this._outerRadius)/2;if("inner"==this._labelHalign||"outer"==this._labelHalign){e.addChild(n);var a=n.getDimensions().w,l=.75*v.TEXT_BUFFER_HORIZ;"inner"==this._labelHalign?r=i+l+a/2:"outer"==this._labelHalign&&(r=this._outerRadius-l-a/2)}var h=v._calcPointOnArc(r,this._startAngle+this._angleExtent/2);n.alignCenter(),n.alignMiddle();var _=this._startAngle+this._angleExtent/2;return(_=(_=_>=v.TWO_PI?_-v.TWO_PI:_)<0?_+v.TWO_PI:_)>.5*Math.PI&&_<1.5*Math.PI&&(_+=Math.PI),n.setRotation(_),n.setTranslate(h.x,h.y),n.setMouseEnabled(!1),n},v._findNodeIndex=function(t,e){for(var i=0;i<e.length;i++)if(t===e[i])return i;return-1},v.prototype.handleMouseOver=function(){this._expandButton||(this._expandButton=this._createExpandCollapseButton(this._shape)),v.superclass.handleMouseOver.call(this)},v.prototype.handleMouseOut=function(){this._expandButton&&this._shape&&(this._shape.removeChild(this._expandButton),this._expandButton=null),v.superclass.handleMouseOut.call(this)},v.prototype.updateShapes=function(e){if(this._shape){var i=this._createPathCmd();if(this._shape.setCmds(i),!this._showRootContent()){this._text&&this._shape.removeChild(this._text),this._text=this._createTextNode(this._shape);var s=this.getLabelBackgroundColor();if(this._text&&(this._pattern||s)){var o=this._text.getDimensions();this._textBackground?this._textBackground.setRect(o.x,o.y,o.w,o.h):(this._textBackground=new t.Rect(this.getView().getCtx(),o.x,o.y,o.w,o.h),s?this._textBackground.setSolidFill(s):this._textBackground.setSolidFill("#FFFFFF"),this._textBackground.setMouseEnabled(!1),this._shape.addChild(this._textBackground));var n=this._text.getMatrix();n.isIdentity()||this._textBackground.setMatrix(n)}else this._textBackground&&(this._shape.removeChild(this._textBackground),this._textBackground=null)}if(t.Agent.isTouchDevice()&&this._expandButton&&this._positionButton(this._expandButton),this._shape.setFill(this.GetFill()),e)for(var r=this.getChildNodes(),a=0;a<r.length;a++)r[a].updateShapes(!0)}},v.prototype.getDropSiteFeedback=function(){return this._shape instanceof t.Circle?new t.Circle(this.getView().getCtx(),this._shape.getCx(),this._shape.getCy(),this._shape.getRadius()):this._shape instanceof t.Path?new t.Path(this.getView().getCtx(),this._shape.getCmds()):null},v.prototype._getExpandButton=function(){var e=this.getView().getCtx(),i=this.getView().getOptions()._resources,s=new t.Image(e,i.expand,0,0,v._EXPAND_ICON_SIZE,v._EXPAND_ICON_SIZE),o=new t.Image(e,i.expandOver,0,0,v._EXPAND_ICON_SIZE,v._EXPAND_ICON_SIZE),n=new t.Image(e,i.expandDown,0,0,v._EXPAND_ICON_SIZE,v._EXPAND_ICON_SIZE);s.setInvisibleFill(),o.setInvisibleFill(),n.setInvisibleFill();var r=new t.Button(e,s,o,n);return r.addEvtListener(t.MouseEvent.CLICK,this.expandCollapse,!1,this),r},v.prototype._getCollapseButton=function(){var e=this.getView().getCtx(),i=this.getView().getOptions()._resources,s=new t.Image(e,i.collapse,0,0,v._EXPAND_ICON_SIZE,v._EXPAND_ICON_SIZE),o=new t.Image(e,i.collapseOver,0,0,v._EXPAND_ICON_SIZE,v._EXPAND_ICON_SIZE),n=new t.Image(e,i.collapseDown,0,0,v._EXPAND_ICON_SIZE,v._EXPAND_ICON_SIZE);s.setInvisibleFill(),o.setInvisibleFill(),n.setInvisibleFill();var r=new t.Button(e,s,o,n);return r.addEvtListener(t.MouseEvent.CLICK,this.expandCollapse,!1,this),r},v.prototype.expandCollapse=function(t){this.getView().expandCollapseNode(this.getId()),t.stopPropagation()},v.prototype.getExpandCollapseButton=function(){return this._expandButton},v.prototype._showRootContent=function(){return!this._parent&&0==this._innerRadius&&this._angleExtent==v.TWO_PI},v.prototype.hasRootContent=function(){return!!this.GetTemplate()},v.prototype.__getRadius=function(){return null!=this._radius?Number(this._radius):this.GetParent()?1:this.isArtificialRoot()?v._CENTER_ARTIFICIAL_ROOT_RADIUS:this.hasRootContent()?v._CENTER_WITH_CONTENT_RADIUS:v._CENTER_NODE_RADIUS},v.prototype.getAriaLabel=function(){var e=this.getView().getOptions(),i=[];return this.isSelectable()&&i.push(t.Bundle.getTranslatedString(t.Bundle.UTIL_PREFIX,this.isSelected()?"STATE_SELECTED":"STATE_UNSELECTED")),this.isExpandCollapseEnabled()&&i.push(t.Bundle.getTranslatedString(t.Bundle.UTIL_PREFIX,this.isDisclosed()?"STATE_EXPANDED":"STATE_COLLAPSED")),this.isDrillReplaceEnabled()&&i.push(t.Bundle.getTranslation(e,"stateDrillable",t.Bundle.UTIL_PREFIX,"STATE_DRILLABLE")),t.Displayable.generateAriaLabel(this.getShortDesc(),i)},v.prototype.UpdateAriaLabel=function(){!t.Agent.deferAriaCreation()&&this._shape&&this._shape.setAriaProperty("label",this.getAriaLabel())},v.prototype.getDataContext=function(){var t=v.superclass.getDataContext.call(this);return t.radius=this.__getRadius(),t},v.prototype._createRootNodeContent=function(){var t=this.getView(),e=t.getOptions(),i=e.rootNodeContent.renderer;if(this._removeRootNodeContentOverlay(),!i)return!1;var s=t.getCtx(),o=t.getCenterPoint(),n=this._outerRadius,r=n*Math.sqrt(2),a={outerBounds:{x:o.x-n,y:o.y-n,width:2*n,height:2*n},innerBounds:{x:o.x-r/2,y:o.y-r/2,width:r,height:r},id:this._id,data:this.getOptions(),component:e._widgetConstructor};a=s.fixRendererContext(a);var l=s.getContainer(),h=i(a);if(h){var _=s.createOverlayDiv();_.appendChild(h),t.rootNodeContent=_,l.appendChild(_);var d=s.getOverlayAttachedCallback();return d&&d(_),!0}},v.prototype._getOuterRadius=function(){return this._outerRadius},v.prototype._removeRootNodeContentOverlay=function(){var t=this.getView(),e=t.rootNodeContent;e&&t.getCtx().getContainer().removeChild(e),t.rootNodeContent=null},v.prototype._evaluateExpanded=function(e,i){var s=e.getOptions(),o=s.expanded;i.bArtificialRoot||i._expanded||(o.has?o.has(i.id)||this.setDisclosed(!1):o instanceof Array&&!t.ArrayUtils.hasAnyMapItem(s._expandedNodes,[i.id])&&this.setDisclosed(!1))};var T=new Object;t.Obj.createSubclass(T,t.Obj),T.layout=function(t,e,i,s,o){var n=t/T._calcLargestRadius(e);T._layout(n,e,i,s,o,0)},T._layout=function(e,i,s,o,n,r){var a=r+i.__getRadius()*e;i.setLayoutParams(r,a,s,o);var l=i.getChildNodes();if(null!=l&&i.isDisclosed()){var h,_=s;"on"==n&&(l=l.slice(0)).sort(function(t,e){return e.getSize()-t.getSize()}),t.Agent.isRightToLeft(i.getView().getCtx())&&(l=l.slice(0).reverse());var d=0;for(h=0;h<l.length;h++)d+=l[h].getSize()>0?l[h].getSize():0;for(h=0;h<l.length;h++){var u=l[h];if(!(u.getSize()<=0)){var p=u.getSize()/d*o;T._layout(e,u,_,p,n,a),_+=p}}}},T._calcLargestRadius=function(t){var e=0,i=t.getChildNodes();if(i&&i.length>0){for(var s=0;s<i.length;s++){var o=T._calcLargestRadius(i[s]);e=Math.max(e,o)}return e+t.__getRadius()}return t.__getRadius()};var A=function(t,e,i,s){o.call(this,t,e,i,s)};t.Obj.createSubclass(A,o),A.ROTATION_ID="_rotationShape",A.prototype.OnMouseDown=function(t){var e=this.GetLogicalObject(t.target);if(e&&e.getId&&e.getId()==A.ROTATION_ID&&!this._bRotating){this._bRotating=!0;var i=this._context.pageToStageCoords(t.pageX,t.pageY);this.GetView().__startRotation(i.x,i.y)}else A.superclass.OnMouseDown.call(this,t)},A.prototype.OnMouseMove=function(t){if(this._bRotating){var e=this._context.pageToStageCoords(t.pageX,t.pageY);this.GetView().__continueRotation(e.x,e.y)}else A.superclass.OnMouseMove.call(this,t)},A.prototype.OnMouseUp=function(t){this._bRotating?(this._bRotating=!1,this.GetView().__endRotation()):A.superclass.OnMouseUp.call(this,t)},A.prototype.ProcessKeyboardEvent=function(e){var i=!0,s=e.keyCode,o=this.getFocus(),n=this.GetView();if(o.isExpandCollapseEnabled()&&(t.KeyboardEvent.isPlus(e)&&!o.isDisclosed()||t.KeyboardEvent.isMinus(e)&&o.isDisclosed()||e.ctrlKey&&s==t.KeyboardEvent.ENTER))n.expandCollapseNode(o.getId()),t.EventManager.consumeEvent(e);else if(n&&n.__isRotationEnabled()&&(s==t.KeyboardEvent.LEFT_ARROW||s==t.KeyboardEvent.RIGHT_ARROW)&&!e.ctrlKey&&e.altKey&&e.shiftKey){var r;r=s==t.KeyboardEvent.LEFT_ARROW?Math.PI/180*-5:Math.PI/180*5,n.__setRotationAnchor(0),n.__rotate(r),n.__endRotation(),t.EventManager.consumeEvent(e)}else i=A.superclass.ProcessKeyboardEvent.call(this,e);return i},A.ROTATE_KEY="rotateKey",A.prototype.HandleImmediateTouchStartInternal=function(t){var e=this.GetLogicalObject(t.target);e&&e.getId&&e.getId()==A.ROTATION_ID&&this.TouchManager.processAssociatedTouchAttempt(t,A.ROTATE_KEY,this.RotateStartTouch,this)},A.prototype.HandleImmediateTouchMoveInternal=function(t){this.TouchManager.processAssociatedTouchMove(t,A.ROTATE_KEY)},A.prototype.HandleImmediateTouchEndInternal=function(t){this.TouchManager.processAssociatedTouchEnd(t,A.ROTATE_KEY)},A.prototype.RotateStartTouch=function(t,e){if(this.TouchManager.getTouchIdsForObj(A.ROTATE_KEY).length<=1){this.TouchManager.saveProcessedTouch(e.identifier,A.ROTATE_KEY,null,A.ROTATE_KEY,A.ROTATE_KEY,this.RotateMoveTouch,this.RotateEndTouch,this),this.TouchManager.setTooltipEnabled(e.identifier,!1);var i=this._context.pageToStageCoords(e.pageX,e.pageY);this.GetView().__startRotation(i.x,i.y),t.blockTouchHold()}},A.prototype.RotateMoveTouch=function(t,e){var i=this._context.pageToStageCoords(e.pageX,e.pageY);this.GetView().__continueRotation(i.x,i.y),t.preventDefault()},A.prototype.RotateEndTouch=function(t,e){this.GetView().__endRotation()},t.Bundle.addDefaultStrings(t.Bundle.SUNBURST_PREFIX,{COLLAPSE:"Collapse",COLOR:"Color",EXPAND:"Expand",OTHER:"Other",SIZE:"Size"});var C=function(){this.Init({skyros:C.VERSION_1,alta:{},next:{}})};t.Obj.createSubclass(C,_),C.VERSION_1={nodeDefaults:{borderColor:"rgba(255,255,255,0.3)",borderWidth:1,hoverColor:"#FFFFFF",labelDisplay:"auto",labelHalign:"center",selectedInnerColor:"#FFFFFF",selectedOuterColor:"#000000"},rootNodeContent:{},rotation:"on",expanded:"all",startAngle:90},t.exportProperty(t,"Sunburst",t.Sunburst),t.exportProperty(t,"Treemap",t.Treemap),t.exportProperty(t.Treemap,"newInstance",t.Treemap.newInstance),t.exportProperty(t.Sunburst,"newInstance",t.Sunburst.newInstance),t.exportProperty(e.prototype,"getAutomation",e.prototype.getAutomation),t.exportProperty(e.prototype,"destroy",e.prototype.destroy),t.exportProperty(e.prototype,"highlight",e.prototype.highlight),t.exportProperty(e.prototype,"render",e.prototype.render),t.exportProperty(e.prototype,"select",e.prototype.select),t.exportProperty(u.prototype,"getDomElementForSubId",u.prototype.getDomElementForSubId),t.exportProperty(u.prototype,"getNode",u.prototype.getNode)}(dvt);
  return dvt;
});
