/**
 * @license
 * Copyright (c) 2014, 2018, Oracle and/or its affiliates.
 * The Universal Permissive License (UPL), Version 1.0
 */
"use strict";define(["ojs/ojcore","jquery","knockout","ojs/ojarraydataprovider","ojs/ojeventtarget","ojs/ojtreedataprovider"],function(t,e,r){t.ArrayDataProvider;var a=function(){function e(e,r,a){this.treeData=e,this.options=r,this._rootDataProvider=a,this.TreeAsyncIterator=function(){function t(t,e){this._parent=t,this._baseIterable=e}return t.prototype.next=function(){var t=this;return this._baseIterable[Symbol.asyncIterator]().next().then(function(e){for(var r=e.value.metadata,a=0;a<r.length;a++)r[a]=t._parent._getNodeMetadata(e.value.data[a]);return e})},t}(),this.TreeAsyncIterable=function(){return function(t,e){this._parent=t,this._asyncIterator=e,this[Symbol.asyncIterator]=function(){return this._asyncIterator}}}(),this._baseDataProvider=new t.ArrayDataProvider(e,r),this._mapKeyToNode=new Map,this._mapNodeToKey=new Map,this._nodeSequenceNum=0,null==a&&this._subscribeObservableArray(e,[])}return e.prototype.containsKeys=function(t){return this.fetchByKeys(t).then(function(e){var r=new Set;return t.keys.forEach(function(t){null!=e.results.get(t)&&r.add(t)}),Promise.resolve({containsParameters:t,results:r})})},e.prototype.getCapability=function(t){return this._baseDataProvider.getCapability(t)},e.prototype.getTotalSize=function(){return this._baseDataProvider.getTotalSize()},e.prototype.isEmpty=function(){return this._baseDataProvider.isEmpty()},e.prototype.getChildDataProvider=function(t,r){var a=this._getNodeForKey(t);if(a){var o=this._getChildren(a);if(o)return new e(o,this.options,this._getRootDataProvider())}return null},e.prototype.fetchFirst=function(t){var e=this._baseDataProvider.fetchFirst(t);return new this.TreeAsyncIterable(this,new this.TreeAsyncIterator(this,e))},e.prototype.fetchByOffset=function(t){var e=this._baseDataProvider.fetchByOffset(t),r=this;return e.then(function(t){for(var e=t.results,a=[],o=0;o<e.length;o++){var n=e[o].metadata,i=e[o].data;n=r._getNodeMetadata(i),a.push({data:i,metadata:n})}return{done:t.done,fetchParameters:t.fetchParameters,results:a}})},e.prototype.fetchByKeys=function(t){var e=this,r=new Map;return t.keys.forEach(function(t){var a=e._getNodeForKey(t);a&&r.set(t,{metadata:{key:t},data:a})}),Promise.resolve({fetchParameters:t,results:r})},e.prototype._getChildren=function(t){var e=this.options&&this.options.childrenAttribute?this.options.childrenAttribute:"children";return this._getVal(t,e)},e.prototype._getRootDataProvider=function(){return this._rootDataProvider?this._rootDataProvider:this},e.prototype._handleArrayChange=function(e,r,a){var o,n=this,i=[],s=[],u=[],d=[],h=!1,y=!1,p=!1;for(o=0;o<e.length;o++)if("deleted"===e[o].status){h=!0;break}for(o=0;o<e.length;o++)if("added"===e[o].status){y=!0;break}if(y&&h&&(p=!0),h){for(o=0;o<e.length;o++)if("deleted"===e[o].status){var f=e[o].value,l=n._getKeyForNode(f);s.push(l),i.push(f),u.push(e[o].index),n._deleteMapEntry(l,f)}if(s.length>0&&!p){d=s.map(function(t){return{key:t}});var c=new Set;s.map(function(t){c.add(t)});var v={remove:{data:i,indexes:u,keys:c,metadata:d}};n.dispatchEvent(new t.DataProviderMutationEvent(v))}}if(y){var _=r();for(o=0;o<e.length;o++)if("added"===e[o].status){f=e[o].value;var g=n._createKeyObj(f,a,-1);n._setMapEntry(g.key,f),s.push(g.key),i.push(f),u.push(e[o].index)}if(s.length>0&&!p){d=s.map(function(t){return{key:t}});var b=new Set;s.map(function(t){b.add(t)});var m=new Set;u.map(function(t){var e;e=t>=_.length-1?"":n._getKeyForNode(_[t+1]),m.add(e)});v={add:{afterKeys:m,data:i,indexes:u,keys:b,metadata:d}};n.dispatchEvent(new t.DataProviderMutationEvent(v))}p&&n.dispatchEvent(new t.DataProviderRefreshEvent)}},e.prototype._subscribeObservableArray=function(t,e){var a,o=this;if(t instanceof Array)a=t;else{if(!r.isObservable(t)||void 0===t.destroyAll)throw new Error("Invalid data type. ArrayTreeDataProvider only supports Array or observableArray.");t.subscribe(function(r){o._handleArrayChange(r,t,e)},null,"arrayChange"),a=t()}a.forEach(function(t,r){var a=o._createKeyObj(t,e,r);o._setMapEntry(a.key,t),++o._nodeSequenceNum;var n=o._getChildren(t);n&&o._subscribeObservableArray(n,a.keyPath)})},e.prototype._createKeyObj=function(t,e,r){var a=this._getId(t),o=e?e.slice():[];return null==a?(o.push(r>=0?r:this._nodeSequenceNum++),a=o):(o.push(a),this.options&&"siblings"==this.options.keyAttributesScope&&(a=o)),{key:a,keyPath:o}},e.prototype._getId=function(t){var e,r=null!=this.options?this.options.keyAttributes:null;if(null!=r){var a;if(Array.isArray(r))for(e=[],a=0;a<r.length;a++)e[a]=this._getVal(t,r[a]);else e="@value"==r?this._getAllVals(t):this._getVal(t,r);return e}return null},e.prototype._getVal=function(t,e){if("string"==typeof e){var r=e.indexOf(".");if(r>0){var a=e.substring(0,r),o=e.substring(r+1),n=t[a];if(n)return this._getVal(n,o)}}return"function"==typeof t[e]?t[e]():t[e]},e.prototype._getAllVals=function(t){var e=this;return Object.keys(t).map(function(r){return e._getVal(t,r)})},e.prototype._getNodeMetadata=function(t){return{key:this._getKeyForNode(t)}},e.prototype._getNodeForKey=function(t){return this._getRootDataProvider()._mapKeyToNode.get(t)},e.prototype._getKeyForNode=function(t){return this._getRootDataProvider()._mapNodeToKey.get(t)},e.prototype._setMapEntry=function(t,e){var r=this._getRootDataProvider();r._mapKeyToNode.set(t,e),r._mapNodeToKey.set(e,t)},e.prototype._deleteMapEntry=function(t,e){var r=this._getRootDataProvider();r._mapKeyToNode.delete(t),r._mapNodeToKey.delete(e)},e}();t.ArrayTreeDataProvider=a,t.ArrayTreeDataProvider=a,t.EventTargetMixin.applyMixin(a)});