/**
 * @license
 * Copyright (c) 2014, 2018, Oracle and/or its affiliates.
 * The Universal Permissive License (UPL), Version 1.0
 */
"use strict";define(["ojs/ojcore","jquery","ojs/ojdatasource-common","ojs/ojmodel"],function(e,t){e.CollectionNodeSet=function(e,t,o,n,c,i){this.parentKey=e,this.collection=t,this.models=o,this.childNodeSet=[],this.treeDataSource=n,this.start=c<o.length?c:0===o.length?0:o.length-1,this.count=-1===i?o.length:Math.min(o.length,i)},e.CollectionNodeSet.prototype.FetchDescendants=function(e){this._fetchDescendants(this,!0).then(function(){e.success&&e.success()})},e.CollectionNodeSet.prototype._fetchDescendants=function(e,t){return new Promise(function(t,o){var n=e.getCount();!function o(c){c<n?e.FetchChildNodeSet(c,{success:function(t){null!==t?e._fetchDescendants(t,!1).then(function(){o(c+1)}):o(c+1)}}):t(void 0)}(0)})},e.CollectionNodeSet.prototype.FetchChildNodeSet=function(e,t){var o=this.models[e];if(this.treeDataSource.parseMetadata(o).leaf)return this.childNodeSet[e]=null,void t.success(null);var n=this.treeDataSource.GetChildCollection(o),c=this.treeDataSource.parseMetadata(o).key,i=this;this.treeDataSource.FetchCollection(n,0,-1,{success:function(o){i.childNodeSet[e]=o,t.success(o)}},c)},e.CollectionNodeSet.prototype._getCollection=function(){return this.collection},e.CollectionNodeSet.prototype.getParent=function(){return this.parentKey},e.CollectionNodeSet.prototype.getStart=function(){return this.start},e.CollectionNodeSet.prototype.getCount=function(){return this.count},e.CollectionNodeSet.prototype.getData=function(e){return this._checkRange(e),this.models[e].attributes},e.CollectionNodeSet.prototype._checkRange=function(e){if(e<this.start||e>this.start+this.count)throw"Out of range"},e.CollectionNodeSet.prototype.getMetadata=function(e){this._checkRange(e);var t={leaf:!1,depth:-1},o=this.models[e],n=this.treeDataSource.parseMetadata(o);return t.key=n.key,t.leaf=n.leaf,t.depth=n.depth,t},e.CollectionNodeSet.prototype.getChildNodeSet=function(e){return this.treeDataSource._virtual?null:(this._checkRange(e),this.childNodeSet[e])},e.CollectionTreeDataSource=function(t){t=t||{},this.rootCollection=t.root,this.childCollectionCallback=t.childCollectionCallback,this.parseMetadata=t.parseMetadata,this.sortkey=null,this.sortdir="none",this.cache={},this._virtual=!1,e.CollectionTreeDataSource.superclass.constructor.call(this)},e.CollectionTreeDataSource.prototype.parseMetadata=function(e){return{key:e.idAttribute+"="+e.id}},e.Object.createSubclass(e.CollectionTreeDataSource,e.TreeDataSource,"oj.CollectionTreeDataSource"),e.CollectionTreeDataSource.prototype.Init=function(){e.CollectionTreeDataSource.superclass.Init.call(this)},e.CollectionTreeDataSource.prototype.getChildCount=function(e){var t=this.__getParentsChildCollectionFromCache(e);return t&&t.length>0?t.length:-1},e.CollectionTreeDataSource.prototype.getChildCollection=function(e,t){this.fetchChildren(e,null,{success:function(e){t.success(e._getCollection())},error:t.error})},e.CollectionTreeDataSource.prototype.fetchChildren=function(e,t,o,n){var c=(t=t||{}).start?t.start:0,i=t.count?t.count:-1;if(null!==e){var r=this;this._getModelForId(this.rootCollection,c,i,e,0).then(function(t){if(t){var n=r.GetChildCollection(t.model);try{r.FetchCollection(n,c,i,o,e)}catch(e){o&&o.error&&o.error({status:e.message})}}else o&&o.error&&o.error(e)})}else this.FetchCollection(null,c,i,o,null)},e.CollectionTreeDataSource.prototype.ModelAdded=function(e,t,o){var n=0;o&&o.at&&(n=o.at);var c=this._getParentChain(t),i=null!=c&&c.length>0?c[c.length-1]:null,r=this._createEvent(this,"insert",n,c,this._putModelInNodeSet(i,e));this.handleEvent("change",r)},e.CollectionTreeDataSource.prototype.ModelRemoved=function(e,t,o){var n=0;o&&o.index&&(n=o.index),this._removeCollectionFromCache(e);var c=this._createEvent(this,"delete",n,this._getParentChain(t),null);this.handleEvent("change",c)},e.CollectionTreeDataSource.prototype.ModelUpdated=function(e,t){var o=e.collection,n=e.GetIndex(),c=null;o&&(c=this._getParentChain(o));var i=null!=c&&c.length>0?c[c.length-1]:null,r=this._createEvent(this,"update",n,c,this._putModelInNodeSet(i,e));this.handleEvent("change",r)},e.CollectionTreeDataSource.prototype.CollectionRefreshed=function(e,t,o){var n=this._createEvent(this,"refresh",null,this._getParentChain(e),null);this.handleEvent("refresh",n)},e.CollectionTreeDataSource.prototype._putModelInNodeSet=function(t,o){var n=new e.Collection;return n.add(o),this._getNodeSet(n,t,0,1,[o])},e.CollectionTreeDataSource.prototype._getParentChain=function(t){var o=[],n=null,c=t;do{null!==(n=this._getParentOfCollection(c))&&(n!==e.CollectionTreeDataSource.ROOT_CACHE_KEY&&o.unshift(n),c=this._getCollectionOfKey(n))}while(null!=n);return o},e.CollectionTreeDataSource.ROOT_CACHE_KEY="%!@ROOT%#@!",e.CollectionTreeDataSource.prototype._getCacheKey=function(t){var o=t instanceof e.Model?this.parseMetadata(t).key:t;return t?o:e.CollectionTreeDataSource.ROOT_CACHE_KEY},e.CollectionTreeDataSource.prototype.__getParentsChildCollectionFromCache=function(e){return this.cache[this._getCacheKey(e)]},e.CollectionTreeDataSource.prototype._setCollectionInCache=function(t,o){o.on(e.Events.EventType.ADD,this.ModelAdded,this),o.on(e.Events.EventType.REMOVE,this.ModelRemoved,this),o.on(e.Events.EventType.CHANGE,this.ModelUpdated,this),o.on(e.Events.EventType.SYNC,this.CollectionRefreshed,this);var n=this._getCacheKey(t);return this.cache[n]=o,this.cache[n]},e.CollectionTreeDataSource.prototype._removeCollectionFromCache=function(e){var t=this._getCacheKey(e);for(var o in this.cache)if(this.cache.hasOwnProperty(o)&&o===t)return this.cache[t].off(null,null,this),void delete this.cache[t]},e.CollectionTreeDataSource.prototype._keyInCollection=function(e,t){for(var o=t.length,n=null,c=0;c<o;c++){if(n=t.models[c])if(e===this._getCacheKey(n))return!0}return!1},e.CollectionTreeDataSource.prototype._getCollectionOfKey=function(e){for(var t in this.cache)if(this.cache.hasOwnProperty(t)){var o=this.cache[t];if(this._keyInCollection(e,o))return o}return null},e.CollectionTreeDataSource.prototype._getParentOfCollection=function(e){for(var t in this.cache)if(this.cache.hasOwnProperty(t)&&this.cache[t]===e)return t;return null},e.CollectionTreeDataSource.prototype.GetChildCollection=function(e){var t=!0,o=this.__getParentsChildCollectionFromCache(e);return o||(t=!1,null!=(o=this.childCollectionCallback(this.rootCollection,e))&&(this._applySortToCollection(o),this._setCollectionInCache(e,o))),{collection:o,cached:t}},e.CollectionTreeDataSource.prototype._createEvent=function(e,t,o,n,c){return{source:e,operation:t,index:o,parent:n,data:c}},e.CollectionTreeDataSource.prototype.FetchCollection=function(e,t,o,n,c){var i=this;null===e&&((e=this.__getParentsChildCollectionFromCache(null))?e={collection:e,cached:!0}:(e={collection:i.rootCollection,cached:!1},i._setCollectionInCache(null,this.rootCollection))),e&&i._fetch(e,t,o,function(e,r){e.IsVirtual()&&(i._virtual=!0),n.success&&n.success(i._getNodeSet(e,c,t,o,r))},n.error)},e.CollectionTreeDataSource.prototype._getNodeSet=function(t,o,n,c,i){return new e.CollectionNodeSet(o,t,i,this,n,c)},e.CollectionTreeDataSource.prototype._scanForKey=function(e,t){var o=this,n=new Array(e.length);return new Promise(function(c,i){!function e(t,i,r){t<i.length?i.at(t,{deferred:!0}).then(function(l){if(n[t]=l,l){var a=o.parseMetadata(l);if(r===a.key)return void c({model:l,models:n})}e(++t,i,r)}):c({model:null,models:n})}(0,e,t)})},e.CollectionTreeDataSource.prototype._getModelForId=function(e,t,o,n,c){var i=this;return new Promise(function(r,l){i._scanForKey(e,n).then(function(e){e.model?r({model:e.model,depth:c}):function e(i,l,a){if(i<l.length){var s=a.GetChildCollection(l[i]);s.collection?a._fetch(s,t,o,function(s,h){a._getModelForId(s,t,o,n,c+1).then(function(t){t?r(t):e(++i,l,a)})},null):e(++i,l,a)}else r(null)}(0,e.models,i)})})},e.CollectionTreeDataSource.prototype._getModelsFromCollection=function(e){if(e.IsVirtual()){var t=new Array(e.length);return new Promise(function(o,n){(function(e,t,o,n){return new Promise(function(c,i){var r,l=function(t){return new Promise(function(o,c){e.at(t).then(function(e){n[t]=e,o(t+1)},c)})},a=Promise.resolve(0);for(r=t;r<o;r++)a=a.then(l);return a.then(c,i)})})(e,0,e.length,t).then(function(){o(t)})})}return new Promise(function(t,o){t(e.models)})},e.CollectionTreeDataSource.prototype._fetch=function(e,t,o,n,c){var i=this;if(e.cached)this._getModelsFromCollection(e.collection).then(function(t){n(e.collection,t)});else{if(this.sortkey&&"none"!==this.sortkey&&(e.collection.comparator=this.sortkey,e.collection.sortDirection=this.sortdir),e.collection.length>0||!e.collection.IsUrlBased(null))return void n(e.collection,e.collection.models);-1===o?(e.collection.modelLimit=-1,e.collection.fetch({success:function(e){i._getModelsFromCollection(e).then(function(t){n(e,t)})},error:c})):(e.collection.modelLimit=-1,e.collection.setRangeLocal(t,o).then(function(t){e.models=t.models,n(e.collection,t.models)}))}},e.CollectionTreeDataSource.prototype.fetchDescendants=function(t,o,n){this._virtual&&e.Assert.failedInAbstractFunction();var c=this;null!==t?this._getModelForId(this.rootCollection,0,-1,t,0).then(function(e){if(e){var n=c.GetChildCollection(e.model);c.FetchCollection(n,0,-1,{success:function(e){e.FetchDescendants({success:function(){o.success&&o.success(e)}})}},t)}}):this.FetchCollection(null,0,-1,{success:function(e){e.FetchDescendants({success:function(){o.success&&o.success(e)}})}},null)},e.CollectionTreeDataSource.prototype.sort=function(e,t){var o=e.key,n=e.direction,c=!1;if(o!==this.sortkey&&(this.sortkey=o,c=!0),n!==this.sortdir&&(this.sortdir=n,c=!0),c)for(var i in"none"===this.sortdir&&(this.cache={}),this.cache)if(this.cache.hasOwnProperty(i)){var r=this.cache[i];this._applySortToCollection(r)}t&&t.success&&t.success()},e.CollectionTreeDataSource.prototype._applySortToCollection=function(e){e.comparator=this.sortkey,e.sortDirection="ascending"===this.sortdir?1:-1,e.sort()},e.CollectionTreeDataSource.prototype.getSortCriteria=function(){return{key:this.sortkey,direction:this.sortdir}},e.CollectionTreeDataSource.prototype.move=function(t,o,n,c){e.Assert.failedInAbstractFunction()},e.CollectionTreeDataSource.prototype.moveOK=function(e,t,o){return"invalid"},e.CollectionTreeDataSource.prototype.getCapability=function(e){return"sort"===e?"default":"move"===e?"none":"batchFetch"===e?"disable":"fetchDescendants"===e?"disable":null}});