/**
 * @license
 * Copyright (c) 2014, 2018, Oracle and/or its affiliates.
 * The Universal Permissive License (UPL), Version 1.0
 */
"use strict";define(["ojs/ojcore","jquery","ojs/ojcomponentcore","ojs/ojdvt-base","ojs/internal-deps/dvt/DvtTreeView","ojs/ojkeyset"],function(e,t,o,n,r){e.__registerWidget("oj.ojSunburst",t.oj.dvtBaseComponent,{widgetEventPrefix:"oj",options:{animationDuration:void 0,animationOnDataChange:"none",animationOnDisplay:"none",animationUpdateColor:"",displayLevels:Number.MAX_VALUE,expanded:new e.ExpandAllKeySet,hiddenCategories:[],highlightedCategories:[],highlightMatch:"all",hoverBehavior:"none",hoverBehaviorDelay:200,tooltip:{renderer:null},selectionMode:"multiple",rotation:"on",sorting:"off",rootNodeContent:{renderer:null},startAngle:90,colorLabel:"",sizeLabel:"",drilling:"off",rootNode:"",nodes:null,nodeDefaults:{borderColor:"rgba(255,255,255,0.3)",borderWidth:1,showDisclosure:"off",labelHalign:"center",labelStyle:void 0,labelMinLength:1,labelDisplay:"auto",hoverColor:void 0,selectedInnerColor:void 0,selectedOuterColor:void 0},selection:[],touchResponse:"auto",rotateInput:null,beforeDrill:null,drill:null,beforeExpand:null,expand:null,beforeCollapse:null,collapse:null},_CreateDvtComponent:function(e,t,o){return r.Sunburst.newInstance(e,t,o)},_ConvertLocatorToSubId:function(e){var t=e.subId;return"oj-sunburst-node"==t?t="node"+this._GetStringFromIndexPath(e.indexPath):"oj-sunburst-tooltip"==t&&(t="tooltip"),t},_ConvertSubIdToLocator:function(e){var t={};return 0==e.indexOf("node")?(t.subId="oj-sunburst-node",t.indexPath=this._GetIndexPath(e)):"tooltip"==e&&(t.subId="oj-sunburst-tooltip"),t},_ProcessOptions:function(){this._super();var t=this.options.rootNodeContent;t&&t._renderer&&(t.renderer=this._GetTemplateRenderer(t._renderer,"rootNodeContent")),this.options.expanded||(this.options.expanded=new e.ExpandAllKeySet)},_GetComponentRendererOptions:function(){return["tooltip/renderer","rootNodeContent/renderer"]},_GetComponentStyleClasses:function(){var e=this._super();return e.push("oj-sunburst"),e},_GetChildStyleClasses:function(){var e=this._super();return e["oj-dvtbase oj-sunburst"]={path:"animationDuration",property:"ANIM_DUR"},e["oj-sunburst-attribute-type-text"]={path:"styleDefaults/_attributeTypeTextStyle",property:"TEXT"},e["oj-sunburst-attribute-value-text"]={path:"styleDefaults/_attributeValueTextStyle",property:"TEXT"},e["oj-sunburst-drill-text"]={path:"styleDefaults/_drillTextStyle",property:"TEXT"},e["oj-sunburst-current-drill-text"]={path:"styleDefaults/_currentTextStyle",property:"TEXT"},e["oj-sunburst-node"]={path:"nodeDefaults/labelStyle",property:"TEXT"},e["oj-sunburst-node oj-hover"]={path:"nodeDefaults/hoverColor",property:"border-top-color"},e["oj-sunburst-node oj-selected"]=[{path:"nodeDefaults/selectedOuterColor",property:"border-top-color"},{path:"nodeDefaults/selectedInnerColor",property:"border-bottom-color"}],e},_GetEventTypes:function(){return["optionChange","rotateInput","beforeDrill","drill","beforeExpand","expand","beforeCollapse","collapse"]},_GetTranslationMap:function(){var e=this.options.translations,t=this._super();return t["DvtSunburstBundle.COLLAPSE"]=e.tooltipCollapse,t["DvtSunburstBundle.COLOR"]=e.labelColor,t["DvtSunburstBundle.EXPAND"]=e.tooltipExpand,t["DvtSunburstBundle.SIZE"]=e.labelSize,t["DvtUtilBundle.SUNBURST"]=e.componentName,t},_HandleEvent:function(e){var t=e.type,o={id:e.id,data:e.data};this._IsCustomElement()||(o.component=e.component),"rotation"===t?e.complete?this._UserOptionChange("startAngle",e.startAngle):this._trigger("rotateInput",null,{value:e.startAngle}):"drill"==t?e.id&&this._trigger("beforeDrill",null,o)&&(this._UserOptionChange("rootNode",e.id),this._Render(),this._trigger("drill",null,o)):"expand"==t?e.id&&this._trigger("beforeExpand",null,o)&&(this._UserOptionChange("expanded",e.expanded),this._Render(),this._trigger("expand",null,o)):"collapse"==t?e.id&&this._trigger("beforeCollapse",null,o)&&(this._UserOptionChange("expanded",e.expanded),this._Render(),this._trigger("collapse",null,o)):this._super(e)},_LoadResources:function(){null==this.options._resources&&(this.options._resources={});var t=this.options._resources;t.rotateCursor=e.Config.getResourceUrl("resources/internal-deps/dvt/sunburst/rotate.cur"),t.expand="oj-sunburst-expand-icon",t.expandOver="oj-sunburst-expand-icon oj-hover",t.expandDown="oj-sunburst-expand-icon oj-active",t.collapse="oj-sunburst-collapse-icon",t.collapseOver="oj-sunburst-collapse-icon oj-hover",t.collapseDown="oj-sunburst-collapse-icon oj-active"},getNode:function(e){return this._component.getAutomation().getNode(e)},getContextByNode:function(e){var t=this.getSubIdByNode(e);return t&&"oj-sunburst-tooltip"!==t.subId?t:null},_GetComponentDeferredDataPaths:function(){return{root:["nodes"]}}}),e.CustomElementBridge.registerMetadata("oj-sunburst","dvtBaseComponent",{properties:{animationDuration:{type:"number"},animationOnDataChange:{type:"string",enumValues:["auto","none"]},animationOnDisplay:{type:"string",enumValues:["auto","none"]},animationUpdateColor:{type:"string"},colorLabel:{type:"string"},displayLevels:{type:"number"},drilling:{type:"string",enumValues:["on","off"]},expanded:{writeback:!0},hiddenCategories:{type:"Array<string>",writeback:!0},highlightedCategories:{type:"Array<string>",writeback:!0},highlightMatch:{type:"string",enumValues:["any","all"]},hoverBehavior:{type:"string",enumValues:["dim","none"]},hoverBehaviorDelay:{type:"number"},nodeDefaults:{type:"object",properties:{borderColor:{type:"string"},borderWidth:{type:"number"},hoverColor:{type:"string"},labelDisplay:{type:"string",enumValues:["auto","horizontal","rotated","off"]},labelHalign:{type:"string",enumValues:["inner","outer","center"]},labelStyle:{type:"object"},selectedInnerColor:{type:"string"},selectedOuterColor:{type:"string"},showDisclosure:{type:"string",enumValues:["on","off"]}}},nodes:{type:"Array<object>|Promise"},rootNode:{type:"string"},rotation:{type:"string",enumValues:["off","on"]},rootNodeContent:{type:"object",properties:{renderer:{}}},selection:{type:"Array<string>",writeback:!0},selectionMode:{type:"string",enumValues:["none","single","multiple"]},sizeLabel:{type:"string"},sorting:{type:"string",enumValues:["on","off"]},startAngle:{type:"number",writeback:!0},tooltip:{type:"object",properties:{renderer:{}}},touchResponse:{type:"string"},translations:{type:"Object",properties:{componentName:{type:"string",value:"Sunburst"},labelAndValue:{type:"string",value:"{0}: {1}"},labelClearSelection:{type:"string",value:"Clear Selection"},labelColor:{type:"string",value:"Color"},labelCountWithTotal:{type:"string",value:"{0} of {1}"},labelDataVisualization:{type:"string",value:"Data Visualization"},labelInvalidData:{type:"string",value:"Invalid data"},labelNoData:{type:"string",value:"No data to display"},labelSize:{type:"string",value:"Size"},stateCollapsed:{type:"string",value:"Collapsed"},stateDrillable:{type:"string",value:"Drillable"},stateExpanded:{type:"string",value:"Expanded"},stateHidden:{type:"string",value:"Hidden"},stateIsolated:{type:"string",value:"Isolated"},stateMaximized:{type:"string",value:"Maximized"},stateMinimized:{type:"string",value:"Minimized"},stateSelected:{type:"string",value:"Selected"},stateUnselected:{type:"string",value:"Unselected"},stateVisible:{type:"string",value:"Visible"},tooltipCollapse:{type:"string",value:"Collapse"},tooltipExpand:{type:"string",value:"Expand"}}}},methods:{getContextByNode:{},getNode:{}},events:{rotateInput:{},beforeDrill:{},drill:{},beforeExpand:{},expand:{},beforeCollapse:{},collapse:{}},extension:{_WIDGET_NAME:"ojSunburst"}}),e.CustomElementBridge.register("oj-sunburst",{metadata:e.CustomElementBridge.getMetadata("oj-sunburst")})});