/**
 * @license
 * Copyright (c) 2014, 2018, Oracle and/or its affiliates.
 * The Universal Permissive License (UPL), Version 1.0
 */
"use strict";define(["ojs/ojcore","jquery","ojs/ojcomponentcore","ojs/ojdvt-base","ojs/internal-deps/dvt/DvtThematicMap"],function(e,t,a,r,o){e.__registerWidget("oj.ojThematicMap",t.oj.dvtBaseComponent,{widgetEventPrefix:"oj",options:{animationDuration:void 0,animationOnDisplay:"none",areas:null,focusRenderer:null,hiddenCategories:[],highlightedCategories:[],highlightMatch:"all",hoverBehavior:"none",hoverRenderer:null,initialZooming:"none",isolatedItem:"",labelDisplay:"off",labelType:"short",links:null,mapProvider:{geo:{},propertiesKeys:{id:"",shortLabel:"",longLabel:""}},markers:null,markerZoomBehavior:"fixed",maxZoom:6,panning:"none",renderer:null,selection:[],selectionMode:"none",selectionRenderer:null,styleDefaults:{dataAreaDefaults:{borderColor:void 0,hoverColor:void 0,selectedInnerColor:void 0,selectedOuterColor:void 0},dataMarkerDefaults:{borderColor:void 0,borderWidth:.5,borderStyle:"solid",color:void 0,height:8,labelStyle:{},opacity:1,shape:"circle",width:8},hoverBehaviorDelay:200,labelStyle:{},linkDefaults:{color:void 0,width:2}},tooltip:{renderer:null},tooltipDisplay:"auto",touchResponse:"auto",zooming:"none"},_currentLocale:"",_loadedBasemaps:[],_basemapPath:"resources/internal-deps/dvt/thematicMap/basemaps/",_supportedLocales:{ar:"ar",cs:"cs",da:"da",de:"de",el:"el",es:"es",fi:"fi",fr:"fr","fr-ca":"fr_CA",he:"iw",hu:"hu",it:"it",ja:"ja",ko:"ko",nl:"nl",no:"no",pl:"pl",pt:"pt_BR","pt-pt":"pt",ro:"ro",ru:"ru",sk:"sk",sv:"sv",th:"th",tr:"tr","zh-hans":"zh_CN","zh-hant":"zh_TW"},_ComponentCreate:function(){this._super(),this._checkBasemaps=[],this._initiallyRendered=!1,this._dataLayersToUpdate=[]},_CreateDvtComponent:function(e,t,a){return o.ThematicMap.newInstance(e,t,a)},_ConvertLocatorToSubId:function(e){var t=e.subId;return"oj-thematicmap-area"==t?t=this._getDataLayerId(e.dataLayer,e.index,"area")+":area["+e.index+"]":"oj-thematicmap-marker"==t?t=this._getDataLayerId(e.dataLayer,e.index,"marker")+":marker["+e.index+"]":"oj-thematicmap-link"==t?t=this._getDataLayerId(e.dataLayer,e.index,"link")+":link["+e.index+"]":"oj-thematicmap-tooltip"==t&&(t="tooltip"),t},_ConvertSubIdToLocator:function(e){var t={};return e.indexOf(":area")>0?(t.subId="oj-thematicmap-area",this._IsCustomElement()||(t.dataLayer=e.substring(0,e.indexOf(":"))),t.index=this._GetFirstIndex(e)):e.indexOf(":marker")>0?(t.subId="oj-thematicmap-marker",this._IsCustomElement()||(t.dataLayer=e.substring(0,e.indexOf(":"))),t.index=this._GetFirstIndex(e)):e.indexOf(":link")>0?(t.subId="oj-thematicmap-link",this._IsCustomElement()||(t.dataLayer=e.substring(0,e.indexOf(":"))),t.index=this._GetFirstIndex(e)):"tooltip"==e&&(t.subId="oj-thematicmap-tooltip"),t},_GetComponentStyleClasses:function(){var e=this._super();return e.push("oj-thematicmap"),e},_GetChildStyleClasses:function(){var e=this._super();return e["oj-dvtbase oj-thematicmap"]={path:"animationDuration",property:"ANIM_DUR"},e["oj-thematicmap-arealayer"]=[{path:"styleDefaults/areaSvgStyle",property:"BACKGROUND"},{path:"styleDefaults/labelStyle",property:"TEXT"}],e["oj-thematicmap-area"]={path:"styleDefaults/dataAreaDefaults/borderColor",property:"border-top-color"},e["oj-thematicmap-area oj-hover"]={path:"styleDefaults/dataAreaDefaults/hoverColor",property:"border-top-color"},e["oj-thematicmap-area oj-selected"]=[{path:"styleDefaults/dataAreaDefaults/selectedInnerColor",property:"border-top-color"},{path:"styleDefaults/dataAreaDefaults/selectedOuterColor",property:"border-bottom-color"}],e["oj-thematicmap-marker"]=[{path:"styleDefaults/dataMarkerDefaults/labelStyle",property:"TEXT"},{path:"styleDefaults/dataMarkerDefaults/color",property:"background-color"},{path:"styleDefaults/dataMarkerDefaults/opacity",property:"opacity"},{path:"styleDefaults/dataMarkerDefaults/borderColor",property:"border-top-color"}],e["oj-thematicmap-link"]={path:"styleDefaults/linkDefaults/color",property:"color"},e["oj-thematicmap-link oj-hover"]={path:"styleDefaults/linkDefaults/_hoverColor",property:"color"},e["oj-thematicmap-link oj-selected"]={path:"styleDefaults/linkDefaults/_selectedColor",property:"border-color"},e},_GetEventTypes:function(){return["optionChange"]},_InitOptions:function(e,t){this._super(e,t);var a=this.options.styleDefaults;this.options.styleDefaults=a},_setOptions:function(t,a){var r=Object.keys(t).length,o=t.areaLayers,s=this.options.areaLayers,i=t.pointDataLayers;if(1==r&&o&&s&&s.length>0)for(var n=0;n<o.length;n++){var l=o[n],p=s[n],d=!0;for(var u in l)"areaDataLayer"!=u&&l[u]!=p[u]&&(d=d&&!1);d&&!e.Object.compareValues(p.areaDataLayer,l.areaDataLayer)&&this._dataLayersToUpdate.push({options:l.areaDataLayer,parentLayer:l.layer,isADL:!0})}else if(1==r&&i&&this.options.pointDataLayers&&this.options.pointDataLayers.length>0)for(n=0;n<i.length;n++)e.Object.compareValues(this.options.pointDataLayers[n],i[n])||this._dataLayersToUpdate.push({options:i[n],parentLayer:i[n].id,isADL:!1});this._super(t,a)},_GetComponentRendererOptions:function(){return["tooltip/renderer","_tooltip/renderer","renderer","focusRenderer","hoverRenderer","selectionRenderer"]},_ProcessOptions:function(){this._super();var t=this.options.tooltip,a=t?t.renderer:null;if(a){var r=this;this.options._tooltip={renderer:function(t){var o=r._IsCustomElement()?{insert:t.tooltip}:t.tooltip;try{return a(t)||o}catch(t){return e.Logger.warn("Showing default tooltip. "+t),o}}}}var o=this.options.areaLayers;if(o)for(var s=0;s<o.length;s++){var i=o[s].areaDataLayer;if(i)(l=i._templateRenderer)&&(i.renderer=this._GetTemplateDataRenderer(l,"area"))}var n=this.options.pointDataLayers;if(n)for(s=0;s<n.length;s++){var l,p=n[s];if(p)(l=p._templateRenderer)&&(p.renderer=this._GetTemplateDataRenderer(l,"point"))}this.options._contextHandler=this._getContextHandler()},_Render:function(){this._NotReady();var e=this.options.areaLayers;if(this._IsCustomElement()){if(!this.options.mapProvider.geo.type)return void this._MakeReady()}else{if(!this.options.basemap||!e||e.length<1)return void this._MakeReady();this._loadBasemap();for(var t=0;t<this._checkBasemaps.length;t++)if(!this._loadedBasemaps[this._checkBasemaps[t]])return;this._checkBasemaps=[]}if(this._initiallyRendered&&this._dataLayersToUpdate.length>0){if(this._context.isReadyToRender()){for(t=0;t<this._dataLayersToUpdate.length;t++){var a=this._dataLayersToUpdate[t],r=a.isADL;r?this._CleanTemplate("area"):this._CleanTemplate("point"),this._component.updateLayer(a.options,a.parentLayer,r)}this._dataLayersToUpdate=[]}}else this._super(),this._initiallyRendered=!0},_RenderComponent:function(e,t){this._IsCustomElement()&&this._mapCustomElementOptions(e),this._updateDataLayerSelection(e),this._super(e,t)},_getContextHandler:function(){var t=this;return function(a,r,o,s,i){var n={component:e.Components.__GetWidgetConstructor(t.element),parentElement:a,rootElement:r,data:o,state:s,previousState:i,id:o.id,label:o.label,color:o.color,location:o.location,x:o.x,y:o.y};return t._IsCustomElement()&&(n.renderDefaultHover=t.renderDefaultHover.bind(t,n),n.renderDefaultSelection=t.renderDefaultSelection.bind(t,n),n.renderDefaultFocus=t.renderDefaultFocus.bind(t,n)),t._FixRendererContext(n)}},renderDefaultHover:function(e){e.previousState&&e.state.hovered==e.previousState.hovered||this._component.processDefaultHoverEffect(e.id,e.state.hovered)},renderDefaultSelection:function(e){e.previousState&&e.state.selected==e.previousState.selected||this._component.processDefaultSelectionEffect(e.id,e.state.selected)},renderDefaultFocus:function(e){e.previousState&&e.state.focused==e.previousState.focused||this._component.processDefaultFocusEffect(e.id,e.state.focused)},_loadBasemap:function(){var t=this.options.basemap;if(t){var a=e.Config.getLocale();a!==this._currentLocale&&(this._currentLocale=a,this._loadedBasemaps=[]);var r=this.options.areaLayers;if(r)for(var o=0;o<r.length;o++){var s=r[o].layer;s&&this._loadBasemapHelper(t,s,a)}var i=this.options.pointDataLayers;!this.options.mapProvider.geo.type&&i&&i.length>0&&this._loadBasemapHelper(t,"cities",a)}},_loadResourceByUrl:function(a,r){if(!this._loadedBasemaps[a]){var o=this,s=function(){o._loadedBasemaps[a]=!0,o._Render()},i=t.getScript(e.Config.getResourceUrl(a),function(e,t){s()});r&&i.fail(function(e,t,a){s()})}},_loadBasemapHelper:function(e,t,a){var r=!0;try{r=Object.keys(o.DvtBaseMapManager.getLayerIds(e,t)).length>0}catch(e){r=!1}if(!r&&!this.options.mapProvider.geo.type){var s=this._basemapPath+"ojthematicmap-"+e+"-"+t+".js";-1==this._checkBasemaps.indexOf(s)&&(this._checkBasemaps.push(s),this._loadResourceByUrl(s,!1))}if(-1===a.indexOf("en")){var i=a.toLowerCase().split("-"),n=[i[0]];i.length>1&&n.unshift(i[0]+"-"+i[1]),i.length>2&&n.unshift(i[0]+"-"+i[2],i[0]+"-"+i[1]+"-"+i[2]),e=e.charAt(0).toUpperCase()+e.slice(1),t=t.charAt(0).toUpperCase()+t.slice(1);for(var l=this._basemapPath+"resourceBundles/"+e+t+"Bundle_",p=0;p<n.length;p++)if(this._supportedLocales[n[p]]){var d=l+this._supportedLocales[n[p]]+".js";-1==this._checkBasemaps.indexOf(d)&&(this._checkBasemaps.push(d),this._loadResourceByUrl(d,!0));break}}},_HandleEvent:function(e){var t=e.type;if(this._IsCustomElement()||"selection"!==t)this._super(e);else{var a={},r=e.clientId;if(a[r]=e.selection,this.options.selection)for(var o in this.options.selection)r!==o&&(a[o]=this.options.selection[o]);this._UserOptionChange("selection",a)}},_GetTranslationMap:function(){var e=this.options.translations,t=this._super();return t["DvtUtilBundle.THEMATIC_MAP"]=e.componentName,t},_updateDataLayerSelection:function(e){var t=e.selection;if(t){var a=e.pointDataLayers;if(a)if(this._IsCustomElement()&&a[0])a[0].selection=t;else for(var r=0;r<a.length;r++)t[a[r].id]&&(a[r].selection=t[a[r].id]);var o=e.areaLayers;if(o&&o[0]){var s=o[0].areaDataLayer;this._IsCustomElement()&&s?s.selection=t:s&&t[s.id]&&(s.selection=t[s.id])}}},getArea:function(e){return this._IsCustomElement()?this._component.getAutomation().getData(this._getDataLayerId(null,e,"area"),"area",e):this._component.getAutomation().getData(arguments[0],"area",arguments[1])},getMarker:function(e){return this._IsCustomElement()?this._component.getAutomation().getData(this._getDataLayerId(null,e,"marker"),"marker",e):this._component.getAutomation().getData(arguments[0],"marker",arguments[1])},getLink:function(e){return this._IsCustomElement()?this._component.getAutomation().getData(this._getDataLayerId(null,e,"link"),"link",e):this._component.getAutomation().getData(arguments[0],"link",arguments[1])},getContextByNode:function(e){var t=this.getSubIdByNode(e);return t&&(this._IsCustomElement()&&delete t.dataLayer,"oj-thematicmap-tooltip"!==t.subId)?t:null},_GetComponentDeferredDataPaths:function(){return this._IsCustomElement()?{root:["areas","markers","links"]}:{areaLayers:["areaDataLayer/areas","areaDataLayer/markers","areaDataLayer/links"],pointDataLayers:["markers","links"]}},_GetComponentNoClonePaths:function(){return this._IsCustomElement()?{areas:!0,markers:!0,links:!0,mapProvider:!0}:{mapProvider:!0,areaLayers:{areaDataLayer:{areas:!0,markers:!0,links:!0}},pointDataLayers:{markers:!0,links:!0}}},_GetDataContext:function(e){if(this._IsCustomElement())return this._super();var t=this.options.basemap,a=e.layer?e.layer:"cities";return{basemap:t,layer:a,ids:o.DvtBaseMapManager.getLayerIds(t,a)}},_mapCustomElementOptions:function(e){var t=e.animationOnDisplay;t&&(e.animationOnMapChange=t);var a=[{}];e.areaLayers=a;var r=a[0],o={id:"adl1"};r.areaDataLayer=o;var s=[{id:"pdl1"}];e.pointDataLayers=s;var i=s[0],n=["labelDisplay","labelType"];this._mapOptionHelper(e,n,[r]),n=["animationOnDataChange","focusRenderer","hoverRenderer","renderer","selectionMode","selectionRenderer"],this._mapOptionHelper(e,n,[o,i]),n=["areas","isolatedItem"],this._mapOptionHelper(e,n,[o]),this._idToDataLayerMap={};var l=e.areas;if(l)for(var p=0;p<l.length;p++){var d=l[p];this._idToDataLayerMap[d.id]="adl1"}var u=e.markers;if(u){this._markerToDataLayerMap=[];var h=[],c=[];for(p=0;p<u.length;p++){var m=u[p];m.location?(h.push(m),this._markerToDataLayerMap[p]="adl1",this._idToDataLayerMap[m.id]="adl1"):m.x&&m.y&&(c.push(m),this._markerToDataLayerMap[p]="pdl1",this._idToDataLayerMap[m.id]="pdl1")}h.length>0&&(o.markers=h),c.length>0&&(i.markers=c)}var y=e.links;if(y){this._linkToDataLayerMap=[];var f=[],_=[];for(p=0;p<y.length;p++){var g=y[p],v=g.startLocation;if(v&&v.location)f.push(g),this._linkToDataLayerMap[p]="adl1";else if(v&&v.x&&v.y)_.push(g),this._linkToDataLayerMap[p]="pdl1";else if(v&&v.id){var D=this._idToDataLayerMap[v.id];"adl1"===D?f.push(g):_.push(g),this._linkToDataLayerMap[p]=D}}f.length>0&&(o.links=f),_.length>0&&(i.links=_)}},_mapOptionHelper:function(e,t,a){for(var r=0;r<t.length;r++){var o=t[r],s=e[o];if(s)for(var i=0;i<a.length;i++)a[i][o]=s}},_getDataLayerId:function(e,t,a){if(!this._IsCustomElement())return e;switch(a){case"area":return"adl1";case"marker":return this._markerToDataLayerMap[t];case"link":return this._linkToDataLayerMap[t];default:return""}}}),e.Components.setDefaultOptions({ojThematicMap:{styleDefaults:e.Components.createDynamicPropertyGetter(function(e){return e.isCustomElement?{areaSvgStyle:{}}:{}})}}),function(){e.CustomElementBridge.registerMetadata("oj-thematic-map","dvtBaseComponent",{properties:{animationDuration:{type:"number"},animationOnDisplay:{type:"string",enumValues:["auto","none"]},areas:{type:"Array<object>|Promise"},focusRenderer:{},hiddenCategories:{type:"Array<string>",writeback:!0},highlightedCategories:{type:"Array<string>",writeback:!0},highlightMatch:{type:"string"},hoverBehavior:{type:"string",enumValues:["dim","none"]},hoverRenderer:{},initialZooming:{type:"string",enumValues:["auto","none"]},isolatedItem:{type:"string"},labelDisplay:{type:"string",enumValues:["auto","on","off"]},labelType:{type:"string",enumValues:["short","long"]},links:{type:"Array<object>|Promise"},mapProvider:{type:"object",properties:{geo:{type:"object"},propertiesKeys:{type:"object"}}},markers:{type:"Array<object>|Promise"},markerZoomBehavior:{type:"string",enumValues:["fixed","zoom"]},maxZoom:{type:"number"},panning:{type:"string",enumValues:["none","auto"]},renderer:{},selection:{type:"Array<string>",writeback:!0},selectionMode:{type:"string",enumValues:["none","single","multiple"]},selectionRenderer:{},styleDefaults:{type:"object",properties:{areaSvgStyle:{type:"object"},dataAreaDefaults:{type:"object",properties:{borderColor:{type:"string"},hoverColor:{type:"string"},selectedInnerColor:{type:"string"},selectedOuterColor:{type:"string"}}},dataMarkerDefaults:{type:"object",properties:{borderColor:{type:"string"},borderStyle:{type:"string",enumValues:["solid","none"]},borderWidth:{type:"number"},color:{type:"string"},height:{type:"number"},labelStyle:{type:"object"},opacity:{type:"number"},shape:{type:"string"},width:{type:"number"}}},hoverBehaviorDelay:{type:"number"},labelStyle:{type:"object"},linkDefaults:{type:"object",properties:{color:{type:"string"},width:{type:"number"}}}}},tooltip:{type:"object",properties:{renderer:{}}},tooltipDisplay:{type:"string",enumValues:["auto","shortDesc","labelAndShortDesc","none"]},touchResponse:{type:"string",enumValues:["auto","touchStart"]},translations:{type:"Object",properties:{componentName:{type:"string",value:"Thematic Map"},labelAndValue:{type:"string",value:"{0}: {1}"},labelClearSelection:{type:"string",value:"Clear Selection"},labelCountWithTotal:{type:"string",value:"{0} of {1}"},labelDataVisualization:{type:"string",value:"Data Visualization"},labelInvalidData:{type:"string",value:"Invalid data"},labelNoData:{type:"string",value:"No data to display"},stateCollapsed:{type:"string",value:"Collapsed"},stateDrillable:{type:"string",value:"Drillable"},stateExpanded:{type:"string",value:"Expanded"},stateHidden:{type:"string",value:"Hidden"},stateIsolated:{type:"string",value:"Isolated"},stateMaximized:{type:"string",value:"Maximized"},stateMinimized:{type:"string",value:"Minimized"},stateSelected:{type:"string",value:"Selected"},stateUnselected:{type:"string",value:"Unselected"},stateVisible:{type:"string",value:"Visible"}}},zooming:{type:"string",enumValues:["none","auto"]}},methods:{getArea:{},getContextByNode:{},getLink:{},getMarker:{}},extension:{_WIDGET_NAME:"ojThematicMap"}});var t=e.CustomElementBridge.getMetadata("oj-thematic-map");e.CustomElementBridge.register("oj-thematic-map",{metadata:t,parseFunction:t.extension._DVT_PARSE_FUNC({"style-defaults.data-marker-defaults.shape":!0})})}()});