/**
 * @license
 * Copyright (c) 2014, 2018, Oracle and/or its affiliates.
 * The Universal Permissive License (UPL), Version 1.0
 */
"use strict";define(["ojs/ojcore","jquery","ojs/ojcomponentcore","ojs/ojdvt-base","ojs/internal-deps/dvt/DvtTreeView"],function(e,t,o,r,n){e.__registerWidget("oj.ojTreemap",t.oj.dvtBaseComponent,{widgetEventPrefix:"oj",options:{animationDuration:void 0,animationOnDataChange:"none",animationOnDisplay:"none",animationUpdateColor:"",hiddenCategories:[],highlightedCategories:[],highlightMatch:"all",hoverBehavior:"none",hoverBehaviorDelay:200,nodeContent:{renderer:null},tooltip:{renderer:null},groupGaps:"outer",displayLevels:Number.MAX_VALUE,layout:"squarified",nodes:null,nodeDefaults:{labelStyle:void 0,labelDisplay:"node",groupLabelDisplay:"header",labelHalign:"center",labelMinLength:1,labelValign:"center",hoverColor:void 0,selectedInnerColor:void 0,selectedOuterColor:void 0,header:{backgroundColor:void 0,borderColor:void 0,hoverBackgroundColor:void 0,hoverInnerColor:void 0,hoverOuterColor:void 0,selectedBackgroundColor:void 0,selectedInnerColor:void 0,selectedOuterColor:void 0,labelHalign:"start",labelStyle:void 0,isolate:"on",useNodeColor:"off"}},nodeSeparators:"gaps",selectionMode:"multiple",sorting:"off",colorLabel:"",sizeLabel:"",drilling:"off",rootNode:"",selection:[],isolatedNode:"",touchResponse:"auto",beforeDrill:null,drill:null},_CreateDvtComponent:function(e,t,o){return n.Treemap.newInstance(e,t,o)},_ConvertLocatorToSubId:function(e){var t=e.subId;return"oj-treemap-node"==t?t="node"+this._GetStringFromIndexPath(e.indexPath):"oj-treemap-tooltip"==t&&(t="tooltip"),t},_ConvertSubIdToLocator:function(e){var t={};return 0==e.indexOf("node")?(t.subId="oj-treemap-node",t.indexPath=this._GetIndexPath(e)):"tooltip"==e&&(t.subId="oj-treemap-tooltip"),t},_GetComponentStyleClasses:function(){var e=this._super();return e.push("oj-treemap"),e},_GetChildStyleClasses:function(){var e=this._super();return e["oj-dvtbase oj-treemap"]={path:"animationDuration",property:"ANIM_DUR"},e["oj-treemap-attribute-type-text"]={path:"styleDefaults/_attributeTypeTextStyle",property:"TEXT"},e["oj-treemap-attribute-value-text"]={path:"styleDefaults/_attributeValueTextStyle",property:"TEXT"},e["oj-treemap-drill-text "]={path:"styleDefaults/_drillTextStyle",property:"TEXT"},e["oj-treemap-current-drill-text "]={path:"styleDefaults/_currentTextStyle",property:"TEXT"},e["oj-treemap-node"]={path:"nodeDefaults/labelStyle",property:"TEXT"},e["oj-treemap-node oj-hover"]={path:"nodeDefaults/hoverColor",property:"border-top-color"},e["oj-treemap-node oj-selected"]=[{path:"nodeDefaults/selectedOuterColor",property:"border-top-color"},{path:"nodeDefaults/selectedInnerColor",property:"border-bottom-color"}],e["oj-treemap-node-header"]=[{path:"nodeDefaults/header/backgroundColor",property:"background-color"},{path:"nodeDefaults/header/borderColor",property:"border-top-color"},{path:"nodeDefaults/header/labelStyle",property:"TEXT"}],e["oj-treemap-node-header oj-hover"]=[{path:"nodeDefaults/header/hoverBackgroundColor",property:"background-color"},{path:"nodeDefaults/header/hoverOuterColor",property:"border-top-color"},{path:"nodeDefaults/header/hoverInnerColor",property:"border-bottom-color"},{path:"nodeDefaults/header/_hoverLabelStyle",property:"TEXT"}],e["oj-treemap-node-header oj-selected"]=[{path:"nodeDefaults/header/selectedBackgroundColor",property:"background-color"},{path:"nodeDefaults/header/selectedOuterColor",property:"border-top-color"},{path:"nodeDefaults/header/selectedInnerColor",property:"border-bottom-color"},{path:"nodeDefaults/header/_selectedLabelStyle",property:"TEXT"}],e},_GetEventTypes:function(){return["optionChange","drill","beforeDrill"]},_GetTranslationMap:function(){var e=this.options.translations,t=this._super();return t["DvtTreemapBundle.COLOR"]=e.labelColor,t["DvtTreemapBundle.ISOLATE"]=e.tooltipIsolate,t["DvtTreemapBundle.RESTORE"]=e.tooltipRestore,t["DvtTreemapBundle.SIZE"]=e.labelSize,t["DvtUtilBundle.TREEMAP"]=e.componentName,t},_HandleEvent:function(e){var t=e.type;if("isolate"===t){var o=this.options._isolatedNodes;o||(this.options._isolatedNodes=[],o=this.options._isolatedNodes);var r=e.id;r?("on",o.push(r),this._UserOptionChange("isolatedNode",r)):("off",r=o.pop(),this._UserOptionChange("isolatedNode",o.length>0?o[o.length]:null))}else if("drill"==t){var n={id:e.id,data:e.data};this._IsCustomElement()||(n.component=e.component),e.id&&this._trigger("beforeDrill",null,n)&&(this._UserOptionChange("rootNode",e.id),this._Render(),this._trigger("drill",null,n))}else this._super(e)},_GetComponentRendererOptions:function(){return["tooltip/renderer","nodeContent/renderer"]},_ProcessOptions:function(){this._super();var e=this.options.nodeContent;e&&e._renderer&&(e.renderer=this._GetTemplateRenderer(e._renderer,"nodeContent"))},_LoadResources:function(){null==this.options._resources&&(this.options._resources={});var e=this.options._resources;e.isolate="oj-treemap-isolate-icon",e.isolateOver="oj-treemap-isolate-icon oj-hover",e.isolateDown="oj-treemap-isolate-icon oj-active",e.restore="oj-treemap-restore-icon",e.restoreOver="oj-treemap-restore-icon oj-hover",e.restoreDown="oj-treemap-restore-icon oj-active"},getNode:function(e){return this._component.getAutomation().getNode(e)},getContextByNode:function(e){var t=this.getSubIdByNode(e);return t&&"oj-treemap-tooltip"!==t.subId?t:null},_GetComponentDeferredDataPaths:function(){return{root:["nodes"]}}}),e.CustomElementBridge.registerMetadata("oj-treemap","dvtBaseComponent",{properties:{animationDuration:{type:"number"},animationOnDataChange:{type:"string",enumValues:["auto","none"]},animationOnDisplay:{type:"string",enumValues:["auto","none"]},animationUpdateColor:{type:"string"},colorLabel:{type:"string"},displayLevels:{type:"number"},drilling:{type:"string",enumValues:["on","off"]},groupGaps:{type:"string",enumValues:["all","none","outer"]},hiddenCategories:{type:"Array<string>",writeback:!0},highlightedCategories:{type:"Array<string>",writeback:!0},highlightMatch:{type:"string",enumValues:["any","all"]},hoverBehavior:{type:"string",enumValues:["dim","none"]},hoverBehaviorDelay:{type:"number"},isolatedNode:{type:"string",writeback:!0},layout:{type:"string",enumValues:["sliceAndDiceHorizontal","sliceAndDiceVertical","squarified"]},nodeDefaults:{type:"object",properties:{groupLabelDisplay:{type:"string",enumValues:["node","off","header"]},header:{type:"object",properties:{backgroundColor:{type:"string"},borderColor:{type:"string"},hoverBackgroundColor:{type:"string"},hoverInnerColor:{type:"string"},hoverOuterColor:{type:"string"},isolate:{type:"string",enumValues:["on","off"]},labelHalign:{type:"string",enumValues:["center","end","start"]},labelStyle:{type:"object"},selectedBackgroundColor:{type:"string"},selectedInnerColor:{type:"string"},selectedOuterColor:{type:"string"},useNodeColor:{type:"string",enumValues:["on","off"]}}},hoverColor:{type:"string"},labelDisplay:{type:"string",enumValues:["off","node"]},labelHalign:{type:"string",enumValues:["start","end","center"]},labelStyle:{type:"object"},labelValign:{type:"string",enumValues:["top","bottom","center"]},selectedInnerColor:{type:"string"},selectedOuterColor:{type:"string"}}},nodes:{type:"Array<object>|Promise"},nodeContent:{type:"object",properties:{renderer:{}}},nodeSeparators:{type:"string",enumValues:["bevels","gap"]},rootNode:{type:"string"},selection:{type:"Array<string>",writeback:!0},selectionMode:{type:"string",enumValues:["none","single","multiple"]},sizeLabel:{type:"string"},sorting:{type:"string",enumValues:["on","off"]},tooltip:{type:"object",properties:{renderer:{}}},touchResponse:{type:"string"},translations:{type:"Object",properties:{componentName:{type:"string",value:"Treemap"},labelAndValue:{type:"string",value:"{0}: {1}"},labelClearSelection:{type:"string",value:"Clear Selection"},labelColor:{type:"string",value:"Color"},labelCountWithTotal:{type:"string",value:"{0} of {1}"},labelDataVisualization:{type:"string",value:"Data Visualization"},labelInvalidData:{type:"string",value:"Invalid data"},labelNoData:{type:"string",value:"No data to display"},labelSize:{type:"string",value:"Size"},stateCollapsed:{type:"string",value:"Collapsed"},stateDrillable:{type:"string",value:"Drillable"},stateExpanded:{type:"string",value:"Expanded"},stateHidden:{type:"string",value:"Hidden"},stateIsolated:{type:"string",value:"Isolated"},stateMaximized:{type:"string",value:"Maximized"},stateMinimized:{type:"string",value:"Minimized"},stateSelected:{type:"string",value:"Selected"},stateUnselected:{type:"string",value:"Unselected"},stateVisible:{type:"string",value:"Visible"},tooltipIsolate:{type:"string",value:"Isolate"},tooltipRestore:{type:"string",value:"Restore"}}}},events:{beforeDrill:{},drill:{}},methods:{getContextByNode:{},getNode:{}},extension:{_WIDGET_NAME:"ojTreemap"}}),e.CustomElementBridge.register("oj-treemap",{metadata:e.CustomElementBridge.getMetadata("oj-treemap")})});