/**
 * Copyright (c) 2017, Oracle and/or its affiliates.
 * All rights reserved.
 */

// Copyright Joyent, Inc. and other Node contributors.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to permit
// persons to whom the Software is furnished to do so, subject to the
// following conditions:
//
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
// OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
// NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
// DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
// OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE
// USE OR OTHER DEALINGS IN THE SOFTWARE.

// originally parseUri 1.2.2, now patched by us
// (c) Steven Levithan <stevenlevithan.com>
// MIT License

define("PersistenceStore",[],function(){"use strict";var e=function(e){this._name=e};return e.prototype={},e.prototype.getName=function(){return this._name},e.prototype.getVersion=function(){return this._version},e.prototype.Init=function(e){return e&&e.version?this._version=e.version:this._version="0",Promise.resolve()},e.prototype.upsert=function(e,t,n,r){throw TypeError("failed in abstract function")},e.prototype.upsertAll=function(e){throw TypeError("failed in abstract function")},e.prototype.find=function(e){throw TypeError("failed in abstract function")},e.prototype.findByKey=function(e){throw TypeError("failed in abstract function")},e.prototype.removeByKey=function(e){throw TypeError("failed in abstract function")},e.prototype.delete=function(e){throw TypeError("failed in abstract function")},e.prototype.keys=function(){throw TypeError("failed in abstract function")},e}),define("impl/storageUtils",["./logger"],function(e){"use strict";function t(t,r){e.log("Offline Persistence Toolkit storageUtils: Processing selector: "+JSON.stringify(t));if(!t)return!0;var s=n(t);return i(s,r)}function n(e){var t,i=[];for(var a in e)if(e.hasOwnProperty(a)){var f=e[a];if(a.indexOf("$")===0){if(s(a)){if(!(f instanceof Array))throw new Error("not a valid expression: "+e);t={operator:a,array:[]};for(var l=0;l<f.length;l++){var c=n(f[l]);t.array.push(c)}}else if(o(a))throw new Error("not a valid expression: "+e)}else if(u(f))i.push({left:a,right:f,operator:"$eq"});else{var h={left:a};r(h,f),i.push(h)}}return i.length>1?t={operator:"$and",array:i}:i.length===1&&(t=i[0]),t}function r(e,t){var n=!1;for(var r in t)if(t.hasOwnProperty(r)){var i=t[r];if(n||!o(r))throw new Error("parsing error "+t);e.operator=r,e.right=i,n=!0}}function i(e,t){var n=e.operator;if(s(n)){if(!e.left&&e.array instanceof Array){var r,u=e.array;for(var a=0;a<u.length;a++){var c=i(u[a],t);if(n==="$or"&&c===!0)return!0;if(n==="$and"&&c===!1)return!1;r=c}return r}throw new Error("invalid expression tree!"+e)}if(o(n)){var h=l(e.left,t),p=e.right;if(n==="$lt"){var d=f(h,p);return h=d[0],p=d[1],h<p}if(n==="$gt"){var d=f(h,p);return h=d[0],p=d[1],h>p}if(n==="$lte"){var d=f(h,p);return h=d[0],p=d[1],h<=p}if(n==="$gte"){var d=f(h,p);return h=d[0],p=d[1],h>=p}if(n==="$eq")return h===p;if(n==="$ne")return h!==p;if(n==="$regex"){var v=h.match(p);return v!==null}if(n==="$exists")return p?h!==null&&h!==undefined:h===null||h===undefined;throw new Error("not a valid expression! "+e)}throw new Error("not a valid expression!"+e)}function s(e){return e==="$and"||e==="$or"}function o(e){return e==="$lt"||e==="$gt"||e==="$lte"||e==="$gte"||e==="$eq"||e==="$ne"||e==="$regex"||e==="$exists"}function u(e){return typeof e!="object"}function a(e){return e!=null&&(e instanceof String||typeof e=="string")}function f(e,t){return a(e)&&t==null?t="":a(t)&&e==null&&(e=""),[e,t]}function l(e,t){var n=e.split("."),r=t;for(var i=0;i<n.length;i++)r=r[n[i]];return r}return{satisfy:t,getValue:l}}),function(e){if(typeof exports=="object"&&typeof module!="undefined")module.exports=e();else if(typeof define=="function"&&define.amd)define("pouchdb",[],e);else{var t;typeof window!="undefined"?t=window:typeof global!="undefined"?t=global:typeof self!="undefined"?t=self:t=this,t.PouchDB=e()}}(function(){var e,t,n;return function(){function e(t,n,r){function i(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(s)return s(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return i(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var s=typeof require=="function"&&require;for(var o=0;o<r.length;o++)i(r[o]);return i}return e}()({1:[function(e,t,n){"use strict";function r(e){return function(){var t=arguments.length;if(t){var n=[],r=-1;while(++r<t)n[r]=arguments[r];return e.call(this,n)}return e.call(this,[])}}t.exports=r},{}],2:[function(e,t,n){function r(){this._events=this._events||{},this._maxListeners=this._maxListeners||undefined}function i(e){return typeof e=="function"}function s(e){return typeof e=="number"}function o(e){return typeof e=="object"&&e!==null}function u(e){return e===void 0}t.exports=r,r.EventEmitter=r,r.prototype._events=undefined,r.prototype._maxListeners=undefined,r.defaultMaxListeners=10,r.prototype.setMaxListeners=function(e){if(!s(e)||e<0||isNaN(e))throw TypeError("n must be a positive number");return this._maxListeners=e,this},r.prototype.emit=function(e){var t,n,r,s,a,f;this._events||(this._events={});if(e==="error")if(!this._events.error||o(this._events.error)&&!this._events.error.length){t=arguments[1];if(t instanceof Error)throw t;var l=new Error('Uncaught, unspecified "error" event. ('+t+")");throw l.context=t,l}n=this._events[e];if(u(n))return!1;if(i(n))switch(arguments.length){case 1:n.call(this);break;case 2:n.call(this,arguments[1]);break;case 3:n.call(this,arguments[1],arguments[2]);break;default:s=Array.prototype.slice.call(arguments,1),n.apply(this,s)}else if(o(n)){s=Array.prototype.slice.call(arguments,1),f=n.slice(),r=f.length;for(a=0;a<r;a++)f[a].apply(this,s)}return!0},r.prototype.addListener=function(e,t){var n;if(!i(t))throw TypeError("listener must be a function");return this._events||(this._events={}),this._events.newListener&&this.emit("newListener",e,i(t.listener)?t.listener:t),this._events[e]?o(this._events[e])?this._events[e].push(t):this._events[e]=[this._events[e],t]:this._events[e]=t,o(this._events[e])&&!this._events[e].warned&&(u(this._maxListeners)?n=r.defaultMaxListeners:n=this._maxListeners,n&&n>0&&this._events[e].length>n&&(this._events[e].warned=!0,console.error("(node) warning: possible EventEmitter memory leak detected. %d listeners added. Use emitter.setMaxListeners() to increase limit.",this._events[e].length),typeof console.trace=="function"&&console.trace())),this},r.prototype.on=r.prototype.addListener,r.prototype.once=function(e,t){function r(){this.removeListener(e,r),n||(n=!0,t.apply(this,arguments))}if(!i(t))throw TypeError("listener must be a function");var n=!1;return r.listener=t,this.on(e,r),this},r.prototype.removeListener=function(e,t){var n,r,s,u;if(!i(t))throw TypeError("listener must be a function");if(!this._events||!this._events[e])return this;n=this._events[e],s=n.length,r=-1;if(n===t||i(n.listener)&&n.listener===t)delete this._events[e],this._events.removeListener&&this.emit("removeListener",e,t);else if(o(n)){for(u=s;u-->0;)if(n[u]===t||n[u].listener&&n[u].listener===t){r=u;break}if(r<0)return this;n.length===1?(n.length=0,delete this._events[e]):n.splice(r,1),this._events.removeListener&&this.emit("removeListener",e,t)}return this},r.prototype.removeAllListeners=function(e){var t,n;if(!this._events)return this;if(!this._events.removeListener)return arguments.length===0?this._events={}:this._events[e]&&delete this._events[e],this;if(arguments.length===0){for(t in this._events){if(t==="removeListener")continue;this.removeAllListeners(t)}return this.removeAllListeners("removeListener"),this._events={},this}n=this._events[e];if(i(n))this.removeListener(e,n);else if(n)while(n.length)this.removeListener(e,n[n.length-1]);return delete this._events[e],this},r.prototype.listeners=function(e){var t;return!this._events||!this._events[e]?t=[]:i(this._events[e])?t=[this._events[e]]:t=this._events[e].slice(),t},r.prototype.listenerCount=function(e){if(this._events){var t=this._events[e];if(i(t))return 1;if(t)return t.length}return 0},r.listenerCount=function(e,t){return e.listenerCount(t)}},{}],3:[function(e,t,n){(function(e){"use strict";function l(){a=!0;var e,t,n=f.length;while(n){t=f,f=[],e=-1;while(++e<n)t[e]();n=f.length}a=!1}function c(e){f.push(e)===1&&!a&&r()}var n=e.MutationObserver||e.WebKitMutationObserver,r;if(n){var i=0,s=new n(l),o=e.document.createTextNode("");s.observe(o,{characterData:!0}),r=function(){o.data=i=++i%2}}else if(!e.setImmediate&&typeof e.MessageChannel!="undefined"){var u=new e.MessageChannel;u.port1.onmessage=l,r=function(){u.port2.postMessage(0)}}else"document"in e&&"onreadystatechange"in e.document.createElement("script")?r=function(){var t=e.document.createElement("script");t.onreadystatechange=function(){l(),t.onreadystatechange=null,t.parentNode.removeChild(t),t=null},e.document.documentElement.appendChild(t)}:r=function(){setTimeout(l,0)};var a,f=[];t.exports=c}).call(this,typeof global!="undefined"?global:typeof self!="undefined"?self:typeof window!="undefined"?window:{})},{}],4:[function(e,t,n){typeof Object.create=="function"?t.exports=function(t,n){t.super_=n,t.prototype=Object.create(n.prototype,{constructor:{value:t,enumerable:!1,writable:!0,configurable:!0}})}:t.exports=function(t,n){t.super_=n;var r=function(){};r.prototype=n.prototype,t.prototype=new r,t.prototype.constructor=t}},{}],5:[function(e,t,n){"use strict";function i(){}function f(e){if(typeof e!="function")throw new TypeError("resolver must be a function");this.state=a,this.queue=[],this.outcome=void 0,e!==i&&p(this,e)}function l(e,t,n){this.promise=e,typeof t=="function"&&(this.onFulfilled=t,this.callFulfilled=this.otherCallFulfilled),typeof n=="function"&&(this.onRejected=n,this.callRejected=this.otherCallRejected)}function c(e,t,n){r(function(){var r;try{r=t(n)}catch(i){return s.reject(e,i)}r===e?s.reject(e,new TypeError("Cannot resolve promise with itself")):s.resolve(e,r)})}function h(e){var t=e&&e.then;if(e&&(typeof e=="object"||typeof e=="function")&&typeof t=="function")return function(){t.apply(e,arguments)}}function p(e,t){function r(t){if(n)return;n=!0,s.reject(e,t)}function i(t){if(n)return;n=!0,s.resolve(e,t)}function o(){t(i,r)}var n=!1,u=d(o);u.status==="error"&&r(u.value)}function d(e,t){var n={};try{n.value=e(t),n.status="success"}catch(r){n.status="error",n.value=r}return n}function v(e){return e instanceof this?e:s.resolve(new this(i),e)}function m(e){var t=new this(i);return s.reject(t,e)}function g(e){function l(e,i){function a(e){o[i]=e,++u===n&&!r&&(r=!0,s.resolve(f,o))}t.resolve(e).then(a,function(e){r||(r=!0,s.reject(f,e))})}var t=this;if(Object.prototype.toString.call(e)!=="[object Array]")return this.reject(new TypeError("must be an array"));var n=e.length,r=!1;if(!n)return this.resolve([]);var o=new Array(n),u=0,a=-1,f=new this(i);while(++a<n)l(e[a],a);return f}function y(e){function a(e){t.resolve(e).then(function(e){r||(r=!0,s.resolve(u,e))},function(e){r||(r=!0,s.reject(u,e))})}var t=this;if(Object.prototype.toString.call(e)!=="[object Array]")return this.reject(new TypeError("must be an array"));var n=e.length,r=!1;if(!n)return this.resolve([]);var o=-1,u=new this(i);while(++o<n)a(e[o]);return u}var r=e("immediate"),s={},o=["REJECTED"],u=["FULFILLED"],a=["PENDING"];t.exports=f,f.prototype["catch"]=function(e){return this.then(null,e)},f.prototype.then=function(e,t){if(typeof e!="function"&&this.state===u||typeof t!="function"&&this.state===o)return this;var n=new this.constructor(i);if(this.state!==a){var r=this.state===u?e:t;c(n,r,this.outcome)}else this.queue.push(new l(n,e,t));return n},l.prototype.callFulfilled=function(e){s.resolve(this.promise,e)},l.prototype.otherCallFulfilled=function(e){c(this.promise,this.onFulfilled,e)},l.prototype.callRejected=function(e){s.reject(this.promise,e)},l.prototype.otherCallRejected=function(e){c(this.promise,this.onRejected,e)},s.resolve=function(e,t){var n=d(h,t);if(n.status==="error")return s.reject(e,n.value);var r=n.value;if(r)p(e,r);else{e.state=u,e.outcome=t;var i=-1,o=e.queue.length;while(++i<o)e.queue[i].callFulfilled(t)}return e},s.reject=function(e,t){e.state=o,e.outcome=t;var n=-1,r=e.queue.length;while(++n<r)e.queue[n].callRejected(t);return e},f.resolve=v,f.reject=m,f.all=g,f.race=y},{immediate:3}],6:[function(e,t,n){(function(n){"use strict";function r(e){return e&&typeof e=="object"&&"default"in e?e["default"]:e}function d(e){return typeof ArrayBuffer!="undefined"&&e instanceof ArrayBuffer||typeof Blob!="undefined"&&e instanceof Blob}function v(e){if(typeof e.slice=="function")return e.slice(0);var t=new ArrayBuffer(e.byteLength),n=new Uint8Array(t),r=new Uint8Array(e);return n.set(r),t}function m(e){if(e instanceof ArrayBuffer)return v(e);var t=e.size,n=e.type;return typeof e.slice=="function"?e.slice(0,t,n):e.webkitSlice(0,t,n)}function b(e){var t=Object.getPrototypeOf(e);if(t===null)return!0;var n=t.constructor;return typeof n=="function"&&n instanceof n&&g.call(n)==y}function w(e){var t,n,r;if(!e||typeof e!="object")return e;if(Array.isArray(e)){t=[];for(n=0,r=e.length;n<r;n++)t[n]=w(e[n]);return t}if(e instanceof Date)return e.toISOString();if(d(e))return m(e);if(!b(e))return e;t={};for(n in e)if(Object.prototype.hasOwnProperty.call(e,n)){var i=w(e[n]);typeof i!="undefined"&&(t[n]=i)}return t}function E(e){var t=!1;return o(function(n){if(t)throw new Error("once called more than once");t=!0,e.apply(this,n)})}function S(e){return o(function(t){t=w(t);var n=this,r=typeof t[t.length-1]=="function"?t.pop():!1,i=new p(function(r,i){var s;try{var o=E(function(e,t){e?i(e):r(t)});t.push(o),s=e.apply(n,t),s&&typeof s.then=="function"&&r(s)}catch(u){i(u)}});return r&&i.then(function(e){r(null,e)},r),i})}function x(e,t,n){if(e.constructor.listeners("debug").length){var r=["api",e.name,t];for(var i=0;i<n.length-1;i++)r.push(n[i]);e.constructor.emit("debug",r);var s=n[n.length-1];n[n.length-1]=function(n,r){var i=["api",e.name,t];i=i.concat(n?["error",n]:["success",r]),e.constructor.emit("debug",i),s(n,r)}}}function T(e,t){return S(o(function(n){if(this._closed)return p.reject(new Error("database is closed"));if(this._destroyed)return p.reject(new Error("database is destroyed"));var r=this;return x(r,e,n),this.taskqueue.isReady?t.apply(this,n):new p(function(t,i){r.taskqueue.addTask(function(s){s?i(s):t(r[e].apply(r,n))})})}))}function N(e){return"$"+e}function C(e){return e.substring(1)}function k(){this._store={}}function L(e){this._store=new k;if(e&&Array.isArray(e))for(var t=0,n=e.length;t<n;t++)this.add(e[t])}function A(){if(typeof Symbol=="undefined"||typeof Map=="undefined"||typeof Set=="undefined")return!1;var e=Object.getOwnPropertyDescriptor(Map,Symbol.species);return e&&"get"in e&&Map[Symbol.species]===Map}function _(e,t){var n={};for(var r=0,i=t.length;r<i;r++){var s=t[r];s in e&&(n[s]=e[s])}return n}function P(e){return e}function H(e){return[{ok:e}]}function B(e,t,n){function a(){var e=[];u.forEach(function(t){t.docs.forEach(function(n){e.push({id:t.id,docs:[n]})})}),n(null,{results:e})}function f(){++o===s&&a()}function l(e,t,n){u[e]={id:t,docs:n},f()}function p(){if(h>=c.length)return;var e=Math.min(h+D,c.length),t=c.slice(h,e);d(t,h),h+=t.length}function d(n,r){n.forEach(function(n,s){var o=r+s,u=i.get(n),a=_(u[0],["atts_since","attachments"]);a.open_revs=u.map(function(e){return e.rev}),a.open_revs=a.open_revs.filter(P);var f=P;a.open_revs.length===0&&(delete a.open_revs,f=H),["revs","attachments","binary","ajax","latest"].forEach(function(e){e in t&&(a[e]=t[e])}),e.get(n,a,function(e,t){var r;e?r=[{error:e}]:r=f(t),l(o,n,r),p()})})}var r=t.docs,i=new M;r.forEach(function(e){i.has(e.id)?i.get(e.id).push(e):i.set(e.id,[e])});var s=i.size,o=0,u=new Array(s),c=[];i.forEach(function(e,t){c.push(t)});var h=0;p()}function j(){return typeof chrome!="undefined"&&typeof chrome.storage!="undefined"&&typeof chrome.storage.local!="undefined"}function q(){return F}function R(e){j()?chrome.storage.onChanged.addListener(function(t){t.db_name!=null&&e.emit(t.dbName.newValue)}):q()&&(typeof addEventListener!="undefined"?addEventListener("storage",function(t){e.emit(t.key)}):window.attachEvent("storage",function(t){e.emit(t.key)}))}function U(){u.EventEmitter.call(this),this._listeners={},R(this)}function z(e){if(console!=="undefined"&&e in console){var t=Array.prototype.slice.call(arguments,1);console[e].apply(console,t)}}function W(e,t){var n=6e5;e=parseInt(e,10)||0,t=parseInt(t,10),t!==t||t<=e?t=(e||1)<<1:t+=1,t>n&&(e=n>>1,t=n);var r=Math.random(),i=t-e;return~~(i*r+e)}function X(e){var t=0;return e||(t=2e3),W(e,t)}function V(e,t){z("info","The above "+e+" is totally normal. "+t)}function K(e,t,n){Error.call(this,n),this.status=e,this.name=t,this.message=n,this.error=!0}function wt(e,t){function n(t){for(var n in e)typeof e[n]!="function"&&(this[n]=e[n]);t!==undefined&&(this.reason=t)}return n.prototype=K.prototype,new n(t)}function Et(e){if(typeof e!="object"){var t=e;e=it,e.data=t}return"error"in e&&e.error==="conflict"&&(e.name="conflict",e.status=409),"name"in e||(e.name=e.error||"unknown"),"status"in e||(e.status=500),"message"in e||(e.message=e.message||e.reason),e}function St(e,t,n){try{return!e(t,n)}catch(r){var i="Filter function threw: "+r.toString();return wt(ft,i)}}function xt(e){var t={},n=e.filter&&typeof e.filter=="function";return t.query=e.query_params,function(i){i.doc||(i.doc={});var s=n&&St(e.filter,i.doc,t);if(typeof s=="object")return s;if(s)return!1;if(!e.include_docs)delete i.doc;else if(!e.attachments)for(var o in i.doc._attachments)i.doc._attachments.hasOwnProperty(o)&&(i.doc._attachments[o].stub=!0);return!0}}function Tt(e){var t=[];for(var n=0,r=e.length;n<r;n++)t=t.concat(e[n]);return t}function Nt(){}function Lt(e){var t;e?typeof e!="string"?t=wt(et):/^_/.test(e)&&!/^_(design|local)/.test(e)&&(t=wt(nt)):t=wt(tt);if(t)throw t}function At(e){return typeof e._remote=="boolean"?e._remote:typeof e.type=="function"?(z("warn","db.type() is deprecated and will be removed in a future version of PouchDB"),e.type()==="http"):!1}function Ot(e,t){return"listenerCount"in e?e.listenerCount(t):u.EventEmitter.listenerCount(e,t)}function Mt(e){if(!e)return null;var t=e.split("/");return t.length===2?t:t.length===1?[e,e]:null}function _t(e){var t=Mt(e);return t?t.join("/"):null}function jt(e){var t=Bt.exec(e),n={},r=14;while(r--){var i=Dt[r],s=t[r]||"",o=["user","password"].indexOf(i)!==-1;n[i]=o?decodeURIComponent(s):s}return n[Pt]={},n[Dt[12]].replace(Ht,function(e,t,r){t&&(n[Pt][t]=r)}),n}function Ft(e,t){var n=[],r=[];for(var i in t)t.hasOwnProperty(i)&&(n.push(i),r.push(t[i]));return n.push(e),Function.apply(null,n).apply(null,r)}function It(e,t,n){return new p(function(r,i){e.get(t,function(s,o){if(s){if(s.status!==404)return i(s);o={}}var u=o._rev,a=n(o);if(!a)return r({updated:!1,rev:u});a._id=t,a._rev=u,r(qt(e,a,n))})})}function qt(e,t,n){return e.put(t).then(function(e){return{updated:!0,rev:e.rev}},function(r){if(r.status!==409)throw r;return It(e,t._id,n)})}function Rt(){return i.v4().replace(/-/g,"").toLowerCase()}function zt(e){var t,n,r,i=e.rev_tree.slice(),s;while(s=i.pop()){var o=s.ids,u=o[2],a=s.pos;if(u.length){for(var f=0,l=u.length;f<l;f++)i.push({pos:a+1,ids:u[f]});continue}var c=!!o[1].deleted,h=o[0];if(!t||(r!==c?r:n!==a?n<a:t<h))t=h,n=a,r=c}return n+"-"+t}function Wt(e,t){var n=e.slice(),r;while(r=n.pop()){var i=r.pos,s=r.ids,o=s[2],u=t(o.length===0,i,s[0],r.ctx,s[1]);for(var a=0,f=o.length;a<f;a++)n.push({pos:i+1,ids:o[a],ctx:u})}}function Xt(e,t){return e.pos-t.pos}function Vt(e){var t=[];Wt(e,function(e,n,r,i,s){e&&t.push({rev:n+"-"+r,pos:n,opts:s})}),t.sort(Xt).reverse();for(var n=0,r=t.length;n<r;n++)delete t[n].pos;return t}function $t(e){var t=zt(e),n=Vt(e.rev_tree),r=[];for(var i=0,s=n.length;i<s;i++){var o=n[i];o.rev!==t&&!o.opts.deleted&&r.push(o.rev)}return r}function Jt(e){var t=[];return Wt(e.rev_tree,function(e,n,r,i,s){s.status==="available"&&!e&&(t.push(n+"-"+r),s.status="missing")}),t}function Kt(e){var t=[],n=e.slice(),r;while(r=n.pop()){var i=r.pos,s=r.ids,o=s[0],u=s[1],a=s[2],f=a.length===0,l=r.history?r.history.slice():[];l.push({id:o,opts:u}),f&&t.push({pos:i+1-l.length,ids:l});for(var c=0,h=a.length;c<h;c++)n.push({pos:i+1,ids:a[c],history:l})}return t.reverse()}function Qt(e,t){return e.pos-t.pos}function Gt(e,t,n){var r=0,i=e.length,s;while(r<i)s=r+i>>>1,n(e[s],t)<0?r=s+1:i=s;return r}function Yt(e,t,n){var r=Gt(e,t,n);e.splice(r,0,t)}function Zt(e,t){var n,r;for(var i=t,s=e.length;i<s;i++){var o=e[i],u=[o.id,o.opts,[]];r?(r[2].push(u),r=u):n=r=u}return n}function en(e,t){return e[0]<t[0]?-1:1}function tn(e,t){var n=[{tree1:e,tree2:t}],r=!1;while(n.length>0){var i=n.pop(),s=i.tree1,o=i.tree2;if(s[1].status||o[1].status)s[1].status=s[1].status==="available"||o[1].status==="available"?"available":"missing";for(var u=0;u<o[2].length;u++){if(!s[2][0]){r="new_leaf",s[2][0]=o[2][u];continue}var a=!1;for(var f=0;f<s[2].length;f++)s[2][f][0]===o[2][u][0]&&(n.push({tree1:s[2][f],tree2:o[2][u]}),a=!0);a||(r="new_branch",Yt(s[2],o[2][u],en))}}return{conflicts:r,tree:e}}function nn(e,t,n){var r=[],i=!1,s=!1,o;if(!e.length)return{tree:[t],conflicts:"new_leaf"};for(var u=0,a=e.length;u<a;u++){var f=e[u];if(f.pos===t.pos&&f.ids[0]===t.ids[0])o=tn(f.ids,t.ids),r.push({pos:f.pos,ids:o.tree}),i=i||o.conflicts,s=!0;else if(n!==!0){var l=f.pos<t.pos?f:t,c=f.pos<t.pos?t:f,h=c.pos-l.pos,p=[],d=[];d.push({ids:l.ids,diff:h,parent:null,parentIdx:null});while(d.length>0){var v=d.pop();if(v.diff===0){v.ids[0]===c.ids[0]&&p.push(v);continue}var m=v.ids[2];for(var g=0,y=m.length;g<y;g++)d.push({ids:m[g],diff:v.diff-1,parent:v.ids,parentIdx:g})}var b=p[0];b?(o=tn(b.ids,c.ids),b.parent[2][b.parentIdx]=o.tree,r.push({pos:l.pos,ids:l.ids}),i=i||o.conflicts,s=!0):r.push(f)}else r.push(f)}return s||r.push(t),r.sort(Qt),{tree:r,conflicts:i||"internal_node"}}function rn(e,t){var n=Kt(e),r,i;for(var s=0,o=n.length;s<o;s++){var u=n[s],a=u.ids,f;if(a.length>t){r||(r={});var l=a.length-t;f={pos:u.pos+l,ids:Zt(a,l)};for(var c=0;c<l;c++){var h=u.pos+c+"-"+a[c].id;r[h]=!0}}else f={pos:u.pos,ids:Zt(a,0)};i?i=nn(i,f,!0).tree:i=[f]}return r&&Wt(i,function(e,t,n){delete r[t+"-"+n]}),{tree:i,revs:r?Object.keys(r):[]}}function sn(e,t,n){var r=nn(e,t),i=rn(r.tree,n);return{tree:i.tree,stemmedRevs:i.revs,conflicts:r.conflicts}}function on(e,t){var n=e.slice(),r=t.split("-"),i=parseInt(r[0],10),s=r[1],o;while(o=n.pop()){if(o.pos===i&&o.ids[0]===s)return!0;var u=o.ids[2];for(var a=0,f=u.length;a<f;a++)n.push({pos:o.pos+1,ids:u[a]})}return!1}function un(e){return e.ids}function an(e,t){t||(t=zt(e));var n=t.substring(t.indexOf("-")+1),r=e.rev_tree.map(un),i;while(i=r.pop()){if(i[0]===n)return!!i[1].deleted;r=r.concat(i[2])}}function fn(e){return/^_local/.test(e)}function ln(e,t){var n=t.rev_tree.slice(),r;while(r=n.pop()){var i=r.pos,s=r.ids,o=s[0],u=s[1],a=s[2],f=a.length===0,l=r.history?r.history.slice():[];l.push({id:o,pos:i,opts:u});if(f)for(var c=0,h=l.length;c<h;c++){var p=l[c],d=p.pos+"-"+p.id;if(d===e)return i+"-"+o}for(var v=0,m=a.length;v<m;v++)n.push({pos:i+1,ids:a[v],history:l})}throw new Error("Unable to resolve latest revision for id "+t.id+", rev "+e)}function cn(e,t){try{e.emit("change",t)}catch(n){z("error",'Error in .on("change", function):',n)}}function hn(e,t,n){function s(){r.cancel()}u.EventEmitter.call(this);var r=this;this.db=e,t=t?w(t):{};var i=t.complete=E(function(t,n){t?Ot(r,"error")>0&&r.emit("error",t):r.emit("complete",n),r.removeAllListeners(),e.removeListener("destroyed",s)});n&&(r.on("complete",function(e){n(null,e)}),r.on("error",n)),e.once("destroyed",s),t.onChange=function(e){if(r.isCancelled)return;cn(r,e)};var o=new p(function(e,n){t.complete=function(t,r){t?n(t):e(r)}});r.once("cancel",function(){e.removeListener("destroyed",s),t.complete(null,{status:"cancelled"})}),this.then=o.then.bind(o),this["catch"]=o["catch"].bind(o),this.then(function(e){i(null,e)},i),e.taskqueue.isReady?r.validateChanges(t):e.taskqueue.addTask(function(e){e?t.complete(e):r.isCancelled?r.emit("cancel"):r.validateChanges(t)})}function pn(e,t,n){var r=[{rev:e._rev}];n.style==="all_docs"&&(r=Vt(t.rev_tree).map(function(e){return{rev:e.rev}}));var i={id:t.id,changes:r,doc:e};return an(t,e._rev)&&(i.deleted=!0),n.conflicts&&(i.doc._conflicts=$t(t),i.doc._conflicts.length||delete i.doc._conflicts),i}function dn(e,t){return e<t?-1:e>t?1:0}function vn(e,t){return function(n,r){n||r[0]&&r[0].error?(n=n||r[0],n.docId=t,e(n)):e(null,r.length?r[0]:r)}}function mn(e){for(var t=0;t<e.length;t++){var n=e[t];if(n._deleted)delete n._attachments;else if(n._attachments){var r=Object.keys(n._attachments);for(var i=0;i<r.length;i++){var s=r[i];n._attachments[s]=_(n._attachments[s],["data","digest","content_type","length","revpos","stub"])}}}}function gn(e,t){var n=dn(e._id,t._id);if(n!==0)return n;var r=e._revisions?e._revisions.start:0,i=t._revisions?t._revisions.start:0;return dn(r,i)}function yn(e){var t={},n=[];return Wt(e,function(e,r,i,s){var o=r+"-"+i;return e&&(t[o]=0),s!==undefined&&n.push({from:s,to:o}),o}),n.reverse(),n.forEach(function(e){t[e.from]===undefined?t[e.from]=1+t[e.to]:t[e.from]=Math.min(t[e.from],1+t[e.to])}),t}function bn(e,t,n){var r="limit"in t?t.keys.slice(t.skip,t.limit+t.skip):t.skip>0?t.keys.slice(t.skip):t.keys;t.descending&&r.reverse();if(!r.length)return e._allDocs({limit:0},n);var i={offset:t.skip};return p.all(r.map(function(n){var r=J({key:n,deleted:"ok"},t);return["limit","skip","keys"].forEach(function(e){delete r[e]}),new p(function(t,s){e._allDocs(r,function(e,r){if(e)return s(e);i.total_rows=r.total_rows,t(r.rows[0]||{key:n,error:"not_found"})})})})).then(function(e){return i.rows=e,i})}function wn(e){var t=e._compactionQueue[0],n=t.opts,r=t.callback;e.get("_local/compaction").catch(function(){return!1}).then(function(t){t&&t.last_seq&&(n.last_seq=t.last_seq),e._compact(n,function(t,n){t?r(t):r(null,n),f(function(){e._compactionQueue.shift(),e._compactionQueue.length&&wn(e)})})})}function En(e){return e.charAt(0)==="_"?e+" is not a valid attachment name, attachment "+"names cannot start with '_'":!1}function Sn(){u.EventEmitter.call(this)}function xn(){this.isReady=!1,this.failed=!1,this.queue=[]}function Tn(e,t){var n=e.match(/([a-z-]*):\/\/(.*)/);if(n)return{name:/https?/.test(n[1])?n[1]+"://"+n[2]:n[2],adapter:n[1]};var r=Cn.adapters,i=Cn.preferredAdapters,s=Cn.prefix,o=t.adapter;if(!o)for(var u=0;u<i.length;++u){o=i[u];if(o==="idb"&&"websql"in r&&q()&&localStorage["_pouch__websqldb_"+s+e]){z("log",'PouchDB is downgrading "'+e+'" to WebSQL to'+" avoid data loss, because it was already opened with WebSQL.");continue}break}var a=r[o],f=a&&"use_prefix"in a?a.use_prefix:!0;return{name:f?s+e:e,adapter:o}}function Nn(e){function t(t){e.removeListener("closed",n),t||e.constructor.emit("destroyed",e.name)}function n(){e.removeListener("destroyed",t),e.constructor.emit("unref",e)}e.once("destroyed",t),e.once("closed",n),e.constructor.emit("ref",e)}function Cn(e,t){if(!(this instanceof Cn))return new Cn(e,t);var n=this;t=t||{},e&&typeof e=="object"&&(t=e,e=t.name,delete t.name),this.__opts=t=w(t),n.auto_compaction=t.auto_compaction,n.prefix=Cn.prefix;if(typeof e!="string")throw new Error("Missing/invalid DB name");var r=(t.prefix||"")+e,i=Tn(r,t);t.name=i.name,t.adapter=t.adapter||i.adapter,n.name=e,n._adapter=t.adapter,Cn.emit("debug",["adapter","Picked adapter: ",t.adapter]);if(!Cn.adapters[t.adapter]||!Cn.adapters[t.adapter].valid())throw new Error("Invalid Adapter: "+t.adapter);Sn.call(n),n.taskqueue=new xn,n.adapter=t.adapter,Cn.adapters[t.adapter].call(n,t,function(e){if(e)return n.taskqueue.fail(e);Nn(n),n.emit("created",n),Cn.emit("created",n.name),n.taskqueue.ready(n)})}function Ln(e){Object.keys(u.EventEmitter.prototype).forEach(function(t){typeof u.EventEmitter.prototype[t]=="function"&&(e[t]=kn[t].bind(kn))});var t=e._destructionListeners=new M;e.on("ref",function(n){t.has(n.name)||t.set(n.name,[]),t.get(n.name).push(n)}),e.on("unref",function(n){if(!t.has(n.name))return;var r=t.get(n.name),i=r.indexOf(n);if(i<0)return;r.splice(i,1),r.length>1?t.set(n.name,r):t.delete(n.name)}),e.on("destroyed",function(n){if(!t.has(n))return;var r=t.get(n);t.delete(n),r.forEach(function(e){e.emit("destroyed",!0)})})}function On(e){e.debug=l;var t={};e.on("debug",function(e){var n=e[0],r=e.slice(1);t[n]||(t[n]=l("pouchdb:"+n)),t[n].apply(null,r)})}function Mn(e,t){var n=e;for(var r=0,i=t.length;r<i;r++){var s=t[r];n=n[s];if(!n)break}return n}function _n(e,t){return e<t?-1:e>t?1:0}function Dn(e){var t=[],n="";for(var r=0,i=e.length;r<i;r++){var s=e[r];s==="."?r>0&&e[r-1]==="\\"?n=n.substring(0,n.length-1)+".":(t.push(n),n=""):n+=s}return t.push(n),t}function Hn(e){return Pn.indexOf(e)>-1}function Bn(e){return Object.keys(e)[0]}function jn(e){return e[Bn(e)]}function Fn(e){var t={};return e.forEach(function(e){Object.keys(e).forEach(function(n){var r=e[n];typeof r!="object"&&(r={$eq:r});if(Hn(n))r instanceof Array?t[n]=r.map(function(e){return Fn([e])}):t[n]=Fn([r]);else{var i=t[n]=t[n]||{};Object.keys(r).forEach(function(e){var t=r[e];if(e==="$gt"||e==="$gte")return In(e,t,i);if(e==="$lt"||e==="$lte")return qn(e,t,i);if(e==="$ne")return Rn(t,i);if(e==="$eq")return Un(t,i);i[e]=t})}})}),t}function In(e,t,n){if(typeof n.$eq!="undefined")return;typeof n.$gte!="undefined"?e==="$gte"?t>n.$gte&&(n.$gte=t):t>=n.$gte&&(delete n.$gte,n.$gt=t):typeof n.$gt!="undefined"?e==="$gte"?t>n.$gt&&(delete n.$gt,n.$gte=t):t>n.$gt&&(n.$gt=t):n[e]=t}function qn(e,t,n){if(typeof n.$eq!="undefined")return;typeof n.$lte!="undefined"?e==="$lte"?t<n.$lte&&(n.$lte=t):t<=n.$lte&&(delete n.$lte,n.$lt=t):typeof n.$lt!="undefined"?e==="$lte"?t<n.$lt&&(delete n.$lt,n.$lte=t):t<n.$lt&&(n.$lt=t):n[e]=t}function Rn(e,t){"$ne"in t?t.$ne.push(e):t.$ne=[e]}function Un(e,t){delete t.$gt,delete t.$gte,delete t.$lt,delete t.$lte,delete t.$ne,t.$eq=e}function zn(e){var t=w(e),n=!1;"$and"in t&&(t=Fn(t.$and),n=!0),["$or","$nor"].forEach(function(e){e in t&&t[e].forEach(function(e){var t=Object.keys(e);for(var n=0;n<t.length;n++){var r=t[n],i=e[r];if(typeof i!="object"||i===null)e[r]={$eq:i}}})}),"$not"in t&&(t.$not=Fn([t.$not]));var r=Object.keys(t);for(var i=0;i<r.length;i++){var s=r[i],o=t[s];typeof o!="object"||o===null?o={$eq:o}:"$ne"in o&&!n&&(o.$ne=[o.$ne]),t[s]=o}return t}function Wn(e,t,n){var r="",i=n-e.length;while(r.length<i)r+=t;return r}function Xn(e,t,n){var r=Wn(e,t,n);return r+e}function Kn(e,t){if(e===t)return 0;e=Qn(e),t=Qn(t);var n=sr(e),r=sr(t);if(n-r!==0)return n-r;switch(typeof e){case"number":return e-t;case"boolean":return e<t?-1:1;case"string":return rr(e,t)}return Array.isArray(e)?nr(e,t):ir(e,t)}function Qn(e){switch(typeof e){case"undefined":return null;case"number":if(e===Infinity||e===-Infinity||isNaN(e))return null;return e;case"object":var t=e;if(Array.isArray(e)){var n=e.length;e=new Array(n);for(var r=0;r<n;r++)e[r]=Qn(t[r])}else{if(e instanceof Date)return e.toJSON();if(e!==null){e={};for(var i in t)if(t.hasOwnProperty(i)){var s=t[i];typeof s!="undefined"&&(e[i]=Qn(s))}}}}return e}function Gn(e){if(e!==null)switch(typeof e){case"boolean":return e?1:0;case"number":return or(e);case"string":return e.replace(/\u0002/g,"").replace(/\u0001/g,"").replace(/\u0000/g,"");case"object":var t=Array.isArray(e),n=t?e:Object.keys(e),r=-1,i=n.length,s="";if(t)while(++r<i)s+=Yn(n[r]);else while(++r<i){var o=n[r];s+=Yn(o)+Yn(e[o])}return s}return""}function Yn(e){var t="\0";return e=Qn(e),sr(e)+Jn+Gn(e)+t}function Zn(e,t){var n=t,r,i=e[t]==="1";if(i)r=0,t++;else{var s=e[t]==="0";t++;var o="",u=e.substring(t,t+$n),a=parseInt(u,10)+Vn;s&&(a=-a),t+=$n;for(;;){var f=e[t];if(f==="\0")break;o+=f,t++}o=o.split("."),o.length===1?r=parseInt(o,10):r=parseFloat(o[0]+"."+o[1]),s&&(r-=10),a!==0&&(r=parseFloat(r+"e"+a))}return{num:r,length:t-n}}function er(e,t){var n=e.pop();if(t.length){var r=t[t.length-1];n===r.element&&(t.pop(),r=t[t.length-1]);var i=r.element,s=r.index;if(Array.isArray(i))i.push(n);else if(s===e.length-2){var o=e.pop();i[o]=n}else e.push(n)}}function tr(e){var t=[],n=[],r=0;for(;;){var i=e[r++];if(i==="\0"){if(t.length===1)return t.pop();er(t,n);continue}switch(i){case"1":t.push(null);break;case"2":t.push(e[r]==="1"),r++;break;case"3":var s=Zn(e,r);t.push(s.num),r+=s.length;break;case"4":var o="";for(;;){var u=e[r];if(u==="\0")break;o+=u,r++}o=o.replace(/\u0001\u0001/g,"\0").replace(/\u0001\u0002/g,"").replace(/\u0002\u0002/g,""),t.push(o);break;case"5":var a={element:[],index:t.length};t.push(a.element),n.push(a);break;case"6":var f={element:{},index:t.length};t.push(f.element),n.push(f);break;default:throw new Error("bad collationIndex or unexpectedly reached end of input: "+i)}}}function nr(e,t){var n=Math.min(e.length,t.length);for(var r=0;r<n;r++){var i=Kn(e[r],t[r]);if(i!==0)return i}return e.length===t.length?0:e.length>t.length?1:-1}function rr(e,t){return e===t?0:e>t?1:-1}function ir(e,t){var n=Object.keys(e),r=Object.keys(t),i=Math.min(n.length,r.length);for(var s=0;s<i;s++){var o=Kn(n[s],r[s]);if(o!==0)return o;o=Kn(e[n[s]],t[r[s]]);if(o!==0)return o}return n.length===r.length?0:n.length>r.length?1:-1}function sr(e){var t=["boolean","number","string","object"],n=t.indexOf(typeof e);if(~n)return e===null?1:Array.isArray(e)?5:n<3?n+2:n+3;if(Array.isArray(e))return 5}function or(e){if(e===0)return"1";var t=e.toExponential().split(/e\+?/),n=parseInt(t[1],10),r=e<0,i=r?"0":"2",s=(r?-n:n)-Vn,o=Xn(s.toString(),"0",$n);i+=Jn+o;var u=Math.abs(parseFloat(t[0]));r&&(u=10-u);var a=u.toFixed(20);return a=a.replace(/\.?0+$/,""),i+=Jn+a,i}function ur(e){function t(t){return e.map(function(e){var n=Bn(e),r=Dn(n),i=Mn(t,r);return i})}return function(e,n){var r=t(e.doc),i=t(n.doc),s=Kn(r,i);return s!==0?s:_n(e.doc._id,n.doc._id)}}function ar(e,t,n){e=e.filter(function(e){return fr(e.doc,t.selector,n)});if(t.sort){var r=ur(t.sort);e=e.sort(r),typeof t.sort[0]!="string"&&jn(t.sort[0])==="desc"&&(e=e.reverse())}if("limit"in t||"skip"in t){var i=t.skip||0,s=("limit"in t?t.limit:e.length)+i;e=e.slice(i,s)}return e}function fr(e,t,n){return n.every(function(n){var r=t[n],i=Dn(n),s=Mn(e,i);return Hn(n)?cr(n,r,e):lr(r,e,i,s)})}function lr(e,t,n,r){return e?Object.keys(e).every(function(i){var s=e[i];return hr(i,t,s,n,r)}):!0}function cr(e,t,n){return e==="$or"?t.some(function(e){return fr(n,e,Object.keys(e))}):e==="$not"?!fr(n,t,Object.keys(t)):!t.find(function(e){return fr(n,e,Object.keys(e))})}function hr(e,t,n,r,i){if(!Er[e])throw new Error('unknown operator "'+e+'" - should be one of $eq, $lte, $lt, $gt, $gte, $exists, $ne, $in, '+"$nin, $size, $mod, $regex, $elemMatch, $type, $allMatch or $all");return Er[e](t,n,r,i)}function pr(e){return typeof e!="undefined"&&e!==null}function dr(e){return typeof e!="undefined"}function vr(e,t){var n=t[0],r=t[1];if(n===0)throw new Error("Bad divisor, cannot divide by zero");if(parseInt(n,10)!==n)throw new Error("Divisor is not an integer");if(parseInt(r,10)!==r)throw new Error("Modulus is not an integer");return parseInt(e,10)!==e?!1:e%n===r}function mr(e,t){return t.some(function(t){return e instanceof Array?e.indexOf(t)>-1:e===t})}function gr(e,t){return t.every(function(t){return e.indexOf(t)>-1})}function yr(e,t){return e.length===t}function br(e,t){var n=new RegExp(t);return n.test(e)}function wr(e,t){switch(t){case"null":return e===null;case"boolean":return typeof e=="boolean";case"number":return typeof e=="number";case"string":return typeof e=="string";case"array":return e instanceof Array;case"object":return{}.toString.call(e)==="[object Object]"}throw new Error(t+" not supported as a type."+"Please use one of object, string, array, number, boolean or null.")}function Sr(e,t){if(typeof t!="object")throw new Error("Selector error: expected a JSON object");t=zn(t);var n={doc:e},r=ar([n],{selector:t},Object.keys(t));return r&&r.length===1}function xr(e){return Ft('"use strict";\nreturn '+e+";",{})}function Tr(e){var t=["return function(doc) {",'  "use strict";',"  var emitted = false;","  var emit = function (a, b) {","    emitted = true;","  };","  var view = "+e+";","  view(doc);","  if (emitted) {","    return true;","  }","};"].join("\n");return Ft(t,{})}function Nr(e,t){if(e.selector&&e.filter&&e.filter!=="_selector"){var n=typeof e.filter=="string"?e.filter:"function";return t(new Error('selector invalid for filter "'+n+'"'))}t()}function Cr(e){e.view&&!e.filter&&(e.filter="_view"),e.selector&&!e.filter&&(e.filter="_selector"),e.filter&&typeof e.filter=="string"&&(e.filter==="_view"?e.view=_t(e.view):e.filter=_t(e.filter))}function kr(e,t){return t.filter&&typeof t.filter=="string"&&!t.doc_ids&&!At(e.db)}function Lr(e,t){var n=t.complete;if(t.filter==="_view"){if(!t.view||typeof t.view!="string"){var r=wt(ft,"`view` filter parameter not found or invalid.");return n(r)}var i=Mt(t.view);e.db.get("_design/"+i[0],function(r,s){if(e.isCancelled)return n(null,{status:"cancelled"});if(r)return n(Et(r));var o=s&&s.views&&s.views[i[1]]&&s.views[i[1]].map;if(!o)return n(wt(Y,s.views?"missing json key: "+i[1]:"missing json key: views"));t.filter=Tr(o),e.doChanges(t)})}else if(t.selector)t.filter=function(e){return Sr(e,t.selector)},e.doChanges(t);else{var s=Mt(t.filter);e.db.get("_design/"+s[0],function(r,i){if(e.isCancelled)return n(null,{status:"cancelled"});if(r)return n(Et(r));var o=i&&i.filters&&i.filters[s[1]];if(!o)return n(wt(Y,i&&i.filters?"missing json key: "+s[1]:"missing json key: filters"));t.filter=xr(o),e.doChanges(t)})}}function Ar(e){e._changesFilterPlugin={validate:Nr,normalize:Cr,shouldFilter:kr,filter:Lr}}function Or(e){return e.reduce(function(e,t){return e[t]=!0,e},{})}function Dr(e){if(!/^\d+-./.test(e))return wt(mt);var t=e.indexOf("-"),n=e.substring(0,t),r=e.substring(t+1);return{prefix:parseInt(n,10),id:r}}function Pr(e,t){var n=e.start-e.ids.length+1,r=e.ids,i=[r[0],t,[]];for(var s=1,o=r.length;s<o;s++)i=[r[s],{status:"missing"},[i]];return[{pos:n,ids:i}]}function Hr(e,t){var n,r,i,s={status:"available"};e._deleted&&(s.deleted=!0);if(t){e._id||(e._id=Ut()),r=Rt();if(e._rev){i=Dr(e._rev);if(i.error)return i;e._rev_tree=[{pos:i.prefix,ids:[i.id,{status:"missing"},[[r,s,[]]]]}],n=i.prefix+1}else e._rev_tree=[{pos:1,ids:[r,s,[]]}],n=1}else{e._revisions&&(e._rev_tree=Pr(e._revisions,s),n=e._revisions.start,r=e._revisions.ids[0]);if(!e._rev_tree){i=Dr(e._rev);if(i.error)return i;n=i.prefix,r=i.id,e._rev_tree=[{pos:n,ids:[r,s,[]]}]}}Lt(e._id),e._rev=n+"-"+r;var o={metadata:{},data:{}};for(var u in e)if(Object.prototype.hasOwnProperty.call(e,u)){var a=u[0]==="_";if(a&&!Mr[u]){var f=wt(at,u);throw f.message=at.message+": "+u,f}a&&!_r[u]?o.metadata[u.slice(1)]=e[u]:o.data[u]=e[u]}return o}function Fr(e,t){e=e||[],t=t||{};try{return new Blob(e,t)}catch(n){if(n.name!=="TypeError")throw n;var r=typeof BlobBuilder!="undefined"?BlobBuilder:typeof MSBlobBuilder!="undefined"?MSBlobBuilder:typeof MozBlobBuilder!="undefined"?MozBlobBuilder:WebKitBlobBuilder,i=new r;for(var s=0;s<e.length;s+=1)i.append(e[s]);return i.getBlob(t.type)}}function Ir(e){var t=e.length,n=new ArrayBuffer(t),r=new Uint8Array(n);for(var i=0;i<t;i++)r[i]=e.charCodeAt(i);return n}function qr(e,t){return Fr([Ir(e)],{type:t})}function Rr(e,t){return qr(Br(e),t)}function Ur(e){var t="",n=new Uint8Array(e),r=n.byteLength;for(var i=0;i<r;i++)t+=String.fromCharCode(n[i]);return t}function zr(e,t){if(typeof FileReader=="undefined")return t(Ur((new FileReaderSync).readAsArrayBuffer(e)));var n=new FileReader,r=typeof n.readAsBinaryString=="function";n.onloadend=function(e){var n=e.target.result||"";if(r)return t(n);t(Ur(n))},r?n.readAsBinaryString(e):n.readAsArrayBuffer(e)}function Wr(e,t){zr(e,function(e){t(e)})}function Xr(e,t){Wr(e,function(e){t(jr(e))})}function Vr(e,t){if(typeof FileReader=="undefined")return t((new FileReaderSync).readAsArrayBuffer(e));var n=new FileReader;n.onloadend=function(e){var n=e.target.result||new ArrayBuffer(0);t(n)},n.readAsArrayBuffer(e)}function Kr(e){return jr(e)}function Qr(e,t,n){return e.webkitSlice?e.webkitSlice(t,n):e.slice(t,n)}function Gr(e,t,n,r,i){if(n>0||r<t.size)t=Qr(t,n,r);Vr(t,function(t){e.append(t),i()})}function Yr(e,t,n,r,i){if(n>0||r<t.length)t=t.substring(n,r);e.appendBinary(t),i()}function Zr(e,t){function f(){$r(h)}function l(){var e=u.end(!0),n=Kr(e);t(n),u.destroy()}function h(){var t=o*i,n=t+i;o++,o<s?a(u,e,t,n,f):a(u,e,t,n,l)}var n=typeof e=="string",r=n?e.length:e.size,i=Math.min(Jr,r),s=Math.ceil(r/i),o=0,u=n?new c:new c.ArrayBuffer,a=n?Yr:Gr;h()}function ei(e){return c.hash(e)}function ti(e){try{return Br(e)}catch(t){var n=wt(st,"Attachment is not a valid base64 string");return{error:n}}}function ni(e,t,n){var r=ti(e.data);if(r.error)return n(r.error);e.length=r.length,t==="blob"?e.data=qr(r,e.content_type):t==="base64"?e.data=jr(r):e.data=r,Zr(r,function(t){e.digest="md5-"+t,n()})}function ri(e,t,n){Zr(e.data,function(r){e.digest="md5-"+r,e.length=e.data.size||e.data.length||0,t==="binary"?Wr(e.data,function(t){e.data=t,n()}):t==="base64"?Xr(e.data,function(t){e.data=t,n()}):n()})}function ii(e,t,n){if(e.stub)return n();typeof e.data=="string"?ni(e,t,n):ri(e,t,n)}function si(e,t,n){function s(){r++,e.length===r&&(i?n(i):n())}if(!e.length)return n();var r=0,i;e.forEach(function(e){function o(e){i=e,r++,r===n.length&&s()}var n=e.data&&e.data._attachments?Object.keys(e.data._attachments):[],r=0;if(!n.length)return s();for(var u in e.data._attachments)e.data._attachments.hasOwnProperty(u)&&ii(e.data._attachments[u],t,o)})}function oi(e,t,n,r,i,s,o,u){if(on(t.rev_tree,n.metadata.rev))return r[i]=n,s();var a=t.winningRev||zt(t),f="deleted"in t?t.deleted:an(t,a),l="deleted"in n.metadata?n.metadata.deleted:an(n.metadata),c=/^1-/.test(n.metadata.rev);if(f&&!l&&u&&c){var h=n.data;h._rev=a,h._id=n.metadata.id,n=Hr(h,u)}var p=sn(t.rev_tree,n.metadata.rev_tree[0],e),d=u&&(f&&l&&p.conflicts!=="new_leaf"||!f&&p.conflicts!=="new_leaf"||f&&!l&&p.conflicts==="new_branch");if(d){var v=wt(Z);return r[i]=v,s()}var m=n.metadata.rev;n.metadata.rev_tree=p.tree,n.stemmedRevs=p.stemmedRevs||[],t.rev_map&&(n.metadata.rev_map=t.rev_map);var g=zt(n.metadata),y=an(n.metadata,g),b=f===y?0:f<y?-1:1,w;m===g?w=y:w=an(n.metadata,m),o(n,g,y,w,!0,b,i,s)}function ui(e){return e.metadata.rev_tree[0].ids[1].status==="missing"}function ai(e,t,n,r,i,s,o,u,a){function f(e,t,n){var r=zt(e.metadata),i=an(e.metadata,r);if("was_delete"in u&&i)return s[t]=wt(Y,"deleted"),n();var a=l&&ui(e);if(a){var f=wt(Z);return s[t]=f,n()}var c=i?0:1;o(e,r,i,i,!1,c,t,n)}function d(){++h===p&&a&&a()}e=e||1e3;var l=u.new_edits,c=new M,h=0,p=t.length;t.forEach(function(e,t){if(e._id&&fn(e._id)){var r=e._deleted?"_removeLocal":"_putLocal";n[r](e,{ctx:i},function(e,n){s[t]=e||n,d()});return}var o=e.metadata.id;c.has(o)?(p--,c.get(o).push([e,t])):c.set(o,[[e,t]])}),c.forEach(function(t,n){function u(){++i<t.length?a():d()}function a(){var a=t[i],c=a[0],h=a[1];if(r.has(n))oi(e,r.get(n),c,s,h,u,o,l);else{var p=sn([],c.metadata.rev_tree[0],e);c.metadata.rev_tree=p.tree,c.stemmedRevs=p.stemmedRevs||[],f(c,h,u)}}var i=0;a()})}function gi(e){try{return JSON.parse(e)}catch(t){return h.parse(e)}}function yi(e){try{return JSON.stringify(e)}catch(t){return h.stringify(e)}}function bi(e){return function(t){var n="unknown_error";t.target&&t.target.error&&(n=t.target.error.name||t.target.error.message),e(wt(ht,n,t.type))}}function wi(e,t,n){return{data:yi(e),winningRev:t,deletedOrLocal:n?"1":"0",seq:e.seq,id:e.id}}function Ei(e){if(!e)return null;var t=gi(e.data);return t.winningRev=e.winningRev,t.deleted=e.deletedOrLocal==="1",t.seq=e.seq,t}function Si(e){if(!e)return e;var t=e._doc_id_rev.lastIndexOf(":");return e._id=e._doc_id_rev.substring(0,t-1),e._rev=e._doc_id_rev.substring(t+1),delete e._doc_id_rev,e}function xi(e,t,n,r){n?e?typeof e!="string"?r(e):r(Rr(e,t)):r(Fr([""],{type:t})):e?typeof e!="string"?zr(e,function(e){r(jr(e))}):r(e):r("")}function Ti(e,t,n,r){function o(){++s===i.length&&r&&r()}function u(e,t){var r=e._attachments[t],i=r.digest,s=n.objectStore(hi).get(i);s.onsuccess=function(e){r.body=e.target.result.body,o()}}var i=Object.keys(e._attachments||{});if(!i.length)return r&&r();var s=0;i.forEach(function(n){t.attachments&&t.include_docs?u(e,n):(e._attachments[n].stub=!0,o())})}function Ni(e,t){return p.all(e.map(function(e){if(e.doc&&e.doc._attachments){var n=Object.keys(e.doc._attachments);return p.all(n.map(function(n){var r=e.doc._attachments[n];if("body"in r){var i=r.body,s=r.content_type;return new p(function(o){xi(i,s,t,function(t){e.doc._attachments[n]=J(_(r,["digest","content_type"]),{data:t}),o()})})}return}))}}))}function Ci(e,t,n){function a(){u--,u||f()}function f(){if(!r.length)return;r.forEach(function(e){var t=o.index("digestSeq").count(IDBKeyRange.bound(e+"::",e+"::￿",!1,!1));t.onsuccess=function(t){var n=t.target.result;n||s.delete(e)}})}var r=[],i=n.objectStore(ci),s=n.objectStore(hi),o=n.objectStore(pi),u=e.length;e.forEach(function(e){var n=i.index("_doc_id_rev"),s=t+"::"+e;n.getKey(s).onsuccess=function(e){var t=e.target.result;if(typeof t!="number")return a();i.delete(t);var n=o.index("seq").openCursor(IDBKeyRange.only(t));n.onsuccess=function(e){var t=e.target.result;if(t){var n=t.value.digestSeq.split("::")[0];r.push(n),o.delete(t.primaryKey),t.continue()}else a()}}})}function ki(e,t,n){try{return{txn:e.transaction(t,n)}}catch(r){return{error:r}}}function Ai(e,t,n,r,i,s){function T(){var e=[li,ci,hi,vi,pi,di],t=ki(i,e,"readwrite");if(t.error)return s(t.error);u=t.txn,u.onabort=bi(s),u.ontimeout=bi(s),u.oncomplete=A,a=u.objectStore(li),f=u.objectStore(ci),l=u.objectStore(hi),c=u.objectStore(pi),h=u.objectStore(di),h.get(di).onsuccess=function(e){d=e.target.result,k()},_(function(e){if(e)return S=!0,s(e);L()})}function N(){y=!0,k()}function C(){ai(e.revs_limit,o,r,E,u,w,D,n,N)}function k(){if(!d||!y)return;d.docCount+=b,h.put(d)}function L(){function t(){++e===o.length&&C()}function n(e){var n=Ei(e.target.result);n&&E.set(n.id,n),t()}if(!o.length)return;var e=0;for(var r=0,i=o.length;r<i;r++){var s=o[r];if(s._id&&fn(s._id)){t();continue}var u=a.get(s.metadata.id);u.onsuccess=n}}function A(){if(S)return;Li.notify(r._meta.name),s(null,w)}function O(e,t){var n=l.get(e);n.onsuccess=function(n){if(!n.target.result){var r=wt(yt,"unknown stub attachment with digest "+e);r.status=412,t(r)}else t()}}function _(e){function i(){++n===t.length&&e(r)}var t=[];o.forEach(function(e){e.data&&e.data._attachments&&Object.keys(e.data._attachments).forEach(function(n){var r=e.data._attachments[n];r.stub&&t.push(r.digest)})});if(!t.length)return e();var n=0,r;t.forEach(function(e){O(e,function(e){e&&!r&&(r=e),i()})})}function D(e,t,n,r,i,s,o,u){e.metadata.winningRev=t,e.metadata.deleted=n;var a=e.data;a._id=e.metadata.id,a._rev=e.metadata.rev,r&&(a._deleted=!0);var f=a._attachments&&Object.keys(a._attachments).length;if(f)return H(e,t,n,i,o,u);b+=s,k(),P(e,t,n,i,o,u)}function P(e,t,n,i,s,o){function h(s){var o=e.stemmedRevs||[];i&&r.auto_compaction&&(o=o.concat(Jt(e.metadata))),o&&o.length&&Ci(o,e.metadata.id,u),c.seq=s.target.result;var f=wi(c,t,n),l=a.put(f);l.onsuccess=d}function p(e){e.preventDefault(),e.stopPropagation();var t=f.index("_doc_id_rev"),n=t.getKey(l._doc_id_rev);n.onsuccess=function(e){var t=f.put(l,e.target.result);t.onsuccess=h}}function d(){w[s]={ok:!0,id:c.id,rev:c.rev},E.set(e.metadata.id,e.metadata),B(e,c.seq,o)}var l=e.data,c=e.metadata;l._doc_id_rev=c.id+"::"+c.rev,delete l._id,delete l._rev;var v=f.put(l);v.onsuccess=h,v.onerror=p}function H(e,t,n,r,i,s){function f(){u===a.length&&P(e,t,n,r,i,s)}function l(){u++,f()}var o=e.data,u=0,a=Object.keys(o._attachments);a.forEach(function(n){var r=e.data._attachments[n];if(!r.stub){var i=r.data;delete r.data,r.revpos=parseInt(t,10);var s=r.digest;j(s,i,l)}else u++,f()})}function B(e,t,n){function s(){++r===i.length&&n()}function o(n){var r=e.data._attachments[n].digest,i=c.put({seq:t,digestSeq:r+"::"+t});i.onsuccess=s,i.onerror=function(e){e.preventDefault(),e.stopPropagation(),s()}}var r=0,i=Object.keys(e.data._attachments||{});if(!i.length)return n();for(var u=0;u<i.length;u++)o(i[u])}function j(e,t,n){var r=l.count(e);r.onsuccess=function(r){var i=r.target.result;if(i)return n();var s={digest:e,body:t},o=l.put(s);o.onsuccess=n}}var o=t.docs,u,a,f,l,c,h,p,d;for(var v=0,m=o.length;v<m;v++){var g=o[v];if(g._id&&fn(g._id))continue;g=o[v]=Hr(g,n.new_edits),g.error&&!p&&(p=g)}if(p)return s(p);var y=!1,b=0,w=new Array(o.length),E=new M,S=!1,x=r._meta.blobSupport?"blob":"base64";si(o,x,function(e){if(e)return s(e);T()})}function Oi(e,t,n,r,i){function f(e){u=e.target.result,o&&i(o,u,a)}function l(e){o=e.target.result,u&&i(o,u,a)}function c(){if(!o.length)return i();var n=o[o.length-1],s;if(t&&t.upper)try{s=IDBKeyRange.bound(n,t.upper,!0,t.upperOpen)}catch(a){if(a.name==="DataError"&&a.code===0)return i()}else s=IDBKeyRange.lowerBound(n,!0);t=s,o=null,u=null,e.getAll(t,r).onsuccess=f,e.getAllKeys(t,r).onsuccess=l}function h(e){var t=e.target.result;if(!t)return i();i([t.key],[t.value],t)}var s=typeof e.getAll=="function"&&typeof e.getAllKeys=="function"&&r>1&&!n,o,u,a;s?(a={"continue":c},e.getAll(t,r).onsuccess=f,e.getAllKeys(t,r).onsuccess=l):n?e.openCursor(t,"prev").onsuccess=h:e.openCursor(t).onsuccess=h}function Mi(e,t,n){function i(e){var t=e.target.result;t?(r.push(t.value),t.continue()):n({target:{result:r}})}if(typeof e.getAll=="function"){e.getAll(t).onsuccess=n;return}var r=[];e.openCursor(t).onsuccess=i}function _i(e,t,n,r,i){try{if(e&&t)return i?IDBKeyRange.bound(t,e,!n,!1):IDBKeyRange.bound(e,t,!1,!n);if(e)return i?IDBKeyRange.upperBound(e):IDBKeyRange.lowerBound(e);if(t)return i?IDBKeyRange.lowerBound(t,!n):IDBKeyRange.upperBound(t,!n);if(r)return IDBKeyRange.only(r)}catch(s){return{error:s}}return null}function Di(e,t,n){function w(t,n,r){var i=t.id+"::"+r;g.get(i).onsuccess=function(i){n.doc=Si(i.target.result);if(e.conflicts){var s=$t(t);s.length&&(n.doc._conflicts=s)}Ti(n.doc,e,p)}}function E(t,n){var r={id:n.id,key:n.id,value:{rev:t}},i=n.deleted;e.deleted==="ok"?(y.push(r),i?(r.value.deleted=!0,r.doc=null):e.include_docs&&w(n,r,t)):!i&&o--<=0&&(y.push(r),e.include_docs&&w(n,r,t))}function S(e){for(var t=0,n=e.length;t<n;t++){if(y.length===u)break;var r=e[t],i=Ei(r),s=i.winningRev;E(s,i)}}function x(e,t,n){if(!n)return;S(t),y.length<u&&n.continue()}function T(t){var n=t.target.result;e.descending&&(n=n.reverse()),S(n)}function N(){n(null,{total_rows:b,offset:e.skip,rows:y})}function C(){e.attachments?Ni(y,e.binary).then(N):N()}var r="startkey"in e?e.startkey:!1,i="endkey"in e?e.endkey:!1,s="key"in e?e.key:!1,o=e.skip||0,u=typeof e.limit=="number"?e.limit:-1,a=e.inclusive_end!==!1,f=_i(r,i,a,s,e.descending),l=f&&f.error;if(!(!l||l.name==="DataError"&&l.code===0))return n(wt(ht,l.name,l.message));var c=[li,ci,di];e.attachments&&c.push(hi);var h=ki(t,c,"readonly");if(h.error)return n(h.error);var p=h.txn;p.oncomplete=C,p.onabort=bi(n);var d=p.objectStore(li),v=p.objectStore(ci),m=p.objectStore(di),g=v.index("_doc_id_rev"),y=[],b;m.get(di).onsuccess=function(e){b=e.target.result.docCount};if(l||u===0)return;if(u===-1)return Mi(d,f,T);Oi(d,f,e.descending,u+o,x)}function Pi(e){return(new p(function(t){var n=Fr([""]),r=e.objectStore(mi).put(n,"key");r.onsuccess=function(){var e=navigator.userAgent.match(/Chrome\/(\d+)/),n=navigator.userAgent.match(/Edge\//);t(n||!e||parseInt(e[1],10)>=43)},e.onabort=function(e){e.preventDefault(),e.stopPropagation(),t(!1)}})).catch(function(){return!1})}function Hi(e,t){var n=e.objectStore(li).index("deletedOrLocal");n.count(IDBKeyRange.only("0")).onsuccess=function(e){t(e.target.result)}}function Fi(e,t,n,r){try{e(t,n)}catch(t){r.emit("error",t)}}function Ii(){if(Bi||!ji.length)return;Bi=!0,ji.shift()()}function qi(e,t,n){ji.push(function(){e(function(r,i){Fi(t,r,i,n),Bi=!1,f(function(){Ii(n)})})}),Ii()}function Ri(e,t,n,r){function g(t,n,r){function h(t,n){var r=e.processChange(n,t,e);o=r.seq=t.seq;var i=c(r);if(typeof i=="object")return e.complete(i);i&&(l++,a&&f.push(r),e.attachments&&e.include_docs?Ti(n,e,p,function(){Ni([r],e.binary).then(function(){e.onChange(r)})}):e.onChange(r))}function d(){for(var e=0,t=i.length;e<t;e++){if(l===u)break;var n=i[e];if(!n)continue;var o=s[e];h(o,n)}l!==u&&r.continue()}if(!r||!t.length)return;var i=new Array(t.length),s=new Array(t.length),v=0;n.forEach(function(e,n){var r=Si(e),o=t[n];b(r,o,function(e,r){s[n]=e,i[n]=r,++v===t.length&&d()})})}function y(e,t,n,r){if(n.seq!==t)return r();if(n.winningRev===e._rev)return r(n,e);var i=e._id+"::"+n.winningRev,s=m.get(i);s.onsuccess=function(e){r(n,Si(e.target.result))}}function b(e,t,n){if(s&&!s.has(e._id))return n();var r=h.get(e._id);if(r)return y(e,t,r,n);v.get(e._id).onsuccess=function(i){r=Ei(i.target.result),h.set(e._id,r),y(e,t,r,n)}}function E(){e.complete(null,{results:f,last_seq:o})}function S(){!e.continuous&&e.attachments?Ni(f).then(E):E()}e=w(e);if(e.continuous){var i=n+":"+Ut();return Li.addListener(n,i,t,e),Li.notify(n),{cancel:function(){Li.removeListener(n,i)}}}var s=e.doc_ids&&new O(e.doc_ids);e.since=e.since||0;var o=e.since,u="limit"in e?e.limit:-1;u===0&&(u=1);var a;"return_docs"in e?a=e.return_docs:"returnDocs"in e?a=e.returnDocs:a=!0;var f=[],l=0,c=xt(e),h=new M,p,d,v,m,x=[li,ci];e.attachments&&x.push(hi);var T=ki(r,x,"readonly");if(T.error)return e.complete(T.error);p=T.txn,p.onabort=bi(e.complete),p.oncomplete=S,d=p.objectStore(ci),v=p.objectStore(li),m=d.index("_doc_id_rev");var N=e.since&&!e.descending?IDBKeyRange.lowerBound(e.since,!0):null;Oi(d,N,e.descending,u,g)}function Xi(e,t){var n=this;qi(function(t){Vi(n,e,t)},t,n.constructor)}function Vi(e,t,n){function s(e){var t=e.createObjectStore(li,{keyPath:"id"});e.createObjectStore(ci,{autoIncrement:!0}).createIndex("_doc_id_rev","_doc_id_rev",{unique:!0}),e.createObjectStore(hi,{keyPath:"digest"}),e.createObjectStore(di,{keyPath:"id",autoIncrement:!1}),e.createObjectStore(mi),t.createIndex("deletedOrLocal","deletedOrLocal",{unique:!1}),e.createObjectStore(vi,{keyPath:"_id"});var n=e.createObjectStore(pi,{autoIncrement:!0});n.createIndex("seq","seq"),n.createIndex("digestSeq","digestSeq",{unique:!0})}function o(e,t){var n=e.objectStore(li);n.createIndex("deletedOrLocal","deletedOrLocal",{unique:!1}),n.openCursor().onsuccess=function(e){var r=e.target.result;if(r){var i=r.value,s=an(i);i.deletedOrLocal=s?"1":"0",n.put(i),r.continue()}else t()}}function u(e){e.createObjectStore(vi,{keyPath:"_id"}).createIndex("_doc_id_rev","_doc_id_rev",{unique:!0})}function a(e,t){var n=e.objectStore(vi),r=e.objectStore(li),i=e.objectStore(ci),s=r.openCursor();s.onsuccess=function(e){var s=e.target.result;if(s){var o=s.value,u=o.id,a=fn(u),f=zt(o);if(a){var l=u+"::"+f,c=u+"::",h=u+"::~",p=i.index("_doc_id_rev"),d=IDBKeyRange.bound(c,h,!1,!1),v=p.openCursor(d);v.onsuccess=function(e){v=e.target.result;if(!v)r.delete(s.primaryKey),s.continue();else{var t=v.value;t._doc_id_rev===l&&n.put(t),i.delete(v.primaryKey),v.continue()}}}else s.continue()}else t&&t()}}function l(e){var t=e.createObjectStore(pi,{autoIncrement:!0});t.createIndex("seq","seq"),t.createIndex("digestSeq","digestSeq",{unique:!0})}function c(e,t){var n=e.objectStore(ci),r=e.objectStore(hi),i=e.objectStore(pi),s=r.count();s.onsuccess=function(e){var r=e.target.result;if(!r)return t();n.openCursor().onsuccess=function(e){var n=e.target.result;if(!n)return t();var r=n.value,s=n.primaryKey,o=Object.keys(r._attachments||{}),u={};for(var a=0;a<o.length;a++){var f=r._attachments[o[a]];u[f.digest]=!0}var l=Object.keys(u);for(a=0;a<l.length;a++){var c=l[a];i.put({seq:s,digestSeq:c+"::"+s})}n.continue()}}}function h(e){function t(e){return e.data?Ei(e):(e.deleted=e.deletedOrLocal==="1",e)}var n=e.objectStore(ci),r=e.objectStore(li),i=r.openCursor();i.onsuccess=function(e){function o(){var e=s.id+"::",t=s.id+"::￿",r=n.index("_doc_id_rev").openCursor(IDBKeyRange.bound(e,t)),i=0;r.onsuccess=function(e){var t=e.target.result;if(!t)return s.seq=i,u();var n=t.primaryKey;n>i&&(i=n),t.continue()}}function u(){var e=wi(s,s.winningRev,s.deleted),t=r.put(e);t.onsuccess=function(){i.continue()}}var i=e.target.result;if(!i)return;var s=t(i.value);s.winningRev=s.winningRev||zt(s);if(s.seq)return u();o()}}var r=t.name,i=null;e._meta=null,e._remote=!1,e.type=function(){return"idb"},e._id=S(function(t){t(null,e._meta.instanceId)}),e._bulkDocs=function(r,s,o){Ai(t,r,s,e,i,o)},e._get=function(t,n,r){function l(){r(u,{doc:s,metadata:o,ctx:a})}var s,o,u,a=n.ctx;if(!a){var f=ki(i,[li,ci,hi],"readonly");if(f.error)return r(f.error);a=f.txn}a.objectStore(li).get(t).onsuccess=function(e){o=Ei(e.target.result);if(!o)return u=wt(Y,"missing"),l();var t;if(!n.rev){t=o.winningRev;var r=an(o);if(r)return u=wt(Y,"deleted"),l()}else t=n.latest?ln(n.rev,o):n.rev;var i=a.objectStore(ci),f=o.id+"::"+t;i.index("_doc_id_rev").get(f).onsuccess=function(e){s=e.target.result,s&&(s=Si(s));if(!s)return u=wt(Y,"missing"),l();l()}}},e._getAttachment=function(e,t,n,r,s){var o;if(r.ctx)o=r.ctx;else{var u=ki(i,[li,ci,hi],"readonly");if(u.error)return s(u.error);o=u.txn}var a=n.digest,f=n.content_type;o.objectStore(hi).get(a).onsuccess=function(e){var t=e.target.result.body;xi(t,f,r.binary,function(e){s(null,e)})}},e._info=function(n){var r,s,o=ki(i,[di,ci],"readonly");if(o.error)return n(o.error);var u=o.txn;u.objectStore(di).get(di).onsuccess=function(e){s=e.target.result.docCount},u.objectStore(ci).openCursor(null,"prev").onsuccess=function(e){var t=e.target.result;r=t?t.key:0},u.oncomplete=function(){n(null,{doc_count:s,update_seq:r,idb_attachment_format:e._meta.blobSupport?"binary":"base64"})}},e._allDocs=function(t,n){Di(t,i,n)},e._changes=function(n){return Ri(n,e,r,i)},e._close=function(e){i.close(),Ui.delete(r),e()},e._getRevisionTree=function(e,t){var n=ki(i,[li],"readonly");if(n.error)return t(n.error);var r=n.txn,s=r.objectStore(li).get(e);s.onsuccess=function(e){var n=Ei(e.target.result);n?t(null,n.rev_tree):t(wt(Y))}},e._doCompaction=function(e,t,n){var r=[li,ci,hi,pi],s=ki(i,r,"readwrite");if(s.error)return n(s.error);var o=s.txn,u=o.objectStore(li);u.get(e).onsuccess=function(n){var r=Ei(n.target.result);Wt(r.rev_tree,function(e,n,r,i,s){var o=n+"-"+r;t.indexOf(o)!==-1&&(s.status="missing")}),Ci(t,e,o);var i=r.winningRev,s=r.deleted;o.objectStore(li).put(wi(r,i,s))},o.onabort=bi(n),o.oncomplete=function(){n()}},e._getLocal=function(e,t){var n=ki(i,[vi],"readonly");if(n.error)return t(n.error);var r=n.txn,s=r.objectStore(vi).get(e);s.onerror=bi(t),s.onsuccess=function(e){var n=e.target.result;n?(delete n._doc_id_rev,t(null,n)):t(wt(Y))}},e._putLocal=function(e,t,n){typeof t=="function"&&(n=t,t={}),delete e._revisions;var r=e._rev,s=e._id;r?e._rev="0-"+(parseInt(r.split("-")[1],10)+1):e._rev="0-1";var o=t.ctx,u;if(!o){var a=ki(i,[vi],"readwrite");if(a.error)return n(a.error);o=a.txn,o.onerror=bi(n),o.oncomplete=function(){u&&n(null,u)}}var f=o.objectStore(vi),l;r?(l=f.get(s),l.onsuccess=function(i){var s=i.target.result;if(!s||s._rev!==r)n(wt(Z));else{var o=f.put(e);o.onsuccess=function(){u={ok:!0,id:e._id,rev:e._rev},t.ctx&&n(null,u)}}}):(l=f.add(e),l.onerror=function(e){n(wt(Z)),e.preventDefault(),e.stopPropagation()},l.onsuccess=function(){u={ok:!0,id:e._id,rev:e._rev},t.ctx&&n(null,u)})},e._removeLocal=function(e,t,n){typeof t=="function"&&(n=t,t={});var r=t.ctx;if(!r){var s=ki(i,[vi],"readwrite");if(s.error)return n(s.error);r=s.txn,r.oncomplete=function(){o&&n(null,o)}}var o,u=e._id,a=r.objectStore(vi),f=a.get(u);f.onerror=bi(n),f.onsuccess=function(r){var i=r.target.result;!i||i._rev!==e._rev?n(wt(Y)):(a.delete(u),o={ok:!0,id:u,rev:"0-0"},t.ctx&&n(null,o))}},e._destroy=function(e,t){Li.removeAllListeners(r);var n=Wi.get(r);n&&n.result&&(n.result.close(),Ui.delete(r));var i=indexedDB.deleteDatabase(r);i.onsuccess=function(){Wi.delete(r),q()&&r in localStorage&&delete localStorage[r],t(null,{ok:!0})},i.onerror=bi(t)};var p=Ui.get(r);if(p)return i=p.idb,e._meta=p.global,f(function(){n(null,e)});var d;t.storage?d=$i(r,t.storage):d=indexedDB.open(r,fi),Wi.set(r,d),d.onupgradeneeded=function(e){function f(){var e=r[i-1];i++,e&&e(n,f)}var t=e.target.result;if(e.oldVersion<1)return s(t);var n=e.currentTarget.transaction;e.oldVersion<3&&u(t),e.oldVersion<4&&l(t);var r=[o,a,c,h],i=e.oldVersion;f()},d.onsuccess=function(t){function c(){if(typeof f=="undefined"||!o)return;e._meta={name:r,instanceId:l,blobSupport:f},Ui.set(r,{idb:i,global:e._meta}),n(null,e)}function h(){if(typeof a=="undefined"||typeof u=="undefined")return;var e=r+"_id";e in u?l=u[e]:u[e]=l=Ut(),u.docCount=a,s.objectStore(di).put(u)}i=t.target.result,i.onversionchange=function(){i.close(),Ui.delete(r)},i.onabort=function(e){z("error","Database has a global failure",e.target.error),i.close(),Ui.delete(r)};var s=i.transaction([di,mi,li],"readwrite"),o=!1,u,a,f,l;s.objectStore(di).get(di).onsuccess=function(e){u=e.target.result||{id:di},h()},Hi(s,function(e){a=e,h()}),zi||(zi=Pi(s)),zi.then(function(e){f=e,c()}),s.oncomplete=function(){o=!0,c()}},d.onerror=function(){var e="Failed to open indexedDB, are you in private browsing mode?";z("error",e),n(wt(ht,e))}}function $i(e,t){try{return indexedDB.open(e,{version:fi,storage:t})}catch(n){return indexedDB.open(e,fi)}}function Ki(e){return decodeURIComponent(escape(e))}function Qi(e){return e<65?e-48:e-55}function Gi(e,t,n){var r="";while(t<n)r+=String.fromCharCode(Qi(e.charCodeAt(t++))<<4|Qi(e.charCodeAt(t++)));return r}function Yi(e,t,n){var r="";while(t<n)r+=String.fromCharCode(Qi(e.charCodeAt(t+2))<<12|Qi(e.charCodeAt(t+3))<<8|Qi(e.charCodeAt(t))<<4|Qi(e.charCodeAt(t+1))),t+=4;return r}function Zi(e,t){return t==="UTF-8"?Ki(Gi(e,0,e.length)):Yi(e,0,e.length)}function es(e){return"'"+e+"'"}function as(e){return e.replace(/\u0002/g,"").replace(/\u0001/g,"").replace(/\u0000/g,"")}function fs(e){return e.replace(/\u0001\u0001/g,"\0").replace(/\u0001\u0002/g,"").replace(/\u0002\u0002/g,"")}function ls(e){return delete e._id,delete e._rev,JSON.stringify(e)}function cs(e,t,n){return e=JSON.parse(e),e._id=t,e._rev=n,e}function hs(e){var t="(";while(e--)t+="?",e&&(t+=",");return t+")"}function ps(e,t,n,r,i){return"SELECT "+e+" FROM "+(typeof t=="string"?t:t.join(" JOIN "))+(n?" ON "+n:"")+(r?" WHERE "+(typeof r=="string"?r:r.join(" AND ")):"")+(i?" ORDER BY "+i:"")}function ds(e,t,n){function s(){++r===e.length&&o()}function o(){if(!i.length)return;var e="SELECT DISTINCT digest AS digest FROM "+us+" WHERE seq IN "+hs(i.length);n.executeSql(e,i,function(e,t){var n=[];for(var r=0;r<t.rows.length;r++)n.push(t.rows.item(r).digest);if(!n.length)return;var s="DELETE FROM "+us+" WHERE seq IN ("+i.map(function(){return"?"}).join(",")+")";e.executeSql(s,i,function(e){var t="SELECT digest FROM "+us+" WHERE digest IN ("+n.map(function(){return"?"}).join(",")+")";e.executeSql(t,n,function(e,t){var r=new O;for(var i=0;i<t.rows.length;i++)r.add(t.rows.item(i).digest);n.forEach(function(t){if(r.has(t))return;e.executeSql("DELETE FROM "+us+" WHERE digest=?",[t]),e.executeSql("DELETE FROM "+is+" WHERE digest=?",[t])})})})})}if(!e.length)return;var r=0,i=[];e.forEach(function(e){var r="SELECT seq FROM "+rs+" WHERE doc_id=? AND rev=?";n.executeSql(r,[t,e],function(e,t){if(!t.rows.length)return s();var n=t.rows.item(0).seq;i.push(n),e.executeSql("DELETE FROM "+rs+" WHERE seq=?",[n],s)})})}function vs(e){return function(t){z("error","WebSQL threw an error",t);var n=t&&t.constructor.toString().match(/function ([^(]+)/),r=n&&n[1]||t.type,i=t.target||t.message;e(wt(pt,i,r))}}function ms(e){if("size"in e)return e.size*1e6;var t=typeof navigator!="undefined"&&/Android/.test(navigator.userAgent);return t?5e6:1}function gs(e,t,n,r,i,s,o){function v(){if(d)return o(d);s.notify(r._name),o(null,h)}function m(e,t){var n="SELECT count(*) as cnt FROM "+is+" WHERE digest=?";c.executeSql(n,[e],function(n,r){if(r.rows.item(0).cnt===0){var i=wt(yt,"unknown stub attachment with digest "+e);t(i)}else t()})}function g(e){function i(){++n===t.length&&e(r)}var t=[];f.forEach(function(e){e.data&&e.data._attachments&&Object.keys(e.data._attachments).forEach(function(n){var r=e.data._attachments[n];r.stub&&t.push(r.digest)})});if(!t.length)return e();var n=0,r;t.forEach(function(e){m(e,function(e){e&&!r&&(r=e),i()})})}function y(e,t,n,i,s,o,u,a){function f(){function f(e,n){function s(){return++r===i.length&&n(),!1}function o(n){var r="INSERT INTO "+us+" (digest, seq) VALUES (?,?)",i=[t._attachments[n].digest,e];c.executeSql(r,i,s,s)}var r=0,i=Object.keys(t._attachments||{});if(!i.length)return n();for(var u=0;u<i.length;u++)o(i[u])}var t=e.data,n=i?1:0,r=t._id,s=t._rev,o=ls(t),u="INSERT INTO "+rs+" (doc_id, rev, json, deleted) VALUES (?, ?, ?, ?);",a=[r,s,o,n];c.executeSql(u,a,function(e,t){var n=t.insertId;f(n,function(){y(e,n)})},function(){var e=ps("seq",rs,null,"doc_id=? AND rev=?");return c.executeSql(e,[r,s],function(e,t){var i=t.rows.item(0).seq,u="UPDATE "+rs+" SET json=?, deleted=? WHERE doc_id=? AND rev=?;",a=[o,n,r,s];e.executeSql(u,a,function(e){f(i,function(){y(e,i)})})}),!1})}function l(e){d||(e?(d=e,a(d)):v===m.length&&f())}function g(e){v++,l(e)}function y(n,i){var o=e.metadata.id,f=e.stemmedRevs||[];s&&r.auto_compaction&&(f=Jt(e.metadata).concat(f)),f.length&&ds(f,o,n),e.metadata.seq=i;var l=e.metadata.rev;delete e.metadata.rev;var c=s?"UPDATE "+ns+" SET json=?, max_seq=?, winningseq="+"(SELECT seq FROM "+rs+" WHERE doc_id="+ns+".id AND rev=?) WHERE id=?":"INSERT INTO "+ns+" (id, winningseq, max_seq, json) VALUES (?,?,?,?);",d=yi(e.metadata),v=s?[d,i,t,o]:[o,i,i,d];n.executeSql(c,v,function(){h[u]={ok:!0,id:e.metadata.id,rev:l},p.set(o,e.metadata),a()})}var d=null,v=0;e.data._id=e.metadata.id,e.data._rev=e.metadata.rev;var m=Object.keys(e.data._attachments||{});i&&(e.data._deleted=!0),m.forEach(function(n){var r=e.data._attachments[n];if(!r.stub){var i=r.data;delete r.data,r.revpos=parseInt(t,10);var s=r.digest;E(s,i,g)}else v++,l()}),m.length||f()}function b(){ai(e.revs_limit,f,r,p,c,h,y,n)}function w(e){function n(){++t===f.length&&e()}if(!f.length)return e();var t=0;f.forEach(function(e){if(e._id&&fn(e._id))return n();var t=e.metadata.id;c.executeSql("SELECT json FROM "+ns+" WHERE id = ?",[t],function(e,r){if(r.rows.length){var i=gi(r.rows.item(0).json);p.set(t,i)}n()})})}function E(e,t,n){var r="SELECT digest FROM "+is+" WHERE digest=?";c.executeSql(r,[e],function(i,s){if(s.rows.length)return n();r="INSERT INTO "+is+" (digest, body, escaped) VALUES (?,?,1)",i.executeSql(r,[e,as(t)],function(){n()},function(){return n(),!1})})}var u=n.new_edits,a=t.docs,f=a.map(function(e){if(e._id&&fn(e._id))return e;var t=Hr(e,u);return t}),l=f.filter(function(e){return e.error});if(l.length)return o(l[0]);var c,h=new Array(f.length),p=new M,d;si(f,"binary",function(e){if(e)return o(e);i.transaction(function(e){c=e,g(function(e){e?d=e:w(b)})},vs(o),v)})}function bs(e){return e.websql(e.name,e.version,e.description,e.size)}function ws(e){try{return{db:bs(e)}}catch(t){return{error:t}}}function Es(e){var t=ys.get(e.name);return t||(t=ws(e),ys.set(e.name,t)),t}function xs(e,t,n,r,i){function u(){++o===s.length&&i&&i()}function a(e,i){var s=e._attachments[i],o={binary:t.binary,ctx:r};n._getAttachment(e._id,i,s,o,function(t,n){e._attachments[i]=J(_(s,["digest","content_type"]),{data:n}),u()})}var s=Object.keys(e._attachments||{});if(!s.length)return i&&i();var o=0;s.forEach(function(n){t.attachments&&t.include_docs?a(e,n):(e._attachments[n].stub=!0,u())})}function _s(e,t){function l(){q()&&(window.localStorage["_pouch__websqldb_"+n._name]=!0),t(null,n)}function c(e,t){e.executeSql(ks),e.executeSql("ALTER TABLE "+rs+" ADD COLUMN deleted TINYINT(1) DEFAULT 0",[],function(){e.executeSql(Ns),e.executeSql("ALTER TABLE "+ns+" ADD COLUMN local TINYINT(1) DEFAULT 0",[],function(){e.executeSql("CREATE INDEX IF NOT EXISTS 'doc-store-local-idx' ON "+ns+" (local, id)");var n="SELECT "+ns+".winningseq AS seq, "+ns+".json AS metadata FROM "+rs+" JOIN "+ns+" ON "+rs+".seq = "+ns+".winningseq";e.executeSql(n,[],function(e,n){var r=[],i=[];for(var s=0;s<n.rows.length;s++){var o=n.rows.item(s),u=o.seq,a=JSON.parse(o.metadata);an(a)&&r.push(u),fn(a.id)&&i.push(a.id)}e.executeSql("UPDATE "+ns+"SET local = 1 WHERE id IN "+hs(i.length),i,function(){e.executeSql("UPDATE "+rs+" SET deleted = 1 WHERE seq IN "+hs(r.length),r,t)})})})})}function h(e,t){var n="CREATE TABLE IF NOT EXISTS "+ss+" (id UNIQUE, rev, json)";e.executeSql(n,[],function(){var n="SELECT "+ns+".id AS id, "+rs+".json AS data "+"FROM "+rs+" JOIN "+ns+" ON "+rs+".seq = "+ns+".winningseq WHERE local = 1";e.executeSql(n,[],function(e,n){function s(){if(!r.length)return t(e);var n=r.shift(),i=JSON.parse(n.data)._rev;e.executeSql("INSERT INTO "+ss+" (id, rev, json) VALUES (?,?,?)",[n.id,i,n.data],function(e){e.executeSql("DELETE FROM "+ns+" WHERE id=?",[n.id],function(e){e.executeSql("DELETE FROM "+rs+" WHERE seq=?",[n.seq],function(){s()})})})}var r=[];for(var i=0;i<n.rows.length;i++)r.push(n.rows.item(i));s()})})}function p(e,t){function n(n){function r(){if(!n.length)return t(e);var i=n.shift(),s=Zi(i.hex,o),u=s.lastIndexOf("::"),a=s.substring(0,u),f=s.substring(u+2),l="UPDATE "+rs+" SET doc_id=?, rev=? WHERE doc_id_rev=?";e.executeSql(l,[a,f,s],function(){r()})}r()}var r="ALTER TABLE "+rs+" ADD COLUMN doc_id";e.executeSql(r,[],function(e){var t="ALTER TABLE "+rs+" ADD COLUMN rev";e.executeSql(t,[],function(e){e.executeSql(Cs,[],function(e){var t="SELECT hex(doc_id_rev) as hex FROM "+rs;e.executeSql(t,[],function(e,t){var r=[];for(var i=0;i<t.rows.length;i++)r.push(t.rows.item(i));n(r)})})})})}function d(e,t){function n(e){var n="SELECT COUNT(*) AS cnt FROM "+is;e.executeSql(n,[],function(e,n){function o(){var n=ps(Ms+", "+ns+".id AS id",[ns,rs],Os,null,ns+".id ");n+=" LIMIT "+s+" OFFSET "+i,i+=s,e.executeSql(n,[],function(e,n){function i(e,t){var n=r[e]=r[e]||[];n.indexOf(t)===-1&&n.push(t)}if(!n.rows.length)return t(e);var r={};for(var s=0;s<n.rows.length;s++){var u=n.rows.item(s),a=cs(u.data,u.id,u.rev),f=Object.keys(a._attachments||{});for(var l=0;l<f.length;l++){var c=a._attachments[f[l]];i(c.digest,u.seq)}}var h=[];Object.keys(r).forEach(function(e){var t=r[e];t.forEach(function(t){h.push([e,t])})});if(!h.length)return o();var p=0;h.forEach(function(t){var n="INSERT INTO "+us+" (digest, seq) VALUES (?,?)";e.executeSql(n,t,function(){++p===h.length&&o()})})})}var r=n.rows.item(0).cnt;if(!r)return t(e);var i=0,s=10;o()})}var r="CREATE TABLE IF NOT EXISTS "+us+" (digest, seq INTEGER)";e.executeSql(r,[],function(e){e.executeSql(As,[],function(e){e.executeSql(Ls,[],n)})})}function v(e,t){var n="ALTER TABLE "+is+" ADD COLUMN escaped TINYINT(1) DEFAULT 0";e.executeSql(n,[],t)}function m(e,t){var n="ALTER TABLE "+ns+" ADD COLUMN max_seq INTEGER";e.executeSql(n,[],function(e){var n="UPDATE "+ns+" SET max_seq=(SELECT MAX(seq) FROM "+rs+" WHERE doc_id=id)";e.executeSql(n,[],function(e){var n="CREATE UNIQUE INDEX IF NOT EXISTS 'doc-max-seq-idx' ON "+ns+" (max_seq)";e.executeSql(n,[],t)})})}function g(e,t){e.executeSql('SELECT HEX("a") AS hex',[],function(e,n){var r=n.rows.item(0).hex;o=r.length===2?"UTF-8":"UTF-16",t()})}function y(){while(s.length>0){var e=s.pop();e(null,r)}}function b(e,t){if(t===0){var n="CREATE TABLE IF NOT EXISTS "+os+" (dbid, db_version INTEGER)",i="CREATE TABLE IF NOT EXISTS "+is+" (digest UNIQUE, escaped TINYINT(1), body BLOB)",s="CREATE TABLE IF NOT EXISTS "+us+" (digest, seq INTEGER)",o="CREATE TABLE IF NOT EXISTS "+ns+" (id unique, json, winningseq, max_seq INTEGER UNIQUE)",u="CREATE TABLE IF NOT EXISTS "+rs+" (seq INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, "+"json, deleted TINYINT(1), doc_id, rev)",a="CREATE TABLE IF NOT EXISTS "+ss+" (id UNIQUE, rev, json)";e.executeSql(i),e.executeSql(a),e.executeSql(s,[],function(){e.executeSql(Ls),e.executeSql(As)}),e.executeSql(o,[],function(){e.executeSql(ks),e.executeSql(u,[],function(){e.executeSql(Ns),e.executeSql(Cs),e.executeSql(n,[],function(){var t="INSERT INTO "+os+" (db_version, dbid) VALUES (?,?)";r=Ut();var n=[ts,r];e.executeSql(t,n,function(){y()})})})})}else{var f=function(){var n=t<ts;n&&e.executeSql("UPDATE "+os+" SET db_version = "+ts);var i="SELECT dbid FROM "+os;e.executeSql(i,[],function(e,t){r=t.rows.item(0).dbid,y()})},l=[c,h,p,d,v,m,f],g=t,b=function(e){l[g-1](e,b),g++};b(e)}}function E(){f.transaction(function(e){g(e,function(){x(e)})},vs(t),l)}function x(e){var t="SELECT sql FROM sqlite_master WHERE tbl_name = "+os;e.executeSql(t,[],function(e,t){t.rows.length?/db_version/.test(t.rows.item(0).sql)?e.executeSql("SELECT db_version FROM "+os,[],function(e,t){var n=t.rows.item(0).db_version;b(e,n)}):e.executeSql("ALTER TABLE "+os+" ADD COLUMN db_version INTEGER",[],function(){b(e,1)}):b(e,0)})}function T(e,t){var n="SELECT MAX(seq) AS seq FROM "+rs;e.executeSql(n,[],function(e,n){var r=n.rows.item(0).seq||0;t(r)})}function N(e,t){var n=ps("COUNT("+ns+".id) AS 'num'",[ns,rs],Os,rs+".deleted=0");e.executeSql(n,[],function(e,n){t(n.rows.item(0).num)})}function C(e,t,n,r,i){var s=ps(Ms,[ns,rs],Os,ns+".id=?"),o=[t];e.executeSql(s,o,function(e,t){if(!t.rows.length){var s=wt(Y,"missing");return i(s)}var o=t.rows.item(0),u=gi(o.metadata);r(ln(n,u))})}var n=this,r=null,i=ms(e),s=[],o;n._name=e.name;var u=J({},e,{version:Ts,description:e.name,size:i}),a=Es(u);if(a.error)return vs(t)(a.error);var f=a.db;typeof f.readTransaction!="function"&&(f.readTransaction=f.transaction),E(),n._remote=!1,n.type=function(){return"websql"},n._id=S(function(e){e(null,r)}),n._info=function(e){var t,n;f.readTransaction(function(e){T(e,function(e){t=e}),N(e,function(e){n=e})},vs(e),function(){e(null,{doc_count:n,update_seq:t,websql_encoding:o})})},n._bulkDocs=function(t,r,i){gs(e,t,r,n,f,Ss,i)},n._get=function(e,t,r){function u(e){r(e,{doc:i,metadata:s,ctx:o})}var i,s,o=t.ctx;if(!o)return f.readTransaction(function(i){n._get(e,J({ctx:i},t),r)});var a,l;if(!t.rev)a=ps(Ms,[ns,rs],Os,ns+".id=?"),l=[e];else{if(t.latest){C(o,e,t.rev,function(i){t.latest=!1,t.rev=i,n._get(e,t,r)},u);return}a=ps(Ms,[ns,rs],ns+".id="+rs+".doc_id",[rs+".doc_id=?",rs+".rev=?"]),l=[e,t.rev]}o.executeSql(a,l,function(e,n){if(!n.rows.length){var r=wt(Y,"missing");return u(r)}var o=n.rows.item(0);s=gi(o.metadata);if(o.deleted&&!t.rev){var a=wt(Y,"deleted");return u(a)}i=cs(o.data,s.id,o.rev),u()})},n._allDocs=function(e,t){var r=[],i,s="startkey"in e?e.startkey:!1,o="endkey"in e?e.endkey:!1,u="key"in e?e.key:!1,a="descending"in e?e.descending:!1,l="limit"in e?e.limit:-1,c="skip"in e?e.skip:0,h=e.inclusive_end!==!1,p=[],d=[];if(u!==!1)d.push(ns+".id = ?"),p.push(u);else if(s!==!1||o!==!1){s!==!1&&(d.push(ns+".id "+(a?"<=":">=")+" ?"),p.push(s));if(o!==!1){var v=a?">":"<";h&&(v+="="),d.push(ns+".id "+v+" ?"),p.push(o)}u!==!1&&(d.push(ns+".id = ?"),p.push(u))}e.deleted!=="ok"&&d.push(rs+".deleted = 0"),f.readTransaction(function(t){N(t,function(e){i=e});if(l===0)return;var s=ps(Ms,[ns,rs],Os,d,ns+".id "+(a?"DESC":"ASC"));s+=" LIMIT "+l+" OFFSET "+c,t.executeSql(s,p,function(t,i){for(var s=0,o=i.rows.length;s<o;s++){var u=i.rows.item(s),a=gi(u.metadata),f=a.id,l=cs(u.data,f,u.rev),c=l._rev,h={id:f,key:f,value:{rev:c}};if(e.include_docs){h.doc=l,h.doc._rev=c;if(e.conflicts){var p=$t(a);p.length&&(h.doc._conflicts=p)}xs(h.doc,e,n,t)}if(u.deleted){if(e.deleted!=="ok")continue;h.value.deleted=!0,h.doc=null}r.push(h)}})},vs(t),function(){t(null,{total_rows:i,offset:e.skip,rows:r})})},n._changes=function(e){function a(){var t=ns+".json AS metadata, "+ns+".max_seq AS maxSeq, "+rs+".json AS winningDoc, "+rs+".rev AS winningRev ",a=ns+" JOIN "+rs,l=ns+".id="+rs+".doc_id"+" AND "+ns+".winningseq="+rs+".seq",c=["maxSeq > ?"],h=[e.since];e.doc_ids&&(c.push(ns+".id IN "+hs(e.doc_ids.length)),h=h.concat(e.doc_ids));var p="maxSeq "+(r?"DESC":"ASC"),d=ps(t,a,l,c,p),v=xt(e);!e.view&&!e.filter&&(d+=" LIMIT "+i);var m=e.since||0;f.readTransaction(function(t){t.executeSql(d,h,function(t,r){function a(t){return function(){e.onChange(t)}}for(var f=0,l=r.rows.length;f<l;f++){var c=r.rows.item(f),h=gi(c.metadata);m=c.maxSeq;var p=cs(c.winningDoc,h.id,c.winningRev),d=e.processChange(p,h,e);d.seq=c.maxSeq;var g=v(d);if(typeof g=="object")return e.complete(g);g&&(u++,s&&o.push(d),e.attachments&&e.include_docs?xs(p,e,n,t,a(d)):a(d)());if(u===i)break}})},vs(e.complete),function(){e.continuous||e.complete(null,{results:o,last_seq:m})})}e=w(e);if(e.continuous){var t=n._name+":"+Ut();return Ss.addListener(n._name,t,n,e),Ss.notify(n._name),{cancel:function(){Ss.removeListener(n._name,t)}}}var r=e.descending;e.since=e.since&&!r?e.since:0;var i="limit"in e?e.limit:-1;i===0&&(i=1);var s;"return_docs"in e?s=e.return_docs:"returnDocs"in e?s=e.returnDocs:s=!0;var o=[],u=0;a()},n._close=function(e){e()},n._getAttachment=function(e,t,n,r,i){var s,u=r.ctx,a=n.digest,f=n.content_type,l="SELECT escaped, CASE WHEN escaped = 1 THEN body ELSE HEX(body) END AS body FROM "+is+" WHERE digest=?";u.executeSql(l,[a],function(e,t){var n=t.rows.item(0),u=n.escaped?fs(n.body):Zi(n.body,o);r.binary?s=qr(u,f):s=jr(u),i(null,s)})},n._getRevisionTree=function(e,t){f.readTransaction(function(n){var r="SELECT json AS metadata FROM "+ns+" WHERE id = ?";n.executeSql(r,[e],function(e,n){if(!n.rows.length)t(wt(Y));else{var r=gi(n.rows.item(0).metadata);t(null,r.rev_tree)}})})},n._doCompaction=function(e,t,n){if(!t.length)return n();f.transaction(function(n){var r="SELECT json AS metadata FROM "+ns+" WHERE id = ?";n.executeSql(r,[e],function(n,r){var i=gi(r.rows.item(0).metadata);Wt(i.rev_tree,function(e,n,r,i,s){var o=n+"-"+r;t.indexOf(o)!==-1&&(s.status="missing")});var s="UPDATE "+ns+" SET json = ? WHERE id = ?";n.executeSql(s,[yi(i),e])}),ds(t,e,n)},vs(n),function(){n()})},n._getLocal=function(e,t){f.readTransaction(function(n){var r="SELECT json, rev FROM "+ss+" WHERE id=?";n.executeSql(r,[e],function(n,r){if(r.rows.length){var i=r.rows.item(0),s=cs(i.json,e,i.rev);t(null,s)}else t(wt(Y))})})},n._putLocal=function(e,t,n){function a(e){var a,f;r?(a="UPDATE "+ss+" SET rev=?, json=? "+"WHERE id=? AND rev=?",f=[s,o,i,r]):(a="INSERT INTO "+ss+" (id, rev, json) VALUES (?,?,?)",f=[i,s,o]),e.executeSql(a,f,function(e,r){r.rowsAffected?(u={ok:!0,id:i,rev:s},t.ctx&&n(null,u)):n(wt(Z))},function(){return n(wt(Z)),!1})}typeof t=="function"&&(n=t,t={}),delete e._revisions;var r=e._rev,i=e._id,s;r?s=e._rev="0-"+(parseInt(r.split("-")[1],10)+1):s=e._rev="0-1";var o=ls(e),u;t.ctx?a(t.ctx):f.transaction(a,vs(n),function(){u&&n(null,u)})},n._removeLocal=function(e,t,n){function i(i){var s="DELETE FROM "+ss+" WHERE id=? AND rev=?",o=[e._id,e._rev];i.executeSql(s,o,function(i,s){if(!s.rowsAffected)return n(wt(Y));r={ok:!0,id:e._id,rev:"0-0"},t.ctx&&n(null,r)})}typeof t=="function"&&(n=t,t={});var r;t.ctx?i(t.ctx):f.transaction(i,vs(n),function(){r&&n(null,r)})},n._destroy=function(e,t){Ss.removeAllListeners(n._name),f.transaction(function(e){var t=[ns,rs,is,os,ss,us];t.forEach(function(t){e.executeSql("DROP TABLE IF EXISTS "+t,[])})},vs(t),function(){q()&&(delete window.localStorage["_pouch__websqldb_"+n._name],delete window.localStorage[n._name]),t(null,{ok:!0})})}}function Ds(){try{return openDatabase("_pouch_validate_websql",1,"",1),!0}catch(e){return!1}}function Ps(){if(typeof indexedDB=="undefined"||indexedDB===null||!/iP(hone|od|ad)/.test(navigator.userAgent))return!0;var e=q(),t="_pouch__websqldb_valid_"+navigator.userAgent;if(e&&localStorage[t])return localStorage[t]==="1";var n=Ds();return e&&(localStorage[t]=n?"1":"0"),n}function Hs(){return typeof openDatabase!="function"?!1:Ps()}function Bs(e,t,n,r){return openDatabase(e,t,n,r)}function js(e,t){var n=J({websql:Bs},e);_s.call(this,n,t)}function Is(){var e={},t=new p(function(t,n){e.resolve=t,e.reject=n}),n=new Array(arguments.length);for(var r=0;r<n.length;r++)n[r]=arguments[r];return e.promise=t,p.resolve().then(function(){return fetch.apply(null,n)}).then(function(t){e.resolve(t)}).catch(function(t){e.reject(t)}),e}function qs(e,t){var n,r,i,s=new Headers,o={method:e.method,credentials:"include",headers:s};return e.json&&(s.set("Accept","application/json"),s.set("Content-Type",e.headers["Content-Type"]||"application/json")),e.body&&e.processData&&typeof e.body!="string"?o.body=JSON.stringify(e.body):"body"in e?o.body=e.body:o.body=null,Object.keys(e.headers).forEach(function(t){e.headers.hasOwnProperty(t)&&s.set(t,e.headers[t])}),n=Is(e.url,o),e.timeout>0&&(r=setTimeout(function(){n.reject(new Error("Load timeout for resource: "+e.url))},e.timeout)),n.promise.then(function(t){return i={statusCode:t.status},e.timeout>0&&clearTimeout(r),i.statusCode>=200&&i.statusCode<300?e.binary?t.blob():t.text():t.json()}).then(function(e){i.statusCode>=200&&i.statusCode<300?t(null,i,e):(e.status=i.statusCode,t(e))}).catch(function(e){e||(e=new Error("canceled")),t(e)}),{abort:n.reject}}function Rs(e,t){var n,r,i=!1,s=function(){n.abort(),a()},o=function(){i=!0,n.abort(),a()},u={abort:s},a=function(){clearTimeout(r),u.abort=function(){},n&&(n.onprogress=undefined,n.upload&&(n.upload.onprogress=undefined),n.onreadystatechange=undefined,n=undefined)};e.xhr?n=new e.xhr:n=new XMLHttpRequest;try{n.open(e.method,e.url)}catch(f){return t(new Error(f.name||"Url is invalid"))}n.withCredentials="withCredentials"in e?e.withCredentials:!0,e.method==="GET"?delete e.headers["Content-Type"]:e.json&&(e.headers.Accept="application/json",e.headers["Content-Type"]=e.headers["Content-Type"]||"application/json",e.body&&e.processData&&typeof e.body!="string"&&(e.body=JSON.stringify(e.body))),e.binary&&(n.responseType="arraybuffer"),"body"in e||(e.body=null);for(var l in e.headers)e.headers.hasOwnProperty(l)&&n.setRequestHeader(l,e.headers[l]);return e.timeout>0&&(r=setTimeout(o,e.timeout),n.onprogress=function(){clearTimeout(r),n.readyState!==4&&(r=setTimeout(o,e.timeout))},typeof n.upload!="undefined"&&(n.upload.onprogress=n.onprogress)),n.onreadystatechange=function(){if(n.readyState!==4)return;var r={statusCode:n.status};if(n.status>=200&&n.status<300){var s;e.binary?s=Fr([n.response||""],{type:n.getResponseHeader("Content-Type")}):s=n.responseText,t(null,r,s)}else{var o={};if(i)o=new Error("ETIMEDOUT"),o.code="ETIMEDOUT";else if(typeof n.response=="string")try{o=JSON.parse(n.response)}catch(u){}o.status=n.status,t(o)}a()},e.body&&e.body instanceof Blob?Vr(e.body,function(e){n.send(e)}):n.send(e.body),u}function Us(){try{return new XMLHttpRequest,!0}catch(e){return!1}}function Ws(e,t){return zs||e.xhr?Rs(e,t):qs(e,t)}function Vs(){return""}function $s(e,t){function r(t,n,r){if(!e.binary&&e.json&&typeof t=="string")try{t=JSON.parse(t)}catch(i){return r(i)}Array.isArray(t)&&(t=t.map(function(e){return e.error||e.missing?Et(e):e})),e.binary&&Xs(t,n),r(null,t,n)}e=w(e);var n={method:"GET",headers:{},json:!0,processData:!0,timeout:1e4,cache:!1};return e=J(n,e),e.json&&(e.binary||(e.headers.Accept="application/json"),e.headers["Content-Type"]=e.headers["Content-Type"]||"application/json"),e.binary&&(e.encoding=null,e.json=!1),e.processData||(e.json=!1),Ws(e,function(n,i,s){if(n)return t(Et(n));var o,u=i.headers&&i.headers["content-type"],a=s||Vs();if(!e.binary&&(e.json||!e.processData)&&typeof a!="object"&&(/json/.test(u)||/^[\s]*\{/.test(a)&&/\}[\s]*$/.test(a)))try{a=JSON.parse(a.toString())}catch(f){}i.statusCode>=200&&i.statusCode<300?r(a,i,t):(o=Et(a),o.status=i.statusCode,t(o))})}function Js(e,t){var n=navigator&&navigator.userAgent?navigator.userAgent.toLowerCase():"",r=n.indexOf("safari")!==-1&&n.indexOf("chrome")===-1,i=n.indexOf("msie")!==-1,s=n.indexOf("edge")!==-1,o=r||(i||s)&&e.method==="GET",u="cache"in e?e.cache:!0,a=/^blob:/.test(e.url);if(!a&&(o||!u)){var f=e.url.indexOf("?")!==-1;e.url+=(f?"&":"?")+"_nonce="+Date.now()}return $s(e,t)}function Ks(e,t){return new p(function(n,r){function f(){i++,e[s++]().then(c,h)}function l(){++o===u?a?r(a):n():p()}function c(){i--,l()}function h(e){i--,a=a||e,l()}function p(){while(i<t&&s<u)f()}var i=0,s=0,o=0,u=e.length,a;p()})}function to(e){var t=e.doc&&e.doc._attachments;if(!t)return;Object.keys(t).forEach(function(e){var n=t[e];n.data=Rr(n.data,n.content_type)})}function no(e){return/^_design/.test(e)?"_design/"+encodeURIComponent(e.slice(8)):/^_local/.test(e)?"_local/"+encodeURIComponent(e.slice(7)):encodeURIComponent(e)}function ro(e){return!e._attachments||!Object.keys(e._attachments)?p.resolve():p.all(Object.keys(e._attachments).map(function(t){var n=e._attachments[t];if(n.data&&typeof n.data!="string")return(new p(function(e){Xr(n.data,e)})).then(function(e){n.data=e})}))}function io(e){if(!e.prefix)return!1;var t=jt(e.prefix).protocol;return t==="http"||t==="https"}function so(e,t){if(io(t)){var n=t.name.substr(t.prefix.length);e=t.prefix+encodeURIComponent(n)}var r=jt(e);if(r.user||r.password)r.auth={username:r.user,password:r.password};var i=r.path.replace(/(^\/|\/$)/g,"").split("/");return r.db=i.pop(),r.db.indexOf("%")===-1&&(r.db=encodeURIComponent(r.db)),r.path=i.join("/"),r}function oo(e,t){return uo(e,e.db+"/"+t)}function uo(e,t){var n=e.path?"/":"";return e.protocol+"://"+e.host+(e.port?":"+e.port:"")+"/"+e.path+n+t}function ao(e){return"?"+Object.keys(e).map(function(t){return t+"="+encodeURIComponent(e[t])}).join("&")}function fo(e,t){function c(e,t,r){var i=e.ajax||{},o=J(w(s),i,t),u=w(s.headers||{});return o.headers=J(u,i.headers,t.headers||{}),n.constructor.listeners("debug").length&&n.constructor.emit("debug",["http",o.method,o.url]),n._ajax(o,r)}function h(e,t){return new p(function(n,r){c(e,t,function(e,t){if(e)return r(e);n(t)})})}function d(e,t){return T(e,o(function(e){m().then(function(){return t.apply(this,e)}).catch(function(t){var n=e.pop();n(t)})}))}function m(){if(e.skipSetup||e.skip_setup)return p.resolve();if(v)return v;var t={method:"GET",url:i};return v=h({},t).catch(function(e){return e&&e.status&&e.status===404?(V(404,"PouchDB is just detecting if the remote exists."),h({},{method:"PUT",url:i})):p.reject(e)}).catch(function(e){return e&&e.status&&e.status===412?!0:p.reject(e)}),v.catch(function(){v=null}),v}function g(e){return e.split("/").map(encodeURIComponent).join("/")}var n=this,r=so(e.name,e),i=oo(r,"");e=w(e);var s=e.ajax||{};if(e.auth||r.auth){var u=e.auth||r.auth,a=u.username+":"+u.password,l=jr(unescape(encodeURIComponent(a)));s.headers=s.headers||{},s.headers.Authorization="Basic "+l}n._ajax=Js;var v;f(function(){t(null,n)}),n._remote=!0,n.type=function(){return"http"},n.id=d("id",function(e){c({},{method:"GET",url:uo(r,"")},function(t,n){var i=n&&n.uuid?n.uuid+r.db:oo(r,"");e(null,i)})}),n.request=d("request",function(e,t){e.url=oo(r,e.url),c({},e,t)}),n.compact=d("compact",function(e,t){typeof e=="function"&&(t=e,e={}),e=w(e),c(e,{url:oo(r,"_compact"),method:"POST"},function(){function r(){n.info(function(n,i){i&&!i.compact_running?t(null,{ok:!0}):setTimeout(r,e.interval||200)})}r()})}),n.bulkGet=T("bulkGet",function(e,t){function i(t){var n={};e.revs&&(n.revs=!0),e.attachments&&(n.attachments=!0),e.latest&&(n.latest=!0),c(e,{url:oo(r,"_bulk_get"+ao(n)),method:"POST",body:{docs:e.docs}},t)}function o(){function a(e){return function(n,r){u[e]=r.results,++o===i&&t(null,{results:Tt(u)})}}var r=Gs,i=Math.ceil(e.docs.length/r),o=0,u=new Array(i);for(var f=0;f<i;f++){var l=_(e,["revs","attachments","latest"]);l.ajax=s,l.docs=e.docs.slice(f*r,Math.min(e.docs.length,(f+1)*r)),B(n,l,a(f))}}var n=this,u=uo(r,""),a=eo[u];typeof a!="boolean"?i(function(e,n){e?(eo[u]=!1,V(e.status,"PouchDB is just detecting if the remote supports the _bulk_get API."),o()):(eo[u]=!0,t(null,n))}):a?i(t):o()}),n._info=function(e){m().then(function(){c({},{method:"GET",url:oo(r,"")},function(t,n){if(t)return e(t);n.host=oo(r,""),e(null,n)})}).catch(e)},n.get=d("get",function(e,t,n){function o(e){function s(i){var s=n[i],o=no(e._id)+"/"+g(i)+"?rev="+e._rev;return h(t,{method:"GET",url:oo(r,o),binary:!0}).then(function(e){return t.binary?e:new p(function(t){Xr(e,t)})}).then(function(e){delete s.stub,delete s.length,s.data=e})}var n=e._attachments,i=n&&Object.keys(n);if(!n||!i.length)return;var o=i.map(function(e){return function(){return s(e)}});return Ks(o,5)}function u(e){return Array.isArray(e)?p.all(e.map(function(e){if(e.ok)return o(e.ok)})):o(e)}typeof t=="function"&&(n=t,t={}),t=w(t);var i={};t.revs&&(i.revs=!0),t.revs_info&&(i.revs_info=!0),t.latest&&(i.latest=!0),t.open_revs&&(t.open_revs!=="all"&&(t.open_revs=JSON.stringify(t.open_revs)),i.open_revs=t.open_revs),t.rev&&(i.rev=t.rev),t.conflicts&&(i.conflicts=t.conflicts),e=no(e);var s={method:"GET",url:oo(r,e+ao(i))};h(t,s).then(function(e){return p.resolve().then(function(){if(t.attachments)return u(e)}).then(function(){n(null,e)})}).catch(function(t){t.docId=e,n(t)})}),n.remove=d("remove",function(e,t,n,i){var s;typeof t=="string"?(s={_id:e,_rev:t},typeof n=="function"&&(i=n,n={})):(s=e,typeof t=="function"?(i=t,n={}):(i=n,n=t));var o=s._rev||n.rev;c(n,{method:"DELETE",url:oo(r,no(s._id))+"?rev="+o},i)}),n.getAttachment=d("getAttachment",function(e,t,n,i){typeof n=="function"&&(i=n,n={});var s=n.rev?"?rev="+n.rev:"",o=oo(r,no(e))+"/"+g(t)+s;c(n,{method:"GET",url:o,binary:!0},i)}),n.removeAttachment=d("removeAttachment",function(e,t,n,i){var s=oo(r,no(e)+"/"+g(t))+"?rev="+n;c({},{method:"DELETE",url:s},i)}),n.putAttachment=d("putAttachment",function(e,t,n,i,o,u){typeof o=="function"&&(u=o,o=i,i=n,n=null);var a=no(e)+"/"+g(t),f=oo(r,a);n&&(f+="?rev="+n);if(typeof i=="string"){var l;try{l=Br(i)}catch(h){return u(wt(st,"Attachment is not a valid base64 string"))}i=l?qr(l,o):""}var p={headers:{"Content-Type":o},method:"PUT",url:f,processData:!1,body:i,timeout:s.timeout||6e4};c({},p,u)}),n._bulkDocs=function(e,t,n){e.new_edits=t.new_edits,m().then(function(){return p.all(e.docs.map(ro))}).then(function(){c(t,{method:"POST",url:oo(r,"_bulk_docs"),timeout:t.timeout,body:e},function(e,t){if(e)return n(e);t.forEach(function(e){e.ok=!0}),n(null,t)})}).catch(n)},n._put=function(e,t,n){m().then(function(){return ro(e)}).then(function(){c(t,{method:"PUT",url:oo(r,no(e._id)),body:e},function(t,r){if(t)return t.docId=e&&e._id,n(t);n(null,r)})}).catch(n)},n.allDocs=d("allDocs",function(e,t){typeof e=="function"&&(t=e,e={}),e=w(e);var n={},i,s="GET";e.conflicts&&(n.conflicts=!0),e.descending&&(n.descending=!0),e.include_docs&&(n.include_docs=!0),e.attachments&&(n.attachments=!0),e.key&&(n.key=JSON.stringify(e.key)),e.start_key&&(e.startkey=e.start_key),e.startkey&&(n.startkey=JSON.stringify(e.startkey)),e.end_key&&(e.endkey=e.end_key),e.endkey&&(n.endkey=JSON.stringify(e.endkey)),typeof e.inclusive_end!="undefined"&&(n.inclusive_end=!!e.inclusive_end),typeof e.limit!="undefined"&&(n.limit=e.limit),typeof e.skip!="undefined"&&(n.skip=e.skip);var o=ao(n);typeof e.keys!="undefined"&&(s="POST",i={keys:e.keys}),h(e,{method:s,url:oo(r,"_all_docs"+o),body:i}).then(function(n){e.include_docs&&e.attachments&&e.binary&&n.rows.forEach(to),t(null,n)}).catch(t)}),n._changes=function(e){var t="batch_size"in e?e.batch_size:Qs;e=w(e),e.continuous&&!("heartbeat"in e)&&(e.heartbeat=Zs);var n="timeout"in e?e.timeout:"timeout"in s?s.timeout:3e4;"timeout"in e&&e.timeout&&n-e.timeout<Ys&&(n=e.timeout+Ys),"heartbeat"in e&&e.heartbeat&&n-e.heartbeat<Ys&&(n=e.heartbeat+Ys);var i={};"timeout"in e&&e.timeout&&(i.timeout=e.timeout);var o=typeof e.limit!="undefined"?e.limit:!1,u;"return_docs"in e?u=e.return_docs:"returnDocs"in e?u=e.returnDocs:u=!0;var a=o;e.style&&(i.style=e.style);if(e.include_docs||e.filter&&typeof e.filter=="function")i.include_docs=!0;e.attachments&&(i.attachments=!0),e.continuous&&(i.feed="longpoll"),e.conflicts&&(i.conflicts=!0),e.descending&&(i.descending=!0),"heartbeat"in e&&e.heartbeat&&(i.heartbeat=e.heartbeat),e.filter&&typeof e.filter=="string"&&(i.filter=e.filter),e.view&&typeof e.view=="string"&&(i.filter="_view",i.view=e.view);if(e.query_params&&typeof e.query_params=="object")for(var l in e.query_params)e.query_params.hasOwnProperty(l)&&(i[l]=e.query_params[l]);var h="GET",p;e.doc_ids?(i.filter="_doc_ids",h="POST",p={doc_ids:e.doc_ids}):e.selector&&(i.filter="_selector",h="POST",p={selector:e.selector});var d,v,g=function(s,u){if(e.aborted)return;i.since=s,typeof i.since=="object"&&(i.since=JSON.stringify(i.since)),e.descending?o&&(i.limit=a):i.limit=!o||a>t?t:a;var f={method:h,url:oo(r,"_changes"+ao(i)),timeout:n,body:p};v=s;if(e.aborted)return;m().then(function(){d=c(e,f,u)}).catch(u)},y={results:[]},b=function(n,r){if(e.aborted)return;var i=0;if(r&&r.results){i=r.results.length,y.last_seq=r.last_seq;var s={};s.query=e.query_params,r.results=r.results.filter(function(t){a--;var n=xt(e)(t);return n&&(e.include_docs&&e.attachments&&e.binary&&to(t),u&&y.results.push(t),e.onChange(t)),n})}else if(n){e.aborted=!0,e.complete(n);return}r&&r.last_seq&&(v=r.last_seq);var l=o&&a<=0||r&&i<t||e.descending;e.continuous&&!(o&&a<=0)||!l?f(function(){g(v,b)}):e.complete(null,y)};return g(e.since||0,b),{cancel:function(){e.aborted=!0,d&&d.abort()}}},n.revsDiff=d("revsDiff",function(e,t,n){typeof t=="function"&&(n=t,t={}),c(t,{method:"POST",url:oo(r,"_revs_diff"),body:e},n)}),n._close=function(e){e()},n._destroy=function(e,t){c(e,{url:oo(r,""),method:"DELETE"},function(e,n){if(e&&e.status&&e.status!==404)return t(e);t(null,n)})}}function co(e){this.status=400,this.name="query_parse_error",this.message=e,this.error=!0;try{Error.captureStackTrace(this,co)}catch(t){}}function ho(e){this.status=404,this.name="not_found",this.message=e,this.error=!0;try{Error.captureStackTrace(this,ho)}catch(t){}}function po(e){this.status=500,this.name="invalid_value",this.message=e,this.error=!0;try{Error.captureStackTrace(this,po)}catch(t){}}function vo(e,t){return t&&e.then(function(e){f(function(){t(null,e)})},function(e){f(function(){t(e)})}),e}function mo(e){return o(function(t){var n=t.pop(),r=e.apply(this,t);return typeof n=="function"&&vo(r,n),r})}function go(e,t){return e.then(function(e){return t().then(function(){return e})},function(e){return t().then(function(){throw e})})}function yo(e,t){return function(){var n=arguments,r=this;return e.add(function(){return t.apply(r,n)})}}function bo(e){var t=new O(e),n=new Array(t.size),r=-1;return t.forEach(function(e){n[++r]=e}),n}function wo(e){var t=new Array(e.size),n=-1;return e.forEach(function(e,r){t[++n]=r}),t}function Eo(e){var t="builtin "+e+" function requires map values to be numbers"+" or number arrays";return new po(t)}function So(e){var t=0;for(var n=0,r=e.length;n<r;n++){var i=e[n];if(typeof i!="number"){if(!Array.isArray(i))throw Eo("_sum");t=typeof t=="number"?[t]:t;for(var s=0,o=i.length;s<o;s++){var u=i[s];if(typeof u!="number")throw Eo("_sum");typeof t[s]=="undefined"?t.push(u):t[s]+=u}}else typeof t=="number"?t+=i:t[0]+=i}return t}function Co(e,t){return Ft("return ("+e.replace(/;\s*$/,"")+");",{emit:t,sum:So,log:xo,isArray:To,toJSON:No})}function ko(){this.promise=new p(function(e){e()})}function Lo(e){if(!e)return"undefined";switch(typeof e){case"function":return e.toString();case"string":return e.toString();default:return JSON.stringify(e)}}function Ao(e,t){return Lo(e)+Lo(t)+"undefined"}function Oo(e,t,n,r,i,s){var o=Ao(n,r),u;if(!i){u=e._cachedViews=e._cachedViews||{};if(u[o])return u[o]}var a=e.info().then(function(a){function l(e){e.views=e.views||{};var n=t;n.indexOf("/")===-1&&(n=t+"/"+t);var r=e.views[n]=e.views[n]||{};if(r[f])return;return r[f]=!0,e}var f=a.db_name+"-mrview-"+(i?"temp":ei(o));return It(e,"_local/"+s,l).then(function(){return e.registerDependentDatabase(f).then(function(t){var i=t.db;i.auto_compaction=!0;var s={name:f,db:i,sourceDB:e,adapter:e.adapter,mapFun:n,reduceFun:r};return s.db.get("_local/lastSeq").catch(function(e){if(e.status!==404)throw e}).then(function(e){return s.seq=e?e.seq:0,u&&s.db.once("destroyed",function(){delete u[o]}),s})})})});return u&&(u[o]=a),a}function Po(e){return e.indexOf("/")===-1?[e,e]:e.split("/")}function Ho(e){return e.length===1&&/^1-/.test(e[0].rev)}function Bo(e,t){try{e.emit("error",t)}catch(n){z("error","The user's map/reduce function threw an uncaught error.\nYou can debug this error by doing:\nmyDatabase.on('error', function (err) { debugger; });\nPlease double-check your map/reduce function."),z("error",t)}}function jo(e,t,n,r){function i(e,t,n){try{t(n)}catch(r){Bo(e,r)}}function s(e,t,n,r,i){try{return{output:t(n,r,i)}}catch(s){return Bo(e,s),{error:s}}}function o(e,t){var n=Kn(e.key,t.key);return n!==0?n:Kn(e.value,t.value)}function u(e,t,n){return n=n||0,typeof t=="number"?e.slice(n,t+n):n>0?e.slice(n):e}function a(e){var t=e.value,n=t&&typeof t=="object"&&t._id||e.id;return n}function l(e){e.rows.forEach(function(e){var t=e.doc&&e.doc._attachments;if(!t)return;Object.keys(t).forEach(function(e){var n=t[e];t[e].data=Rr(n.data,n.content_type)})})}function c(e){return function(t){return e.include_docs&&e.attachments&&e.binary&&l(t),t}}function h(e,t,n,r){var i=t[e];typeof i!="undefined"&&(r&&(i=encodeURIComponent(JSON.stringify(i))),n.push(e+"="+i))}function d(e){if(typeof e!="undefined"){var t=Number(e);return!isNaN(t)&&t===parseInt(e,10)?t:e}}function v(e){return e.group_level=d(e.group_level),e.limit=d(e.limit),e.skip=d(e.skip),e}function m(e){if(e){if(typeof e!="number")return new co('Invalid value for integer: "'+e+'"');if(e<0)return new co('Invalid value for positive integer: "'+e+'"')}}function g(e,t){var n=e.descending?"endkey":"startkey",r=e.descending?"startkey":"endkey";if(typeof e[n]!="undefined"&&typeof e[r]!="undefined"&&Kn(e[n],e[r])>0)throw new co("No rows can match your key range, reverse your start_key and end_key or set {descending : true}");if(t.reduce&&e.reduce!==!1){if(e.include_docs)throw new co("{include_docs:true} is invalid for reduce");if(e.keys&&e.keys.length>1&&!e.group&&!e.group_level)throw new co("Multi-key fetches for reduce views must use {group: true}")}["group_level","limit","skip"].forEach(function(t){var n=m(e[t]);if(n)throw n})}function y(e,t,n){var r=[],i,s="GET";h("reduce",n,r),h("include_docs",n,r),h("attachments",n,r),h("limit",n,r),h("descending",n,r),h("group",n,r),h("group_level",n,r),h("skip",n,r),h("stale",n,r),h("conflicts",n,r),h("startkey",n,r,!0),h("start_key",n,r,!0),h("endkey",n,r,!0),h("end_key",n,r,!0),h("inclusive_end",n,r),h("key",n,r,!0),r=r.join("&"),r=r===""?"":"?"+r;if(typeof n.keys!="undefined"){var o=2e3,u="keys="+encodeURIComponent(JSON.stringify(n.keys));u.length+r.length+1<=o?r+=(r[0]==="?"?"&":"?")+u:(s="POST",typeof t=="string"?i={keys:n.keys}:t.keys=n.keys)}if(typeof t=="string"){var a=Po(t);return e.request({method:s,url:"_design/"+a[0]+"/_view/"+a[1]+r,body:i}).then(function(e){return e.rows.forEach(function(e){if(e.value&&e.value.error&&e.value.error==="builtin_reduce_error")throw new Error(e.reason)}),e}).then(c(n))}return i=i||{},Object.keys(t).forEach(function(e){Array.isArray(t[e])?i[e]=t[e]:i[e]=t[e].toString()}),e.request({method:"POST",url:"_temp_view"+r,body:i}).then(c(n))}function b(e,t,n){return new p(function(r,i){e._query(t,n,function(e,t){if(e)return i(e);r(t)})})}function w(e){return new p(function(t,n){e._viewCleanup(function(e,r){if(e)return n(e);t(r)})})}function E(e){return function(t){if(t.status===404)return e;throw t}}function S(e,t,n){function a(){return Ho(u)?p.resolve(i):t.db.get(r).catch(E(i))}function f(e){return e.keys.length?t.db.allDocs({keys:e.keys,include_docs:!0}):p.resolve({rows:[]})}function l(e,t){var n=[],r=new O;for(var i=0,s=t.rows.length;i<s;i++){var u=t.rows[i],a=u.doc;if(!a)continue;n.push(a),r.add(a._id),a._deleted=!o.has(a._id);if(!a._deleted){var f=o.get(a._id);"value"in f&&(a.value=f.value)}}var l=wo(o);return l.forEach(function(e){if(!r.has(e)){var t={_id:e},i=o.get(e);"value"in i&&(t.value=i.value),n.push(t)}}),e.keys=bo(l.concat(e.keys)),n.push(e),n}var r="_local/doc_"+e,i={_id:r,keys:[]},s=n.get(e),o=s[0],u=s[1];return a().then(function(e){return f(e).then(function(t){return l(e,t)})})}function x(e,t,n){var r="_local/lastSeq";return e.db.get(r).catch(E({_id:r,seq:0})).then(function(r){var i=wo(t);return p.all(i.map(function(n){return S(n,e,t)})).then(function(t){var i=Tt(t);return r.seq=n,i.push(r),e.db.bulkDocs({docs:i})})})}function T(e){var t=typeof e=="string"?e:e.name,n=Mo[t];return n||(n=Mo[t]=new ko),n}function N(e){return yo(T(e),function(){return C(e)})()}function C(e){function s(e,t){var i={id:r._id,key:Qn(e)};typeof t!="undefined"&&t!==null&&(i.value=Qn(t)),n.push(i)}function f(t,n){return function(){return x(e,t,n)}}function c(){return e.sourceDB.changes({conflicts:!0,include_docs:!0,style:"all_docs",since:a,limit:Do}).then(h)}function h(e){var t=e.results;if(!t.length)return;var n=p(t);l.add(f(n,a));if(t.length<Do)return;return c()}function p(t){var s=new M;for(var f=0,l=t.length;f<l;f++){var c=t[f];if(c.doc._id[0]!=="_"){n=[],r=c.doc,r._deleted||i(e.sourceDB,u,r),n.sort(o);var h=d(n);s.set(c.doc._id,[h,c.changes])}a=c.seq}return s}function d(e){var t=new M,n;for(var r=0,i=e.length;r<i;r++){var s=e[r],o=[s.key,s.id];r>0&&Kn(s.key,n)===0&&o.push(r),t.set(Yn(o),s),n=s.key}return t}var n,r,u=t(e.mapFun,s),a=e.seq||0,l=new ko;return c().then(function(){return l.finish()}).then(function(){e.seq=a})}function k(e,t,r){r.group_level===0&&delete r.group_level;var i=r.group||r.group_level,o=n(e.reduceFun),a=[],f=isNaN(r.group_level)?Number.POSITIVE_INFINITY:r.group_level;t.forEach(function(e){var t=a[a.length-1],n=i?e.key:null;i&&Array.isArray(n)&&(n=n.slice(0,f));if(t&&Kn(t.groupKey,n)===0){t.keys.push([e.key,e.id]),t.values.push(e.value);return}a.push({keys:[[e.key,e.id]],values:[e.value],groupKey:n})}),t=[];for(var l=0,c=a.length;l<c;l++){var h=a[l],p=s(e.sourceDB,o,h.keys,h.values,!1);if(p.error&&p.error instanceof po)throw p.error;t.push({value:p.error?null:p.output,key:h.groupKey})}return{rows:u(t,r.limit,r.skip)}}function L(e,t){return yo(T(e),function(){return A(e,t)})()}function A(e,t){function s(t){return t.include_docs=!0,e.db.allDocs(t).then(function(e){return n=e.total_rows,e.rows.map(function(e){if("value"in e.doc&&typeof e.doc.value=="object"&&e.doc.value!==null){var t=Object.keys(e.doc.value).sort(),n=["id","key","value"];if(!(t<n||t>n))return e.doc.value}var r=tr(e.doc._id);return{key:r[0],id:r[1],value:"value"in e.doc?e.doc.value:null}})})}function o(s){var o;r?o=k(e,s,t):o={total_rows:n,offset:i,rows:s};if(t.include_docs){var u=bo(s.map(a));return e.sourceDB.allDocs({keys:u,include_docs:!0,conflicts:t.conflicts,attachments:t.attachments,binary:t.binary}).then(function(e){var t=new M;return e.rows.forEach(function(e){t.set(e.id,e.doc)}),s.forEach(function(e){var n=a(e),r=t.get(n);r&&(e.doc=r)}),o})}return o}var n,r=e.reduceFun&&t.reduce!==!1,i=t.skip||0;typeof t.keys!="undefined"&&!t.keys.length&&(t.limit=0,delete t.keys);if(typeof t.keys!="undefined"){var u=t.keys,f=u.map(function(e){var t={startkey:Yn([e]),endkey:Yn([e,{}])};return s(t)});return p.all(f).then(Tt).then(o)}var l={descending:t.descending},c,h;"start_key"in t&&(c=t.start_key),"startkey"in t&&(c=t.startkey),"end_key"in t&&(h=t.end_key),"endkey"in t&&(h=t.endkey),typeof c!="undefined"&&(l.startkey=t.descending?Yn([c,{}]):Yn([c]));if(typeof h!="undefined"){var d=t.inclusive_end!==!1;t.descending&&(d=!d),l.endkey=Yn(d?[h,{}]:[h])}if(typeof t.key!="undefined"){var v=Yn([t.key]),m=Yn([t.key,{}]);l.descending?(l.endkey=v,l.startkey=m):(l.startkey=v,l.endkey=m)}return r||(typeof t.limit=="number"&&(l.limit=t.limit),l.skip=i),s(l).then(o)}function _(e){return e.request({method:"POST",url:"_view_cleanup"})}function D(t){return t.get("_local/"+e).then(function(e){var n=new M;Object.keys(e.views).forEach(function(e){var t=Po(e),r="_design/"+t[0],i=t[1],s=n.get(r);s||(s=new O,n.set(r,s)),s.add(i)});var r={keys:wo(n),include_docs:!0};return t.allDocs(r).then(function(r){var i={};r.rows.forEach(function(t){var r=t.key.substring(8);n.get(t.key).forEach(function(n){var s=r+"/"+n;e.views[s]||(s=n);var o=Object.keys(e.views[s]),u=t.doc&&t.doc.views&&t.doc.views[n];o.forEach(function(e){i[e]=i[e]||u})})});var s=Object.keys(i).filter(function(e){return!i[e]}),o=s.map(function(e){return yo(T(e),function(){return(new t.constructor(e,t.__opts)).destroy()})()});return p.all(o).then(function(){return{ok:!0}})})},E({ok:!0}))}function P(t,n,i){if(typeof t._query=="function")return b(t,n,i);if(At(t))return y(t,n,i);if(typeof n!="string")return g(i,n),_o.add(function(){var r=Oo(t,"temp_view/temp_view",n.map,n.reduce,!0,e);return r.then(function(e){return go(N(e).then(function(){return L(e,i)}),function(){return e.db.destroy()})})}),_o.finish();var s=n,o=Po(s),u=o[0],a=o[1];return t.get("_design/"+u).then(function(n){var o=n.views&&n.views[a];if(!o)throw new ho("ddoc "+n._id+" has no view named "+a);r(n,a),g(i,o);var u=Oo(t,s,o.map,o.reduce,!1,e);return u.then(function(e){return i.stale==="ok"||i.stale==="update_after"?(i.stale==="update_after"&&f(function(){N(e)}),L(e,i)):N(e).then(function(){return L(e,i)})})})}function H(e,t,n){var r=this;typeof t=="function"&&(n=t,t={}),t=t?v(t):{},typeof e=="function"&&(e={map:e});var i=p.resolve().then(function(){return P(r,e,t)});return vo(i,n),i}var B=mo(function(){var e=this;return typeof e._viewCleanup=="function"?w(e):At(e)?_(e):D(e)});return{query:H,viewCleanup:B}}function Io(e){if(/^_sum/.test(e))return Fo._sum;if(/^_count/.test(e))return Fo._count;if(/^_stats/.test(e))return Fo._stats;if(/^_/.test(e))throw new Error(e+" is not a supported reduce function.")}function qo(e,t){if(typeof e=="function"&&e.length===2){var n=e;return function(e){return n(e,t)}}return Co(e.toString(),t)}function Ro(e){var t=e.toString(),n=Io(t);return n?n:Co(t)}function Uo(e,t){var n=e.views&&e.views[t];if(typeof n.map!="string")throw new ho("ddoc "+e._id+" has no string view named "+t+", instead found object of type: "+typeof n.map)}function Xo(e,t,n){return Wo.query.call(this,e,t,n)}function Vo(e){return Wo.viewCleanup.call(this,e)}function Jo(e){return/^1-/.test(e)}function Ko(e,t,n){return!e._attachments||!e._attachments[n]||e._attachments[n].digest!==t._attachments[n].digest}function Qo(e,t){var n=Object.keys(t._attachments);return p.all(n.map(function(n){return e.getAttachment(t._id,n,{rev:t._rev})}))}function Go(e,t,n){var r=At(t)&&!At(e),i=Object.keys(n._attachments);return r?e.get(n._id).then(function(r){return p.all(i.map(function(i){return Ko(r,n,i)?t.getAttachment(n._id,i):e.getAttachment(r._id,i)}))}).catch(function(e){if(e.status!==404)throw e;return Qo(t,n)}):Qo(t,n)}function Yo(e){var t=[];return Object.keys(e).forEach(function(n){var r=e[n].missing;r.forEach(function(e){t.push({id:n,rev:e})})}),{docs:t,revs:!0,latest:!0}}function Zo(e,t,n,r){function o(){var o=Yo(n);if(!o.docs.length)return;return e.bulkGet(o).then(function(n){if(r.cancelled)throw new Error("cancelled");return p.all(n.results.map(function(n){return p.all(n.docs.map(function(n){var r=n.ok;return n.error&&(s=!1),!r||!r._attachments?r:Go(t,e,r).then(function(e){var t=Object.keys(r._attachments);return e.forEach(function(e,n){var i=r._attachments[t[n]];delete i.stub,delete i.length,i.data=e}),r})}))})).then(function(e){i=i.concat(Tt(e).filter(Boolean))})})}function u(e){return e._attachments&&Object.keys(e._attachments).length>0}function a(e){return e._conflicts&&e._conflicts.length>0}function f(t){return e.allDocs({keys:t,include_docs:!0,conflicts:!0}).then(function(e){if(r.cancelled)throw new Error("cancelled");e.rows.forEach(function(e){if(e.deleted||!e.doc||!Jo(e.value.rev)||u(e.doc)||a(e.doc))return;e.doc._conflicts&&delete e.doc._conflicts,i.push(e.doc),delete n[e.id]})})}function l(){var e=Object.keys(n).filter(function(e){var t=n[e].missing;return t.length===1&&Jo(t[0])});if(e.length>0)return f(e)}function c(){return{ok:s,docs:i}}n=w(n);var i=[],s=!0;return p.resolve().then(l).then(o).then(c)}function iu(e,t,n,r,i){return e.get(t).catch(function(n){if(n.status===404)return(e.adapter==="http"||e.adapter==="https")&&V(404,"PouchDB is just checking if a remote checkpoint exists."),{session_id:r,_id:t,history:[],replicator:tu,version:eu};throw n}).then(function(s){if(i.cancelled)return;if(s.last_seq===n)return;return s.history=(s.history||[]).filter(function(e){return e.session_id!==r}),s.history.unshift({last_seq:n,session_id:r}),s.history=s.history.slice(0,nu),s.version=eu,s.replicator=tu,s.session_id=r,s.last_seq=n,e.put(s).catch(function(s){if(s.status===409)return iu(e,t,n,r,i);throw s})})}function su(e,t,n,r,i){this.src=e,this.target=t,this.id=n,this.returnValue=r,this.opts=i}function uu(e,t){return e.session_id===t.session_id?{last_seq:e.last_seq,history:e.history}:au(e.history,t.history)}function au(e,t){var n=e[0],r=e.slice(1),i=t[0],s=t.slice(1);if(!n||t.length===0)return{last_seq:ru,history:[]};var o=n.session_id;if(fu(o,t))return{last_seq:n.last_seq,history:e};var u=i.session_id;return fu(u,r)?{last_seq:i.last_seq,history:s}:au(r,s)}function fu(e,t){var n=t[0],r=t.slice(1);return!e||t.length===0?!1:e===n.session_id?!0:fu(e,r)}function lu(e){return typeof e.status=="number"&&Math.floor(e.status/100)===4}function hu(e,t,n,r){if(e.retry===!1){t.emit("error",n),t.removeAllListeners();return}typeof e.back_off_function!="function"&&(e.back_off_function=X),t.emit("requestError",n);if(t.state==="active"||t.state==="pending"){t.emit("paused",n),t.state="stopped";var i=function(){e.current_back_off=cu},s=function(){t.removeListener("active",i)};t.once("paused",s),t.once("active",i)}e.current_back_off=e.current_back_off||cu,e.current_back_off=e.back_off_function(e.current_back_off),setTimeout(r,e.current_back_off)}function pu(e){return Object.keys(e).sort(Kn).reduce(function(t,n){return t[n]=e[n],t},{})}function du(e,t,n){var r=n.doc_ids?n.doc_ids.sort(Kn):"",i=n.filter?n.filter.toString():"",s="",o="",u="";return n.selector&&(u=JSON.stringify(n.selector)),n.filter&&n.query_params&&(s=JSON.stringify(pu(n.query_params))),n.filter&&n.filter==="_view"&&(o=n.view.toString()),p.all([e.id(),t.id()]).then(function(e){var t=e[0]+e[1]+i+o+s+r+u;return new p(function(e){Zr(t,e)})}).then(function(e){return e=e.replace(/\//g,".").replace(/\+/g,"_"),"_local/"+e})}function vu(e,t,n,r,i){function N(){return E?p.resolve():du(e,t,n).then(function(i){b=i;var s={};n.checkpoint===!1?s={writeSourceCheckpoint:!1,writeTargetCheckpoint:!1}:n.checkpoint==="source"?s={writeSourceCheckpoint:!0,writeTargetCheckpoint:!1}:n.checkpoint==="target"?s={writeSourceCheckpoint:!1,writeTargetCheckpoint:!0}:s={writeSourceCheckpoint:!0,writeTargetCheckpoint:!0},E=new su(e,t,b,r,s)})}function C(){S=[];if(o.docs.length===0)return;var e=o.docs,s={timeout:n.timeout};return t.bulkDocs({docs:e,new_edits:!1},s).then(function(t){if(r.cancelled)throw D(),new Error("cancelled");var n=Object.create(null);t.forEach(function(e){e.error&&(n[e.id]=e)});var s=Object.keys(n).length;i.doc_write_failures+=s,i.docs_written+=e.length-s,e.forEach(function(e){var t=n[e._id];if(t){i.errors.push(t);if(t.name!=="unauthorized"&&t.name!=="forbidden")throw t;r.emit("denied",w(t))}else S.push(e)})},function(t){throw i.doc_write_failures+=e.length,t})}function k(){if(o.error)throw new Error("There was a problem getting docs.");i.last_seq=c=o.seq;var e=w(i);return S.length&&(e.docs=S,r.emit("change",e)),a=!0,E.writeCheckpoint(o.seq,x).then(function(){a=!1;if(r.cancelled)throw D(),new Error("cancelled");o=undefined,j()}).catch(function(e){throw I(e),e})}function L(){var e={};return o.changes.forEach(function(t){if(t.id==="_user/")return;e[t.id]=t.changes.map(function(e){return e.rev})}),t.revsDiff(e).then(function(e){if(r.cancelled)throw D(),new Error("cancelled");o.diffs=e})}function A(){return Zo(e,t,o.diffs,r).then(function(e){o.error=!e.ok,e.docs.forEach(function(e){delete o.diffs[e._id],i.docs_read++,o.docs.push(e)})})}function O(){if(r.cancelled||o)return;if(s.length===0){M(!0);return}o=s.shift(),L().then(A).then(C).then(k).then(O).catch(function(e){_("batch processing terminated with error",e)})}function M(e){if(u.changes.length===0){if(s.length===0&&!o){if(h&&T.live||f)r.state="pending",r.emit("paused");f&&D()}return}if(e||f||u.changes.length>=d){s.push(u),u={seq:0,changes:[],docs:[]};if(r.state==="pending"||r.state==="stopped")r.state="active",r.emit("active");O()}}function _(e,t){if(l)return;t.message||(t.message=e),i.ok=!1,i.status="aborting",s=[],u={seq:0,changes:[],docs:[]},D(t)}function D(s){if(l)return;if(r.cancelled){i.status="cancelled";if(a)return}i.status=i.status||"complete",i.end_time=new Date,i.last_seq=c,l=!0,s?(s=wt(s),s.result=i,s.name==="unauthorized"||s.name==="forbidden"?(r.emit("error",s),r.removeAllListeners()):hu(n,r,s,function(){vu(e,t,n,r)})):(r.emit("complete",i),r.removeAllListeners())}function P(e){if(r.cancelled)return D();var t=xt(n)(e);if(!t)return;u.seq=e.seq,u.changes.push(e),M(s.length===0&&T.live)}function H(e){m=!1;if(r.cancelled)return D();if(e.results.length>0)T.since=e.last_seq,j(),M(!0);else{var t=function(){h?(T.live=!0,j()):f=!0,M(!0)};!o&&e.results.length===0?(a=!0,E.writeCheckpoint(e.last_seq,x).then(function(){a=!1,i.last_seq=c=e.last_seq,t()}).catch(I)):t()}}function B(e){m=!1;if(r.cancelled)return D();_("changes rejected",e)}function j(){function t(){o.cancel()}function i(){r.removeListener("cancel",t)}if(!(!m&&!f&&s.length<v))return;m=!0,r._changes&&(r.removeListener("cancel",r._abortChanges),r._changes.cancel()),r.once("cancel",t);var o=e.changes(T).on("change",P);o.then(i,i),o.then(H).catch(B),n.retry&&(r._changes=o,r._abortChanges=t)}function F(){N().then(function(){if(r.cancelled){D();return}return E.getCheckpoint().then(function(e){c=e,T={since:c,limit:d,batch_size:d,style:"all_docs",doc_ids:g,selector:y,return_docs:!0},n.filter&&(typeof n.filter!="string"?T.include_docs=!0:T.filter=n.filter),"heartbeat"in n&&(T.heartbeat=n.heartbeat),"timeout"in n&&(T.timeout=n.timeout),n.query_params&&(T.query_params=n.query_params),n.view&&(T.view=n.view),j()})}).catch(function(e){_("getCheckpoint rejected with ",e)})}function I(e){a=!1,_("writeCheckpoint completed with error",e)}var s=[],o,u={seq:0,changes:[],docs:[]},a=!1,f=!1,l=!1,c=0,h=n.continuous||n.live||!1,d=n.batch_size||100,v=n.batches_limit||10,m=!1,g=n.doc_ids,y=n.selector,b,E,S=[],x=Ut();i=i||{ok:!0,start_time:new Date,docs_read:0,docs_written:0,doc_write_failures:0,errors:[]};var T={};r.ready(e,t);if(r.cancelled){D();return}r._addedListeners||(r.once("cancel",D),typeof n.complete=="function"&&(r.once("error",n.complete),r.once("complete",function(e){n.complete(null,e)})),r._addedListeners=!0),typeof n.since=="undefined"?F():N().then(function(){return a=!0,E.writeCheckpoint(n.since,x)}).then(function(){a=!1;if(r.cancelled){D();return}c=n.since,F()}).catch(I)}function mu(){u.EventEmitter.call(this),this.cancelled=!1,this.state="pending";var e=this,t=new p(function(t,n){e.once("complete",t),e.once("error",n)});e.then=function(e,n){return t.then(e,n)},e.catch=function(e){return t.catch(e)},e.catch(function(){})}function gu(e,t){var n=t.PouchConstructor;return typeof e=="string"?new n(e,t):e}function yu(e,t,n,r){typeof n=="function"&&(r=n,n={}),typeof n=="undefined"&&(n={});if(n.doc_ids&&!Array.isArray(n.doc_ids))throw wt(ft,"`doc_ids` filter parameter is not a list.");n.complete=r,n=w(n),n.continuous=n.continuous||n.live,n.retry="retry"in n?n.retry:!1,n.PouchConstructor=n.PouchConstructor||this;var i=new mu(n),s=gu(e,n),o=gu(t,n);return vu(s,o,n,i),i}function bu(e,t,n,r){return typeof n=="function"&&(r=n,n={}),typeof n=="undefined"&&(n={}),n=w(n),n.PouchConstructor=n.PouchConstructor||this,e=gu(e,n),t=gu(t,n),new wu(e,t,n,r)}function wu(e,t,n,r){function u(e){i.emit("change",{direction:"pull",change:e})}function a(e){i.emit("change",{direction:"push",change:e})}function f(e){i.emit("denied",{direction:"push",doc:e})}function l(e){i.emit("denied",{direction:"pull",doc:e})}function c(){i.pushPaused=!0,i.pullPaused&&i.emit("paused")}function h(){i.pullPaused=!0,i.pushPaused&&i.emit("paused")}function d(){i.pushPaused=!1,i.pullPaused&&i.emit("active",{direction:"push"})}function v(){i.pullPaused=!1,i.pushPaused&&i.emit("active",{direction:"pull"})}function g(e){return function(t,n){var r=t==="change"&&(n===u||n===a),s=t==="denied"&&(n===l||n===f),o=t==="paused"&&(n===h||n===c),p=t==="active"&&(n===v||n===d);if(r||s||o||p)t in m||(m[t]={}),m[t][e]=!0,Object.keys(m[t]).length===2&&i.removeAllListeners(t)}}function y(e,t,n){e.listeners(t).indexOf(n)==-1&&e.on(t,n)}var i=this;this.canceled=!1;var s=n.push?J({},n,n.push):n,o=n.pull?J({},n,n.pull):n;this.push=yu(e,t,s),this.pull=yu(t,e,o),this.pushPaused=!0,this.pullPaused=!0;var m={};n.live&&(this.push.on("complete",i.pull.cancel.bind(i.pull)),this.pull.on("complete",i.push.cancel.bind(i.push))),this.on("newListener",function(e){e==="change"?(y(i.pull,"change",u),y(i.push,"change",a)):e==="denied"?(y(i.pull,"denied",l),y(i.push,"denied",f)):e==="active"?(y(i.pull,"active",v),y(i.push,"active",d)):e==="paused"&&(y(i.pull,"paused",h),y(i.push,"paused",c))}),this.on("removeListener",function(e){e==="change"?(i.pull.removeListener("change",u),i.push.removeListener("change",a)):e==="denied"?(i.pull.removeListener("denied",l),i.push.removeListener("denied",f)):e==="active"?(i.pull.removeListener("active",v),i.push.removeListener("active",d)):e==="paused"&&(i.pull.removeListener("paused",h),i.push.removeListener("paused",c))}),this.pull.on("removeListener",g("pull")),this.push.on("removeListener",g("push"));var b=p.all([this.push,this.pull]).then(function(e){var t={push:e[0],pull:e[1]};return i.emit("complete",t),r&&r(null,t),i.removeAllListeners(),t},function(e){i.cancel(),r?r(e):i.emit("error",e),i.removeAllListeners();if(r)throw e});this.then=function(e,t){return b.then(e,t)},this.catch=function(e){return b.catch(e)}}function Eu(e){e.replicate=yu,e.sync=bu,Object.defineProperty(e.prototype,"replicate",{get:function(){var e=this;return{from:function(t,n,r){return e.constructor.replicate(t,e,n,r)},to:function(t,n,r){return e.constructor.replicate(e,t,n,r)}}}}),e.prototype.sync=function(e,t,n){return this.constructor.sync(this,e,t,n)}}var i=r(e("uuid")),s=r(e("lie")),o=r(e("argsarray")),u=e("events"),a=r(e("inherits")),f=r(e("immediate")),l=r(e("debug")),c=r(e("spark-md5")),h=r(e("vuvuzela")),p=typeof Promise=="function"?Promise:s,g=Function.prototype.toString,y=g.call(Object);k.prototype.get=function(e){var t=N(e);return this._store[t]},k.prototype.set=function(e,t){var n=N(e);return this._store[n]=t,!0},k.prototype.has=function(e){var t=N(e);return t in this._store},k.prototype.delete=function(e){var t=N(e),n=t in this._store;return delete this._store[t],n},k.prototype.forEach=function(e){var t=Object.keys(this._store);for(var n=0,r=t.length;n<r;n++){var i=t[n],s=this._store[i];i=C(i),e(s,i)}},Object.defineProperty(k.prototype,"size",{get:function(){return Object.keys(this._store).length}}),L.prototype.add=function(e){return this._store.set(e,!0)},L.prototype.has=function(e){return this._store.has(e)},L.prototype.forEach=function(e){this._store.forEach(function(t,n){e(n)})},Object.defineProperty(L.prototype,"size",{get:function(){return this._store.size}});var O,M;A()?(O=Set,M=Map):(O=L,M=k);var D=6,F;if(j())F=!1;else try{localStorage.setItem("_pouch_check_localstorage",1),F=!!localStorage.getItem("_pouch_check_localstorage")}catch(I){F=!1}a(U,u.EventEmitter),U.prototype.addListener=function(e,t,n,r){function o(){function u(){s=!1}if(!i._listeners[t])return;if(s){s="waiting";return}s=!0;var e=_(r,["style","include_docs","attachments","conflicts","filter","doc_ids","view","since","query_params","binary"]);n.changes(e).on("change",function(e){e.seq>r.since&&!r.cancelled&&(r.since=e.seq,r.onChange(e))}).on("complete",function(){s==="waiting"&&f(o),s=!1}).on("error",u)}if(this._listeners[t])return;var i=this,s=!1;this._listeners[t]=o,this.on(e,o)},U.prototype.removeListener=function(e,t){if(!(t in this._listeners))return;u.EventEmitter.prototype.removeListener.call(this,e,this._listeners[t]),delete this._listeners[t]},U.prototype.notifyLocalWindows=function(e){j()?chrome.storage.local.set({dbName:e}):q()&&(localStorage[e]=localStorage[e]==="a"?"b":"a")},U.prototype.notify=function(e){this.emit(e),this.notifyLocalWindows(e)};var $;typeof Object.assign=="function"?$=Object.assign:$=function(e){var t=Object(e);for(var n=1;n<arguments.length;n++){var r=arguments[n];if(r!=null)for(var i in r)Object.prototype.hasOwnProperty.call(r,i)&&(t[i]=r[i])}return t};var J=$;a(K,Error),K.prototype.toString=function(){return JSON.stringify({status:this.status,name:this.name,message:this.message,reason:this.reason})};var Q=new K(401,"unauthorized","Name or password is incorrect."),G=new K(400,"bad_request","Missing JSON list of 'docs'"),Y=new K(404,"not_found","missing"),Z=new K(409,"conflict","Document update conflict"),et=new K(400,"bad_request","_id field must contain a string"),tt=new K(412,"missing_id","_id is required for puts"),nt=new K(400,"bad_request","Only reserved document ids may start with underscore."),rt=new K(412,"precondition_failed","Database not open"),it=new K(500,"unknown_error","Database encountered an unknown error"),st=new K(500,"badarg","Some query argument is invalid"),ot=new K(400,"invalid_request","Request was invalid"),ut=new K(400,"query_parse_error","Some query parameter is invalid"),at=new K(500,"doc_validation","Bad special document member"),ft=new K(400,"bad_request","Something wrong with the request"),lt=new K(400,"bad_request","Document must be a JSON object"),ct=new K(404,"not_found","Database not found"),ht=new K(500,"indexed_db_went_bad","unknown"),pt=new K(500,"web_sql_went_bad","unknown"),dt=new K(500,"levelDB_went_went_bad","unknown"),vt=new K(403,"forbidden","Forbidden by design doc validate_doc_update function"),mt=new K(400,"bad_request","Invalid rev format"),gt=new K(412,"file_exists","The database could not be created, the file already exists."),yt=new K(412,"missing_stub","A pre-existing attachment stub wasn't found"),bt=new K(413,"invalid_url","Provided URL is invalid"),Ct=Nt.name,kt;Ct?kt=function(e){return e.name}:kt=function(e){return e.toString().match(/^\s*function\s*(\S*)\s*\(/)[1]};var Dt=["source","protocol","authority","userInfo","user","password","host","port","relative","path","directory","file","query","anchor"],Pt="queryKey",Ht=/(?:^|&)([^&=]*)=?([^&]*)/g,Bt=/^(?:(?![^:@]+:[^:@\/]*@)([^:\/?#.]+):)?(?:\/\/)?((?:(([^:@]*)(?::([^:@]*))?)?@)?([^:\/?#]*)(?::(\d*))?)(((\/(?:[^?#](?![^?#\/]*\.[^?#\/.]+(?:[?#]|$)))*\/?)?([^?#\/]*))(?:\?([^#]*))?(?:#(.*))?)/,Ut=i.v4;a(hn,u.EventEmitter),hn.prototype.cancel=function(){this.isCancelled=!0,this.db.taskqueue.isReady&&this.emit("cancel")},hn.prototype.validateChanges=function(e){var t=e.complete,n=this;Cn._changesFilterPlugin?Cn._changesFilterPlugin.validate(e,function(r){if(r)return t(r);n.doChanges(e)}):n.doChanges(e)},hn.prototype.doChanges=function(e){var t=this,n=e.complete;e=w(e),"live"in e&&!("continuous"in e)&&(e.continuous=e.live),e.processChange=pn,e.since==="latest"&&(e.since="now"),e.since||(e.since=0);if(e.since==="now"){this.db.info().then(function(r){if(t.isCancelled){n(null,{status:"cancelled"});return}e.since=r.update_seq,t.doChanges(e)},n);return}if(Cn._changesFilterPlugin){Cn._changesFilterPlugin.normalize(e);if(Cn._changesFilterPlugin.shouldFilter(this,e))return Cn._changesFilterPlugin.filter(this,e)}else["doc_ids","filter","selector","view"].forEach(function(t){t in e&&z("warn",'The "'+t+'" option was passed in to changes/replicate, '+"but pouchdb-changes-filter plugin is not installed, so it "+"was ignored. Please install the plugin to enable filtering.")});"descending"in e||(e.descending=!1),e.limit=e.limit===0?1:e.limit,e.complete=n;var r=this.db._changes(e);if(r&&typeof r.cancel=="function"){var i=t.cancel;t.cancel=o(function(e){r.cancel(),i.apply(this,e)})}},a(Sn,u.EventEmitter),Sn.prototype.post=T("post",function(e,t,n){typeof t=="function"&&(n=t,t={});if(typeof e!="object"||Array.isArray(e))return n(wt(lt));this.bulkDocs({docs:[e]},t,vn(n,e._id))}),Sn.prototype.put=T("put",function(e,t,n){function i(){var n=e._rev.split("-"),r=n[1],i=parseInt(n[0],10),s=i+1,o=Rt();e._revisions={start:s,ids:[o,r]},e._rev=s+"-"+o,t.new_edits=!1}function s(n){typeof r._put=="function"&&t.new_edits!==!1?r._put(e,t,n):r.bulkDocs({docs:[e]},t,vn(n,e._id))}typeof t=="function"&&(n=t,t={});if(typeof e!="object"||Array.isArray(e))return n(wt(lt));Lt(e._id);if(fn(e._id)&&typeof this._putLocal=="function")return e._deleted?this._removeLocal(e,n):this._putLocal(e,n);var r=this;t.force&&e._rev?(i(),s(function(t){var r=t?null:{ok:!0,id:e._id,rev:e._rev};n(t,r)})):s(n)}),Sn.prototype.putAttachment=T("putAttachment",function(e,t,n,r,i){function o(e){var n="_rev"in e?parseInt(e._rev,10):0;return e._attachments=e._attachments||{},e._attachments[t]={content_type:i,data:r,revpos:++n},s.put(e)}var s=this;return typeof i=="function"&&(i=r,r=n,n=null),typeof i=="undefined"&&(i=r,r=n,n=null),i||z("warn","Attachment",t,"on document",e,"is missing content_type"),s.get(e).then(function(e){if(e._rev!==n)throw wt(Z);return o(e)},function(t){if(t.reason===Y.message)return o({_id:e});throw t})}),Sn.prototype.removeAttachment=T("removeAttachment",function(e,t,n,r){var i=this;i.get(e,function(e,s){if(e){r(e);return}if(s._rev!==n){r(wt(Z));return}if(!s._attachments)return r();delete s._attachments[t],Object.keys(s._attachments).length===0&&delete s._attachments,i.put(s,r)})}),Sn.prototype.remove=T("remove",function(e,t,n,r){var i;typeof t=="string"?(i={_id:e,_rev:t},typeof n=="function"&&(r=n,n={})):(i=e,typeof t=="function"?(r=t,n={}):(r=n,n=t)),n=n||{},n.was_delete=!0;var s={_id:i._id,_rev:i._rev||n.rev};s._deleted=!0;if(fn(s._id)&&typeof this._removeLocal=="function")return this._removeLocal(i,r);this.bulkDocs({docs:[s]},n,vn(r,s._id))}),Sn.prototype.revsDiff=T("revsDiff",function(e,t,n){function o(e,t){s.has(e)||s.set(e,{missing:[]}),s.get(e).missing.push(t)}function u(t,n){var r=e[t].slice(0);Wt(n,function(e,n,i,s,u){var a=n+"-"+i,f=r.indexOf(a);if(f===-1)return;r.splice(f,1),u.status!=="available"&&o(t,a)}),r.forEach(function(e){o(t,e)})}typeof t=="function"&&(n=t,t={});var r=Object.keys(e);if(!r.length)return n(null,{});var i=0,s=new M;r.map(function(t){this._getRevisionTree(t,function(o,a){if(o&&o.status===404&&o.message==="missing")s.set(t,{missing:e[t]});else{if(o)return n(o);u(t,a)}if(++i===r.length){var f={};return s.forEach(function(e,t){f[t]=e}),n(null,f)}})},this)}),Sn.prototype.bulkGet=T("bulkGet",function(e,t){B(this,e,t)}),Sn.prototype.compactDocument=T("compactDocument",function(e,t,n){var r=this;this._getRevisionTree(e,function(i,s){if(i)return n(i);var o=yn(s),u=[],a=[];Object.keys(o).forEach(function(e){o[e]>t&&u.push(e)}),Wt(s,function(e,t,n,r,i){var s=t+"-"+n;i.status==="available"&&u.indexOf(s)!==-1&&a.push(s)}),r._doCompaction(e,a,n)})}),Sn.prototype.compact=T("compact",function(e,t){typeof e=="function"&&(t=e,e={});var n=this;e=e||{},n._compactionQueue=n._compactionQueue||[],n._compactionQueue.push({opts:e,callback:t}),n._compactionQueue.length===1&&wn(n)}),Sn.prototype._compact=function(e,t){function s(e){i.push(n.compactDocument(e.id,0))}function o(e){var r=e.last_seq;p.all(i).then(function(){return It(n,"_local/compaction",function(t){return!t.last_seq||t.last_seq<r?(t.last_seq=r,t):!1})}).then(function(){t(null,{ok:!0})}).catch(t)}var n=this,r={return_docs:!1,last_seq:e.last_seq||0},i=[];n.changes(r).on("change",s).on("complete",o).on("error",t)},Sn.prototype.get=T("get",function(e,t,n){function s(){var s=[],o=r.length;if(!o)return n(null,s);r.forEach(function(r){i.get(e,{rev:r,revs:t.revs,latest:t.latest,attachments:t.attachments},function(e,t){if(!e){var i;for(var u=0,a=s.length;u<a;u++)if(s[u].ok&&s[u].ok._rev===t._rev){i=!0;break}i||s.push({ok:t})}else s.push({missing:r});o--,o||n(null,s)})})}typeof t=="function"&&(n=t,t={});if(typeof e!="string")return n(wt(et));if(fn(e)&&typeof this._getLocal=="function")return this._getLocal(e,n);var r=[],i=this;if(t.open_revs){if(t.open_revs==="all")this._getRevisionTree(e,function(e,t){if(e)return n(e);r=Vt(t).map(function(e){return e.rev}),s()});else{if(!Array.isArray(t.open_revs))return n(wt(it,"function_clause"));r=t.open_revs;for(var o=0;o<r.length;o++){var u=r[o];if(typeof u!="string"||!/^\d+-/.test(u))return n(wt(mt))}s()}return}return this._get(e,t,function(r,s){if(r)return r.docId=e,n(r);var o=s.doc,u=s.metadata,a=s.ctx;if(t.conflicts){var f=$t(u);f.length&&(o._conflicts=f)}an(u,o._rev)&&(o._deleted=!0);if(t.revs||t.revs_info){var l=o._rev.split("-"),c=parseInt(l[0],10),h=l[1],p=Kt(u.rev_tree),d=null;for(var v=0;v<p.length;v++){var m=p[v],g=m.ids.map(function(e){return e.id}).indexOf(h),y=g===c-1;if(y||!d&&g!==-1)d=m}var b=d.ids.map(function(e){return e.id}).indexOf(o._rev.split("-")[1])+1,w=d.ids.length-b;d.ids.splice(b,w),d.ids.reverse(),t.revs&&(o._revisions={start:d.pos+d.ids.length-1,ids:d.ids.map(function(e){return e.id})});if(t.revs_info){var E=d.pos+d.ids.length;o._revs_info=d.ids.map(function(e){return E--,{rev:E+"-"+e.id,status:e.opts.status}})}}if(t.attachments&&o._attachments){var S=o._attachments,x=Object.keys(S).length;if(x===0)return n(null,o);Object.keys(S).forEach(function(e){this._getAttachment(o._id,e,S[e],{rev:o._rev,binary:t.binary,ctx:a},function(t,r){var i=o._attachments[e];i.data=r,delete i.stub,delete i.length,--x||n(null,o)})},i)}else{if(o._attachments)for(var T in o._attachments)o._attachments.hasOwnProperty(T)&&(o._attachments[T].stub=!0);n(null,o)}})}),Sn.prototype.getAttachment=T("getAttachment",function(e,t,n,r){var i=this;n instanceof Function&&(r=n,n={}),this._get(e,n,function(s,o){if(s)return r(s);if(!o.doc._attachments||!o.doc._attachments[t])return r(wt(Y));n.ctx=o.ctx,n.binary=!0,i._getAttachment(e,t,o.doc._attachments[t],n,r)})}),Sn.prototype.allDocs=T("allDocs",function(e,t){typeof e=="function"&&(t=e,e={}),e.skip=typeof e.skip!="undefined"?e.skip:0,e.start_key&&(e.startkey=e.start_key),e.end_key&&(e.endkey=e.end_key);if("keys"in e){if(!Array.isArray(e.keys))return t(new TypeError("options.keys must be an array"));var n=["startkey","endkey","key"].filter(function(t){return t in e})[0];if(n){t(wt(ut,"Query parameter `"+n+"` is not compatible with multi-get"));return}if(!At(this))return bn(this,e,t)}return this._allDocs(e,t)}),Sn.prototype.changes=function(e,t){return typeof e=="function"&&(t=e,e={}),new hn(this,e,t)},Sn.prototype.close=T("close",function(e){return this._closed=!0,this.emit("closed"),this._close(e)}),Sn.prototype.info=T("info",function(e){var t=this;this._info(function(n,r){if(n)return e(n);r.db_name=r.db_name||t.name,r.auto_compaction=!!t.auto_compaction&&!At(t),r.adapter=t.adapter,e(null,r)})}),Sn.prototype.id=T("id",function(e){return this._id(e)}),Sn.prototype.type=function(){return typeof this._type=="function"?this._type():this.adapter},Sn.prototype.bulkDocs=T("bulkDocs",function(e,t,n){typeof t=="function"&&(n=t,t={}),t=t||{},Array.isArray(e)&&(e={docs:e});if(!e||!e.docs||!Array.isArray(e.docs))return n(wt(G));for(var r=0;r<e.docs.length;++r)if(typeof e.docs[r]!="object"||Array.isArray(e.docs[r]))return n(wt(lt));var i;e.docs.forEach(function(e){e._attachments&&Object.keys(e._attachments).forEach(function(t){i=i||En(t),e._attachments[t].content_type||z("warn","Attachment",t,"on document",e._id,"is missing content_type")})});if(i)return n(wt(ft,i));"new_edits"in t||("new_edits"in e?t.new_edits=e.new_edits:t.new_edits=!0);var s=this;!t.new_edits&&!At(s)&&e.docs.sort(gn),mn(e.docs);var o=e.docs.map(function(e){return e._id});return this._bulkDocs(e,t,function(e,r){if(e)return n(e);t.new_edits||(r=r.filter(function(e){return e.error}));if(!At(s))for(var i=0,u=r.length;i<u;i++)r[i].id=r[i].id||o[i];n(null,r)})}),Sn.prototype.registerDependentDatabase=T("registerDependentDatabase",function(e,t){function r(t){return t.dependentDbs=t.dependentDbs||{},t.dependentDbs[e]?!1:(t.dependentDbs[e]=!0,t)}var n=new this.constructor(e,this.__opts);It(this,"_local/_pouch_dependentDbs",r).then(function(){t(null,{db:n})}).catch(t)}),Sn.prototype.destroy=T("destroy",function(e,t){function i(){n._destroy(e,function(e,r){if(e)return t(e);n._destroyed=!0,n.emit("destroyed"),t(null,r||{ok:!0})})}typeof e=="function"&&(t=e,e={});var n=this,r="use_prefix"in n?n.use_prefix:!0;if(At(n))return i();n.get("_local/_pouch_dependentDbs",function(e,s){if(e)return e.status!==404?t(e):i();var o=s.dependentDbs,u=n.constructor,a=Object.keys(o).map(function(e){var t=r?e.replace(new RegExp("^"+u.prefix),""):e;return(new u(t,n.__opts)).destroy()});p.all(a).then(i,t)})}),xn.prototype.execute=function(){var e;if(this.failed)while(e=this.queue.shift())e(this.failed);else while(e=this.queue.shift())e()},xn.prototype.fail=function(e){this.failed=e,this.execute()},xn.prototype.ready=function(e){this.isReady=!0,this.db=e,this.execute()},xn.prototype.addTask=function(e){this.queue.push(e),this.failed&&this.execute()},a(Cn,Sn),Cn.adapters={},Cn.preferredAdapters=[],Cn.prefix="_pouch_";var kn=new u.EventEmitter;Ln(Cn),Cn.adapter=function(e,t,n){t.valid()&&(Cn.adapters[e]=t,n&&Cn.preferredAdapters.push(e))},Cn.plugin=function(e){if(typeof e=="function")e(Cn);else{if(typeof e!="object"||Object.keys(e).length===0)throw new Error('Invalid plugin: got "'+e+'", expected an object or a function');Object.keys(e).forEach(function(t){Cn.prototype[t]=e[t]})}return this.__defaults&&(Cn.__defaults=J({},this.__defaults)),Cn},Cn.defaults=function(e){function t(e,n){if(!(this instanceof t))return new t(e,n);n=n||{},e&&typeof e=="object"&&(n=e,e=n.name,delete n.name),n=J({},t.__defaults,n),Cn.call(this,e,n)}return a(t,Cn),t.preferredAdapters=Cn.preferredAdapters.slice(),Object.keys(Cn).forEach(function(e){e in t||(t[e]=Cn[e])}),t.__defaults=J({},this.__defaults,e),t};var An="6.3.4",Pn=["$or","$nor","$not"],Vn=-324,$n=3,Jn="",Er={$elemMatch:function(e,t,n,r){return Array.isArray(r)?r.length===0?!1:typeof r[0]=="object"?r.some(function(e){return fr(e,t,Object.keys(t))}):r.some(function(r){return lr(t,e,n,r)}):!1},$allMatch:function(e,t,n,r){return Array.isArray(r)?r.length===0?!1:typeof r[0]=="object"?r.every(function(e){return fr(e,t,Object.keys(t))}):r.every(function(r){return lr(t,e,n,r)}):!1},$eq:function(e,t,n,r){return dr(r)&&Kn(r,t)===0},$gte:function(e,t,n,r){return dr(r)&&Kn(r,t)>=0},$gt:function(e,t,n,r){return dr(r)&&Kn(r,t)>0},$lte:function(e,t,n,r){return dr(r)&&Kn(r,t)<=0},$lt:function(e,t,n,r){return dr(r)&&Kn(r,t)<0},$exists:function(e,t,n,r){return t?dr(r):!dr(r)},$mod:function(e,t,n,r){return pr(r)&&vr(r,t)},$ne:function(e,t,n,r){return t.every(function(e){return Kn(r,e)!==0})},$in:function(e,t,n,r){return pr(r)&&mr(r,t)},$nin:function(e,t,n,r){return pr(r)&&!mr(r,t)},$size:function(e,t,n,r){return pr(r)&&yr(r,t)},$all:function(e,t,n,r){return Array.isArray(r)&&gr(r,t)},$regex:function(e,t,n,r){return pr(r)&&br(r,t)},$type:function(e,t,n,r){return wr(r,t)}};Cn.plugin(On),Cn.plugin(Ar),Cn.version=An;var Mr=Or(["_id","_rev","_attachments","_deleted","_revisions","_revs_info","_conflicts","_deleted_conflicts","_local_seq","_rev_tree","_replication_id","_replication_state","_replication_state_time","_replication_state_reason","_replication_stats","_removed"]),_r=Or(["_attachments","_replication_id","_replication_state","_replication_state_time","_replication_state_reason","_replication_stats"]),Br=function(e){return atob(e)},jr=function(e){return btoa(e)},$r=n.setImmediate||n.setTimeout,Jr=32768,fi=5,li="document-store",ci="by-sequence",hi="attach-store",pi="attach-seq-store",di="meta-store",vi="local-store",mi="detect-blob-support",Li=new U,Bi=!1,ji=[],Ui=new M,zi,Wi=new M;Xi.valid=function(){var e=typeof openDatabase!="undefined"&&/(Safari|iPhone|iPad|iPod)/.test(navigator.userAgent)&&!/Chrome/.test(navigator.userAgent)&&!/BlackBerry/.test(navigator.platform);return!e&&typeof indexedDB!="undefined"&&typeof IDBKeyRange!="undefined"};var Ji=function(e){e.adapter("idb",Xi,!0)},ts=7,ns=es("document-store"),rs=es("by-sequence"),is=es("attach-store"),ss=es("local-store"),os=es("metadata-store"),us=es("attach-seq-store"),ys=new M,Ss=new U,Ts=1,Ns="CREATE INDEX IF NOT EXISTS 'by-seq-deleted-idx' ON "+rs+" (seq, deleted)",Cs="CREATE UNIQUE INDEX IF NOT EXISTS 'by-seq-doc-id-rev' ON "+rs+" (doc_id, rev)",ks="CREATE INDEX IF NOT EXISTS 'doc-winningseq-idx' ON "+ns+" (winningseq)",Ls="CREATE INDEX IF NOT EXISTS 'attach-seq-seq-idx' ON "+us+" (seq)",As="CREATE UNIQUE INDEX IF NOT EXISTS 'attach-seq-digest-idx' ON "+us+" (digest, seq)",Os=rs+".seq = "+ns+".winningseq",Ms=rs+".seq AS seq, "+rs+".deleted AS deleted, "+rs+".json AS data, "+rs+".rev AS rev, "+ns+".json AS metadata";js.valid=Hs,js.use_prefix=!0;var Fs=function(e){e.adapter("websql",js,!0)},zs=Us(),Xs=function(){},Qs=25,Gs=50,Ys=5e3,Zs=1e4,eo={};fo.valid=function(){return!0};var lo=function(e){e.adapter("http",fo,!1),e.adapter("https",fo,!1)};a(co,Error),a(ho,Error),a(po,Error);var xo=z.bind(null,"log"),To=Array.isArray,No=JSON.parse;ko.prototype.add=function(e){return this.promise=this.promise.catch(function(){}).then(function(){return e()}),this.promise},ko.prototype.finish=function(){return this.promise};var Mo={},_o=new ko,Do=50,Fo={_sum:function(e,t){return So(t)},_count:function(e,t){return t.length},_stats:function(e,t){function n(e){var t=0;for(var n=0,r=e.length;n<r;n++){var i=e[n];t+=i*i}return t}return{sum:So(t),min:Math.min.apply(null,t),max:Math.max.apply(null,t),count:t.length,sumsqr:n(t)}}},zo="mrviews",Wo=jo(zo,qo,Ro,Uo),$o={query:Xo,viewCleanup:Vo},eu=1,tu="pouchdb",nu=5,ru=0;su.prototype.writeCheckpoint=function(e,t){var n=this;return this.updateTarget(e,t).then(function(){return n.updateSource(e,t)})},su.prototype.updateTarget=function(e,t){return this.opts.writeTargetCheckpoint?iu(this.target,this.id,e,t,this.returnValue):p.resolve(!0)},su.prototype.updateSource=function(e,t){if(this.opts.writeSourceCheckpoint){var n=this;return this.readOnlySource?p.resolve(!0):iu(this.src,this.id,e,t,this.returnValue).catch(function(e){if(lu(e))return n.readOnlySource=!0,!0;throw e})}return p.resolve(!0)};var ou={"undefined":function(e,t){return Kn(e.last_seq,t.last_seq)===0?t.last_seq:0},1:function(e,t){return uu(t,e).last_seq}};su.prototype.getCheckpoint=function(){var e=this;return e.target.get(e.id).then(function(t){return e.readOnlySource?p.resolve(t.last_seq):e.src.get(e.id).then(function(e){if(t.version!==e.version)return ru;var n;return t.version?n=t.version.toString():n="undefined",n in ou?ou[n](t,e):ru},function(n){if(n.status===404&&t.last_seq)return e.src.put({_id:e.id,last_seq:ru}).then(function(){return ru},function(n){return lu(n)?(e.readOnlySource=!0,t.last_seq):ru});throw n})}).catch(function(e){if(e.status!==404)throw e;return ru})};var cu=0;a(mu,u.EventEmitter),mu.prototype.cancel=function(){this.cancelled=!0,this.state="cancelled",this.emit("cancel")},mu.prototype.ready=function(e,t){function r(){n.cancel()}function i(){e.removeListener("destroyed",r),t.removeListener("destroyed",r)}var n=this;if(n._readyCalled)return;n._readyCalled=!0,e.once("destroyed",r),t.once("destroyed",r),n.once("complete",i)},a(wu,u.EventEmitter),wu.prototype.cancel=function(){this.canceled||(this.canceled=!0,this.push.cancel(),this.pull.cancel())},Cn.plugin(Ji).plugin(Fs).plugin(lo).plugin($o).plugin(Eu),t.exports=Cn}).call(this,typeof global!="undefined"?global:typeof self!="undefined"?self:typeof window!="undefined"?window:{})},{argsarray:1,debug:7,events:2,immediate:3,inherits:4,lie:5,"spark-md5":11,uuid:12,vuvuzela:17}],7:[function(e,t,n){(function(r){function i(){return typeof window!="undefined"&&window&&typeof window.process!="undefined"&&window.process.type==="renderer"?!0:typeof document!="undefined"&&document&&"WebkitAppearance"in document.documentElement.style||typeof window!="undefined"&&window&&window.console&&(console.firebug||console.exception&&console.table)||typeof navigator!="undefined"&&navigator&&navigator.userAgent&&navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/)&&parseInt(RegExp.$1,10)>=31||typeof navigator!="undefined"&&navigator&&navigator.userAgent&&navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/)}function s(e){var t=this.useColors;e[0]=(t?"%c":"")+this.namespace+(t?" %c":" ")+e[0]+(t?"%c ":" ")+"+"+n.humanize(this.diff);if(!t)return;var r="color: "+this.color;e.splice(1,0,r,"color: inherit");var i=0,s=0;e[0].replace(/%[a-zA-Z%]/g,function(e){if("%%"===e)return;i++,"%c"===e&&(s=i)}),e.splice(s,0,r)}function o(){return"object"==typeof console&&console.log&&Function.prototype.apply.call(console.log,console,arguments)}function u(e){try{null==e?n.storage.removeItem("debug"):n.storage.debug=e}catch(t){}}function a(){var e;try{e=n.storage.debug}catch(t){}return!e&&typeof r!="undefined"&&"env"in r&&(e=r.env.DEBUG),e}function f(){try{return window.localStorage}catch(e){}}n=t.exports=e("./debug"),n.log=o,n.formatArgs=s,n.save=u,n.load=a,n.useColors=i,n.storage="undefined"!=typeof chrome&&"undefined"!=typeof chrome.storage?chrome.storage.local:f(),n.colors=["lightseagreen","forestgreen","goldenrod","dodgerblue","darkorchid","crimson"],n.formatters.j=function(e){try{return JSON.stringify(e)}catch(t){return"[UnexpectedJSONParseError]: "+t.message}},n.enable(a())}).call(this,e("_process"))},{"./debug":8,_process:10}],8:[function(e,t,n){function i(e){var t=0,r;for(r in e)t=(t<<5)-t+e.charCodeAt(r),t|=0;return n.colors[Math.abs(t)%n.colors.length]}function s(e){function t(){if(!t.enabled)return;var e=t,i=+(new Date),s=i-(r||i);e.diff=s,e.prev=r,e.curr=i,r=i;var o=new Array(arguments.length);for(var u=0;u<o.length;u++)o[u]=arguments[u];o[0]=n.coerce(o[0]),"string"!=typeof o[0]&&o.unshift("%O");var a=0;o[0]=o[0].replace(/%([a-zA-Z%])/g,function(t,r){if(t==="%%")return t;a++;var i=n.formatters[r];if("function"==typeof i){var s=o[a];t=i.call(e,s),o.splice(a,1),a--}return t}),n.formatArgs.call(e,o);var f=t.log||n.log||console.log.bind(console);f.apply(e,o)}return t.namespace=e,t.enabled=n.enabled(e),t.useColors=n.useColors(),t.color=i(e),"function"==typeof n.init&&n.init(t),t}function o(e){n.save(e),n.names=[],n.skips=[];var t=(typeof e=="string"?e:"").split(/[\s,]+/),r=t.length;for(var i=0;i<r;i++){if(!t[i])continue;e=t[i].replace(/\*/g,".*?"),e[0]==="-"?n.skips.push(new RegExp("^"+e.substr(1)+"$")):n.names.push(new RegExp("^"+e+"$"))}}function u(){n.enable("")}function a(e){var t,r;for(t=0,r=n.skips.length;t<r;t++)if(n.skips[t].test(e))return!1;for(t=0,r=n.names.length;t<r;t++)if(n.names[t].test(e))return!0;return!1}function f(e){return e instanceof Error?e.stack||e.message:e}n=t.exports=s.debug=s["default"]=s,n.coerce=f,n.disable=u,n.enable=o,n.enabled=a,n.humanize=e("ms"),n.names=[],n.skips=[],n.formatters={};var r},{ms:9}],9:[function(e,t,n){function a(e){e=String(e);if(e.length>1e4)return;var t=/^((?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|years?|yrs?|y)?$/i.exec(e);if(!t)return;var n=parseFloat(t[1]),a=(t[2]||"ms").toLowerCase();switch(a){case"years":case"year":case"yrs":case"yr":case"y":return n*u;case"days":case"day":case"d":return n*o;case"hours":case"hour":case"hrs":case"hr":case"h":return n*s;case"minutes":case"minute":case"mins":case"min":case"m":return n*i;case"seconds":case"second":case"secs":case"sec":case"s":return n*r;case"milliseconds":case"millisecond":case"msecs":case"msec":case"ms":return n;default:return undefined}}function f(e){return e>=o?Math.round(e/o)+"d":e>=s?Math.round(e/s)+"h":e>=i?Math.round(e/i)+"m":e>=r?Math.round(e/r)+"s":e+"ms"}function l(e){return c(e,o,"day")||c(e,s,"hour")||c(e,i,"minute")||c(e,r,"second")||e+" ms"}function c(e,t,n){if(e<t)return;return e<t*1.5?Math.floor(e/t)+" "+n:Math.ceil(e/t)+" "+n+"s"}var r=1e3,i=r*60,s=i*60,o=s*24,u=o*365.25;t.exports=function(e,t){t=t||{};var n=typeof e;if(n==="string"&&e.length>0)return a(e);if(n==="number"&&isNaN(e)===!1)return t.long?l(e):f(e);throw new Error("val is not a non-empty string or a valid number. val="+JSON.stringify(e))}},{}],10:[function(e,t,n){function o(){throw new Error("setTimeout has not been defined")}function u(){throw new Error("clearTimeout has not been defined")}function a(e){if(i===setTimeout)return setTimeout(e,0);if((i===o||!i)&&setTimeout)return i=setTimeout,setTimeout(e,0);try{return i(e,0)}catch(t){try{return i.call(null,e,0)}catch(t){return i.call(this,e,0)}}}function f(e){if(s===clearTimeout)return clearTimeout(e);if((s===u||!s)&&clearTimeout)return s=clearTimeout,clearTimeout(e);try{return s(e)}catch(t){try{return s.call(null,e)}catch(t){return s.call(this,e)}}}function d(){if(!c||!h)return;c=!1,h.length?l=h.concat(l):p=-1,l.length&&v()}function v(){if(c)return;var e=a(d);c=!0;var t=l.length;while(t){h=l,l=[];while(++p<t)h&&h[p].run();p=-1,t=l.length}h=null,c=!1,f(e)}function m(e,t){this.fun=e,this.array=t}function g(){}var r=t.exports={},i,s;(function(){try{typeof setTimeout=="function"?i=setTimeout:i=o}catch(e){i=o}try{typeof clearTimeout=="function"?s=clearTimeout:s=u}catch(e){s=u}})();var l=[],c=!1,h,p=-1;r.nextTick=function(e){var t=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)t[n-1]=arguments[n];l.push(new m(e,t)),l.length===1&&!c&&a(v)},m.prototype.run=function(){this.fun.apply(null,this.array)},r.title="browser",r.browser=!0,r.env={},r.argv=[],r.version="",r.versions={},r.on=g,r.addListener=g,r.once=g,r.off=g,r.removeListener=g,r.removeAllListeners=g,r.emit=g,r.prependListener=g,r.prependOnceListener=g,r.listeners=function(e){return[]},r.binding=function(e){throw new Error("process.binding is not supported")},r.cwd=function(){return"/"},r.chdir=function(e){throw new Error("process.chdir is not supported")},r.umask=function(){return 0}},{}],11:[function(t,n,r){(function(t){if(typeof r=="object")n.exports=t();else if(typeof e=="function"&&e.amd)e(t);else{var i;try{i=window}catch(s){i=self}i.SparkMD5=t()}})(function(e){"use strict";function r(e,n,r,i,s,o){return n=t(t(n,e),t(i,o)),t(n<<s|n>>>32-s,r)}function i(e,t){var n=e[0],r=e[1],i=e[2],s=e[3];n+=(r&i|~r&s)+t[0]-680876936|0,n=(n<<7|n>>>25)+r|0,s+=(n&r|~n&i)+t[1]-389564586|0,s=(s<<12|s>>>20)+n|0,i+=(s&n|~s&r)+t[2]+606105819|0,i=(i<<17|i>>>15)+s|0,r+=(i&s|~i&n)+t[3]-1044525330|0,r=(r<<22|r>>>10)+i|0,n+=(r&i|~r&s)+t[4]-176418897|0,n=(n<<7|n>>>25)+r|0,s+=(n&r|~n&i)+t[5]+1200080426|0,s=(s<<12|s>>>20)+n|0,i+=(s&n|~s&r)+t[6]-1473231341|0,i=(i<<17|i>>>15)+s|0,r+=(i&s|~i&n)+t[7]-45705983|0,r=(r<<22|r>>>10)+i|0,n+=(r&i|~r&s)+t[8]+1770035416|0,n=(n<<7|n>>>25)+r|0,s+=(n&r|~n&i)+t[9]-1958414417|0,s=(s<<12|s>>>20)+n|0,i+=(s&n|~s&r)+t[10]-42063|0,i=(i<<17|i>>>15)+s|0,r+=(i&s|~i&n)+t[11]-1990404162|0,r=(r<<22|r>>>10)+i|0,n+=(r&i|~r&s)+t[12]+1804603682|0,n=(n<<7|n>>>25)+r|0,s+=(n&r|~n&i)+t[13]-40341101|0,s=(s<<12|s>>>20)+n|0,i+=(s&n|~s&r)+t[14]-1502002290|0,i=(i<<17|i>>>15)+s|0,r+=(i&s|~i&n)+t[15]+1236535329|0,r=(r<<22|r>>>10)+i|0,n+=(r&s|i&~s)+t[1]-165796510|0,n=(n<<5|n>>>27)+r|0,s+=(n&i|r&~i)+t[6]-1069501632|0,s=(s<<9|s>>>23)+n|0,i+=(s&r|n&~r)+t[11]+643717713|0,i=(i<<14|i>>>18)+s|0,r+=(i&n|s&~n)+t[0]-373897302|0,r=(r<<20|r>>>12)+i|0,n+=(r&s|i&~s)+t[5]-701558691|0,n=(n<<5|n>>>27)+r|0,s+=(n&i|r&~i)+t[10]+38016083|0,s=(s<<9|s>>>23)+n|0,i+=(s&r|n&~r)+t[15]-660478335|0,i=(i<<14|i>>>18)+s|0,r+=(i&n|s&~n)+t[4]-405537848|0,r=(r<<20|r>>>12)+i|0,n+=(r&s|i&~s)+t[9]+568446438|0,n=(n<<5|n>>>27)+r|0,s+=(n&i|r&~i)+t[14]-1019803690|0,s=(s<<9|s>>>23)+n|0,i+=(s&r|n&~r)+t[3]-187363961|0,i=(i<<14|i>>>18)+s|0,r+=(i&n|s&~n)+t[8]+1163531501|0,r=(r<<20|r>>>12)+i|0,n+=(r&s|i&~s)+t[13]-1444681467|0,n=(n<<5|n>>>27)+r|0,s+=(n&i|r&~i)+t[2]-51403784|0,s=(s<<9|s>>>23)+n|0,i+=(s&r|n&~r)+t[7]+1735328473|0,i=(i<<14|i>>>18)+s|0,r+=(i&n|s&~n)+t[12]-1926607734|0,r=(r<<20|r>>>12)+i|0,n+=(r^i^s)+t[5]-378558|0,n=(n<<4|n>>>28)+r|0,s+=(n^r^i)+t[8]-2022574463|0,s=(s<<11|s>>>21)+n|0,i+=(s^n^r)+t[11]+1839030562|0,i=(i<<16|i>>>16)+s|0,r+=(i^s^n)+t[14]-35309556|0,r=(r<<23|r>>>9)+i|0,n+=(r^i^s)+t[1]-1530992060|0,n=(n<<4|n>>>28)+r|0,s+=(n^r^i)+t[4]+1272893353|0,s=(s<<11|s>>>21)+n|0,i+=(s^n^r)+t[7]-155497632|0,i=(i<<16|i>>>16)+s|0,r+=(i^s^n)+t[10]-1094730640|0,r=(r<<23|r>>>9)+i|0,n+=(r^i^s)+t[13]+681279174|0,n=(n<<4|n>>>28)+r|0,s+=(n^r^i)+t[0]-358537222|0,s=(s<<11|s>>>21)+n|0,i+=(s^n^r)+t[3]-722521979|0,i=(i<<16|i>>>16)+s|0,r+=(i^s^n)+t[6]+76029189|0,r=(r<<23|r>>>9)+i|0,n+=(r^i^s)+t[9]-640364487|0,n=(n<<4|n>>>28)+r|0,s+=(n^r^i)+t[12]-421815835|0,s=(s<<11|s>>>21)+n|0,i+=(s^n^r)+t[15]+530742520|0,i=(i<<16|i>>>16)+s|0,r+=(i^s^n)+t[2]-995338651|0,r=(r<<23|r>>>9)+i|0,n+=(i^(r|~s))+t[0]-198630844|0,n=(n<<6|n>>>26)+r|0,s+=(r^(n|~i))+t[7]+1126891415|0,s=(s<<10|s>>>22)+n|0,i+=(n^(s|~r))+t[14]-1416354905|0,i=(i<<15|i>>>17)+s|0,r+=(s^(i|~n))+t[5]-57434055|0,r=(r<<21|r>>>11)+i|0,n+=(i^(r|~s))+t[12]+1700485571|0,n=(n<<6|n>>>26)+r|0,s+=(r^(n|~i))+t[3]-1894986606|0,s=(s<<10|s>>>22)+n|0,i+=(n^(s|~r))+t[10]-1051523|0,i=(i<<15|i>>>17)+s|0,r+=(s^(i|~n))+t[1]-2054922799|0,r=(r<<21|r>>>11)+i|0,n+=(i^(r|~s))+t[8]+1873313359|0,n=(n<<6|n>>>26)+r|0,s+=(r^(n|~i))+t[15]-30611744|0,s=(s<<10|s>>>22)+n|0,i+=(n^(s|~r))+t[6]-1560198380|0,i=(i<<15|i>>>17)+s|0,r+=(s^(i|~n))+t[13]+1309151649|0,r=(r<<21|r>>>11)+i|0,n+=(i^(r|~s))+t[4]-145523070|0,n=(n<<6|n>>>26)+r|0,s+=(r^(n|~i))+t[11]-1120210379|0,s=(s<<10|s>>>22)+n|0,i+=(n^(s|~r))+t[2]+718787259|0,i=(i<<15|i>>>17)+s|0,r+=(s^(i|~n))+t[9]-343485551|0,r=(r<<21|r>>>11)+i|0,e[0]=n+e[0]|0,e[1]=r+e[1]|0,e[2]=i+e[2]|0,e[3]=s+e[3]|0}function s(e){var t=[],n;for(n=0;n<64;n+=4)t[n>>2]=e.charCodeAt(n)+(e.charCodeAt(n+1)<<8)+(e.charCodeAt(n+2)<<16)+(e.charCodeAt(n+3)<<24);return t}function o(e){var t=[],n;for(n=0;n<64;n+=4)t[n>>2]=e[n]+(e[n+1]<<8)+(e[n+2]<<16)+(e[n+3]<<24);return t}function u(e){var t=e.length,n=[1732584193,-271733879,-1732584194,271733878],r,o,u,a,f,l;for(r=64;r<=t;r+=64)i(n,s(e.substring(r-64,r)));e=e.substring(r-64),o=e.length,u=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0];for(r=0;r<o;r+=1)u[r>>2]|=e.charCodeAt(r)<<(r%4<<3);u[r>>2]|=128<<(r%4<<3);if(r>55){i(n,u);for(r=0;r<16;r+=1)u[r]=0}return a=t*8,a=a.toString(16).match(/(.*?)(.{0,8})$/),f=parseInt(a[2],16),l=parseInt(a[1],16)||0,u[14]=f,u[15]=l,i(n,u),n}function a(e){var t=e.length,n=[1732584193,-271733879,-1732584194,271733878],r,s,u,a,f,l;for(r=64;r<=t;r+=64)i(n,o(e.subarray(r-64,r)));e=r-64<t?e.subarray(r-64):new Uint8Array(0),s=e.length,u=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0];for(r=0;r<s;r+=1)u[r>>2]|=e[r]<<(r%4<<3);u[r>>2]|=128<<(r%4<<3);if(r>55){i(n,u);for(r=0;r<16;r+=1)u[r]=0}return a=t*8,a=a.toString(16).match(/(.*?)(.{0,8})$/),f=parseInt(a[2],16),l=parseInt(a[1],16)||0,u[14]=f,u[15]=l,i(n,u),n}function f(e){var t="",r;for(r=0;r<4;r+=1)t+=n[e>>r*8+4&15]+n[e>>r*8&15];return t}function l(e){var t;for(t=0;t<e.length;t+=1)e[t]=f(e[t]);return e.join("")}function c(e){return/[\u0080-\uFFFF]/.test(e)&&(e=unescape(encodeURIComponent(e))),e}function h(e,t){var n=e.length,r=new ArrayBuffer(n),i=new Uint8Array(r),s;for(s=0;s<n;s+=1)i[s]=e.charCodeAt(s);return t?i:r}function p(e){return String.fromCharCode.apply(null,new Uint8Array(e))}function d(e,t,n){var r=new Uint8Array(e.byteLength+t.byteLength);return r.set(new Uint8Array(e)),r.set(new Uint8Array(t),e.byteLength),n?r:r.buffer}function v(e){var t=[],n=e.length,r;for(r=0;r<n-1;r+=2)t.push(parseInt(e.substr(r,2),16));return String.fromCharCode.apply(String,t)}function m(){this.reset()}var t=function(e,t){return e+t&4294967295},n=["0","1","2","3","4","5","6","7","8","9","a","b","c","d","e","f"];return l(u("hello"))!=="5d41402abc4b2a76b9719d911017c592"&&(t=function(e,t){var n=(e&65535)+(t&65535),r=(e>>16)+(t>>16)+(n>>16);return r<<16|n&65535}),typeof ArrayBuffer!="undefined"&&!ArrayBuffer.prototype.slice&&function(){function t(e,t){return e=e|0||0,e<0?Math.max(e+t,0):Math.min(e,t)}ArrayBuffer.prototype.slice=function(n,r){var i=this.byteLength,s=t(n,i),o=i,u,a,f,l;return r!==e&&(o=t(r,i)),s>o?new ArrayBuffer(0):(u=o-s,a=new ArrayBuffer(u),f=new Uint8Array(a),l=new Uint8Array(this,s,u),f.set(l),a)}}(),m.prototype.append=function(e){return this.appendBinary(c(e)),this},m.prototype.appendBinary=function(e){this._buff+=e,this._length+=e.length;var t=this._buff.length,n;for(n=64;n<=t;n+=64)i(this._hash,s(this._buff.substring(n-64,n)));return this._buff=this._buff.substring(n-64),this},m.prototype.end=function(e){var t=this._buff,n=t.length,r,i=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],s;for(r=0;r<n;r+=1)i[r>>2]|=t.charCodeAt(r)<<(r%4<<3);return this._finish(i,n),s=l(this._hash),e&&(s=v(s)),this.reset(),s},m.prototype.reset=function(){return this._buff="",this._length=0,this._hash=[1732584193,-271733879,-1732584194,271733878],this},m.prototype.getState=function(){return{buff:this._buff,length:this._length,hash:this._hash}},m.prototype.setState=function(e){return this._buff=e.buff,this._length=e.length,this._hash=e.hash,this},m.prototype.destroy=function(){delete this._hash,delete this._buff,delete this._length},m.prototype._finish=function(e,t){var n=t,r,s,o;e[n>>2]|=128<<(n%4<<3);if(n>55){i(this._hash,e);for(n=0;n<16;n+=1)e[n]=0}r=this._length*8,r=r.toString(16).match(/(.*?)(.{0,8})$/),s=parseInt(r[2],16),o=parseInt(r[1],16)||0,e[14]=s,e[15]=o,i(this._hash,e)},m.hash=function(e,t){return m.hashBinary(c(e),t)},m.hashBinary=function(e,t){var n=u(e),r=l(n);return t?v(r):r},m.ArrayBuffer=function(){this.reset()},m.ArrayBuffer.prototype.append=function(e){var t=d(this._buff.buffer,e,!0),n=t.length,r;this._length+=e.byteLength;for(r=64;r<=n;r+=64)i(this._hash,o(t.subarray(r-64,r)));return this._buff=r-64<n?new Uint8Array(t.buffer.slice(r-64)):new Uint8Array(0),this},m.ArrayBuffer.prototype.end=function(e){var t=this._buff,n=t.length,r=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],i,s;for(i=0;i<n;i+=1)r[i>>2]|=t[i]<<(i%4<<3);return this._finish(r,n),s=l(this._hash),e&&(s=v(s)),this.reset(),s},m.ArrayBuffer.prototype.reset=function(){return this._buff=new Uint8Array(0),this._length=0,this._hash=[1732584193,-271733879,-1732584194,271733878],this},m.ArrayBuffer.prototype.getState=function(){var e=m.prototype.getState.call(this);return e.buff=p(e.buff),e},m.ArrayBuffer.prototype.setState=function(e){return e.buff=h(e.buff,!0),m.prototype.setState.call(this,e)},m.ArrayBuffer.prototype.destroy=m.prototype.destroy,m.ArrayBuffer.prototype._finish=m.prototype._finish,m.ArrayBuffer.hash=function(e,t){var n=a(new Uint8Array(e)),r=l(n);return t?v(r):r},m})},{}],12:[function(e,t,n){var r=e("./v1"),i=e("./v4"),s=i;s.v1=r,s.v4=i,t.exports=s},{"./v1":15,"./v4":16}],13:[function(e,t,n){function s(e,t){var n=t||0,i=r;return i[e[n++]]+i[e[n++]]+i[e[n++]]+i[e[n++]]+"-"+i[e[n++]]+i[e[n++]]+"-"+i[e[n++]]+i[e[n++]]+"-"+i[e[n++]]+i[e[n++]]+"-"+i[e[n++]]+i[e[n++]]+i[e[n++]]+i[e[n++]]+i[e[n++]]+i[e[n++]]}var r=[];for(var i=0;i<256;++i)r[i]=(i+256).toString(16).substr(1);t.exports=s},{}],14:[function(e,t,n){(function(e){var n,r=e.crypto||e.msCrypto;if(r&&r.getRandomValues){var i=new Uint8Array(16);n=function(){return r.getRandomValues(i),i}}if(!n){var s=new Array(16);n=function(){for(var e=0,t;e<16;e++)(e&3)===0&&(t=Math.random()*4294967296),s[e]=t>>>((e&3)<<3)&255;return s}}t.exports=n}).call(this,typeof global!="undefined"?global:typeof self!="undefined"?self:typeof window!="undefined"?window:{})},{}],15:[function(e,t,n){function l(e,t,n){var r=t&&n||0,s=t||[];e=e||{};var l=e.clockseq!==undefined?e.clockseq:u,c=e.msecs!==undefined?e.msecs:(new Date).getTime(),h=e.nsecs!==undefined?e.nsecs:f+1,p=c-a+(h-f)/1e4;p<0&&e.clockseq===undefined&&(l=l+1&16383),(p<0||c>a)&&e.nsecs===undefined&&(h=0);if(h>=1e4)throw new Error("uuid.v1(): Can't create more than 10M uuids/sec");a=c,f=h,u=l,c+=122192928e5;var d=((c&268435455)*1e4+h)%4294967296;s[r++]=d>>>24&255,s[r++]=d>>>16&255,s[r++]=d>>>8&255,s[r++]=d&255;var v=c/4294967296*1e4&268435455;s[r++]=v>>>8&255,s[r++]=v&255,s[r++]=v>>>24&15|16,s[r++]=v>>>16&255,s[r++]=l>>>8|128,s[r++]=l&255;var m=e.node||o;for(var g=0;g<6;++g)s[r+g]=m[g];return t?t:i(s)}var r=e("./lib/rng"),i=e("./lib/bytesToUuid"),s=r(),o=[s[0]|1,s[1],s[2],s[3],s[4],s[5]],u=(s[6]<<8|s[7])&16383,a=0,f=0;t.exports=l},{"./lib/bytesToUuid":13,"./lib/rng":14}],16:[function(e,t,n){function s(e,t,n){var s=t&&n||0;typeof e=="string"&&(t=e=="binary"?new Array(16):null,e=null),e=e||{};var o=e.random||(e.rng||r)();o[6]=o[6]&15|64,o[8]=o[8]&63|128;if(t)for(var u=0;u<16;++u)t[s+u]=o[u];return t||i(o)}var r=e("./lib/rng"),i=e("./lib/bytesToUuid");t.exports=s},{"./lib/bytesToUuid":13,"./lib/rng":14}],17:[function(e,t,n){"use strict";function r(e,t,n){var r=n[n.length-1];e===r.element&&(n.pop(),r=n[n.length-1]);var i=r.element,s=r.index;if(Array.isArray(i))i.push(e);else if(s===t.length-2){var o=t.pop();i[o]=e}else t.push(e)}n.stringify=function(t){var n=[];n.push({obj:t});var r="",i,s,o,u,a,f,l,c,h,p,d;while(i=n.pop()){s=i.obj,o=i.prefix||"",u=i.val||"",r+=o;if(u)r+=u;else if(typeof s!="object")r+=typeof s=="undefined"?null:JSON.stringify(s);else if(s===null)r+="null";else if(Array.isArray(s)){n.push({val:"]"});for(a=s.length-1;a>=0;a--)f=a===0?"":",",n.push({obj:s[a],prefix:f});n.push({val:"["})}else{l=[];for(c in s)s.hasOwnProperty(c)&&l.push(c);n.push({val:"}"});for(a=l.length-1;a>=0;a--)h=l[a],p=s[h],d=a>0?",":"",d+=JSON.stringify(h)+":",n.push({obj:p,prefix:d});n.push({val:"{"})}}return r},n.parse=function(e){var t=[],n=[],i=0,s,o,u,a,f,l,c,h,p;for(;;){s=e[i++];if(s==="}"||s==="]"||typeof s=="undefined"){if(t.length===1)return t.pop();r(t.pop(),t,n);continue}switch(s){case" ":case"	":case"\n":case":":case",":break;case"n":i+=3,r(null,t,n);break;case"t":i+=3,r(!0,t,n);break;case"f":i+=4,r(!1,t,n);break;case"0":case"1":case"2":case"3":case"4":case"5":case"6":case"7":case"8":case"9":case"-":o="",i--;for(;;){u=e[i++];if(!/[\d\.\-e\+]/.test(u)){i--;break}o+=u}r(parseFloat(o),t,n);break;case'"':a="",f=void 0,l=0;for(;;){c=e[i++];if(c==='"'&&(f!=="\\"||l%2!==1))break;a+=c,f=c,f==="\\"?l++:l=0}r(JSON.parse('"'+a+'"'),t,n);break;case"[":h={element:[],index:t.length},t.push(h.element),n.push(h);break;case"{":p={element:{},index:t.length},t.push(p.element),n.push(p);break;default:throw new Error("unexpectedly reached end of input: "+s)}}}},{}]},{},[6])(6)}),define("impl/pouchDBPersistenceStore",["../PersistenceStore","../impl/storageUtils","pouchdb","./logger"],function(e,t,n,r){"use strict";var i=function(t){e.call(this,t)};i.prototype=new e,i.prototype.Init=function(e){this._version=e&&e.version||"0";var t=this._name+this._version;this._db=new n(t);if(!e||!e.index)return Promise.resolve();var r=this,i=e.index,s=r._name+i.toString().replace(",","").replace(".",""),o={index:{fields:i,name:s}};return r._db.createIndex?r._db.createIndex(o).then(function(){return Promise.resolve()}):Promise.resolve()},i.prototype.upsert=function(e,t,n,i){r.log("Offline Persistence Toolkit pouchDBPersistenceStore: upsert() for key: "+e);var o=this,u=e.toString(),a=[];return this._prepareUpsert(n,a),o._db.get(u).then(function(e){return s(i,e)?e:Promise.reject({status:409})}).catch(function(e){return e.status===404&&e.message==="missing"?Promise.resolve():Promise.reject(e)}).then(function(e){return o._put(u,t,n,i,a,e)}).then(function(){return Promise.resolve()})},i.prototype._put=function(e,t,n,r,i,o){var u={_id:e,metadata:t,value:n};o&&(u._rev=o._rev);var a=this;return a._db.put(u).then(function(e){return Promise.resolve(e)}).catch(function(t){return t.status===409?a._db.get(e).then(function(e){return r?s(r,e)?Promise.resolve(e):Promise.reject({status:409}):Promise.resolve(e)}):Promise.reject(t)}).then(function(e){return a._addAttachments(e,i)}).then(function(){return Promise.resolve()})};var s=function(e,t){if(!e)return!0;var n=t.metadata.versionIdentifier;return n===e};return i.prototype._addAttachments=function(e,t){if(!t||!t.length)return Promise.resolve();var n=t.map(function(t){var n;return t.value instanceof Blob?n=t.value:n=new Blob([t.value]),this._db.putAttachment(e.id,t.path,e.rev,n,"binary")},this);return Promise.all(n)},i.prototype.upsertAll=function(e){r.log("Offline Persistence Toolkit pouchDBPersistenceStore: upsertAll()");if(!e||!e.length)return Promise.resolve();var t=e.map(function(e){return this.upsert(e.key,e.metadata,e.value,e.expectedVersionIdentifier)},this);return Promise.all(t)},i.prototype.find=function(e){r.log("Offline Persistence Toolkit pouchDBPersistenceStore: find() for expression: "+JSON.stringify(e));var n=this,i=n._prepareFind(e);return n._db.find?n._db.find(i).then(function(e){if(e&&e.docs&&e.docs.length){var t=e.docs.map(n._findResultCallback(i.fields),n);return Promise.all(t)}return Promise.resolve([])}).catch(function(e){return e.status===404&&e.message==="missing"?Promise.resolve([]):Promise.reject(e)}):n._db.allDocs({include_docs:!0}).then(function(r){if(r&&r.rows&&r.rows.length){var s=r.rows.filter(function(n){return t.satisfy(e.selector,n.doc)?!0:!1}),o=s.map(function(e){return n._findResultCallback(i.fields).bind(n)(e.doc)});return Promise.all(o)}return Promise.resolve([])})},i.prototype._findResultCallback=function(e){return function(t){var n=this;return n._fixValue(t).then(function(t){return e?t:t.value})}},i.prototype._fixValue=function(e){var t=e._id||e.id||e.key;t&&(e.key=t);var n=e._attachments;if(!n)return Promise.resolve(e);var r=this,i=Object.keys(n)[0];return r._db.getAttachment(t,i).then(function(t){var n=i.split("."),r=e.value;for(var s=0;s<n.length-1;s++)r=r[n[s]];return r[n[n.length-1]]=t,e})},i.prototype.findByKey=function(e){r.log("Offline Persistence Toolkit pouchDBPersistenceStore: findByKey() for key: "+e);var t=this,n=e.toString();return t._db.get(n).then(function(e){return e.value}).catch(function(e){return e.status===404&&e.message==="missing"?Promise.resolve():Promise.reject(e)})},i.prototype.removeByKey=function(e){r.log("Offline Persistence Toolkit pouchDBPersistenceStore: removeByKey() for key: "+e);var t=this,n=e.toString();return t._db.get(n).then(function(e){return t._db.remove(e)}).then(function(){return!0}).catch(function(e){return e.status===404&&e.message==="missing"?Promise.resolve(!1):Promise.reject(e)})},i.prototype.delete=function(e){r.log("Offline Persistence Toolkit pouchDBPersistenceStore: delete() for expression: "+JSON.stringify(e));var t=this;if(e){var n=e;return n.fields=["_id","_rev"],t.find(n).then(function(e){if(e&&e.length){var n=e.map(function(e){return this._db.remove(e._id,e._rev)},t);return Promise.all(n)}return Promise.resolve()}).then(function(){return Promise.resolve()})}return t._db.allDocs({include_docs:!0}).then(function(e){if(e&&e.rows&&e.rows.length){var n=e.rows.map(function(e){this._db.remove(e.doc)},t);return Promise.all(n)}return Promise.resolve()}).then(function(){return Promise.resolve()})},i.prototype.keys=function(){r.log("Offline Persistence Toolkit pouchDBPersistenceStore: keys()");var e=this;return e._db.allDocs().then(function(e){var t=e.rows,n=[];return t&&t.length&&(n=t.map(function(e){return e.id})),n})},i.prototype._prepareFind=function(e){var t=e||{},n=t.sort;n!==undefined&&delete t.sort;var r=t.selector;r||(t.selector={_id:{$gt:null}});var i=t.fields;if(i&&i.length){var s=i.map(function(e){return e==="key"?"_id":e});t.fields=s}return t},i.prototype._prepareUpsert=function(e,t){var n="";this._inspectValue(n,e,t)},i.prototype._inspectValue=function(e,t,n){for(var r in t)if(t.hasOwnProperty(r)){var i=t[r];if(i&&typeof i=="object")if(i instanceof Blob||i instanceof ArrayBuffer){var s=e;s.length>0&&(s+=".");var o={path:s+r,value:i};n.push(o),t.key=null}else if(i.length===undefined){var u=e;e.length>0&&(e+="."),e+=r,this._inspectValue(e,i,n),e=u}}},i}),define("pouchDBPersistenceStoreFactory",["./impl/pouchDBPersistenceStore"],function(e){"use strict";var t=function(){function t(t,n){var r=new e(t);return r.Init(n).then(function(){return Promise.resolve(r)})}return{createPersistenceStore:function(e,n){return t(e,n)}}}();return t}),define("persistenceStoreFactory",[],function(){"use strict";var e={createPersistenceStore:function(e,t){}};return e});